/****************************************************************************
 *
 * Copyright (c) 2019 by Grandstream Networks, Inc.
 * 
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License as
 * published by the Free Software Foundation; either version 2 of
 * the License, or (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston,
 * MA 02111-1307 USA
 *
 ***************************************************************************/

//=======================
//  Includes
//=======================
#include <common.h>
#include <gs_rsa/gs_rsa.h>

//=======================
//  Defines
//=======================

//=======================
//  Globals
//=======================

/* Use mkbootimg: 
 * ./mkbootimg --sign=grp_firmware.pub --print_pubkey
 */
#ifdef CONFIG_GHP610
struct gs_pubkey_t gs_public_key =
{
	.n = {
		0xdb, 0x5e, 0xc0, 0x14, 0xfc, 0x93, 0xd4, 0x7e, 
		0xfc, 0xdf, 0xf1, 0x62, 0xe8, 0x09, 0xc4, 0x72, 
		0x24, 0xc1, 0x4e, 0x4e, 0x97, 0x54, 0x77, 0x02, 
		0x04, 0xd6, 0xa5, 0xe0, 0x1a, 0x66, 0x2d, 0x26, 
		0x33, 0x97, 0xce, 0x75, 0x77, 0x6e, 0x7f, 0xda, 
		0x5c, 0x11, 0x4f, 0x1e, 0x2a, 0xa5, 0x12, 0x33, 
		0xa9, 0x6c, 0x57, 0x34, 0x89, 0x1c, 0xc0, 0xed, 
		0x80, 0xd2, 0x71, 0xe0, 0x4c, 0xb5, 0xba, 0xda, 
		0xc8, 0x7f, 0x61, 0x61, 0x61, 0x87, 0x6a, 0x45, 
		0x27, 0x33, 0x4b, 0xd2, 0x2b, 0x9c, 0xe8, 0x56, 
		0x37, 0x48, 0x99, 0xba, 0x36, 0x54, 0x18, 0x07, 
		0x35, 0x52, 0x4e, 0x1f, 0xa4, 0xac, 0x1c, 0x9f, 
		0x32, 0x81, 0xde, 0x52, 0x4a, 0xa3, 0x8a, 0xc7, 
		0x7c, 0x2f, 0xa2, 0xf8, 0xb6, 0xc5, 0x15, 0xa0, 
		0xae, 0x6c, 0x5d, 0xdb, 0x64, 0xb5, 0xe1, 0x04, 
		0x81, 0xd4, 0x45, 0xa6, 0x14, 0x29, 0x93, 0xb6, 
		0x78, 0x11, 0x8d, 0xce, 0x22, 0x53, 0xe1, 0x80, 
		0x03, 0xc3, 0x2d, 0x2d, 0x97, 0xd2, 0x21, 0x41, 
		0x9c, 0x55, 0xe0, 0x1b, 0x36, 0xb4, 0x10, 0x3a, 
		0xe1, 0xf0, 0xf4, 0xa4, 0xef, 0x4d, 0x55, 0x09, 
		0x00, 0x36, 0xe9, 0x60, 0xcc, 0xb1, 0x28, 0x98, 
		0x09, 0xd6, 0x9a, 0x1d, 0xd7, 0x22, 0xe2, 0xac, 
		0xcd, 0x55, 0x04, 0xa7, 0x78, 0x90, 0x2b, 0x7e, 
		0x8e, 0x6f, 0x81, 0x50, 0x6a, 0x4f, 0xf9, 0x47, 
		0xad, 0x64, 0xe2, 0x80, 0x0c, 0x15, 0xba, 0x0b, 
		0x62, 0x1a, 0x85, 0x61, 0x96, 0x43, 0x6c, 0x68, 
		0x62, 0xe2, 0x31, 0x6a, 0x7c, 0xd0, 0xef, 0x02, 
		0x62, 0xae, 0xdb, 0xb5, 0x2c, 0xf8, 0x91, 0xad, 
		0x1c, 0xce, 0x5a, 0xf5, 0x53, 0xee, 0xb7, 0xe1, 
		0xa8, 0x9f, 0x7b, 0xa6, 0xeb, 0x6e, 0x98, 0xb0, 
		0x0d, 0xa8, 0xdd, 0x70, 0x5c, 0xbb, 0x4e, 0x9c, 
		0x16, 0xf8, 0xbc, 0x22, 0xd0, 0x3e, 0x65, 0x3f, 
	},
	.e = 0x00010001

};
#else
#error "Must define gs_public_key based on product if CONFIG_GS_SECURE_BOOT enabled"
#endif


/* EOF */
