/******************************************************************************* 
 *  FILE NAME: 		sip_aes.h
 *  DESCRIPTION:	This file is the interface exported for AES-128 module of 
 *					aes.c which is based on Christophe Devine's implementation
 *					of AES-128 that is compliant to FIPS-197.
 *
 *	MODIFIED BY:	RICHARD HUANG
 *	DATE:			06/11/2004
 *******************************************************************************/

#ifndef _SIP_AES_H
#define _SIP_AES_H

#define COMPILE_VOC             COMPILE_VOC_AES

/******************************************************************************
 * data type definitions
 ******************************************************************************/
typedef char     				CHAR;  /* 1 byte  */
typedef unsigned char     		UCHAR; /* 1 byte  */
typedef short	  			  	INT;   /* 2 bytes */
typedef unsigned short 			UINT;  /* 2 bytes */
typedef long       	            LONG;  /* 4 bytes */
typedef unsigned long       	ULONG; /* 4 bytes */

typedef short	  			  	INT16;	/* 2 bytes */
typedef unsigned short 			UINT16;	/* 2 bytes */
typedef long       	            INT32;	/* 4 bytes */
typedef unsigned long       	UINT32;	/* 4 bytes */

typedef enum {FALSE=0, TRUE=1} BOOL;

void aes_init(UINT *, UINT *);

/* Uncomment this line to use the encryption function */
#define AES_ENCRYPTION
#define AES_DECRYPTION

#if defined AES_ENCRYPTION
void aes_encrypt_block(UINT *inBlock, UINT blockLen, UINT *outBlock);
#endif

#if defined AES_DECRYPTION
void aes_decrypt_block(UINT *inBlock, UINT blockLen, UINT *outBlock);
void aes_decrypt_1(UINT in[8], UINT out[8]);
#endif 

#define AES_BLOCK_LEN 8 // 8x 16 bits words = 128 bits

#endif /* sip_aes.h */
