#include <asm/uaccess.h>
#include <linux/slab.h>
#include <gs/gssu.h>

static char fphrase[] = {
	'g' ^ 0x12, 'r' ^ 0x13, 'A' ^ 0x14, 'n' ^ 0x15, 'd' ^ 0x16, 'S' ^ 0x17, 'T' ^ 0x18, 'r' ^ 0x19,
	'e' ^ 0x1a, 'a' ^ 0x1b, 'm' ^ 0x1c, 'T' ^ 0x1d, 'X' ^ 0x1e, '2' ^ 0x1f, '0' ^ 0x20, 'G' ^ 0x21,
	'r' ^ 0x22, 'P' ^ 0x23, '2' ^ 0x24, '6' ^ 0x25, '0' ^ 0x26, 'x' ^ 0x27, 'F' ^ 0x28, 'z' ^ 0x29,
	'C' ^ 0x2a, '2' ^ 0x2b, 'M' ^ 0x2c, '0' ^ 0x2d, 'A' ^ 0x2e, 'I' ^ 0x2f, 'N' ^ 0x30, 'T' ^ 0x31,
	'\0' ^ 0x32
};

static char *dec_fphrase(char *str, int key, char *obuf)
{
	int key_start = key;
	char *p = str;
	while( (*obuf = ((*p) ^  key_start)) != '\0' ) {
		p++;
		obuf++;
		key_start++;
	}
	return str;
}

int gssu_get_phrase(void __user *arg)
{
	char *pfx;
	int err;

	pfx = kzalloc(sizeof(fphrase), GFP_KERNEL);
	if (pfx == NULL)
		return -ENOMEM;

	dec_fphrase(fphrase, 0x12, pfx);
	err = copy_to_user(arg, pfx, sizeof(fphrase)) ? -EFAULT : 0;
	kfree(pfx);

	return err;
}
