/*
* camclk.h- Sigmastar
*
* Copyright (c) [2019~2020] SigmaStar Technology.
*
*
* This software is licensed under the terms of the GNU General Public
* License version 2, as published by the Free Software Foundation, and
* may be copied, distributed, and modified under those terms.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License version 2 for more details.
*
*/

#ifndef __CAMCLK_H__
#define __CAMCLK_H__

#define    CAMCLK_VOID 0
#define    CAMCLK_mpll_432m 1
#define    CAMCLK_upll_384m 2
#define    CAMCLK_upll_320m 3
#define    CAMCLK_mpll_288m 4
#define    CAMCLK_utmi_240m 5
#define    CAMCLK_mpll_216m 6
#define    CAMCLK_utmi_192m 7
#define    CAMCLK_mpll_172m 8
#define    CAMCLK_utmi_160m 9
#define    CAMCLK_mpll_123m 10
#define    CAMCLK_mpll_86m 11
#define    CAMCLK_mpll_288m_div2 12
#define    CAMCLK_mpll_288m_div4 13
#define    CAMCLK_mpll_288m_div8 14
#define    CAMCLK_mpll_216m_div2 15
#define    CAMCLK_mpll_216m_div4 16
#define    CAMCLK_mpll_216m_div8 17
#define    CAMCLK_mpll_123m_div2 18
#define    CAMCLK_mpll_86m_div2 19
#define    CAMCLK_mpll_86m_div4 20
#define    CAMCLK_mpll_86m_div16 21
#define    CAMCLK_utmi_192m_div4 22
#define    CAMCLK_utmi_160m_div4 23
#define    CAMCLK_utmi_160m_div5 24
#define    CAMCLK_utmi_160m_div8 25
#define    CAMCLK_xtali_12m 26
#define    CAMCLK_xtali_12m_div8 27
#define    CAMCLK_xtali_12m_div16 28
#define    CAMCLK_xtali_12m_div40 29
#define    CAMCLK_xtali_12m_div64 30
#define    CAMCLK_xtali_12m_div128 31
#define    CAMCLK_RTC_CLK_32K 32
#define    CAMCLK_pm_riu_w_clk_in 33
#define    CAMCLK_riu_w_clk_in 34
#define    CAMCLK_riu_w_clk_top 35
#define    CAMCLK_riu_w_clk_sc_gp 36
#define    CAMCLK_riu_w_clk_vhe_gp 37
#define    CAMCLK_riu_w_clk_hemcu_gp 38
#define    CAMCLK_riu_w_clk_mipi_if_gp 39
#define    CAMCLK_riu_w_clk_mcu_if_gp 40
#define    CAMCLK_miu_p 41
#define    CAMCLK_miu_vhe_gp_p 42
#define    CAMCLK_miu_sc_gp_p 43
#define    CAMCLK_miu2x_p 44
#define    CAMCLK_mcu_p 45
#define    CAMCLK_mcu_pm_p 46
#define    CAMCLK_isp_p 47
#define    CAMCLK_fclk1_p 48
#define    CAMCLK_fclk2_p 49
#define    CAMCLK_sdio_p 50
#define    CAMCLK_fcie_p 51
#define    CAMCLK_tck_buf 52
#define    CAMCLK_pad2isp_sr_pclk 53
#define    CAMCLK_ccir_in_clk 54
#define    CAMCLK_eth_buf 55
#define    CAMCLK_rmii_buf 56
#define    CAMCLK_emac_testrx125_in_lan 57
#define    CAMCLK_miu_ff 58
#define    CAMCLK_miu_sc_gp 59
#define    CAMCLK_miu_vhe_gp 60
#define    CAMCLK_miu_dig 61
#define    CAMCLK_miu_xd2miu 62
#define    CAMCLK_miu_urdma 63
#define    CAMCLK_miu_bdma 64
#define    CAMCLK_miu_vhe 65
#define    CAMCLK_miu_jpe1 66
#define    CAMCLK_miu_jpe0 67
#define    CAMCLK_miu_bach 68
#define    CAMCLK_miu_file 69
#define    CAMCLK_miu_uhc0 70
#define    CAMCLK_miu_emac 71
#define    CAMCLK_miu_cmdq 72
#define    CAMCLK_miu_isp_dnr 73
#define    CAMCLK_miu_isp_rot 74
#define    CAMCLK_miu_isp_dma 75
#define    CAMCLK_miu_isp_sta 76
#define    CAMCLK_miu_gop 77
#define    CAMCLK_miu_sc_dnr 78
#define    CAMCLK_miu_sc_dnr_sad 79
#define    CAMCLK_miu_sc_crop 80
#define    CAMCLK_miu_sc1_frm 81
#define    CAMCLK_miu_sc1_snp 82
#define    CAMCLK_miu_sc1_snpi 83
#define    CAMCLK_miu_sc1_dbg 84
#define    CAMCLK_miu_sc2_frm 85
#define    CAMCLK_miu_sc2_snpi 86
#define    CAMCLK_miu_sc3_frm 87
#define    CAMCLK_miu_fcie 88
#define    CAMCLK_miu_sdio 89
#define    CAMCLK_miu_ive 90
#define    CAMCLK_riu 91
#define    CAMCLK_riu_nogating 92
#define    CAMCLK_riu_sc_gp 93
#define    CAMCLK_riu_vhe_gp 94
#define    CAMCLK_riu_hemcu_gp 95
#define    CAMCLK_riu_mipi_gp 96
#define    CAMCLK_riu_mcu_if 97
#define    CAMCLK_miu2x 98
#define    CAMCLK_axi2x 99
#define    CAMCLK_tck 100
#define    CAMCLK_imi 101
#define    CAMCLK_gop0 102
#define    CAMCLK_gop1 103
#define    CAMCLK_gop2 104
#define    CAMCLK_mpll_144m 105
#define    CAMCLK_mpll_144m_div2 106
#define    CAMCLK_mpll_144m_div4 107
#define    CAMCLK_xtali_24m 108
#define    CAMCLK_xtali_12m_div2 109
#define    CAMCLK_xtali_12m_div4 110
#define    CAMCLK_xtali_12m_div12 111
#define    CAMCLK_rtc_32k 112
#define    CAMCLK_rtc_32k_div4 113
#define    CAMCLK_live_pm 114
#define    CAMCLK_riu_pm 115
#define    CAMCLK_miupll_clk 116
#define    CAMCLK_ddrpll_clk 117
#define    CAMCLK_lpll_clk 118
#define    CAMCLK_lpll_clk_div2 119
#define    CAMCLK_lpll_clk_div4 120
#define    CAMCLK_lpll_clk_div8 121
#define    CAMCLK_cpupll_clk 122
#define    CAMCLK_ipupll_clk 123
#define    CAMCLK_venpll_clk 124
#define    CAMCLK_utmi 125
#define    CAMCLK_upll 126
#define    CAMCLK_fuart0_synth_out 127
#define    CAMCLK_csi2_mac_p 128
#define    CAMCLK_miu 129
#define    CAMCLK_ddr_syn 130
#define    CAMCLK_miu_rec 131
#define    CAMCLK_mcu 132
#define    CAMCLK_riubrdg 133
#define    CAMCLK_bdma 134
#define    CAMCLK_spi 135
#define    CAMCLK_uart0 136
#define    CAMCLK_uart1 137
#define    CAMCLK_fuart0_synth_in 138
#define    CAMCLK_fuart 139
#define    CAMCLK_mspi0 140
#define    CAMCLK_mspi1 141
#define    CAMCLK_miic0 142
#define    CAMCLK_miic1 143
#define    CAMCLK_bist 144
#define    CAMCLK_xtali 145
#define    CAMCLK_live 146
#define    CAMCLK_sr_mclk 147
#define    CAMCLK_sr_mclk1 148
#define    CAMCLK_bist_pm 149
#define    CAMCLK_pwr_ctl 150
#define    CAMCLK_ipu 151
#define    CAMCLK_bist_ipu_gp 152
#define    CAMCLK_miic2 153
#define    CAMCLK_miic3 154
#define    CAMCLK_csi_mac_lptx_top_i_0 155
#define    CAMCLK_csi_mac_top_i_0 156
#define    CAMCLK_csi_ns_top_i_0 157
#define    CAMCLK_csi_mac_lptx_top_i_1 158
#define    CAMCLK_csi_mac_top_i_1 159
#define    CAMCLK_csi_ns_top_i_1 160
#define    CAMCLK_bist_vhe_gp 161
#define    CAMCLK_vhe 162
#define    CAMCLK_xtali_sc_gp 163
#define    CAMCLK_bist_sc_gp 164
#define    CAMCLK_emac_ahb 165
#define    CAMCLK_jpe 166
#define    CAMCLK_aesdma 167
#define    CAMCLK_sdio 168
#define    CAMCLK_fcie 169
#define    CAMCLK_ecc 170
#define    CAMCLK_sr 171
#define    CAMCLK_isp 172
#define    CAMCLK_idclk 173
#define    CAMCLK_fclk1 174
#define    CAMCLK_fclk2 175
#define    CAMCLK_odclk 176
#define    CAMCLK_ive 177
#define    CAMCLK_dip 178
#define    CAMCLK_emac_tx 179
#define    CAMCLK_emac_rx 180
#define    CAMCLK_emac_tx_ref 181
#define    CAMCLK_emac_rx_ref 182
#define    CAMCLK_hemcu_216m 183
#define    CAMCLK_csi_mac 184
#define    CAMCLK_mac_lptx 185
#define    CAMCLK_ns 186
#define    CAMCLK_mcu_pm 187
#define    CAMCLK_spi_pm 188
#define    CAMCLK_pm_sleep 189
#define    CAMCLK_sar 190
#define    CAMCLK_rtc 191
#endif
