/*
* padmux.h- Sigmastar
*
* Copyright (c) [2019~2020] SigmaStar Technology.
*
*
* This software is licensed under the terms of the GNU General Public
* License version 2, as published by the Free Software Foundation, and
* may be copied, distributed, and modified under those terms.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License version 2 for more details.
*
*/
#ifndef ___PADMUX_H
#define ___PADMUX_H

#define PINMUX_FOR_GPIO_MODE                    0x00

#define PINMUX_FOR_EJ_MODE_1                    0x01
#define PINMUX_FOR_EJ_MODE_2                    0x02
#define PINMUX_FOR_EJ_MODE_3                    0x03
#define PINMUX_FOR_DLA_EJ_MODE_1                0x04
#define PINMUX_FOR_DLA_EJ_MODE_2                0x05
#define PINMUX_FOR_DLA_EJ_MODE_3                0x06
#define PINMUX_FOR_TEST_IN_MODE_1               0x07
#define PINMUX_FOR_TEST_IN_MODE_2               0x08
#define PINMUX_FOR_TEST_IN_MODE_3               0x09
#define PINMUX_FOR_TEST_OUT_MODE_1              0x0a
#define PINMUX_FOR_TEST_OUT_MODE_2              0x0b
#define PINMUX_FOR_TEST_OUT_MODE_3              0x0c
#define PINMUX_FOR_SPI_MODE                     0x0d
#define PINMUX_FOR_SPIWPN_MODE                  0x0e
#define PINMUX_FOR_SPIHOLDN_MODE                0x0f
#define PINMUX_FOR_SPICSZ1_MODE                 0x10
#define PINMUX_FOR_SPICSZ2_MODE                 0x11
#define PINMUX_FOR_I2C0_MODE_1                  0x12
#define PINMUX_FOR_I2C0_MODE_2                  0x13
#define PINMUX_FOR_I2C0_MODE_3                  0x14
#define PINMUX_FOR_I2C0_MODE_4                  0x15
#define PINMUX_FOR_I2C0_MODE_5                  0x16
#define PINMUX_FOR_I2C1_MODE_1                  0x17
#define PINMUX_FOR_I2C1_MODE_2                  0x18
#define PINMUX_FOR_I2C1_MODE_3                  0x19
#define PINMUX_FOR_I2C2_MODE_1                  0x1a
#define PINMUX_FOR_I2C2_MODE_2                  0x1b
#define PINMUX_FOR_I2C2_MODE_3                  0x1c
#define PINMUX_FOR_I2C2_MODE_4                  0x1d
#define PINMUX_FOR_I2C2_MODE_5                  0x1e
#define PINMUX_FOR_SPI0_MODE_1                  0x1f
#define PINMUX_FOR_SPI0_MODE_2                  0x20
#define PINMUX_FOR_SPI0_MODE_3                  0x21
#define PINMUX_FOR_SPI0_MODE_4                  0x22
#define PINMUX_FOR_SPI1_MODE_1                  0x23
#define PINMUX_FOR_SPI1_MODE_2                  0x24
#define PINMUX_FOR_SPI1_MODE_3                  0x25
#define PINMUX_FOR_SPI1_MODE_4                  0x26
#define PINMUX_FOR_SPI1_MODE_5                  0x27
#define PINMUX_FOR_FUART_MODE_1                 0x28
#define PINMUX_FOR_FUART_MODE_2                 0x29
#define PINMUX_FOR_FUART_MODE_3                 0x2a
#define PINMUX_FOR_FUART_MODE_4                 0x2b
#define PINMUX_FOR_FUART_MODE_5                 0x2c
#define PINMUX_FOR_FUART_MODE_6                 0x2d
#define PINMUX_FOR_FUART_MODE_7                 0x2e
#define PINMUX_FOR_UART0_MODE_1                 0x2f
#define PINMUX_FOR_UART0_MODE_2                 0x30
#define PINMUX_FOR_UART0_MODE_3                 0x31
#define PINMUX_FOR_UART0_MODE_4                 0x32
#define PINMUX_FOR_UART1_MODE_1                 0x33
#define PINMUX_FOR_UART1_MODE_2                 0x34
#define PINMUX_FOR_UART1_MODE_3                 0x35
#define PINMUX_FOR_UART1_MODE_4                 0x36
#define PINMUX_FOR_UART1_MODE_5                 0x37
#define PINMUX_FOR_UART1_MODE_6                 0x38
#define PINMUX_FOR_SD0_MODE                     0x39
#define PINMUX_FOR_SD0_CDZ_MODE                 0x3a
#define PINMUX_FOR_SD1_MODE_1                   0x3b
#define PINMUX_FOR_SD1_MODE_2                   0x3c
#define PINMUX_FOR_SD1_CDZ_MODE_1               0x3d
#define PINMUX_FOR_SD1_CDZ_MODE_2               0x3e
#define PINMUX_FOR_EMMC0_8B_MODE_1              0x3f
#define PINMUX_FOR_EMMC0_8B_MODE_2              0x40
#define PINMUX_FOR_EMMC0_4B_MODE                0x41
#define PINMUX_FOR_EMMC1_4B_MODE_1              0x42
#define PINMUX_FOR_EMMC1_4B_MODE_2              0x43
#define PINMUX_FOR_EMMC0_RST_MODE               0x44
#define PINMUX_FOR_EMMC1_RST_MODE_1             0x45
#define PINMUX_FOR_EMMC1_RST_MODE_2             0x46
#define PINMUX_FOR_PWM0_MODE_1                  0x47
#define PINMUX_FOR_PWM0_MODE_2                  0x48
#define PINMUX_FOR_PWM0_MODE_3                  0x49
#define PINMUX_FOR_PWM0_MODE_4                  0x4a
#define PINMUX_FOR_PWM0_MODE_5                  0x4b
#define PINMUX_FOR_PWM0_MODE_6                  0x4c
#define PINMUX_FOR_PWM1_MODE_1                  0x4d
#define PINMUX_FOR_PWM1_MODE_2                  0x4e
#define PINMUX_FOR_PWM1_MODE_3                  0x4f
#define PINMUX_FOR_PWM1_MODE_4                  0x50
#define PINMUX_FOR_PWM1_MODE_5                  0x51
#define PINMUX_FOR_PWM1_MODE_6                  0x52
#define PINMUX_FOR_PWM2_MODE_1                  0x53
#define PINMUX_FOR_PWM2_MODE_2                  0x54
#define PINMUX_FOR_PWM2_MODE_3                  0x55
#define PINMUX_FOR_PWM2_MODE_4                  0x56
#define PINMUX_FOR_PWM2_MODE_5                  0x57
#define PINMUX_FOR_PWM2_MODE_6                  0x58
#define PINMUX_FOR_PWM3_MODE_1                  0x59
#define PINMUX_FOR_PWM3_MODE_2                  0x5a
#define PINMUX_FOR_PWM3_MODE_3                  0x5b
#define PINMUX_FOR_PWM3_MODE_4                  0x5c
#define PINMUX_FOR_PWM3_MODE_5                  0x5d
#define PINMUX_FOR_PWM3_MODE_6                  0x5e
#define PINMUX_FOR_PWM4_MODE_1                  0x5f
#define PINMUX_FOR_PWM4_MODE_2                  0x60
#define PINMUX_FOR_PWM4_MODE_3                  0x61
#define PINMUX_FOR_PWM4_MODE_4                  0x62
#define PINMUX_FOR_PWM4_MODE_5                  0x63
#define PINMUX_FOR_PWM4_MODE_6                  0x64
#define PINMUX_FOR_PWM5_MODE_1                  0x65
#define PINMUX_FOR_PWM5_MODE_2                  0x66
#define PINMUX_FOR_PWM5_MODE_3                  0x67
#define PINMUX_FOR_PWM5_MODE_4                  0x68
#define PINMUX_FOR_PWM5_MODE_5                  0x69
#define PINMUX_FOR_PWM5_MODE_6                  0x6a
#define PINMUX_FOR_PWM6_MODE_1                  0x6b
#define PINMUX_FOR_PWM6_MODE_2                  0x6c
#define PINMUX_FOR_PWM6_MODE_3                  0x6d
#define PINMUX_FOR_PWM6_MODE_4                  0x6e
#define PINMUX_FOR_PWM6_MODE_5                  0x6f
#define PINMUX_FOR_PWM6_MODE_6                  0x70
#define PINMUX_FOR_PWM7_MODE_1                  0x71
#define PINMUX_FOR_PWM7_MODE_2                  0x72
#define PINMUX_FOR_PWM7_MODE_3                  0x73
#define PINMUX_FOR_PWM7_MODE_4                  0x74
#define PINMUX_FOR_PWM7_MODE_5                  0x75
#define PINMUX_FOR_PWM7_MODE_6                  0x76
#define PINMUX_FOR_PWM8_MODE_1                  0x77
#define PINMUX_FOR_PWM8_MODE_2                  0x78
#define PINMUX_FOR_PWM8_MODE_3                  0x79
#define PINMUX_FOR_PWM8_MODE_4                  0x7a
#define PINMUX_FOR_PWM8_MODE_5                  0x7b
#define PINMUX_FOR_PWM8_MODE_6                  0x7c
#define PINMUX_FOR_PWM8_MODE_7                  0x7d
#define PINMUX_FOR_PWM8_MODE_8                  0x7e
#define PINMUX_FOR_PWM9_MODE_1                  0x7f
#define PINMUX_FOR_PWM9_MODE_2                  0x80
#define PINMUX_FOR_PWM9_MODE_3                  0x81
#define PINMUX_FOR_PWM9_MODE_4                  0x82
#define PINMUX_FOR_PWM9_MODE_5                  0x83
#define PINMUX_FOR_PWM9_MODE_6                  0x84
#define PINMUX_FOR_PWM9_MODE_7                  0x85
#define PINMUX_FOR_PWM9_MODE_8                  0x86
#define PINMUX_FOR_ETH_MODE                     0x87
#define PINMUX_FOR_LED0_MODE_1                  0x88
#define PINMUX_FOR_LED0_MODE_2                  0x89
#define PINMUX_FOR_LED0_MODE_3                  0x8a
#define PINMUX_FOR_LED0_MODE_4                  0x8b
#define PINMUX_FOR_LED1_MODE_1                  0x8c
#define PINMUX_FOR_LED1_MODE_2                  0x8d
#define PINMUX_FOR_LED1_MODE_3                  0x8e
#define PINMUX_FOR_LED1_MODE_4                  0x8f
#define PINMUX_FOR_I2S_MCK_MODE_1               0x90
#define PINMUX_FOR_I2S_MCK_MODE_2               0x91
#define PINMUX_FOR_I2S_MCK_MODE_3               0x92
#define PINMUX_FOR_I2S_MCK_MODE_4               0x93
#define PINMUX_FOR_I2S_RX_MODE_1                0x94
#define PINMUX_FOR_I2S_RX_MODE_2                0x95
#define PINMUX_FOR_I2S_RX_MODE_3                0x96
#define PINMUX_FOR_I2S_RX_MODE_4                0x97
#define PINMUX_FOR_I2S_TX_MODE_1                0x98
#define PINMUX_FOR_I2S_TX_MODE_2                0x99
#define PINMUX_FOR_I2S_TX_MODE_3                0x9a
#define PINMUX_FOR_I2S_TX_MODE_4                0x9b
#define PINMUX_FOR_I2S_TX_MODE_5                0x9c
#define PINMUX_FOR_I2S_TX_MODE_6                0x9d
#define PINMUX_FOR_I2S_TX_MODE_7                0x9e
#define PINMUX_FOR_I2S_RXTX_MODE_1              0x9f
#define PINMUX_FOR_I2S_RXTX_MODE_2              0xa0
#define PINMUX_FOR_I2S_RXTX_MODE_3              0xa1
#define PINMUX_FOR_I2S_RXTX_MODE_4              0xa2
#define PINMUX_FOR_I2S_RXTX_MODE_5              0xa3
#define PINMUX_FOR_I2S_RXTX_MODE_6              0xa4
#define PINMUX_FOR_DMIC_MODE_1                  0xa5
#define PINMUX_FOR_DMIC_MODE_2                  0xa6
#define PINMUX_FOR_DMIC_MODE_3                  0xa7
#define PINMUX_FOR_DMIC_MODE_4                  0xa8
#define PINMUX_FOR_DMIC_MODE_5                  0xa9
#define PINMUX_FOR_DMIC_MODE_6                  0xaa
#define PINMUX_FOR_DMIC_MODE_7                  0xab
#define PINMUX_FOR_DMIC_MODE_8                  0xac
#define PINMUX_FOR_SR00_MIPI_MODE_1             0xad
#define PINMUX_FOR_SR00_MIPI_MODE_2             0xae
#define PINMUX_FOR_SR00_MIPI_MODE_3             0xaf
#define PINMUX_FOR_SR00_MIPI_MODE_4             0xb0
#define PINMUX_FOR_SR00_CTRL_MODE               0xb1
#define PINMUX_FOR_SR00_MCLK_MODE               0xb2
#define PINMUX_FOR_SR00_RST_MODE                0xb3
#define PINMUX_FOR_SR00_PDN_MODE_1              0xb4
#define PINMUX_FOR_SR00_PDN_MODE_2              0xb5
#define PINMUX_FOR_SR01_MIPI_MODE               0xb6
#define PINMUX_FOR_SR01_CTRL_MODE               0xb7
#define PINMUX_FOR_SR01_MCLK_MODE               0xb8
#define PINMUX_FOR_SR01_RST_MODE_1              0xb9
#define PINMUX_FOR_SR01_RST_MODE_2              0xba
#define PINMUX_FOR_SR0_BT601_MODE_1             0xbb
#define PINMUX_FOR_SR0_BT601_MODE_2             0xbc
#define PINMUX_FOR_SR0_BT656_MODE_1             0xbd
#define PINMUX_FOR_SR0_BT656_MODE_2             0xbe
#define PINMUX_FOR_SR0_BT656_MODE_3             0xbf
#define PINMUX_FOR_SR1_MIPI_MODE_1              0xc0
#define PINMUX_FOR_SR1_MIPI_MODE_2              0xc1
#define PINMUX_FOR_SR1_MIPI_MODE_3              0xc2
#define PINMUX_FOR_SR1_MIPI_MODE_4              0xc3
#define PINMUX_FOR_SR1_MIPI_MODE_5              0xc4
#define PINMUX_FOR_SR1_CTRL_MODE                0xc5
#define PINMUX_FOR_SR1_MCLK_MODE_1              0xc6
#define PINMUX_FOR_SR1_MCLK_MODE_2              0xc7
#define PINMUX_FOR_SR1_RST_MODE_1               0xc8
#define PINMUX_FOR_SR1_RST_MODE_2               0xc9
#define PINMUX_FOR_SR1_BT601_MODE               0xca
#define PINMUX_FOR_SR1_BT656_MODE               0xcb
#define PINMUX_FOR_MIPI_TX_MODE_1               0xcc
#define PINMUX_FOR_MIPI_TX_MODE_2               0xcd
#define PINMUX_FOR_MIPI_TX_MODE_3               0xce
#define PINMUX_FOR_MIPI_TX_MODE_4               0xcf
#define PINMUX_FOR_TTL24_MODE                   0xd0
#define PINMUX_FOR_TTL16_MODE_1                 0xd1
#define PINMUX_FOR_TTL16_MODE_2                 0xd2
#define PINMUX_FOR_TTL16_MODE_3                 0xd3
#define PINMUX_FOR_TTL16_MODE_4                 0xd4
#define PINMUX_FOR_BT656_OUT_MODE_1             0xd5
#define PINMUX_FOR_BT656_OUT_MODE_2             0xd6
#define PINMUX_FOR_BT656_OUT_MODE_3             0xd7
#define PINMUX_FOR_OTP_TEST                     0xd8

#define PINMUX_FOR_PM_SPI_MODE                  0xd9
#define PINMUX_FOR_PM_SPIWPN_MODE               0xda
#define PINMUX_FOR_PM_SPIHOLDN_MODE             0xdb
#define PINMUX_FOR_PM_SPICSZ1_MODE              0xdc
#define PINMUX_FOR_PM_SPICSZ2_MODE              0xdd
#define PINMUX_FOR_PM_VID_MODE_1                0xde
#define PINMUX_FOR_PM_VID_MODE_2                0xdf
#define PINMUX_FOR_PM_PIR_SERIN_MODE_1          0xe0
#define PINMUX_FOR_PM_PIR_SERIN_MODE_2          0xe1
#define PINMUX_FOR_PM_PIR_DIR_LINK_MODE_1       0xe2
#define PINMUX_FOR_PM_PIR_DIR_LINK_MODE_2       0xe3
#define PINMUX_FOR_PM_I2CM_MODE_1               0xe4
#define PINMUX_FOR_PM_I2CM_MODE_2               0xe5
#define PINMUX_FOR_PM_PWM0_MODE_1               0xe6
#define PINMUX_FOR_PM_PWM0_MODE_2               0xe7
#define PINMUX_FOR_PM_UART1_MODE_1              0xe8
#define PINMUX_FOR_PM_UART1_MODE_2              0xe9
#define PINMUX_FOR_PM_PM51_UART_MODE_1          0xea
#define PINMUX_FOR_PM_PM51_UART_MODE_2          0xeb
#define PINMUX_FOR_PM_PM51_UART_MODE_3          0xec
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_0         0xed
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_1         0xee
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_2         0xef
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_3         0xf0
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_4         0xf1
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_5         0xf2
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_6         0xf3
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_7         0xf4
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_8         0xf5
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_9         0xf6
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_10        0xf7
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_11        0xf8
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_12        0xf9
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_13        0xfa
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_14        0xfb
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_15        0xfc
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_16        0xfd
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_17        0xfe
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_18        0xff
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_19        0x100
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_20        0x101
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_21        0x102
#define PINMUX_FOR_PM_PM_PAD_EXT_MODE_22        0x103
#define PINMUX_FOR_PM_PM_UART_IS_MODE           0x104
#define PINMUX_FOR_PM_SAR_MODE                  0x105


// add manually for misc pads here
#define PINMUX_FOR_USB_MODE                     0x106



#define PINMUX_FOR_UNKNOWN_MODE         0xFF

#endif // ___PADMUX_H
