/*
 * arch/arm/mach-dvf/include/mach/factory.h
 *
 * factory data support
 *
 * (c) 2013 Grandstream Networks, Inc.
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
 *
 */

#ifndef __ASM_ARCH_DVF_FACTORY_H
#define __ASM_ARCH_DVF_FACTORY_H

// #define CONFIG_GRP26XX

#include <provision.h>

typedef enum {
	GS_LAN_MAC_ID = 0,
	GS_WIFI_MAC_ID,
	GS_BT_MAC_ID,
	GS_MAX_ID,
} gs_mac_id;


unsigned int get_pfact(void);
uint16_t fact_para_checksum(GS_FACTORYPARA* fact_para);
GS_FACTORYPARA* fact_para_get(void);
hw_info_t* hw_get_hw_feature(void);
int ate_mode(void);
void enter_ate_mode(void);
int gs_factory_mac_get(u32 id, void *pbuv, u32 size);

#endif /* __ASM_ARCH_DVF_FACTORY_H */
