/*
* hal_disp_reg.h- Sigmastar
*
* Copyright (c) [2019~2020] SigmaStar Technology.
*
*
* This software is licensed under the terms of the GNU General Public
* License version 2, as published by the Free Software Foundation, and
* may be copied, distributed, and modified under those terms.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License version 2 for more details.
*
*/

#ifndef __HAL_DISP_REG_H__
#define __HAL_DISP_REG_H__

#define REG_CHIPTOP_BASE            0x101E00UL
#define REG_LPLL_BASE               0x103300UL
#define REG_CLKGEN_BASE             0x103800UL

//#define REG_HDMITX_DTOP_BASE        0x145900UL
//#define REG_HDMITX_ATOP_BASE        0x145A00UL
//#define REG_DISP_DAC_BASE           0x145B00UL
#define REG_SC_GP_CTRL_BASE            0x113300UL
//#define REG_DISP_GP_CTRL_BASE       0x113700UL

#define REG_DISP_TOP_0_BASE         0x112800UL
#define REG_DISP_TOP_OP2_0_BASE     0x112900UL
#define REG_DISP_TOP_MACE_BASE      0x112A00UL
#define REG_DISP_TOP_GAMMA_0_BASE   0x112B00UL
#define REG_LCD_BASE                0x112C00UL

//#define REG_DISP_TOP_1_BASE         0x116000UL
//#define REG_DISP_TOP_OP2_1_BASE     0x116100UL
//#define REG_DISP_TOP_GAMMA_1_BASE   0x116300UL

//#define REG_DISP_MOPG_BK00_BASE     0x117000UL
//#define REG_DISP_MOPG_BK01_BASE     0x117100UL
//#define REG_DISP_MOPG_BK02_BASE     0x117200UL
#define REG_DISP_MOPS_BK0_BASE      0x140800UL
//#define REG_DISP_MOP_ROT_BK0_BASE   0x117400UL
#define REG_DISP_MOPS_HVSP_BASE     0x140E00UL

//#define REG_DISP_MOPG_BK10_BASE     0x117500UL
//#define REG_DISP_MOPG_BK11_BASE     0x117600UL
//#define REG_DISP_MOPG_BK12_BASE     0x117700UL
//#define REG_DISP_MOPS_BK1_BASE      0x117800UL
//#define REG_DISP_MOP_ROT_BK1_BASE   0x117900UL

#define REG_LCD_MISC_BASE           0x112D00UL
//#define REG_DISP_DMA_BASE           0x115800UL

#define REG_EFUSE_BASE              0x002000UL

//-------------------------------------------------------------------------------------

//-------------------------------------------------------------------------------------
#define REG_CHIPTOP_00_L     (REG_CHIPTOP_BASE + 0x00)
#define REG_CHIPTOP_00_H     (REG_CHIPTOP_BASE + 0x01)
#define REG_CHIPTOP_01_L     (REG_CHIPTOP_BASE + 0x02)
#define REG_CHIPTOP_01_H     (REG_CHIPTOP_BASE + 0x03)
#define REG_CHIPTOP_02_L     (REG_CHIPTOP_BASE + 0x04)
#define REG_CHIPTOP_02_H     (REG_CHIPTOP_BASE + 0x05)
#define REG_CHIPTOP_03_L     (REG_CHIPTOP_BASE + 0x06)
#define REG_CHIPTOP_03_H     (REG_CHIPTOP_BASE + 0x07)
#define REG_CHIPTOP_04_L     (REG_CHIPTOP_BASE + 0x08)
#define REG_CHIPTOP_04_H     (REG_CHIPTOP_BASE + 0x09)
#define REG_CHIPTOP_05_L     (REG_CHIPTOP_BASE + 0x0A)
#define REG_CHIPTOP_05_H     (REG_CHIPTOP_BASE + 0x0B)
#define REG_CHIPTOP_06_L     (REG_CHIPTOP_BASE + 0x0C)
#define REG_CHIPTOP_06_H     (REG_CHIPTOP_BASE + 0x0D)
#define REG_CHIPTOP_07_L     (REG_CHIPTOP_BASE + 0x0E)
#define REG_CHIPTOP_07_H     (REG_CHIPTOP_BASE + 0x0F)
#define REG_CHIPTOP_08_L     (REG_CHIPTOP_BASE + 0x10)
#define REG_CHIPTOP_08_H     (REG_CHIPTOP_BASE + 0x11)
#define REG_CHIPTOP_09_L     (REG_CHIPTOP_BASE + 0x12)
#define REG_CHIPTOP_09_H     (REG_CHIPTOP_BASE + 0x13)
#define REG_CHIPTOP_0A_L     (REG_CHIPTOP_BASE + 0x14)
#define REG_CHIPTOP_0A_H     (REG_CHIPTOP_BASE + 0x15)
#define REG_CHIPTOP_0B_L     (REG_CHIPTOP_BASE + 0x16)
#define REG_CHIPTOP_0B_H     (REG_CHIPTOP_BASE + 0x17)
#define REG_CHIPTOP_0C_L     (REG_CHIPTOP_BASE + 0x18)
#define REG_CHIPTOP_0C_H     (REG_CHIPTOP_BASE + 0x19)
#define REG_CHIPTOP_0D_L     (REG_CHIPTOP_BASE + 0x1A)
#define REG_CHIPTOP_0D_H     (REG_CHIPTOP_BASE + 0x1B)
#define REG_CHIPTOP_0E_L     (REG_CHIPTOP_BASE + 0x1C)
#define REG_CHIPTOP_0E_H     (REG_CHIPTOP_BASE + 0x1D)
#define REG_CHIPTOP_0F_L     (REG_CHIPTOP_BASE + 0x1E)
#define REG_CHIPTOP_0F_H     (REG_CHIPTOP_BASE + 0x1F)
#define REG_CHIPTOP_10_L     (REG_CHIPTOP_BASE + 0x20)
#define REG_CHIPTOP_10_H     (REG_CHIPTOP_BASE + 0x21)
#define REG_CHIPTOP_11_L     (REG_CHIPTOP_BASE + 0x22)
#define REG_CHIPTOP_11_H     (REG_CHIPTOP_BASE + 0x23)
#define REG_CHIPTOP_12_L     (REG_CHIPTOP_BASE + 0x24)
#define REG_CHIPTOP_12_H     (REG_CHIPTOP_BASE + 0x25)
#define REG_CHIPTOP_13_L     (REG_CHIPTOP_BASE + 0x26)
#define REG_CHIPTOP_13_H     (REG_CHIPTOP_BASE + 0x27)
#define REG_CHIPTOP_14_L     (REG_CHIPTOP_BASE + 0x28)
#define REG_CHIPTOP_14_H     (REG_CHIPTOP_BASE + 0x29)
#define REG_CHIPTOP_15_L     (REG_CHIPTOP_BASE + 0x2A)
#define REG_CHIPTOP_15_H     (REG_CHIPTOP_BASE + 0x2B)
#define REG_CHIPTOP_16_L     (REG_CHIPTOP_BASE + 0x2C)
#define REG_CHIPTOP_16_H     (REG_CHIPTOP_BASE + 0x2D)
#define REG_CHIPTOP_17_L     (REG_CHIPTOP_BASE + 0x2E)
#define REG_CHIPTOP_17_H     (REG_CHIPTOP_BASE + 0x2F)
#define REG_CHIPTOP_18_L     (REG_CHIPTOP_BASE + 0x30)
#define REG_CHIPTOP_18_H     (REG_CHIPTOP_BASE + 0x31)
#define REG_CHIPTOP_19_L     (REG_CHIPTOP_BASE + 0x32)
#define REG_CHIPTOP_19_H     (REG_CHIPTOP_BASE + 0x33)
#define REG_CHIPTOP_1A_L     (REG_CHIPTOP_BASE + 0x34)
#define REG_CHIPTOP_1A_H     (REG_CHIPTOP_BASE + 0x35)
#define REG_CHIPTOP_1B_L     (REG_CHIPTOP_BASE + 0x36)
#define REG_CHIPTOP_1B_H     (REG_CHIPTOP_BASE + 0x37)
#define REG_CHIPTOP_1C_L     (REG_CHIPTOP_BASE + 0x38)
#define REG_CHIPTOP_1C_H     (REG_CHIPTOP_BASE + 0x39)
#define REG_CHIPTOP_1D_L     (REG_CHIPTOP_BASE + 0x3A)
#define REG_CHIPTOP_1D_H     (REG_CHIPTOP_BASE + 0x3B)
#define REG_CHIPTOP_1E_L     (REG_CHIPTOP_BASE + 0x3C)
#define REG_CHIPTOP_1E_H     (REG_CHIPTOP_BASE + 0x3D)
#define REG_CHIPTOP_1F_L     (REG_CHIPTOP_BASE + 0x3E)
#define REG_CHIPTOP_1F_H     (REG_CHIPTOP_BASE + 0x3F)
#define REG_CHIPTOP_20_L     (REG_CHIPTOP_BASE + 0x40)
#define REG_CHIPTOP_20_H     (REG_CHIPTOP_BASE + 0x41)
#define REG_CHIPTOP_21_L     (REG_CHIPTOP_BASE + 0x42)
#define REG_CHIPTOP_21_H     (REG_CHIPTOP_BASE + 0x43)
#define REG_CHIPTOP_22_L     (REG_CHIPTOP_BASE + 0x44)
#define REG_CHIPTOP_22_H     (REG_CHIPTOP_BASE + 0x45)
#define REG_CHIPTOP_23_L     (REG_CHIPTOP_BASE + 0x46)
#define REG_CHIPTOP_23_H     (REG_CHIPTOP_BASE + 0x47)
#define REG_CHIPTOP_24_L     (REG_CHIPTOP_BASE + 0x48)
#define REG_CHIPTOP_24_H     (REG_CHIPTOP_BASE + 0x49)
#define REG_CHIPTOP_25_L     (REG_CHIPTOP_BASE + 0x4A)
#define REG_CHIPTOP_25_H     (REG_CHIPTOP_BASE + 0x4B)
#define REG_CHIPTOP_26_L     (REG_CHIPTOP_BASE + 0x4C)
#define REG_CHIPTOP_26_H     (REG_CHIPTOP_BASE + 0x4D)
#define REG_CHIPTOP_27_L     (REG_CHIPTOP_BASE + 0x4E)
#define REG_CHIPTOP_27_H     (REG_CHIPTOP_BASE + 0x4F)
#define REG_CHIPTOP_28_L     (REG_CHIPTOP_BASE + 0x50)
#define REG_CHIPTOP_28_H     (REG_CHIPTOP_BASE + 0x51)
#define REG_CHIPTOP_29_L     (REG_CHIPTOP_BASE + 0x52)
#define REG_CHIPTOP_29_H     (REG_CHIPTOP_BASE + 0x53)
#define REG_CHIPTOP_2A_L     (REG_CHIPTOP_BASE + 0x54)
#define REG_CHIPTOP_2A_H     (REG_CHIPTOP_BASE + 0x55)
#define REG_CHIPTOP_2B_L     (REG_CHIPTOP_BASE + 0x56)
#define REG_CHIPTOP_2B_H     (REG_CHIPTOP_BASE + 0x57)
#define REG_CHIPTOP_2C_L     (REG_CHIPTOP_BASE + 0x58)
#define REG_CHIPTOP_2C_H     (REG_CHIPTOP_BASE + 0x59)
#define REG_CHIPTOP_2D_L     (REG_CHIPTOP_BASE + 0x5A)
#define REG_CHIPTOP_2D_H     (REG_CHIPTOP_BASE + 0x5B)
#define REG_CHIPTOP_2E_L     (REG_CHIPTOP_BASE + 0x5C)
#define REG_CHIPTOP_2E_H     (REG_CHIPTOP_BASE + 0x5D)
#define REG_CHIPTOP_2F_L     (REG_CHIPTOP_BASE + 0x5E)
#define REG_CHIPTOP_2F_H     (REG_CHIPTOP_BASE + 0x5F)
#define REG_CHIPTOP_30_L     (REG_CHIPTOP_BASE + 0x60)
#define REG_CHIPTOP_30_H     (REG_CHIPTOP_BASE + 0x61)
#define REG_CHIPTOP_31_L     (REG_CHIPTOP_BASE + 0x62)
#define REG_CHIPTOP_31_H     (REG_CHIPTOP_BASE + 0x63)
#define REG_CHIPTOP_32_L     (REG_CHIPTOP_BASE + 0x64)
#define REG_CHIPTOP_32_H     (REG_CHIPTOP_BASE + 0x65)
#define REG_CHIPTOP_33_L     (REG_CHIPTOP_BASE + 0x66)
#define REG_CHIPTOP_33_H     (REG_CHIPTOP_BASE + 0x67)
#define REG_CHIPTOP_34_L     (REG_CHIPTOP_BASE + 0x68)
#define REG_CHIPTOP_34_H     (REG_CHIPTOP_BASE + 0x69)
#define REG_CHIPTOP_35_L     (REG_CHIPTOP_BASE + 0x6A)
#define REG_CHIPTOP_35_H     (REG_CHIPTOP_BASE + 0x6B)
#define REG_CHIPTOP_36_L     (REG_CHIPTOP_BASE + 0x6C)
#define REG_CHIPTOP_36_H     (REG_CHIPTOP_BASE + 0x6D)
#define REG_CHIPTOP_37_L     (REG_CHIPTOP_BASE + 0x6E)
#define REG_CHIPTOP_37_H     (REG_CHIPTOP_BASE + 0x6F)
#define REG_CHIPTOP_38_L     (REG_CHIPTOP_BASE + 0x70)
#define REG_CHIPTOP_38_H     (REG_CHIPTOP_BASE + 0x71)
#define REG_CHIPTOP_39_L     (REG_CHIPTOP_BASE + 0x72)
#define REG_CHIPTOP_39_H     (REG_CHIPTOP_BASE + 0x73)
#define REG_CHIPTOP_3A_L     (REG_CHIPTOP_BASE + 0x74)
#define REG_CHIPTOP_3A_H     (REG_CHIPTOP_BASE + 0x75)
#define REG_CHIPTOP_3B_L     (REG_CHIPTOP_BASE + 0x76)
#define REG_CHIPTOP_3B_H     (REG_CHIPTOP_BASE + 0x77)
#define REG_CHIPTOP_3C_L     (REG_CHIPTOP_BASE + 0x78)
#define REG_CHIPTOP_3C_H     (REG_CHIPTOP_BASE + 0x79)
#define REG_CHIPTOP_3D_L     (REG_CHIPTOP_BASE + 0x7A)
#define REG_CHIPTOP_3D_H     (REG_CHIPTOP_BASE + 0x7B)
#define REG_CHIPTOP_3E_L     (REG_CHIPTOP_BASE + 0x7C)
#define REG_CHIPTOP_3E_H     (REG_CHIPTOP_BASE + 0x7D)
#define REG_CHIPTOP_3F_L     (REG_CHIPTOP_BASE + 0x7E)
#define REG_CHIPTOP_3F_H     (REG_CHIPTOP_BASE + 0x7F)
#define REG_CHIPTOP_40_L     (REG_CHIPTOP_BASE + 0x80)
#define REG_CHIPTOP_40_H     (REG_CHIPTOP_BASE + 0x81)
#define REG_CHIPTOP_41_L     (REG_CHIPTOP_BASE + 0x82)
#define REG_CHIPTOP_41_H     (REG_CHIPTOP_BASE + 0x83)
#define REG_CHIPTOP_42_L     (REG_CHIPTOP_BASE + 0x84)
#define REG_CHIPTOP_42_H     (REG_CHIPTOP_BASE + 0x85)
#define REG_CHIPTOP_43_L     (REG_CHIPTOP_BASE + 0x86)
#define REG_CHIPTOP_43_H     (REG_CHIPTOP_BASE + 0x87)
#define REG_CHIPTOP_44_L     (REG_CHIPTOP_BASE + 0x88)
#define REG_CHIPTOP_44_H     (REG_CHIPTOP_BASE + 0x89)
#define REG_CHIPTOP_45_L     (REG_CHIPTOP_BASE + 0x8A)
#define REG_CHIPTOP_45_H     (REG_CHIPTOP_BASE + 0x8B)
#define REG_CHIPTOP_46_L     (REG_CHIPTOP_BASE + 0x8C)
#define REG_CHIPTOP_46_H     (REG_CHIPTOP_BASE + 0x8D)
#define REG_CHIPTOP_47_L     (REG_CHIPTOP_BASE + 0x8E)
#define REG_CHIPTOP_47_H     (REG_CHIPTOP_BASE + 0x8F)
#define REG_CHIPTOP_48_L     (REG_CHIPTOP_BASE + 0x90)
#define REG_CHIPTOP_48_H     (REG_CHIPTOP_BASE + 0x91)
#define REG_CHIPTOP_49_L     (REG_CHIPTOP_BASE + 0x92)
#define REG_CHIPTOP_49_H     (REG_CHIPTOP_BASE + 0x93)
#define REG_CHIPTOP_4A_L     (REG_CHIPTOP_BASE + 0x94)
#define REG_CHIPTOP_4A_H     (REG_CHIPTOP_BASE + 0x95)
#define REG_CHIPTOP_4B_L     (REG_CHIPTOP_BASE + 0x96)
#define REG_CHIPTOP_4B_H     (REG_CHIPTOP_BASE + 0x97)
#define REG_CHIPTOP_4C_L     (REG_CHIPTOP_BASE + 0x98)
#define REG_CHIPTOP_4C_H     (REG_CHIPTOP_BASE + 0x99)
#define REG_CHIPTOP_4D_L     (REG_CHIPTOP_BASE + 0x9A)
#define REG_CHIPTOP_4D_H     (REG_CHIPTOP_BASE + 0x9B)
#define REG_CHIPTOP_4E_L     (REG_CHIPTOP_BASE + 0x9C)
#define REG_CHIPTOP_4E_H     (REG_CHIPTOP_BASE + 0x9D)
#define REG_CHIPTOP_4F_L     (REG_CHIPTOP_BASE + 0x9E)
#define REG_CHIPTOP_4F_H     (REG_CHIPTOP_BASE + 0x9F)
#define REG_CHIPTOP_50_L     (REG_CHIPTOP_BASE + 0xA0)
#define REG_CHIPTOP_50_H     (REG_CHIPTOP_BASE + 0xA1)
#define REG_CHIPTOP_51_L     (REG_CHIPTOP_BASE + 0xA2)
#define REG_CHIPTOP_51_H     (REG_CHIPTOP_BASE + 0xA3)
#define REG_CHIPTOP_52_L     (REG_CHIPTOP_BASE + 0xA4)
#define REG_CHIPTOP_52_H     (REG_CHIPTOP_BASE + 0xA5)
#define REG_CHIPTOP_53_L     (REG_CHIPTOP_BASE + 0xA6)
#define REG_CHIPTOP_53_H     (REG_CHIPTOP_BASE + 0xA7)
#define REG_CHIPTOP_54_L     (REG_CHIPTOP_BASE + 0xA8)
#define REG_CHIPTOP_54_H     (REG_CHIPTOP_BASE + 0xA9)
#define REG_CHIPTOP_55_L     (REG_CHIPTOP_BASE + 0xAA)
#define REG_CHIPTOP_55_H     (REG_CHIPTOP_BASE + 0xAB)
#define REG_CHIPTOP_56_L     (REG_CHIPTOP_BASE + 0xAC)
#define REG_CHIPTOP_56_H     (REG_CHIPTOP_BASE + 0xAD)
#define REG_CHIPTOP_57_L     (REG_CHIPTOP_BASE + 0xAE)
#define REG_CHIPTOP_57_H     (REG_CHIPTOP_BASE + 0xAF)
#define REG_CHIPTOP_58_L     (REG_CHIPTOP_BASE + 0xB0)
#define REG_CHIPTOP_58_H     (REG_CHIPTOP_BASE + 0xB1)
#define REG_CHIPTOP_59_L     (REG_CHIPTOP_BASE + 0xB2)
#define REG_CHIPTOP_59_H     (REG_CHIPTOP_BASE + 0xB3)
#define REG_CHIPTOP_5A_L     (REG_CHIPTOP_BASE + 0xB4)
#define REG_CHIPTOP_5A_H     (REG_CHIPTOP_BASE + 0xB5)
#define REG_CHIPTOP_5B_L     (REG_CHIPTOP_BASE + 0xB6)
#define REG_CHIPTOP_5B_H     (REG_CHIPTOP_BASE + 0xB7)
#define REG_CHIPTOP_5C_L     (REG_CHIPTOP_BASE + 0xB8)
#define REG_CHIPTOP_5C_H     (REG_CHIPTOP_BASE + 0xB9)
#define REG_CHIPTOP_5D_L     (REG_CHIPTOP_BASE + 0xBA)
#define REG_CHIPTOP_5D_H     (REG_CHIPTOP_BASE + 0xBB)
#define REG_CHIPTOP_5E_L     (REG_CHIPTOP_BASE + 0xBC)
#define REG_CHIPTOP_5E_H     (REG_CHIPTOP_BASE + 0xBD)
#define REG_CHIPTOP_5F_L     (REG_CHIPTOP_BASE + 0xBE)
#define REG_CHIPTOP_5F_H     (REG_CHIPTOP_BASE + 0xBF)
#define REG_CHIPTOP_60_L     (REG_CHIPTOP_BASE + 0xC0)
#define REG_CHIPTOP_60_H     (REG_CHIPTOP_BASE + 0xC1)
#define REG_CHIPTOP_61_L     (REG_CHIPTOP_BASE + 0xC2)
#define REG_CHIPTOP_61_H     (REG_CHIPTOP_BASE + 0xC3)
#define REG_CHIPTOP_62_L     (REG_CHIPTOP_BASE + 0xC4)
#define REG_CHIPTOP_62_H     (REG_CHIPTOP_BASE + 0xC5)
#define REG_CHIPTOP_63_L     (REG_CHIPTOP_BASE + 0xC6)
#define REG_CHIPTOP_63_H     (REG_CHIPTOP_BASE + 0xC7)
#define REG_CHIPTOP_64_L     (REG_CHIPTOP_BASE + 0xC8)
#define REG_CHIPTOP_64_H     (REG_CHIPTOP_BASE + 0xC9)
#define REG_CHIPTOP_65_L     (REG_CHIPTOP_BASE + 0xCA)
#define REG_CHIPTOP_65_H     (REG_CHIPTOP_BASE + 0xCB)
#define REG_CHIPTOP_66_L     (REG_CHIPTOP_BASE + 0xCC)
#define REG_CHIPTOP_66_H     (REG_CHIPTOP_BASE + 0xCD)
#define REG_CHIPTOP_67_L     (REG_CHIPTOP_BASE + 0xCE)
#define REG_CHIPTOP_67_H     (REG_CHIPTOP_BASE + 0xCF)
#define REG_CHIPTOP_68_L     (REG_CHIPTOP_BASE + 0xD0)
#define REG_CHIPTOP_68_H     (REG_CHIPTOP_BASE + 0xD1)
#define REG_CHIPTOP_69_L     (REG_CHIPTOP_BASE + 0xD2)
#define REG_CHIPTOP_69_H     (REG_CHIPTOP_BASE + 0xD3)
#define REG_CHIPTOP_6A_L     (REG_CHIPTOP_BASE + 0xD4)
#define REG_CHIPTOP_6A_H     (REG_CHIPTOP_BASE + 0xD5)
#define REG_CHIPTOP_6B_L     (REG_CHIPTOP_BASE + 0xD6)
#define REG_CHIPTOP_6B_H     (REG_CHIPTOP_BASE + 0xD7)
#define REG_CHIPTOP_6C_L     (REG_CHIPTOP_BASE + 0xD8)
#define REG_CHIPTOP_6C_H     (REG_CHIPTOP_BASE + 0xD9)
#define REG_CHIPTOP_6D_L     (REG_CHIPTOP_BASE + 0xDA)
#define REG_CHIPTOP_6D_H     (REG_CHIPTOP_BASE + 0xDB)
#define REG_CHIPTOP_6E_L     (REG_CHIPTOP_BASE + 0xDC)
#define REG_CHIPTOP_6E_H     (REG_CHIPTOP_BASE + 0xDD)
#define REG_CHIPTOP_6F_L     (REG_CHIPTOP_BASE + 0xDE)
#define REG_CHIPTOP_6F_H     (REG_CHIPTOP_BASE + 0xDF)
#define REG_CHIPTOP_70_L     (REG_CHIPTOP_BASE + 0xE0)
#define REG_CHIPTOP_70_H     (REG_CHIPTOP_BASE + 0xE1)
#define REG_CHIPTOP_71_L     (REG_CHIPTOP_BASE + 0xE2)
#define REG_CHIPTOP_71_H     (REG_CHIPTOP_BASE + 0xE3)
#define REG_CHIPTOP_72_L     (REG_CHIPTOP_BASE + 0xE4)
#define REG_CHIPTOP_72_H     (REG_CHIPTOP_BASE + 0xE5)
#define REG_CHIPTOP_73_L     (REG_CHIPTOP_BASE + 0xE6)
#define REG_CHIPTOP_73_H     (REG_CHIPTOP_BASE + 0xE7)
#define REG_CHIPTOP_74_L     (REG_CHIPTOP_BASE + 0xE8)
#define REG_CHIPTOP_74_H     (REG_CHIPTOP_BASE + 0xE9)
#define REG_CHIPTOP_75_L     (REG_CHIPTOP_BASE + 0xEA)
#define REG_CHIPTOP_75_H     (REG_CHIPTOP_BASE + 0xEB)
#define REG_CHIPTOP_76_L     (REG_CHIPTOP_BASE + 0xEC)
#define REG_CHIPTOP_76_H     (REG_CHIPTOP_BASE + 0xED)
#define REG_CHIPTOP_77_L     (REG_CHIPTOP_BASE + 0xEE)
#define REG_CHIPTOP_77_H     (REG_CHIPTOP_BASE + 0xEF)
#define REG_CHIPTOP_78_L     (REG_CHIPTOP_BASE + 0xF0)
#define REG_CHIPTOP_78_H     (REG_CHIPTOP_BASE + 0xF1)
#define REG_CHIPTOP_79_L     (REG_CHIPTOP_BASE + 0xF2)
#define REG_CHIPTOP_79_H     (REG_CHIPTOP_BASE + 0xF3)
#define REG_CHIPTOP_7A_L     (REG_CHIPTOP_BASE + 0xF4)
#define REG_CHIPTOP_7A_H     (REG_CHIPTOP_BASE + 0xF5)
#define REG_CHIPTOP_7B_L     (REG_CHIPTOP_BASE + 0xF6)
#define REG_CHIPTOP_7B_H     (REG_CHIPTOP_BASE + 0xF7)
#define REG_CHIPTOP_7C_L     (REG_CHIPTOP_BASE + 0xF8)
#define REG_CHIPTOP_7C_H     (REG_CHIPTOP_BASE + 0xF9)
#define REG_CHIPTOP_7D_L     (REG_CHIPTOP_BASE + 0xFA)
#define REG_CHIPTOP_7D_H     (REG_CHIPTOP_BASE + 0xFB)
#define REG_CHIPTOP_7E_L     (REG_CHIPTOP_BASE + 0xFC)
#define REG_CHIPTOP_7E_H     (REG_CHIPTOP_BASE + 0xFD)
#define REG_CHIPTOP_7F_L     (REG_CHIPTOP_BASE + 0xFE)
#define REG_CHIPTOP_7F_H     (REG_CHIPTOP_BASE + 0xFF)

#define REG_LPLL_00_L     (REG_LPLL_BASE + 0x00)
#define REG_LPLL_00_H     (REG_LPLL_BASE + 0x01)
#define REG_LPLL_01_L     (REG_LPLL_BASE + 0x02)
#define REG_LPLL_01_H     (REG_LPLL_BASE + 0x03)
#define REG_LPLL_02_L     (REG_LPLL_BASE + 0x04)
#define REG_LPLL_02_H     (REG_LPLL_BASE + 0x05)
#define REG_LPLL_03_L     (REG_LPLL_BASE + 0x06)
#define REG_LPLL_03_H     (REG_LPLL_BASE + 0x07)
#define REG_LPLL_04_L     (REG_LPLL_BASE + 0x08)
#define REG_LPLL_04_H     (REG_LPLL_BASE + 0x09)
#define REG_LPLL_05_L     (REG_LPLL_BASE + 0x0A)
#define REG_LPLL_05_H     (REG_LPLL_BASE + 0x0B)
#define REG_LPLL_06_L     (REG_LPLL_BASE + 0x0C)
#define REG_LPLL_06_H     (REG_LPLL_BASE + 0x0D)
#define REG_LPLL_07_L     (REG_LPLL_BASE + 0x0E)
#define REG_LPLL_07_H     (REG_LPLL_BASE + 0x0F)
#define REG_LPLL_08_L     (REG_LPLL_BASE + 0x10)
#define REG_LPLL_08_H     (REG_LPLL_BASE + 0x11)
#define REG_LPLL_09_L     (REG_LPLL_BASE + 0x12)
#define REG_LPLL_09_H     (REG_LPLL_BASE + 0x13)
#define REG_LPLL_0A_L     (REG_LPLL_BASE + 0x14)
#define REG_LPLL_0A_H     (REG_LPLL_BASE + 0x15)
#define REG_LPLL_0B_L     (REG_LPLL_BASE + 0x16)
#define REG_LPLL_0B_H     (REG_LPLL_BASE + 0x17)
#define REG_LPLL_0C_L     (REG_LPLL_BASE + 0x18)
#define REG_LPLL_0C_H     (REG_LPLL_BASE + 0x19)
#define REG_LPLL_0D_L     (REG_LPLL_BASE + 0x1A)
#define REG_LPLL_0D_H     (REG_LPLL_BASE + 0x1B)
#define REG_LPLL_0E_L     (REG_LPLL_BASE + 0x1C)
#define REG_LPLL_0E_H     (REG_LPLL_BASE + 0x1D)
#define REG_LPLL_0F_L     (REG_LPLL_BASE + 0x1E)
#define REG_LPLL_0F_H     (REG_LPLL_BASE + 0x1F)
#define REG_LPLL_10_L     (REG_LPLL_BASE + 0x20)
#define REG_LPLL_10_H     (REG_LPLL_BASE + 0x21)
#define REG_LPLL_11_L     (REG_LPLL_BASE + 0x22)
#define REG_LPLL_11_H     (REG_LPLL_BASE + 0x23)
#define REG_LPLL_12_L     (REG_LPLL_BASE + 0x24)
#define REG_LPLL_12_H     (REG_LPLL_BASE + 0x25)
#define REG_LPLL_13_L     (REG_LPLL_BASE + 0x26)
#define REG_LPLL_13_H     (REG_LPLL_BASE + 0x27)
#define REG_LPLL_14_L     (REG_LPLL_BASE + 0x28)
#define REG_LPLL_14_H     (REG_LPLL_BASE + 0x29)
#define REG_LPLL_15_L     (REG_LPLL_BASE + 0x2A)
#define REG_LPLL_15_H     (REG_LPLL_BASE + 0x2B)
#define REG_LPLL_16_L     (REG_LPLL_BASE + 0x2C)
#define REG_LPLL_16_H     (REG_LPLL_BASE + 0x2D)
#define REG_LPLL_17_L     (REG_LPLL_BASE + 0x2E)
#define REG_LPLL_17_H     (REG_LPLL_BASE + 0x2F)
#define REG_LPLL_18_L     (REG_LPLL_BASE + 0x30)
#define REG_LPLL_18_H     (REG_LPLL_BASE + 0x31)
#define REG_LPLL_19_L     (REG_LPLL_BASE + 0x32)
#define REG_LPLL_19_H     (REG_LPLL_BASE + 0x33)
#define REG_LPLL_1A_L     (REG_LPLL_BASE + 0x34)
#define REG_LPLL_1A_H     (REG_LPLL_BASE + 0x35)
#define REG_LPLL_1B_L     (REG_LPLL_BASE + 0x36)
#define REG_LPLL_1B_H     (REG_LPLL_BASE + 0x37)
#define REG_LPLL_1C_L     (REG_LPLL_BASE + 0x38)
#define REG_LPLL_1C_H     (REG_LPLL_BASE + 0x39)
#define REG_LPLL_1D_L     (REG_LPLL_BASE + 0x3A)
#define REG_LPLL_1D_H     (REG_LPLL_BASE + 0x3B)
#define REG_LPLL_1E_L     (REG_LPLL_BASE + 0x3C)
#define REG_LPLL_1E_H     (REG_LPLL_BASE + 0x3D)
#define REG_LPLL_1F_L     (REG_LPLL_BASE + 0x3E)
#define REG_LPLL_1F_H     (REG_LPLL_BASE + 0x3F)
#define REG_LPLL_20_L     (REG_LPLL_BASE + 0x40)
#define REG_LPLL_20_H     (REG_LPLL_BASE + 0x41)
#define REG_LPLL_21_L     (REG_LPLL_BASE + 0x42)
#define REG_LPLL_21_H     (REG_LPLL_BASE + 0x43)
#define REG_LPLL_22_L     (REG_LPLL_BASE + 0x44)
#define REG_LPLL_22_H     (REG_LPLL_BASE + 0x45)
#define REG_LPLL_23_L     (REG_LPLL_BASE + 0x46)
#define REG_LPLL_23_H     (REG_LPLL_BASE + 0x47)
#define REG_LPLL_24_L     (REG_LPLL_BASE + 0x48)
#define REG_LPLL_24_H     (REG_LPLL_BASE + 0x49)
#define REG_LPLL_25_L     (REG_LPLL_BASE + 0x4A)
#define REG_LPLL_25_H     (REG_LPLL_BASE + 0x4B)
#define REG_LPLL_26_L     (REG_LPLL_BASE + 0x4C)
#define REG_LPLL_26_H     (REG_LPLL_BASE + 0x4D)
#define REG_LPLL_27_L     (REG_LPLL_BASE + 0x4E)
#define REG_LPLL_27_H     (REG_LPLL_BASE + 0x4F)
#define REG_LPLL_28_L     (REG_LPLL_BASE + 0x50)
#define REG_LPLL_28_H     (REG_LPLL_BASE + 0x51)
#define REG_LPLL_29_L     (REG_LPLL_BASE + 0x52)
#define REG_LPLL_29_H     (REG_LPLL_BASE + 0x53)
#define REG_LPLL_2A_L     (REG_LPLL_BASE + 0x54)
#define REG_LPLL_2A_H     (REG_LPLL_BASE + 0x55)
#define REG_LPLL_2B_L     (REG_LPLL_BASE + 0x56)
#define REG_LPLL_2B_H     (REG_LPLL_BASE + 0x57)
#define REG_LPLL_2C_L     (REG_LPLL_BASE + 0x58)
#define REG_LPLL_2C_H     (REG_LPLL_BASE + 0x59)
#define REG_LPLL_2D_L     (REG_LPLL_BASE + 0x5A)
#define REG_LPLL_2D_H     (REG_LPLL_BASE + 0x5B)
#define REG_LPLL_2E_L     (REG_LPLL_BASE + 0x5C)
#define REG_LPLL_2E_H     (REG_LPLL_BASE + 0x5D)
#define REG_LPLL_2F_L     (REG_LPLL_BASE + 0x5E)
#define REG_LPLL_2F_H     (REG_LPLL_BASE + 0x5F)
#define REG_LPLL_30_L     (REG_LPLL_BASE + 0x60)
#define REG_LPLL_30_H     (REG_LPLL_BASE + 0x61)
#define REG_LPLL_31_L     (REG_LPLL_BASE + 0x62)
#define REG_LPLL_31_H     (REG_LPLL_BASE + 0x63)
#define REG_LPLL_32_L     (REG_LPLL_BASE + 0x64)
#define REG_LPLL_32_H     (REG_LPLL_BASE + 0x65)
#define REG_LPLL_33_L     (REG_LPLL_BASE + 0x66)
#define REG_LPLL_33_H     (REG_LPLL_BASE + 0x67)
#define REG_LPLL_34_L     (REG_LPLL_BASE + 0x68)
#define REG_LPLL_34_H     (REG_LPLL_BASE + 0x69)
#define REG_LPLL_35_L     (REG_LPLL_BASE + 0x6A)
#define REG_LPLL_35_H     (REG_LPLL_BASE + 0x6B)
#define REG_LPLL_36_L     (REG_LPLL_BASE + 0x6C)
#define REG_LPLL_36_H     (REG_LPLL_BASE + 0x6D)
#define REG_LPLL_37_L     (REG_LPLL_BASE + 0x6E)
#define REG_LPLL_37_H     (REG_LPLL_BASE + 0x6F)
#define REG_LPLL_38_L     (REG_LPLL_BASE + 0x70)
#define REG_LPLL_38_H     (REG_LPLL_BASE + 0x71)
#define REG_LPLL_39_L     (REG_LPLL_BASE + 0x72)
#define REG_LPLL_39_H     (REG_LPLL_BASE + 0x73)
#define REG_LPLL_3A_L     (REG_LPLL_BASE + 0x74)
#define REG_LPLL_3A_H     (REG_LPLL_BASE + 0x75)
#define REG_LPLL_3B_L     (REG_LPLL_BASE + 0x76)
#define REG_LPLL_3B_H     (REG_LPLL_BASE + 0x77)
#define REG_LPLL_3C_L     (REG_LPLL_BASE + 0x78)
#define REG_LPLL_3C_H     (REG_LPLL_BASE + 0x79)
#define REG_LPLL_3D_L     (REG_LPLL_BASE + 0x7A)
#define REG_LPLL_3D_H     (REG_LPLL_BASE + 0x7B)
#define REG_LPLL_3E_L     (REG_LPLL_BASE + 0x7C)
#define REG_LPLL_3E_H     (REG_LPLL_BASE + 0x7D)
#define REG_LPLL_3F_L     (REG_LPLL_BASE + 0x7E)
#define REG_LPLL_3F_H     (REG_LPLL_BASE + 0x7F)
#define REG_LPLL_40_L     (REG_LPLL_BASE + 0x80)
#define REG_LPLL_40_H     (REG_LPLL_BASE + 0x81)
#define REG_LPLL_41_L     (REG_LPLL_BASE + 0x82)
#define REG_LPLL_41_H     (REG_LPLL_BASE + 0x83)
#define REG_LPLL_42_L     (REG_LPLL_BASE + 0x84)
#define REG_LPLL_42_H     (REG_LPLL_BASE + 0x85)
#define REG_LPLL_43_L     (REG_LPLL_BASE + 0x86)
#define REG_LPLL_43_H     (REG_LPLL_BASE + 0x87)
#define REG_LPLL_44_L     (REG_LPLL_BASE + 0x88)
#define REG_LPLL_44_H     (REG_LPLL_BASE + 0x89)
#define REG_LPLL_45_L     (REG_LPLL_BASE + 0x8A)
#define REG_LPLL_45_H     (REG_LPLL_BASE + 0x8B)
#define REG_LPLL_46_L     (REG_LPLL_BASE + 0x8C)
#define REG_LPLL_46_H     (REG_LPLL_BASE + 0x8D)
#define REG_LPLL_47_L     (REG_LPLL_BASE + 0x8E)
#define REG_LPLL_47_H     (REG_LPLL_BASE + 0x8F)
#define REG_LPLL_48_L     (REG_LPLL_BASE + 0x90)
#define REG_LPLL_48_H     (REG_LPLL_BASE + 0x91)
#define REG_LPLL_49_L     (REG_LPLL_BASE + 0x92)
#define REG_LPLL_49_H     (REG_LPLL_BASE + 0x93)
#define REG_LPLL_4A_L     (REG_LPLL_BASE + 0x94)
#define REG_LPLL_4A_H     (REG_LPLL_BASE + 0x95)
#define REG_LPLL_4B_L     (REG_LPLL_BASE + 0x96)
#define REG_LPLL_4B_H     (REG_LPLL_BASE + 0x97)
#define REG_LPLL_4C_L     (REG_LPLL_BASE + 0x98)
#define REG_LPLL_4C_H     (REG_LPLL_BASE + 0x99)
#define REG_LPLL_4D_L     (REG_LPLL_BASE + 0x9A)
#define REG_LPLL_4D_H     (REG_LPLL_BASE + 0x9B)
#define REG_LPLL_4E_L     (REG_LPLL_BASE + 0x9C)
#define REG_LPLL_4E_H     (REG_LPLL_BASE + 0x9D)
#define REG_LPLL_4F_L     (REG_LPLL_BASE + 0x9E)
#define REG_LPLL_4F_H     (REG_LPLL_BASE + 0x9F)
#define REG_LPLL_50_L     (REG_LPLL_BASE + 0xA0)
#define REG_LPLL_50_H     (REG_LPLL_BASE + 0xA1)
#define REG_LPLL_51_L     (REG_LPLL_BASE + 0xA2)
#define REG_LPLL_51_H     (REG_LPLL_BASE + 0xA3)
#define REG_LPLL_52_L     (REG_LPLL_BASE + 0xA4)
#define REG_LPLL_52_H     (REG_LPLL_BASE + 0xA5)
#define REG_LPLL_53_L     (REG_LPLL_BASE + 0xA6)
#define REG_LPLL_53_H     (REG_LPLL_BASE + 0xA7)
#define REG_LPLL_54_L     (REG_LPLL_BASE + 0xA8)
#define REG_LPLL_54_H     (REG_LPLL_BASE + 0xA9)
#define REG_LPLL_55_L     (REG_LPLL_BASE + 0xAA)
#define REG_LPLL_55_H     (REG_LPLL_BASE + 0xAB)
#define REG_LPLL_56_L     (REG_LPLL_BASE + 0xAC)
#define REG_LPLL_56_H     (REG_LPLL_BASE + 0xAD)
#define REG_LPLL_57_L     (REG_LPLL_BASE + 0xAE)
#define REG_LPLL_57_H     (REG_LPLL_BASE + 0xAF)
#define REG_LPLL_58_L     (REG_LPLL_BASE + 0xB0)
#define REG_LPLL_58_H     (REG_LPLL_BASE + 0xB1)
#define REG_LPLL_59_L     (REG_LPLL_BASE + 0xB2)
#define REG_LPLL_59_H     (REG_LPLL_BASE + 0xB3)
#define REG_LPLL_5A_L     (REG_LPLL_BASE + 0xB4)
#define REG_LPLL_5A_H     (REG_LPLL_BASE + 0xB5)
#define REG_LPLL_5B_L     (REG_LPLL_BASE + 0xB6)
#define REG_LPLL_5B_H     (REG_LPLL_BASE + 0xB7)
#define REG_LPLL_5C_L     (REG_LPLL_BASE + 0xB8)
#define REG_LPLL_5C_H     (REG_LPLL_BASE + 0xB9)
#define REG_LPLL_5D_L     (REG_LPLL_BASE + 0xBA)
#define REG_LPLL_5D_H     (REG_LPLL_BASE + 0xBB)
#define REG_LPLL_5E_L     (REG_LPLL_BASE + 0xBC)
#define REG_LPLL_5E_H     (REG_LPLL_BASE + 0xBD)
#define REG_LPLL_5F_L     (REG_LPLL_BASE + 0xBE)
#define REG_LPLL_5F_H     (REG_LPLL_BASE + 0xBF)
#define REG_LPLL_60_L     (REG_LPLL_BASE + 0xC0)
#define REG_LPLL_60_H     (REG_LPLL_BASE + 0xC1)
#define REG_LPLL_61_L     (REG_LPLL_BASE + 0xC2)
#define REG_LPLL_61_H     (REG_LPLL_BASE + 0xC3)
#define REG_LPLL_62_L     (REG_LPLL_BASE + 0xC4)
#define REG_LPLL_62_H     (REG_LPLL_BASE + 0xC5)
#define REG_LPLL_63_L     (REG_LPLL_BASE + 0xC6)
#define REG_LPLL_63_H     (REG_LPLL_BASE + 0xC7)
#define REG_LPLL_64_L     (REG_LPLL_BASE + 0xC8)
#define REG_LPLL_64_H     (REG_LPLL_BASE + 0xC9)
#define REG_LPLL_65_L     (REG_LPLL_BASE + 0xCA)
#define REG_LPLL_65_H     (REG_LPLL_BASE + 0xCB)
#define REG_LPLL_66_L     (REG_LPLL_BASE + 0xCC)
#define REG_LPLL_66_H     (REG_LPLL_BASE + 0xCD)
#define REG_LPLL_67_L     (REG_LPLL_BASE + 0xCE)
#define REG_LPLL_67_H     (REG_LPLL_BASE + 0xCF)
#define REG_LPLL_68_L     (REG_LPLL_BASE + 0xD0)
#define REG_LPLL_68_H     (REG_LPLL_BASE + 0xD1)
#define REG_LPLL_69_L     (REG_LPLL_BASE + 0xD2)
#define REG_LPLL_69_H     (REG_LPLL_BASE + 0xD3)
#define REG_LPLL_6A_L     (REG_LPLL_BASE + 0xD4)
#define REG_LPLL_6A_H     (REG_LPLL_BASE + 0xD5)
#define REG_LPLL_6B_L     (REG_LPLL_BASE + 0xD6)
#define REG_LPLL_6B_H     (REG_LPLL_BASE + 0xD7)
#define REG_LPLL_6C_L     (REG_LPLL_BASE + 0xD8)
#define REG_LPLL_6C_H     (REG_LPLL_BASE + 0xD9)
#define REG_LPLL_6D_L     (REG_LPLL_BASE + 0xDA)
#define REG_LPLL_6D_H     (REG_LPLL_BASE + 0xDB)
#define REG_LPLL_6E_L     (REG_LPLL_BASE + 0xDC)
#define REG_LPLL_6E_H     (REG_LPLL_BASE + 0xDD)
#define REG_LPLL_6F_L     (REG_LPLL_BASE + 0xDE)
#define REG_LPLL_6F_H     (REG_LPLL_BASE + 0xDF)
#define REG_LPLL_70_L     (REG_LPLL_BASE + 0xE0)
#define REG_LPLL_70_H     (REG_LPLL_BASE + 0xE1)
#define REG_LPLL_71_L     (REG_LPLL_BASE + 0xE2)
#define REG_LPLL_71_H     (REG_LPLL_BASE + 0xE3)
#define REG_LPLL_72_L     (REG_LPLL_BASE + 0xE4)
#define REG_LPLL_72_H     (REG_LPLL_BASE + 0xE5)
#define REG_LPLL_73_L     (REG_LPLL_BASE + 0xE6)
#define REG_LPLL_73_H     (REG_LPLL_BASE + 0xE7)
#define REG_LPLL_74_L     (REG_LPLL_BASE + 0xE8)
#define REG_LPLL_74_H     (REG_LPLL_BASE + 0xE9)
#define REG_LPLL_75_L     (REG_LPLL_BASE + 0xEA)
#define REG_LPLL_75_H     (REG_LPLL_BASE + 0xEB)
#define REG_LPLL_76_L     (REG_LPLL_BASE + 0xEC)
#define REG_LPLL_76_H     (REG_LPLL_BASE + 0xED)
#define REG_LPLL_77_L     (REG_LPLL_BASE + 0xEE)
#define REG_LPLL_77_H     (REG_LPLL_BASE + 0xEF)
#define REG_LPLL_78_L     (REG_LPLL_BASE + 0xF0)
#define REG_LPLL_78_H     (REG_LPLL_BASE + 0xF1)
#define REG_LPLL_79_L     (REG_LPLL_BASE + 0xF2)
#define REG_LPLL_79_H     (REG_LPLL_BASE + 0xF3)
#define REG_LPLL_7A_L     (REG_LPLL_BASE + 0xF4)
#define REG_LPLL_7A_H     (REG_LPLL_BASE + 0xF5)
#define REG_LPLL_7B_L     (REG_LPLL_BASE + 0xF6)
#define REG_LPLL_7B_H     (REG_LPLL_BASE + 0xF7)
#define REG_LPLL_7C_L     (REG_LPLL_BASE + 0xF8)
#define REG_LPLL_7C_H     (REG_LPLL_BASE + 0xF9)
#define REG_LPLL_7D_L     (REG_LPLL_BASE + 0xFA)
#define REG_LPLL_7D_H     (REG_LPLL_BASE + 0xFB)
#define REG_LPLL_7E_L     (REG_LPLL_BASE + 0xFC)
#define REG_LPLL_7E_H     (REG_LPLL_BASE + 0xFD)
#define REG_LPLL_7F_L     (REG_LPLL_BASE + 0xFE)
#define REG_LPLL_7F_H     (REG_LPLL_BASE + 0xFF)

#define REG_DISP_TOP_0_00_L    (REG_DISP_TOP_0_BASE + 0x00)
#define REG_DISP_TOP_0_00_H    (REG_DISP_TOP_0_BASE + 0x01)
#define REG_DISP_TOP_0_01_L    (REG_DISP_TOP_0_BASE + 0x02)
#define REG_DISP_TOP_0_01_H    (REG_DISP_TOP_0_BASE + 0x03)
#define REG_DISP_TOP_0_02_L    (REG_DISP_TOP_0_BASE + 0x04)
#define REG_DISP_TOP_0_02_H    (REG_DISP_TOP_0_BASE + 0x05)
#define REG_DISP_TOP_0_03_L    (REG_DISP_TOP_0_BASE + 0x06)
#define REG_DISP_TOP_0_03_H    (REG_DISP_TOP_0_BASE + 0x07)
#define REG_DISP_TOP_0_04_L    (REG_DISP_TOP_0_BASE + 0x08)
#define REG_DISP_TOP_0_04_H    (REG_DISP_TOP_0_BASE + 0x09)
#define REG_DISP_TOP_0_05_L    (REG_DISP_TOP_0_BASE + 0x0A)
#define REG_DISP_TOP_0_05_H    (REG_DISP_TOP_0_BASE + 0x0B)
#define REG_DISP_TOP_0_06_L    (REG_DISP_TOP_0_BASE + 0x0C)
#define REG_DISP_TOP_0_06_H    (REG_DISP_TOP_0_BASE + 0x0D)
#define REG_DISP_TOP_0_07_L    (REG_DISP_TOP_0_BASE + 0x0E)
#define REG_DISP_TOP_0_07_H    (REG_DISP_TOP_0_BASE + 0x0F)
#define REG_DISP_TOP_0_08_L    (REG_DISP_TOP_0_BASE + 0x10)
#define REG_DISP_TOP_0_08_H    (REG_DISP_TOP_0_BASE + 0x11)
#define REG_DISP_TOP_0_09_L    (REG_DISP_TOP_0_BASE + 0x12)
#define REG_DISP_TOP_0_09_H    (REG_DISP_TOP_0_BASE + 0x13)
#define REG_DISP_TOP_0_0A_L    (REG_DISP_TOP_0_BASE + 0x14)
#define REG_DISP_TOP_0_0A_H    (REG_DISP_TOP_0_BASE + 0x15)
#define REG_DISP_TOP_0_0B_L    (REG_DISP_TOP_0_BASE + 0x16)
#define REG_DISP_TOP_0_0B_H    (REG_DISP_TOP_0_BASE + 0x17)
#define REG_DISP_TOP_0_0C_L    (REG_DISP_TOP_0_BASE + 0x18)
#define REG_DISP_TOP_0_0C_H    (REG_DISP_TOP_0_BASE + 0x19)
#define REG_DISP_TOP_0_0D_L    (REG_DISP_TOP_0_BASE + 0x1A)
#define REG_DISP_TOP_0_0D_H    (REG_DISP_TOP_0_BASE + 0x1B)
#define REG_DISP_TOP_0_0E_L    (REG_DISP_TOP_0_BASE + 0x1C)
#define REG_DISP_TOP_0_0E_H    (REG_DISP_TOP_0_BASE + 0x1D)
#define REG_DISP_TOP_0_0F_L    (REG_DISP_TOP_0_BASE + 0x1E)
#define REG_DISP_TOP_0_0F_H    (REG_DISP_TOP_0_BASE + 0x1F)
#define REG_DISP_TOP_0_10_L    (REG_DISP_TOP_0_BASE + 0x20)
#define REG_DISP_TOP_0_10_H    (REG_DISP_TOP_0_BASE + 0x21)
#define REG_DISP_TOP_0_11_L    (REG_DISP_TOP_0_BASE + 0x22)
#define REG_DISP_TOP_0_11_H    (REG_DISP_TOP_0_BASE + 0x23)
#define REG_DISP_TOP_0_12_L    (REG_DISP_TOP_0_BASE + 0x24)
#define REG_DISP_TOP_0_12_H    (REG_DISP_TOP_0_BASE + 0x25)
#define REG_DISP_TOP_0_13_L    (REG_DISP_TOP_0_BASE + 0x26)
#define REG_DISP_TOP_0_13_H    (REG_DISP_TOP_0_BASE + 0x27)
#define REG_DISP_TOP_0_14_L    (REG_DISP_TOP_0_BASE + 0x28)
#define REG_DISP_TOP_0_14_H    (REG_DISP_TOP_0_BASE + 0x29)
#define REG_DISP_TOP_0_15_L    (REG_DISP_TOP_0_BASE + 0x2A)
#define REG_DISP_TOP_0_15_H    (REG_DISP_TOP_0_BASE + 0x2B)
#define REG_DISP_TOP_0_16_L    (REG_DISP_TOP_0_BASE + 0x2C)
#define REG_DISP_TOP_0_16_H    (REG_DISP_TOP_0_BASE + 0x2D)
#define REG_DISP_TOP_0_17_L    (REG_DISP_TOP_0_BASE + 0x2E)
#define REG_DISP_TOP_0_17_H    (REG_DISP_TOP_0_BASE + 0x2F)
#define REG_DISP_TOP_0_18_L    (REG_DISP_TOP_0_BASE + 0x30)
#define REG_DISP_TOP_0_18_H    (REG_DISP_TOP_0_BASE + 0x31)
#define REG_DISP_TOP_0_19_L    (REG_DISP_TOP_0_BASE + 0x32)
#define REG_DISP_TOP_0_19_H    (REG_DISP_TOP_0_BASE + 0x33)
#define REG_DISP_TOP_0_1A_L    (REG_DISP_TOP_0_BASE + 0x34)
#define REG_DISP_TOP_0_1A_H    (REG_DISP_TOP_0_BASE + 0x35)
#define REG_DISP_TOP_0_1B_L    (REG_DISP_TOP_0_BASE + 0x36)
#define REG_DISP_TOP_0_1B_H    (REG_DISP_TOP_0_BASE + 0x37)
#define REG_DISP_TOP_0_1C_L    (REG_DISP_TOP_0_BASE + 0x38)
#define REG_DISP_TOP_0_1C_H    (REG_DISP_TOP_0_BASE + 0x39)
#define REG_DISP_TOP_0_1D_L    (REG_DISP_TOP_0_BASE + 0x3A)
#define REG_DISP_TOP_0_1D_H    (REG_DISP_TOP_0_BASE + 0x3B)
#define REG_DISP_TOP_0_1E_L    (REG_DISP_TOP_0_BASE + 0x3C)
#define REG_DISP_TOP_0_1E_H    (REG_DISP_TOP_0_BASE + 0x3D)
#define REG_DISP_TOP_0_1F_L    (REG_DISP_TOP_0_BASE + 0x3E)
#define REG_DISP_TOP_0_1F_H    (REG_DISP_TOP_0_BASE + 0x3F)
#define REG_DISP_TOP_0_20_L    (REG_DISP_TOP_0_BASE + 0x40)
#define REG_DISP_TOP_0_20_H    (REG_DISP_TOP_0_BASE + 0x41)
#define REG_DISP_TOP_0_21_L    (REG_DISP_TOP_0_BASE + 0x42)
#define REG_DISP_TOP_0_21_H    (REG_DISP_TOP_0_BASE + 0x43)
#define REG_DISP_TOP_0_22_L    (REG_DISP_TOP_0_BASE + 0x44)
#define REG_DISP_TOP_0_22_H    (REG_DISP_TOP_0_BASE + 0x45)
#define REG_DISP_TOP_0_23_L    (REG_DISP_TOP_0_BASE + 0x46)
#define REG_DISP_TOP_0_23_H    (REG_DISP_TOP_0_BASE + 0x47)
#define REG_DISP_TOP_0_24_L    (REG_DISP_TOP_0_BASE + 0x48)
#define REG_DISP_TOP_0_24_H    (REG_DISP_TOP_0_BASE + 0x49)
#define REG_DISP_TOP_0_25_L    (REG_DISP_TOP_0_BASE + 0x4A)
#define REG_DISP_TOP_0_25_H    (REG_DISP_TOP_0_BASE + 0x4B)
#define REG_DISP_TOP_0_26_L    (REG_DISP_TOP_0_BASE + 0x4C)
#define REG_DISP_TOP_0_26_H    (REG_DISP_TOP_0_BASE + 0x4D)
#define REG_DISP_TOP_0_27_L    (REG_DISP_TOP_0_BASE + 0x4E)
#define REG_DISP_TOP_0_27_H    (REG_DISP_TOP_0_BASE + 0x4F)
#define REG_DISP_TOP_0_28_L    (REG_DISP_TOP_0_BASE + 0x50)
#define REG_DISP_TOP_0_28_H    (REG_DISP_TOP_0_BASE + 0x51)
#define REG_DISP_TOP_0_29_L    (REG_DISP_TOP_0_BASE + 0x52)
#define REG_DISP_TOP_0_29_H    (REG_DISP_TOP_0_BASE + 0x53)
#define REG_DISP_TOP_0_2A_L    (REG_DISP_TOP_0_BASE + 0x54)
#define REG_DISP_TOP_0_2A_H    (REG_DISP_TOP_0_BASE + 0x55)
#define REG_DISP_TOP_0_2B_L    (REG_DISP_TOP_0_BASE + 0x56)
#define REG_DISP_TOP_0_2B_H    (REG_DISP_TOP_0_BASE + 0x57)
#define REG_DISP_TOP_0_2C_L    (REG_DISP_TOP_0_BASE + 0x58)
#define REG_DISP_TOP_0_2C_H    (REG_DISP_TOP_0_BASE + 0x59)
#define REG_DISP_TOP_0_2D_L    (REG_DISP_TOP_0_BASE + 0x5A)
#define REG_DISP_TOP_0_2D_H    (REG_DISP_TOP_0_BASE + 0x5B)
#define REG_DISP_TOP_0_2E_L    (REG_DISP_TOP_0_BASE + 0x5C)
#define REG_DISP_TOP_0_2E_H    (REG_DISP_TOP_0_BASE + 0x5D)
#define REG_DISP_TOP_0_2F_L    (REG_DISP_TOP_0_BASE + 0x5E)
#define REG_DISP_TOP_0_2F_H    (REG_DISP_TOP_0_BASE + 0x5F)
#define REG_DISP_TOP_0_30_L    (REG_DISP_TOP_0_BASE + 0x60)
#define REG_DISP_TOP_0_30_H    (REG_DISP_TOP_0_BASE + 0x61)
#define REG_DISP_TOP_0_31_L    (REG_DISP_TOP_0_BASE + 0x62)
#define REG_DISP_TOP_0_31_H    (REG_DISP_TOP_0_BASE + 0x63)
#define REG_DISP_TOP_0_32_L    (REG_DISP_TOP_0_BASE + 0x64)
#define REG_DISP_TOP_0_32_H    (REG_DISP_TOP_0_BASE + 0x65)
#define REG_DISP_TOP_0_33_L    (REG_DISP_TOP_0_BASE + 0x66)
#define REG_DISP_TOP_0_33_H    (REG_DISP_TOP_0_BASE + 0x67)
#define REG_DISP_TOP_0_34_L    (REG_DISP_TOP_0_BASE + 0x68)
#define REG_DISP_TOP_0_34_H    (REG_DISP_TOP_0_BASE + 0x69)
#define REG_DISP_TOP_0_35_L    (REG_DISP_TOP_0_BASE + 0x6A)
#define REG_DISP_TOP_0_35_H    (REG_DISP_TOP_0_BASE + 0x6B)
#define REG_DISP_TOP_0_36_L    (REG_DISP_TOP_0_BASE + 0x6C)
#define REG_DISP_TOP_0_36_H    (REG_DISP_TOP_0_BASE + 0x6D)
#define REG_DISP_TOP_0_37_L    (REG_DISP_TOP_0_BASE + 0x6E)
#define REG_DISP_TOP_0_37_H    (REG_DISP_TOP_0_BASE + 0x6F)
#define REG_DISP_TOP_0_38_L    (REG_DISP_TOP_0_BASE + 0x70)
#define REG_DISP_TOP_0_38_H    (REG_DISP_TOP_0_BASE + 0x71)
#define REG_DISP_TOP_0_39_L    (REG_DISP_TOP_0_BASE + 0x72)
#define REG_DISP_TOP_0_39_H    (REG_DISP_TOP_0_BASE + 0x73)
#define REG_DISP_TOP_0_3A_L    (REG_DISP_TOP_0_BASE + 0x74)
#define REG_DISP_TOP_0_3A_H    (REG_DISP_TOP_0_BASE + 0x75)
#define REG_DISP_TOP_0_3B_L    (REG_DISP_TOP_0_BASE + 0x76)
#define REG_DISP_TOP_0_3B_H    (REG_DISP_TOP_0_BASE + 0x77)
#define REG_DISP_TOP_0_3C_L    (REG_DISP_TOP_0_BASE + 0x78)
#define REG_DISP_TOP_0_3C_H    (REG_DISP_TOP_0_BASE + 0x79)
#define REG_DISP_TOP_0_3D_L    (REG_DISP_TOP_0_BASE + 0x7A)
#define REG_DISP_TOP_0_3D_H    (REG_DISP_TOP_0_BASE + 0x7B)
#define REG_DISP_TOP_0_3E_L    (REG_DISP_TOP_0_BASE + 0x7C)
#define REG_DISP_TOP_0_3E_H    (REG_DISP_TOP_0_BASE + 0x7D)
#define REG_DISP_TOP_0_3F_L    (REG_DISP_TOP_0_BASE + 0x7E)
#define REG_DISP_TOP_0_3F_H    (REG_DISP_TOP_0_BASE + 0x7F)
#define REG_DISP_TOP_0_40_L    (REG_DISP_TOP_0_BASE + 0x80)
#define REG_DISP_TOP_0_40_H    (REG_DISP_TOP_0_BASE + 0x81)
#define REG_DISP_TOP_0_41_L    (REG_DISP_TOP_0_BASE + 0x82)
#define REG_DISP_TOP_0_41_H    (REG_DISP_TOP_0_BASE + 0x83)
#define REG_DISP_TOP_0_42_L    (REG_DISP_TOP_0_BASE + 0x84)
#define REG_DISP_TOP_0_42_H    (REG_DISP_TOP_0_BASE + 0x85)
#define REG_DISP_TOP_0_43_L    (REG_DISP_TOP_0_BASE + 0x86)
#define REG_DISP_TOP_0_43_H    (REG_DISP_TOP_0_BASE + 0x87)
#define REG_DISP_TOP_0_44_L    (REG_DISP_TOP_0_BASE + 0x88)
#define REG_DISP_TOP_0_44_H    (REG_DISP_TOP_0_BASE + 0x89)
#define REG_DISP_TOP_0_45_L    (REG_DISP_TOP_0_BASE + 0x8A)
#define REG_DISP_TOP_0_45_H    (REG_DISP_TOP_0_BASE + 0x8B)
#define REG_DISP_TOP_0_46_L    (REG_DISP_TOP_0_BASE + 0x8C)
#define REG_DISP_TOP_0_46_H    (REG_DISP_TOP_0_BASE + 0x8D)
#define REG_DISP_TOP_0_47_L    (REG_DISP_TOP_0_BASE + 0x8E)
#define REG_DISP_TOP_0_47_H    (REG_DISP_TOP_0_BASE + 0x8F)
#define REG_DISP_TOP_0_48_L    (REG_DISP_TOP_0_BASE + 0x90)
#define REG_DISP_TOP_0_48_H    (REG_DISP_TOP_0_BASE + 0x91)
#define REG_DISP_TOP_0_49_L    (REG_DISP_TOP_0_BASE + 0x92)
#define REG_DISP_TOP_0_49_H    (REG_DISP_TOP_0_BASE + 0x93)
#define REG_DISP_TOP_0_4A_L    (REG_DISP_TOP_0_BASE + 0x94)
#define REG_DISP_TOP_0_4A_H    (REG_DISP_TOP_0_BASE + 0x95)
#define REG_DISP_TOP_0_4B_L    (REG_DISP_TOP_0_BASE + 0x96)
#define REG_DISP_TOP_0_4B_H    (REG_DISP_TOP_0_BASE + 0x97)
#define REG_DISP_TOP_0_4C_L    (REG_DISP_TOP_0_BASE + 0x98)
#define REG_DISP_TOP_0_4C_H    (REG_DISP_TOP_0_BASE + 0x99)
#define REG_DISP_TOP_0_4D_L    (REG_DISP_TOP_0_BASE + 0x9A)
#define REG_DISP_TOP_0_4D_H    (REG_DISP_TOP_0_BASE + 0x9B)
#define REG_DISP_TOP_0_4E_L    (REG_DISP_TOP_0_BASE + 0x9C)
#define REG_DISP_TOP_0_4E_H    (REG_DISP_TOP_0_BASE + 0x9D)
#define REG_DISP_TOP_0_4F_L    (REG_DISP_TOP_0_BASE + 0x9E)
#define REG_DISP_TOP_0_4F_H    (REG_DISP_TOP_0_BASE + 0x9F)
#define REG_DISP_TOP_0_50_L    (REG_DISP_TOP_0_BASE + 0xA0)
#define REG_DISP_TOP_0_50_H    (REG_DISP_TOP_0_BASE + 0xA1)
#define REG_DISP_TOP_0_51_L    (REG_DISP_TOP_0_BASE + 0xA2)
#define REG_DISP_TOP_0_51_H    (REG_DISP_TOP_0_BASE + 0xA3)
#define REG_DISP_TOP_0_52_L    (REG_DISP_TOP_0_BASE + 0xA4)
#define REG_DISP_TOP_0_52_H    (REG_DISP_TOP_0_BASE + 0xA5)
#define REG_DISP_TOP_0_53_L    (REG_DISP_TOP_0_BASE + 0xA6)
#define REG_DISP_TOP_0_53_H    (REG_DISP_TOP_0_BASE + 0xA7)
#define REG_DISP_TOP_0_54_L    (REG_DISP_TOP_0_BASE + 0xA8)
#define REG_DISP_TOP_0_54_H    (REG_DISP_TOP_0_BASE + 0xA9)
#define REG_DISP_TOP_0_55_L    (REG_DISP_TOP_0_BASE + 0xAA)
#define REG_DISP_TOP_0_55_H    (REG_DISP_TOP_0_BASE + 0xAB)
#define REG_DISP_TOP_0_56_L    (REG_DISP_TOP_0_BASE + 0xAC)
#define REG_DISP_TOP_0_56_H    (REG_DISP_TOP_0_BASE + 0xAD)
#define REG_DISP_TOP_0_57_L    (REG_DISP_TOP_0_BASE + 0xAE)
#define REG_DISP_TOP_0_57_H    (REG_DISP_TOP_0_BASE + 0xAF)
#define REG_DISP_TOP_0_58_L    (REG_DISP_TOP_0_BASE + 0xB0)
#define REG_DISP_TOP_0_58_H    (REG_DISP_TOP_0_BASE + 0xB1)
#define REG_DISP_TOP_0_59_L    (REG_DISP_TOP_0_BASE + 0xB2)
#define REG_DISP_TOP_0_59_H    (REG_DISP_TOP_0_BASE + 0xB3)
#define REG_DISP_TOP_0_5A_L    (REG_DISP_TOP_0_BASE + 0xB4)
#define REG_DISP_TOP_0_5A_H    (REG_DISP_TOP_0_BASE + 0xB5)
#define REG_DISP_TOP_0_5B_L    (REG_DISP_TOP_0_BASE + 0xB6)
#define REG_DISP_TOP_0_5B_H    (REG_DISP_TOP_0_BASE + 0xB7)
#define REG_DISP_TOP_0_5C_L    (REG_DISP_TOP_0_BASE + 0xB8)
#define REG_DISP_TOP_0_5C_H    (REG_DISP_TOP_0_BASE + 0xB9)
#define REG_DISP_TOP_0_5D_L    (REG_DISP_TOP_0_BASE + 0xBA)
#define REG_DISP_TOP_0_5D_H    (REG_DISP_TOP_0_BASE + 0xBB)
#define REG_DISP_TOP_0_5E_L    (REG_DISP_TOP_0_BASE + 0xBC)
#define REG_DISP_TOP_0_5E_H    (REG_DISP_TOP_0_BASE + 0xBD)
#define REG_DISP_TOP_0_5F_L    (REG_DISP_TOP_0_BASE + 0xBE)
#define REG_DISP_TOP_0_5F_H    (REG_DISP_TOP_0_BASE + 0xBF)
#define REG_DISP_TOP_0_60_L    (REG_DISP_TOP_0_BASE + 0xC0)
#define REG_DISP_TOP_0_60_H    (REG_DISP_TOP_0_BASE + 0xC1)
#define REG_DISP_TOP_0_61_L    (REG_DISP_TOP_0_BASE + 0xC2)
#define REG_DISP_TOP_0_61_H    (REG_DISP_TOP_0_BASE + 0xC3)
#define REG_DISP_TOP_0_62_L    (REG_DISP_TOP_0_BASE + 0xC4)
#define REG_DISP_TOP_0_62_H    (REG_DISP_TOP_0_BASE + 0xC5)
#define REG_DISP_TOP_0_63_L    (REG_DISP_TOP_0_BASE + 0xC6)
#define REG_DISP_TOP_0_63_H    (REG_DISP_TOP_0_BASE + 0xC7)
#define REG_DISP_TOP_0_64_L    (REG_DISP_TOP_0_BASE + 0xC8)
#define REG_DISP_TOP_0_64_H    (REG_DISP_TOP_0_BASE + 0xC9)
#define REG_DISP_TOP_0_65_L    (REG_DISP_TOP_0_BASE + 0xCA)
#define REG_DISP_TOP_0_65_H    (REG_DISP_TOP_0_BASE + 0xCB)
#define REG_DISP_TOP_0_66_L    (REG_DISP_TOP_0_BASE + 0xCC)
#define REG_DISP_TOP_0_66_H    (REG_DISP_TOP_0_BASE + 0xCD)
#define REG_DISP_TOP_0_67_L    (REG_DISP_TOP_0_BASE + 0xCE)
#define REG_DISP_TOP_0_67_H    (REG_DISP_TOP_0_BASE + 0xCF)
#define REG_DISP_TOP_0_68_L    (REG_DISP_TOP_0_BASE + 0xD0)
#define REG_DISP_TOP_0_68_H    (REG_DISP_TOP_0_BASE + 0xD1)
#define REG_DISP_TOP_0_69_L    (REG_DISP_TOP_0_BASE + 0xD2)
#define REG_DISP_TOP_0_69_H    (REG_DISP_TOP_0_BASE + 0xD3)
#define REG_DISP_TOP_0_6A_L    (REG_DISP_TOP_0_BASE + 0xD4)
#define REG_DISP_TOP_0_6A_H    (REG_DISP_TOP_0_BASE + 0xD5)
#define REG_DISP_TOP_0_6B_L    (REG_DISP_TOP_0_BASE + 0xD6)
#define REG_DISP_TOP_0_6B_H    (REG_DISP_TOP_0_BASE + 0xD7)
#define REG_DISP_TOP_0_6C_L    (REG_DISP_TOP_0_BASE + 0xD8)
#define REG_DISP_TOP_0_6C_H    (REG_DISP_TOP_0_BASE + 0xD9)
#define REG_DISP_TOP_0_6D_L    (REG_DISP_TOP_0_BASE + 0xDA)
#define REG_DISP_TOP_0_6D_H    (REG_DISP_TOP_0_BASE + 0xDB)
#define REG_DISP_TOP_0_6E_L    (REG_DISP_TOP_0_BASE + 0xDC)
#define REG_DISP_TOP_0_6E_H    (REG_DISP_TOP_0_BASE + 0xDD)
#define REG_DISP_TOP_0_6F_L    (REG_DISP_TOP_0_BASE + 0xDE)
#define REG_DISP_TOP_0_6F_H    (REG_DISP_TOP_0_BASE + 0xDF)
#define REG_DISP_TOP_0_70_L    (REG_DISP_TOP_0_BASE + 0xE0)
#define REG_DISP_TOP_0_70_H    (REG_DISP_TOP_0_BASE + 0xE1)
#define REG_DISP_TOP_0_71_L    (REG_DISP_TOP_0_BASE + 0xE2)
#define REG_DISP_TOP_0_71_H    (REG_DISP_TOP_0_BASE + 0xE3)
#define REG_DISP_TOP_0_72_L    (REG_DISP_TOP_0_BASE + 0xE4)
#define REG_DISP_TOP_0_72_H    (REG_DISP_TOP_0_BASE + 0xE5)
#define REG_DISP_TOP_0_73_L    (REG_DISP_TOP_0_BASE + 0xE6)
#define REG_DISP_TOP_0_73_H    (REG_DISP_TOP_0_BASE + 0xE7)
#define REG_DISP_TOP_0_74_L    (REG_DISP_TOP_0_BASE + 0xE8)
#define REG_DISP_TOP_0_74_H    (REG_DISP_TOP_0_BASE + 0xE9)
#define REG_DISP_TOP_0_75_L    (REG_DISP_TOP_0_BASE + 0xEA)
#define REG_DISP_TOP_0_75_H    (REG_DISP_TOP_0_BASE + 0xEB)
#define REG_DISP_TOP_0_76_L    (REG_DISP_TOP_0_BASE + 0xEC)
#define REG_DISP_TOP_0_76_H    (REG_DISP_TOP_0_BASE + 0xED)
#define REG_DISP_TOP_0_77_L    (REG_DISP_TOP_0_BASE + 0xEE)
#define REG_DISP_TOP_0_77_H    (REG_DISP_TOP_0_BASE + 0xEF)
#define REG_DISP_TOP_0_78_L    (REG_DISP_TOP_0_BASE + 0xF0)
#define REG_DISP_TOP_0_78_H    (REG_DISP_TOP_0_BASE + 0xF1)
#define REG_DISP_TOP_0_79_L    (REG_DISP_TOP_0_BASE + 0xF2)
#define REG_DISP_TOP_0_79_H    (REG_DISP_TOP_0_BASE + 0xF3)
#define REG_DISP_TOP_0_7A_L    (REG_DISP_TOP_0_BASE + 0xF4)
#define REG_DISP_TOP_0_7A_H    (REG_DISP_TOP_0_BASE + 0xF5)
#define REG_DISP_TOP_0_7B_L    (REG_DISP_TOP_0_BASE + 0xF6)
#define REG_DISP_TOP_0_7B_H    (REG_DISP_TOP_0_BASE + 0xF7)
#define REG_DISP_TOP_0_7C_L    (REG_DISP_TOP_0_BASE + 0xF8)
#define REG_DISP_TOP_0_7C_H    (REG_DISP_TOP_0_BASE + 0xF9)
#define REG_DISP_TOP_0_7D_L    (REG_DISP_TOP_0_BASE + 0xFA)
#define REG_DISP_TOP_0_7D_H    (REG_DISP_TOP_0_BASE + 0xFB)
#define REG_DISP_TOP_0_7E_L    (REG_DISP_TOP_0_BASE + 0xFC)
#define REG_DISP_TOP_0_7E_H    (REG_DISP_TOP_0_BASE + 0xFD)
#define REG_DISP_TOP_0_7F_L    (REG_DISP_TOP_0_BASE + 0xFE)
#define REG_DISP_TOP_0_7F_H    (REG_DISP_TOP_0_BASE + 0xFF)

#define REG_DISP_TOP_OP2_0_00_L    (REG_DISP_TOP_OP2_0_BASE + 0x00)
#define REG_DISP_TOP_OP2_0_00_H    (REG_DISP_TOP_OP2_0_BASE + 0x01)
#define REG_DISP_TOP_OP2_0_01_L    (REG_DISP_TOP_OP2_0_BASE + 0x02)
#define REG_DISP_TOP_OP2_0_01_H    (REG_DISP_TOP_OP2_0_BASE + 0x03)
#define REG_DISP_TOP_OP2_0_02_L    (REG_DISP_TOP_OP2_0_BASE + 0x04)
#define REG_DISP_TOP_OP2_0_02_H    (REG_DISP_TOP_OP2_0_BASE + 0x05)
#define REG_DISP_TOP_OP2_0_03_L    (REG_DISP_TOP_OP2_0_BASE + 0x06)
#define REG_DISP_TOP_OP2_0_03_H    (REG_DISP_TOP_OP2_0_BASE + 0x07)
#define REG_DISP_TOP_OP2_0_04_L    (REG_DISP_TOP_OP2_0_BASE + 0x08)
#define REG_DISP_TOP_OP2_0_04_H    (REG_DISP_TOP_OP2_0_BASE + 0x09)
#define REG_DISP_TOP_OP2_0_05_L    (REG_DISP_TOP_OP2_0_BASE + 0x0A)
#define REG_DISP_TOP_OP2_0_05_H    (REG_DISP_TOP_OP2_0_BASE + 0x0B)
#define REG_DISP_TOP_OP2_0_06_L    (REG_DISP_TOP_OP2_0_BASE + 0x0C)
#define REG_DISP_TOP_OP2_0_06_H    (REG_DISP_TOP_OP2_0_BASE + 0x0D)
#define REG_DISP_TOP_OP2_0_07_L    (REG_DISP_TOP_OP2_0_BASE + 0x0E)
#define REG_DISP_TOP_OP2_0_07_H    (REG_DISP_TOP_OP2_0_BASE + 0x0F)
#define REG_DISP_TOP_OP2_0_08_L    (REG_DISP_TOP_OP2_0_BASE + 0x10)
#define REG_DISP_TOP_OP2_0_08_H    (REG_DISP_TOP_OP2_0_BASE + 0x11)
#define REG_DISP_TOP_OP2_0_09_L    (REG_DISP_TOP_OP2_0_BASE + 0x12)
#define REG_DISP_TOP_OP2_0_09_H    (REG_DISP_TOP_OP2_0_BASE + 0x13)
#define REG_DISP_TOP_OP2_0_0A_L    (REG_DISP_TOP_OP2_0_BASE + 0x14)
#define REG_DISP_TOP_OP2_0_0A_H    (REG_DISP_TOP_OP2_0_BASE + 0x15)
#define REG_DISP_TOP_OP2_0_0B_L    (REG_DISP_TOP_OP2_0_BASE + 0x16)
#define REG_DISP_TOP_OP2_0_0B_H    (REG_DISP_TOP_OP2_0_BASE + 0x17)
#define REG_DISP_TOP_OP2_0_0C_L    (REG_DISP_TOP_OP2_0_BASE + 0x18)
#define REG_DISP_TOP_OP2_0_0C_H    (REG_DISP_TOP_OP2_0_BASE + 0x19)
#define REG_DISP_TOP_OP2_0_0D_L    (REG_DISP_TOP_OP2_0_BASE + 0x1A)
#define REG_DISP_TOP_OP2_0_0D_H    (REG_DISP_TOP_OP2_0_BASE + 0x1B)
#define REG_DISP_TOP_OP2_0_0E_L    (REG_DISP_TOP_OP2_0_BASE + 0x1C)
#define REG_DISP_TOP_OP2_0_0E_H    (REG_DISP_TOP_OP2_0_BASE + 0x1D)
#define REG_DISP_TOP_OP2_0_0F_L    (REG_DISP_TOP_OP2_0_BASE + 0x1E)
#define REG_DISP_TOP_OP2_0_0F_H    (REG_DISP_TOP_OP2_0_BASE + 0x1F)
#define REG_DISP_TOP_OP2_0_10_L    (REG_DISP_TOP_OP2_0_BASE + 0x20)
#define REG_DISP_TOP_OP2_0_10_H    (REG_DISP_TOP_OP2_0_BASE + 0x21)
#define REG_DISP_TOP_OP2_0_11_L    (REG_DISP_TOP_OP2_0_BASE + 0x22)
#define REG_DISP_TOP_OP2_0_11_H    (REG_DISP_TOP_OP2_0_BASE + 0x23)
#define REG_DISP_TOP_OP2_0_12_L    (REG_DISP_TOP_OP2_0_BASE + 0x24)
#define REG_DISP_TOP_OP2_0_12_H    (REG_DISP_TOP_OP2_0_BASE + 0x25)
#define REG_DISP_TOP_OP2_0_13_L    (REG_DISP_TOP_OP2_0_BASE + 0x26)
#define REG_DISP_TOP_OP2_0_13_H    (REG_DISP_TOP_OP2_0_BASE + 0x27)
#define REG_DISP_TOP_OP2_0_14_L    (REG_DISP_TOP_OP2_0_BASE + 0x28)
#define REG_DISP_TOP_OP2_0_14_H    (REG_DISP_TOP_OP2_0_BASE + 0x29)
#define REG_DISP_TOP_OP2_0_15_L    (REG_DISP_TOP_OP2_0_BASE + 0x2A)
#define REG_DISP_TOP_OP2_0_15_H    (REG_DISP_TOP_OP2_0_BASE + 0x2B)
#define REG_DISP_TOP_OP2_0_16_L    (REG_DISP_TOP_OP2_0_BASE + 0x2C)
#define REG_DISP_TOP_OP2_0_16_H    (REG_DISP_TOP_OP2_0_BASE + 0x2D)
#define REG_DISP_TOP_OP2_0_17_L    (REG_DISP_TOP_OP2_0_BASE + 0x2E)
#define REG_DISP_TOP_OP2_0_17_H    (REG_DISP_TOP_OP2_0_BASE + 0x2F)
#define REG_DISP_TOP_OP2_0_18_L    (REG_DISP_TOP_OP2_0_BASE + 0x30)
#define REG_DISP_TOP_OP2_0_18_H    (REG_DISP_TOP_OP2_0_BASE + 0x31)
#define REG_DISP_TOP_OP2_0_19_L    (REG_DISP_TOP_OP2_0_BASE + 0x32)
#define REG_DISP_TOP_OP2_0_19_H    (REG_DISP_TOP_OP2_0_BASE + 0x33)
#define REG_DISP_TOP_OP2_0_1A_L    (REG_DISP_TOP_OP2_0_BASE + 0x34)
#define REG_DISP_TOP_OP2_0_1A_H    (REG_DISP_TOP_OP2_0_BASE + 0x35)
#define REG_DISP_TOP_OP2_0_1B_L    (REG_DISP_TOP_OP2_0_BASE + 0x36)
#define REG_DISP_TOP_OP2_0_1B_H    (REG_DISP_TOP_OP2_0_BASE + 0x37)
#define REG_DISP_TOP_OP2_0_1C_L    (REG_DISP_TOP_OP2_0_BASE + 0x38)
#define REG_DISP_TOP_OP2_0_1C_H    (REG_DISP_TOP_OP2_0_BASE + 0x39)
#define REG_DISP_TOP_OP2_0_1D_L    (REG_DISP_TOP_OP2_0_BASE + 0x3A)
#define REG_DISP_TOP_OP2_0_1D_H    (REG_DISP_TOP_OP2_0_BASE + 0x3B)
#define REG_DISP_TOP_OP2_0_1E_L    (REG_DISP_TOP_OP2_0_BASE + 0x3C)
#define REG_DISP_TOP_OP2_0_1E_H    (REG_DISP_TOP_OP2_0_BASE + 0x3D)
#define REG_DISP_TOP_OP2_0_1F_L    (REG_DISP_TOP_OP2_0_BASE + 0x3E)
#define REG_DISP_TOP_OP2_0_1F_H    (REG_DISP_TOP_OP2_0_BASE + 0x3F)
#define REG_DISP_TOP_OP2_0_20_L    (REG_DISP_TOP_OP2_0_BASE + 0x40)
#define REG_DISP_TOP_OP2_0_20_H    (REG_DISP_TOP_OP2_0_BASE + 0x41)
#define REG_DISP_TOP_OP2_0_21_L    (REG_DISP_TOP_OP2_0_BASE + 0x42)
#define REG_DISP_TOP_OP2_0_21_H    (REG_DISP_TOP_OP2_0_BASE + 0x43)
#define REG_DISP_TOP_OP2_0_22_L    (REG_DISP_TOP_OP2_0_BASE + 0x44)
#define REG_DISP_TOP_OP2_0_22_H    (REG_DISP_TOP_OP2_0_BASE + 0x45)
#define REG_DISP_TOP_OP2_0_23_L    (REG_DISP_TOP_OP2_0_BASE + 0x46)
#define REG_DISP_TOP_OP2_0_23_H    (REG_DISP_TOP_OP2_0_BASE + 0x47)
#define REG_DISP_TOP_OP2_0_24_L    (REG_DISP_TOP_OP2_0_BASE + 0x48)
#define REG_DISP_TOP_OP2_0_24_H    (REG_DISP_TOP_OP2_0_BASE + 0x49)
#define REG_DISP_TOP_OP2_0_25_L    (REG_DISP_TOP_OP2_0_BASE + 0x4A)
#define REG_DISP_TOP_OP2_0_25_H    (REG_DISP_TOP_OP2_0_BASE + 0x4B)
#define REG_DISP_TOP_OP2_0_26_L    (REG_DISP_TOP_OP2_0_BASE + 0x4C)
#define REG_DISP_TOP_OP2_0_26_H    (REG_DISP_TOP_OP2_0_BASE + 0x4D)
#define REG_DISP_TOP_OP2_0_27_L    (REG_DISP_TOP_OP2_0_BASE + 0x4E)
#define REG_DISP_TOP_OP2_0_27_H    (REG_DISP_TOP_OP2_0_BASE + 0x4F)
#define REG_DISP_TOP_OP2_0_28_L    (REG_DISP_TOP_OP2_0_BASE + 0x50)
#define REG_DISP_TOP_OP2_0_28_H    (REG_DISP_TOP_OP2_0_BASE + 0x51)
#define REG_DISP_TOP_OP2_0_29_L    (REG_DISP_TOP_OP2_0_BASE + 0x52)
#define REG_DISP_TOP_OP2_0_29_H    (REG_DISP_TOP_OP2_0_BASE + 0x53)
#define REG_DISP_TOP_OP2_0_2A_L    (REG_DISP_TOP_OP2_0_BASE + 0x54)
#define REG_DISP_TOP_OP2_0_2A_H    (REG_DISP_TOP_OP2_0_BASE + 0x55)
#define REG_DISP_TOP_OP2_0_2B_L    (REG_DISP_TOP_OP2_0_BASE + 0x56)
#define REG_DISP_TOP_OP2_0_2B_H    (REG_DISP_TOP_OP2_0_BASE + 0x57)
#define REG_DISP_TOP_OP2_0_2C_L    (REG_DISP_TOP_OP2_0_BASE + 0x58)
#define REG_DISP_TOP_OP2_0_2C_H    (REG_DISP_TOP_OP2_0_BASE + 0x59)
#define REG_DISP_TOP_OP2_0_2D_L    (REG_DISP_TOP_OP2_0_BASE + 0x5A)
#define REG_DISP_TOP_OP2_0_2D_H    (REG_DISP_TOP_OP2_0_BASE + 0x5B)
#define REG_DISP_TOP_OP2_0_2E_L    (REG_DISP_TOP_OP2_0_BASE + 0x5C)
#define REG_DISP_TOP_OP2_0_2E_H    (REG_DISP_TOP_OP2_0_BASE + 0x5D)
#define REG_DISP_TOP_OP2_0_2F_L    (REG_DISP_TOP_OP2_0_BASE + 0x5E)
#define REG_DISP_TOP_OP2_0_2F_H    (REG_DISP_TOP_OP2_0_BASE + 0x5F)
#define REG_DISP_TOP_OP2_0_30_L    (REG_DISP_TOP_OP2_0_BASE + 0x60)
#define REG_DISP_TOP_OP2_0_30_H    (REG_DISP_TOP_OP2_0_BASE + 0x61)
#define REG_DISP_TOP_OP2_0_31_L    (REG_DISP_TOP_OP2_0_BASE + 0x62)
#define REG_DISP_TOP_OP2_0_31_H    (REG_DISP_TOP_OP2_0_BASE + 0x63)
#define REG_DISP_TOP_OP2_0_32_L    (REG_DISP_TOP_OP2_0_BASE + 0x64)
#define REG_DISP_TOP_OP2_0_32_H    (REG_DISP_TOP_OP2_0_BASE + 0x65)
#define REG_DISP_TOP_OP2_0_33_L    (REG_DISP_TOP_OP2_0_BASE + 0x66)
#define REG_DISP_TOP_OP2_0_33_H    (REG_DISP_TOP_OP2_0_BASE + 0x67)
#define REG_DISP_TOP_OP2_0_34_L    (REG_DISP_TOP_OP2_0_BASE + 0x68)
#define REG_DISP_TOP_OP2_0_34_H    (REG_DISP_TOP_OP2_0_BASE + 0x69)
#define REG_DISP_TOP_OP2_0_35_L    (REG_DISP_TOP_OP2_0_BASE + 0x6A)
#define REG_DISP_TOP_OP2_0_35_H    (REG_DISP_TOP_OP2_0_BASE + 0x6B)
#define REG_DISP_TOP_OP2_0_36_L    (REG_DISP_TOP_OP2_0_BASE + 0x6C)
#define REG_DISP_TOP_OP2_0_36_H    (REG_DISP_TOP_OP2_0_BASE + 0x6D)
#define REG_DISP_TOP_OP2_0_37_L    (REG_DISP_TOP_OP2_0_BASE + 0x6E)
#define REG_DISP_TOP_OP2_0_37_H    (REG_DISP_TOP_OP2_0_BASE + 0x6F)
#define REG_DISP_TOP_OP2_0_38_L    (REG_DISP_TOP_OP2_0_BASE + 0x70)
#define REG_DISP_TOP_OP2_0_38_H    (REG_DISP_TOP_OP2_0_BASE + 0x71)
#define REG_DISP_TOP_OP2_0_39_L    (REG_DISP_TOP_OP2_0_BASE + 0x72)
#define REG_DISP_TOP_OP2_0_39_H    (REG_DISP_TOP_OP2_0_BASE + 0x73)
#define REG_DISP_TOP_OP2_0_3A_L    (REG_DISP_TOP_OP2_0_BASE + 0x74)
#define REG_DISP_TOP_OP2_0_3A_H    (REG_DISP_TOP_OP2_0_BASE + 0x75)
#define REG_DISP_TOP_OP2_0_3B_L    (REG_DISP_TOP_OP2_0_BASE + 0x76)
#define REG_DISP_TOP_OP2_0_3B_H    (REG_DISP_TOP_OP2_0_BASE + 0x77)
#define REG_DISP_TOP_OP2_0_3C_L    (REG_DISP_TOP_OP2_0_BASE + 0x78)
#define REG_DISP_TOP_OP2_0_3C_H    (REG_DISP_TOP_OP2_0_BASE + 0x79)
#define REG_DISP_TOP_OP2_0_3D_L    (REG_DISP_TOP_OP2_0_BASE + 0x7A)
#define REG_DISP_TOP_OP2_0_3D_H    (REG_DISP_TOP_OP2_0_BASE + 0x7B)
#define REG_DISP_TOP_OP2_0_3E_L    (REG_DISP_TOP_OP2_0_BASE + 0x7C)
#define REG_DISP_TOP_OP2_0_3E_H    (REG_DISP_TOP_OP2_0_BASE + 0x7D)
#define REG_DISP_TOP_OP2_0_3F_L    (REG_DISP_TOP_OP2_0_BASE + 0x7E)
#define REG_DISP_TOP_OP2_0_3F_H    (REG_DISP_TOP_OP2_0_BASE + 0x7F)
#define REG_DISP_TOP_OP2_0_40_L    (REG_DISP_TOP_OP2_0_BASE + 0x80)
#define REG_DISP_TOP_OP2_0_40_H    (REG_DISP_TOP_OP2_0_BASE + 0x81)
#define REG_DISP_TOP_OP2_0_41_L    (REG_DISP_TOP_OP2_0_BASE + 0x82)
#define REG_DISP_TOP_OP2_0_41_H    (REG_DISP_TOP_OP2_0_BASE + 0x83)
#define REG_DISP_TOP_OP2_0_42_L    (REG_DISP_TOP_OP2_0_BASE + 0x84)
#define REG_DISP_TOP_OP2_0_42_H    (REG_DISP_TOP_OP2_0_BASE + 0x85)
#define REG_DISP_TOP_OP2_0_43_L    (REG_DISP_TOP_OP2_0_BASE + 0x86)
#define REG_DISP_TOP_OP2_0_43_H    (REG_DISP_TOP_OP2_0_BASE + 0x87)
#define REG_DISP_TOP_OP2_0_44_L    (REG_DISP_TOP_OP2_0_BASE + 0x88)
#define REG_DISP_TOP_OP2_0_44_H    (REG_DISP_TOP_OP2_0_BASE + 0x89)
#define REG_DISP_TOP_OP2_0_45_L    (REG_DISP_TOP_OP2_0_BASE + 0x8A)
#define REG_DISP_TOP_OP2_0_45_H    (REG_DISP_TOP_OP2_0_BASE + 0x8B)
#define REG_DISP_TOP_OP2_0_46_L    (REG_DISP_TOP_OP2_0_BASE + 0x8C)
#define REG_DISP_TOP_OP2_0_46_H    (REG_DISP_TOP_OP2_0_BASE + 0x8D)
#define REG_DISP_TOP_OP2_0_47_L    (REG_DISP_TOP_OP2_0_BASE + 0x8E)
#define REG_DISP_TOP_OP2_0_47_H    (REG_DISP_TOP_OP2_0_BASE + 0x8F)
#define REG_DISP_TOP_OP2_0_48_L    (REG_DISP_TOP_OP2_0_BASE + 0x90)
#define REG_DISP_TOP_OP2_0_48_H    (REG_DISP_TOP_OP2_0_BASE + 0x91)
#define REG_DISP_TOP_OP2_0_49_L    (REG_DISP_TOP_OP2_0_BASE + 0x92)
#define REG_DISP_TOP_OP2_0_49_H    (REG_DISP_TOP_OP2_0_BASE + 0x93)
#define REG_DISP_TOP_OP2_0_4A_L    (REG_DISP_TOP_OP2_0_BASE + 0x94)
#define REG_DISP_TOP_OP2_0_4A_H    (REG_DISP_TOP_OP2_0_BASE + 0x95)
#define REG_DISP_TOP_OP2_0_4B_L    (REG_DISP_TOP_OP2_0_BASE + 0x96)
#define REG_DISP_TOP_OP2_0_4B_H    (REG_DISP_TOP_OP2_0_BASE + 0x97)
#define REG_DISP_TOP_OP2_0_4C_L    (REG_DISP_TOP_OP2_0_BASE + 0x98)
#define REG_DISP_TOP_OP2_0_4C_H    (REG_DISP_TOP_OP2_0_BASE + 0x99)
#define REG_DISP_TOP_OP2_0_4D_L    (REG_DISP_TOP_OP2_0_BASE + 0x9A)
#define REG_DISP_TOP_OP2_0_4D_H    (REG_DISP_TOP_OP2_0_BASE + 0x9B)
#define REG_DISP_TOP_OP2_0_4E_L    (REG_DISP_TOP_OP2_0_BASE + 0x9C)
#define REG_DISP_TOP_OP2_0_4E_H    (REG_DISP_TOP_OP2_0_BASE + 0x9D)
#define REG_DISP_TOP_OP2_0_4F_L    (REG_DISP_TOP_OP2_0_BASE + 0x9E)
#define REG_DISP_TOP_OP2_0_4F_H    (REG_DISP_TOP_OP2_0_BASE + 0x9F)
#define REG_DISP_TOP_OP2_0_50_L    (REG_DISP_TOP_OP2_0_BASE + 0xA0)
#define REG_DISP_TOP_OP2_0_50_H    (REG_DISP_TOP_OP2_0_BASE + 0xA1)
#define REG_DISP_TOP_OP2_0_51_L    (REG_DISP_TOP_OP2_0_BASE + 0xA2)
#define REG_DISP_TOP_OP2_0_51_H    (REG_DISP_TOP_OP2_0_BASE + 0xA3)
#define REG_DISP_TOP_OP2_0_52_L    (REG_DISP_TOP_OP2_0_BASE + 0xA4)
#define REG_DISP_TOP_OP2_0_52_H    (REG_DISP_TOP_OP2_0_BASE + 0xA5)
#define REG_DISP_TOP_OP2_0_53_L    (REG_DISP_TOP_OP2_0_BASE + 0xA6)
#define REG_DISP_TOP_OP2_0_53_H    (REG_DISP_TOP_OP2_0_BASE + 0xA7)
#define REG_DISP_TOP_OP2_0_54_L    (REG_DISP_TOP_OP2_0_BASE + 0xA8)
#define REG_DISP_TOP_OP2_0_54_H    (REG_DISP_TOP_OP2_0_BASE + 0xA9)
#define REG_DISP_TOP_OP2_0_55_L    (REG_DISP_TOP_OP2_0_BASE + 0xAA)
#define REG_DISP_TOP_OP2_0_55_H    (REG_DISP_TOP_OP2_0_BASE + 0xAB)
#define REG_DISP_TOP_OP2_0_56_L    (REG_DISP_TOP_OP2_0_BASE + 0xAC)
#define REG_DISP_TOP_OP2_0_56_H    (REG_DISP_TOP_OP2_0_BASE + 0xAD)
#define REG_DISP_TOP_OP2_0_57_L    (REG_DISP_TOP_OP2_0_BASE + 0xAE)
#define REG_DISP_TOP_OP2_0_57_H    (REG_DISP_TOP_OP2_0_BASE + 0xAF)
#define REG_DISP_TOP_OP2_0_58_L    (REG_DISP_TOP_OP2_0_BASE + 0xB0)
#define REG_DISP_TOP_OP2_0_58_H    (REG_DISP_TOP_OP2_0_BASE + 0xB1)
#define REG_DISP_TOP_OP2_0_59_L    (REG_DISP_TOP_OP2_0_BASE + 0xB2)
#define REG_DISP_TOP_OP2_0_59_H    (REG_DISP_TOP_OP2_0_BASE + 0xB3)
#define REG_DISP_TOP_OP2_0_5A_L    (REG_DISP_TOP_OP2_0_BASE + 0xB4)
#define REG_DISP_TOP_OP2_0_5A_H    (REG_DISP_TOP_OP2_0_BASE + 0xB5)
#define REG_DISP_TOP_OP2_0_5B_L    (REG_DISP_TOP_OP2_0_BASE + 0xB6)
#define REG_DISP_TOP_OP2_0_5B_H    (REG_DISP_TOP_OP2_0_BASE + 0xB7)
#define REG_DISP_TOP_OP2_0_5C_L    (REG_DISP_TOP_OP2_0_BASE + 0xB8)
#define REG_DISP_TOP_OP2_0_5C_H    (REG_DISP_TOP_OP2_0_BASE + 0xB9)
#define REG_DISP_TOP_OP2_0_5D_L    (REG_DISP_TOP_OP2_0_BASE + 0xBA)
#define REG_DISP_TOP_OP2_0_5D_H    (REG_DISP_TOP_OP2_0_BASE + 0xBB)
#define REG_DISP_TOP_OP2_0_5E_L    (REG_DISP_TOP_OP2_0_BASE + 0xBC)
#define REG_DISP_TOP_OP2_0_5E_H    (REG_DISP_TOP_OP2_0_BASE + 0xBD)
#define REG_DISP_TOP_OP2_0_5F_L    (REG_DISP_TOP_OP2_0_BASE + 0xBE)
#define REG_DISP_TOP_OP2_0_5F_H    (REG_DISP_TOP_OP2_0_BASE + 0xBF)
#define REG_DISP_TOP_OP2_0_60_L    (REG_DISP_TOP_OP2_0_BASE + 0xC0)
#define REG_DISP_TOP_OP2_0_60_H    (REG_DISP_TOP_OP2_0_BASE + 0xC1)
#define REG_DISP_TOP_OP2_0_61_L    (REG_DISP_TOP_OP2_0_BASE + 0xC2)
#define REG_DISP_TOP_OP2_0_61_H    (REG_DISP_TOP_OP2_0_BASE + 0xC3)
#define REG_DISP_TOP_OP2_0_62_L    (REG_DISP_TOP_OP2_0_BASE + 0xC4)
#define REG_DISP_TOP_OP2_0_62_H    (REG_DISP_TOP_OP2_0_BASE + 0xC5)
#define REG_DISP_TOP_OP2_0_63_L    (REG_DISP_TOP_OP2_0_BASE + 0xC6)
#define REG_DISP_TOP_OP2_0_63_H    (REG_DISP_TOP_OP2_0_BASE + 0xC7)
#define REG_DISP_TOP_OP2_0_64_L    (REG_DISP_TOP_OP2_0_BASE + 0xC8)
#define REG_DISP_TOP_OP2_0_64_H    (REG_DISP_TOP_OP2_0_BASE + 0xC9)
#define REG_DISP_TOP_OP2_0_65_L    (REG_DISP_TOP_OP2_0_BASE + 0xCA)
#define REG_DISP_TOP_OP2_0_65_H    (REG_DISP_TOP_OP2_0_BASE + 0xCB)
#define REG_DISP_TOP_OP2_0_66_L    (REG_DISP_TOP_OP2_0_BASE + 0xCC)
#define REG_DISP_TOP_OP2_0_66_H    (REG_DISP_TOP_OP2_0_BASE + 0xCD)
#define REG_DISP_TOP_OP2_0_67_L    (REG_DISP_TOP_OP2_0_BASE + 0xCE)
#define REG_DISP_TOP_OP2_0_67_H    (REG_DISP_TOP_OP2_0_BASE + 0xCF)
#define REG_DISP_TOP_OP2_0_68_L    (REG_DISP_TOP_OP2_0_BASE + 0xD0)
#define REG_DISP_TOP_OP2_0_68_H    (REG_DISP_TOP_OP2_0_BASE + 0xD1)
#define REG_DISP_TOP_OP2_0_69_L    (REG_DISP_TOP_OP2_0_BASE + 0xD2)
#define REG_DISP_TOP_OP2_0_69_H    (REG_DISP_TOP_OP2_0_BASE + 0xD3)
#define REG_DISP_TOP_OP2_0_6A_L    (REG_DISP_TOP_OP2_0_BASE + 0xD4)
#define REG_DISP_TOP_OP2_0_6A_H    (REG_DISP_TOP_OP2_0_BASE + 0xD5)
#define REG_DISP_TOP_OP2_0_6B_L    (REG_DISP_TOP_OP2_0_BASE + 0xD6)
#define REG_DISP_TOP_OP2_0_6B_H    (REG_DISP_TOP_OP2_0_BASE + 0xD7)
#define REG_DISP_TOP_OP2_0_6C_L    (REG_DISP_TOP_OP2_0_BASE + 0xD8)
#define REG_DISP_TOP_OP2_0_6C_H    (REG_DISP_TOP_OP2_0_BASE + 0xD9)
#define REG_DISP_TOP_OP2_0_6D_L    (REG_DISP_TOP_OP2_0_BASE + 0xDA)
#define REG_DISP_TOP_OP2_0_6D_H    (REG_DISP_TOP_OP2_0_BASE + 0xDB)
#define REG_DISP_TOP_OP2_0_6E_L    (REG_DISP_TOP_OP2_0_BASE + 0xDC)
#define REG_DISP_TOP_OP2_0_6E_H    (REG_DISP_TOP_OP2_0_BASE + 0xDD)
#define REG_DISP_TOP_OP2_0_6F_L    (REG_DISP_TOP_OP2_0_BASE + 0xDE)
#define REG_DISP_TOP_OP2_0_6F_H    (REG_DISP_TOP_OP2_0_BASE + 0xDF)
#define REG_DISP_TOP_OP2_0_70_L    (REG_DISP_TOP_OP2_0_BASE + 0xE0)
#define REG_DISP_TOP_OP2_0_70_H    (REG_DISP_TOP_OP2_0_BASE + 0xE1)
#define REG_DISP_TOP_OP2_0_71_L    (REG_DISP_TOP_OP2_0_BASE + 0xE2)
#define REG_DISP_TOP_OP2_0_71_H    (REG_DISP_TOP_OP2_0_BASE + 0xE3)
#define REG_DISP_TOP_OP2_0_72_L    (REG_DISP_TOP_OP2_0_BASE + 0xE4)
#define REG_DISP_TOP_OP2_0_72_H    (REG_DISP_TOP_OP2_0_BASE + 0xE5)
#define REG_DISP_TOP_OP2_0_73_L    (REG_DISP_TOP_OP2_0_BASE + 0xE6)
#define REG_DISP_TOP_OP2_0_73_H    (REG_DISP_TOP_OP2_0_BASE + 0xE7)
#define REG_DISP_TOP_OP2_0_74_L    (REG_DISP_TOP_OP2_0_BASE + 0xE8)
#define REG_DISP_TOP_OP2_0_74_H    (REG_DISP_TOP_OP2_0_BASE + 0xE9)
#define REG_DISP_TOP_OP2_0_75_L    (REG_DISP_TOP_OP2_0_BASE + 0xEA)
#define REG_DISP_TOP_OP2_0_75_H    (REG_DISP_TOP_OP2_0_BASE + 0xEB)
#define REG_DISP_TOP_OP2_0_76_L    (REG_DISP_TOP_OP2_0_BASE + 0xEC)
#define REG_DISP_TOP_OP2_0_76_H    (REG_DISP_TOP_OP2_0_BASE + 0xED)
#define REG_DISP_TOP_OP2_0_77_L    (REG_DISP_TOP_OP2_0_BASE + 0xEE)
#define REG_DISP_TOP_OP2_0_77_H    (REG_DISP_TOP_OP2_0_BASE + 0xEF)
#define REG_DISP_TOP_OP2_0_78_L    (REG_DISP_TOP_OP2_0_BASE + 0xF0)
#define REG_DISP_TOP_OP2_0_78_H    (REG_DISP_TOP_OP2_0_BASE + 0xF1)
#define REG_DISP_TOP_OP2_0_79_L    (REG_DISP_TOP_OP2_0_BASE + 0xF2)
#define REG_DISP_TOP_OP2_0_79_H    (REG_DISP_TOP_OP2_0_BASE + 0xF3)
#define REG_DISP_TOP_OP2_0_7A_L    (REG_DISP_TOP_OP2_0_BASE + 0xF4)
#define REG_DISP_TOP_OP2_0_7A_H    (REG_DISP_TOP_OP2_0_BASE + 0xF5)
#define REG_DISP_TOP_OP2_0_7B_L    (REG_DISP_TOP_OP2_0_BASE + 0xF6)
#define REG_DISP_TOP_OP2_0_7B_H    (REG_DISP_TOP_OP2_0_BASE + 0xF7)
#define REG_DISP_TOP_OP2_0_7C_L    (REG_DISP_TOP_OP2_0_BASE + 0xF8)
#define REG_DISP_TOP_OP2_0_7C_H    (REG_DISP_TOP_OP2_0_BASE + 0xF9)
#define REG_DISP_TOP_OP2_0_7D_L    (REG_DISP_TOP_OP2_0_BASE + 0xFA)
#define REG_DISP_TOP_OP2_0_7D_H    (REG_DISP_TOP_OP2_0_BASE + 0xFB)
#define REG_DISP_TOP_OP2_0_7E_L    (REG_DISP_TOP_OP2_0_BASE + 0xFC)
#define REG_DISP_TOP_OP2_0_7E_H    (REG_DISP_TOP_OP2_0_BASE + 0xFD)
#define REG_DISP_TOP_OP2_0_7F_L    (REG_DISP_TOP_OP2_0_BASE + 0xFE)
#define REG_DISP_TOP_OP2_0_7F_H    (REG_DISP_TOP_OP2_0_BASE + 0xFF)


#define REG_DISP_TOP_GAMMA_0_00_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x00)
#define REG_DISP_TOP_GAMMA_0_00_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x01)
#define REG_DISP_TOP_GAMMA_0_01_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x02)
#define REG_DISP_TOP_GAMMA_0_01_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x03)
#define REG_DISP_TOP_GAMMA_0_02_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x04)
#define REG_DISP_TOP_GAMMA_0_02_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x05)
#define REG_DISP_TOP_GAMMA_0_03_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x06)
#define REG_DISP_TOP_GAMMA_0_03_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x07)
#define REG_DISP_TOP_GAMMA_0_04_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x08)
#define REG_DISP_TOP_GAMMA_0_04_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x09)
#define REG_DISP_TOP_GAMMA_0_05_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x0A)
#define REG_DISP_TOP_GAMMA_0_05_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x0B)
#define REG_DISP_TOP_GAMMA_0_06_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x0C)
#define REG_DISP_TOP_GAMMA_0_06_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x0D)
#define REG_DISP_TOP_GAMMA_0_07_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x0E)
#define REG_DISP_TOP_GAMMA_0_07_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x0F)
#define REG_DISP_TOP_GAMMA_0_08_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x10)
#define REG_DISP_TOP_GAMMA_0_08_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x11)
#define REG_DISP_TOP_GAMMA_0_09_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x12)
#define REG_DISP_TOP_GAMMA_0_09_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x13)
#define REG_DISP_TOP_GAMMA_0_0A_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x14)
#define REG_DISP_TOP_GAMMA_0_0A_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x15)
#define REG_DISP_TOP_GAMMA_0_0B_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x16)
#define REG_DISP_TOP_GAMMA_0_0B_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x17)
#define REG_DISP_TOP_GAMMA_0_0C_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x18)
#define REG_DISP_TOP_GAMMA_0_0C_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x19)
#define REG_DISP_TOP_GAMMA_0_0D_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x1A)
#define REG_DISP_TOP_GAMMA_0_0D_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x1B)
#define REG_DISP_TOP_GAMMA_0_0E_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x1C)
#define REG_DISP_TOP_GAMMA_0_0E_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x1D)
#define REG_DISP_TOP_GAMMA_0_0F_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x1E)
#define REG_DISP_TOP_GAMMA_0_0F_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x1F)
#define REG_DISP_TOP_GAMMA_0_10_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x20)
#define REG_DISP_TOP_GAMMA_0_10_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x21)
#define REG_DISP_TOP_GAMMA_0_11_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x22)
#define REG_DISP_TOP_GAMMA_0_11_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x23)
#define REG_DISP_TOP_GAMMA_0_12_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x24)
#define REG_DISP_TOP_GAMMA_0_12_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x25)
#define REG_DISP_TOP_GAMMA_0_13_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x26)
#define REG_DISP_TOP_GAMMA_0_13_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x27)
#define REG_DISP_TOP_GAMMA_0_14_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x28)
#define REG_DISP_TOP_GAMMA_0_14_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x29)
#define REG_DISP_TOP_GAMMA_0_15_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x2A)
#define REG_DISP_TOP_GAMMA_0_15_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x2B)
#define REG_DISP_TOP_GAMMA_0_16_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x2C)
#define REG_DISP_TOP_GAMMA_0_16_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x2D)
#define REG_DISP_TOP_GAMMA_0_17_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x2E)
#define REG_DISP_TOP_GAMMA_0_17_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x2F)
#define REG_DISP_TOP_GAMMA_0_18_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x30)
#define REG_DISP_TOP_GAMMA_0_18_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x31)
#define REG_DISP_TOP_GAMMA_0_19_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x32)
#define REG_DISP_TOP_GAMMA_0_19_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x33)
#define REG_DISP_TOP_GAMMA_0_1A_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x34)
#define REG_DISP_TOP_GAMMA_0_1A_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x35)
#define REG_DISP_TOP_GAMMA_0_1B_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x36)
#define REG_DISP_TOP_GAMMA_0_1B_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x37)
#define REG_DISP_TOP_GAMMA_0_1C_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x38)
#define REG_DISP_TOP_GAMMA_0_1C_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x39)
#define REG_DISP_TOP_GAMMA_0_1D_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x3A)
#define REG_DISP_TOP_GAMMA_0_1D_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x3B)
#define REG_DISP_TOP_GAMMA_0_1E_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x3C)
#define REG_DISP_TOP_GAMMA_0_1E_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x3D)
#define REG_DISP_TOP_GAMMA_0_1F_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x3E)
#define REG_DISP_TOP_GAMMA_0_1F_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x3F)
#define REG_DISP_TOP_GAMMA_0_20_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x40)
#define REG_DISP_TOP_GAMMA_0_20_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x41)
#define REG_DISP_TOP_GAMMA_0_21_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x42)
#define REG_DISP_TOP_GAMMA_0_21_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x43)
#define REG_DISP_TOP_GAMMA_0_22_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x44)
#define REG_DISP_TOP_GAMMA_0_22_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x45)
#define REG_DISP_TOP_GAMMA_0_23_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x46)
#define REG_DISP_TOP_GAMMA_0_23_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x47)
#define REG_DISP_TOP_GAMMA_0_24_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x48)
#define REG_DISP_TOP_GAMMA_0_24_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x49)
#define REG_DISP_TOP_GAMMA_0_25_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x4A)
#define REG_DISP_TOP_GAMMA_0_25_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x4B)
#define REG_DISP_TOP_GAMMA_0_26_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x4C)
#define REG_DISP_TOP_GAMMA_0_26_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x4D)
#define REG_DISP_TOP_GAMMA_0_27_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x4E)
#define REG_DISP_TOP_GAMMA_0_27_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x4F)
#define REG_DISP_TOP_GAMMA_0_28_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x50)
#define REG_DISP_TOP_GAMMA_0_28_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x51)
#define REG_DISP_TOP_GAMMA_0_29_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x52)
#define REG_DISP_TOP_GAMMA_0_29_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x53)
#define REG_DISP_TOP_GAMMA_0_2A_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x54)
#define REG_DISP_TOP_GAMMA_0_2A_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x55)
#define REG_DISP_TOP_GAMMA_0_2B_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x56)
#define REG_DISP_TOP_GAMMA_0_2B_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x57)
#define REG_DISP_TOP_GAMMA_0_2C_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x58)
#define REG_DISP_TOP_GAMMA_0_2C_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x59)
#define REG_DISP_TOP_GAMMA_0_2D_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x5A)
#define REG_DISP_TOP_GAMMA_0_2D_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x5B)
#define REG_DISP_TOP_GAMMA_0_2E_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x5C)
#define REG_DISP_TOP_GAMMA_0_2E_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x5D)
#define REG_DISP_TOP_GAMMA_0_2F_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x5E)
#define REG_DISP_TOP_GAMMA_0_2F_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x5F)
#define REG_DISP_TOP_GAMMA_0_30_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x60)
#define REG_DISP_TOP_GAMMA_0_30_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x61)
#define REG_DISP_TOP_GAMMA_0_31_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x62)
#define REG_DISP_TOP_GAMMA_0_31_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x63)
#define REG_DISP_TOP_GAMMA_0_32_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x64)
#define REG_DISP_TOP_GAMMA_0_32_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x65)
#define REG_DISP_TOP_GAMMA_0_33_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x66)
#define REG_DISP_TOP_GAMMA_0_33_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x67)
#define REG_DISP_TOP_GAMMA_0_34_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x68)
#define REG_DISP_TOP_GAMMA_0_34_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x69)
#define REG_DISP_TOP_GAMMA_0_35_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x6A)
#define REG_DISP_TOP_GAMMA_0_35_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x6B)
#define REG_DISP_TOP_GAMMA_0_36_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x6C)
#define REG_DISP_TOP_GAMMA_0_36_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x6D)
#define REG_DISP_TOP_GAMMA_0_37_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x6E)
#define REG_DISP_TOP_GAMMA_0_37_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x6F)
#define REG_DISP_TOP_GAMMA_0_38_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x70)
#define REG_DISP_TOP_GAMMA_0_38_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x71)
#define REG_DISP_TOP_GAMMA_0_39_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x72)
#define REG_DISP_TOP_GAMMA_0_39_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x73)
#define REG_DISP_TOP_GAMMA_0_3A_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x74)
#define REG_DISP_TOP_GAMMA_0_3A_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x75)
#define REG_DISP_TOP_GAMMA_0_3B_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x76)
#define REG_DISP_TOP_GAMMA_0_3B_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x77)
#define REG_DISP_TOP_GAMMA_0_3C_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x78)
#define REG_DISP_TOP_GAMMA_0_3C_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x79)
#define REG_DISP_TOP_GAMMA_0_3D_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x7A)
#define REG_DISP_TOP_GAMMA_0_3D_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x7B)
#define REG_DISP_TOP_GAMMA_0_3E_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x7C)
#define REG_DISP_TOP_GAMMA_0_3E_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x7D)
#define REG_DISP_TOP_GAMMA_0_3F_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x7E)
#define REG_DISP_TOP_GAMMA_0_3F_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x7F)
#define REG_DISP_TOP_GAMMA_0_40_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x80)
#define REG_DISP_TOP_GAMMA_0_40_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x81)
#define REG_DISP_TOP_GAMMA_0_41_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x82)
#define REG_DISP_TOP_GAMMA_0_41_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x83)
#define REG_DISP_TOP_GAMMA_0_42_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x84)
#define REG_DISP_TOP_GAMMA_0_42_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x85)
#define REG_DISP_TOP_GAMMA_0_43_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x86)
#define REG_DISP_TOP_GAMMA_0_43_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x87)
#define REG_DISP_TOP_GAMMA_0_44_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x88)
#define REG_DISP_TOP_GAMMA_0_44_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x89)
#define REG_DISP_TOP_GAMMA_0_45_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x8A)
#define REG_DISP_TOP_GAMMA_0_45_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x8B)
#define REG_DISP_TOP_GAMMA_0_46_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x8C)
#define REG_DISP_TOP_GAMMA_0_46_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x8D)
#define REG_DISP_TOP_GAMMA_0_47_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x8E)
#define REG_DISP_TOP_GAMMA_0_47_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x8F)
#define REG_DISP_TOP_GAMMA_0_48_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x90)
#define REG_DISP_TOP_GAMMA_0_48_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x91)
#define REG_DISP_TOP_GAMMA_0_49_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x92)
#define REG_DISP_TOP_GAMMA_0_49_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x93)
#define REG_DISP_TOP_GAMMA_0_4A_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x94)
#define REG_DISP_TOP_GAMMA_0_4A_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x95)
#define REG_DISP_TOP_GAMMA_0_4B_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x96)
#define REG_DISP_TOP_GAMMA_0_4B_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x97)
#define REG_DISP_TOP_GAMMA_0_4C_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x98)
#define REG_DISP_TOP_GAMMA_0_4C_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x99)
#define REG_DISP_TOP_GAMMA_0_4D_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x9A)
#define REG_DISP_TOP_GAMMA_0_4D_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x9B)
#define REG_DISP_TOP_GAMMA_0_4E_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x9C)
#define REG_DISP_TOP_GAMMA_0_4E_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x9D)
#define REG_DISP_TOP_GAMMA_0_4F_L    (REG_DISP_TOP_GAMMA_0_BASE + 0x9E)
#define REG_DISP_TOP_GAMMA_0_4F_H    (REG_DISP_TOP_GAMMA_0_BASE + 0x9F)
#define REG_DISP_TOP_GAMMA_0_50_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xA0)
#define REG_DISP_TOP_GAMMA_0_50_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xA1)
#define REG_DISP_TOP_GAMMA_0_51_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xA2)
#define REG_DISP_TOP_GAMMA_0_51_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xA3)
#define REG_DISP_TOP_GAMMA_0_52_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xA4)
#define REG_DISP_TOP_GAMMA_0_52_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xA5)
#define REG_DISP_TOP_GAMMA_0_53_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xA6)
#define REG_DISP_TOP_GAMMA_0_53_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xA7)
#define REG_DISP_TOP_GAMMA_0_54_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xA8)
#define REG_DISP_TOP_GAMMA_0_54_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xA9)
#define REG_DISP_TOP_GAMMA_0_55_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xAA)
#define REG_DISP_TOP_GAMMA_0_55_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xAB)
#define REG_DISP_TOP_GAMMA_0_56_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xAC)
#define REG_DISP_TOP_GAMMA_0_56_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xAD)
#define REG_DISP_TOP_GAMMA_0_57_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xAE)
#define REG_DISP_TOP_GAMMA_0_57_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xAF)
#define REG_DISP_TOP_GAMMA_0_58_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xB0)
#define REG_DISP_TOP_GAMMA_0_58_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xB1)
#define REG_DISP_TOP_GAMMA_0_59_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xB2)
#define REG_DISP_TOP_GAMMA_0_59_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xB3)
#define REG_DISP_TOP_GAMMA_0_5A_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xB4)
#define REG_DISP_TOP_GAMMA_0_5A_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xB5)
#define REG_DISP_TOP_GAMMA_0_5B_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xB6)
#define REG_DISP_TOP_GAMMA_0_5B_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xB7)
#define REG_DISP_TOP_GAMMA_0_5C_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xB8)
#define REG_DISP_TOP_GAMMA_0_5C_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xB9)
#define REG_DISP_TOP_GAMMA_0_5D_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xBA)
#define REG_DISP_TOP_GAMMA_0_5D_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xBB)
#define REG_DISP_TOP_GAMMA_0_5E_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xBC)
#define REG_DISP_TOP_GAMMA_0_5E_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xBD)
#define REG_DISP_TOP_GAMMA_0_5F_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xBE)
#define REG_DISP_TOP_GAMMA_0_5F_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xBF)
#define REG_DISP_TOP_GAMMA_0_60_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xC0)
#define REG_DISP_TOP_GAMMA_0_60_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xC1)
#define REG_DISP_TOP_GAMMA_0_61_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xC2)
#define REG_DISP_TOP_GAMMA_0_61_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xC3)
#define REG_DISP_TOP_GAMMA_0_62_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xC4)
#define REG_DISP_TOP_GAMMA_0_62_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xC5)
#define REG_DISP_TOP_GAMMA_0_63_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xC6)
#define REG_DISP_TOP_GAMMA_0_63_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xC7)
#define REG_DISP_TOP_GAMMA_0_64_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xC8)
#define REG_DISP_TOP_GAMMA_0_64_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xC9)
#define REG_DISP_TOP_GAMMA_0_65_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xCA)
#define REG_DISP_TOP_GAMMA_0_65_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xCB)
#define REG_DISP_TOP_GAMMA_0_66_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xCC)
#define REG_DISP_TOP_GAMMA_0_66_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xCD)
#define REG_DISP_TOP_GAMMA_0_67_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xCE)
#define REG_DISP_TOP_GAMMA_0_67_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xCF)
#define REG_DISP_TOP_GAMMA_0_68_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xD0)
#define REG_DISP_TOP_GAMMA_0_68_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xD1)
#define REG_DISP_TOP_GAMMA_0_69_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xD2)
#define REG_DISP_TOP_GAMMA_0_69_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xD3)
#define REG_DISP_TOP_GAMMA_0_6A_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xD4)
#define REG_DISP_TOP_GAMMA_0_6A_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xD5)
#define REG_DISP_TOP_GAMMA_0_6B_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xD6)
#define REG_DISP_TOP_GAMMA_0_6B_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xD7)
#define REG_DISP_TOP_GAMMA_0_6C_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xD8)
#define REG_DISP_TOP_GAMMA_0_6C_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xD9)
#define REG_DISP_TOP_GAMMA_0_6D_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xDA)
#define REG_DISP_TOP_GAMMA_0_6D_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xDB)
#define REG_DISP_TOP_GAMMA_0_6E_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xDC)
#define REG_DISP_TOP_GAMMA_0_6E_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xDD)
#define REG_DISP_TOP_GAMMA_0_6F_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xDE)
#define REG_DISP_TOP_GAMMA_0_6F_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xDF)
#define REG_DISP_TOP_GAMMA_0_70_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xE0)
#define REG_DISP_TOP_GAMMA_0_70_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xE1)
#define REG_DISP_TOP_GAMMA_0_71_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xE2)
#define REG_DISP_TOP_GAMMA_0_71_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xE3)
#define REG_DISP_TOP_GAMMA_0_72_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xE4)
#define REG_DISP_TOP_GAMMA_0_72_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xE5)
#define REG_DISP_TOP_GAMMA_0_73_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xE6)
#define REG_DISP_TOP_GAMMA_0_73_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xE7)
#define REG_DISP_TOP_GAMMA_0_74_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xE8)
#define REG_DISP_TOP_GAMMA_0_74_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xE9)
#define REG_DISP_TOP_GAMMA_0_75_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xEA)
#define REG_DISP_TOP_GAMMA_0_75_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xEB)
#define REG_DISP_TOP_GAMMA_0_76_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xEC)
#define REG_DISP_TOP_GAMMA_0_76_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xED)
#define REG_DISP_TOP_GAMMA_0_77_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xEE)
#define REG_DISP_TOP_GAMMA_0_77_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xEF)
#define REG_DISP_TOP_GAMMA_0_78_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xF0)
#define REG_DISP_TOP_GAMMA_0_78_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xF1)
#define REG_DISP_TOP_GAMMA_0_79_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xF2)
#define REG_DISP_TOP_GAMMA_0_79_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xF3)
#define REG_DISP_TOP_GAMMA_0_7A_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xF4)
#define REG_DISP_TOP_GAMMA_0_7A_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xF5)
#define REG_DISP_TOP_GAMMA_0_7B_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xF6)
#define REG_DISP_TOP_GAMMA_0_7B_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xF7)
#define REG_DISP_TOP_GAMMA_0_7C_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xF8)
#define REG_DISP_TOP_GAMMA_0_7C_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xF9)
#define REG_DISP_TOP_GAMMA_0_7D_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xFA)
#define REG_DISP_TOP_GAMMA_0_7D_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xFB)
#define REG_DISP_TOP_GAMMA_0_7E_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xFC)
#define REG_DISP_TOP_GAMMA_0_7E_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xFD)
#define REG_DISP_TOP_GAMMA_0_7F_L    (REG_DISP_TOP_GAMMA_0_BASE + 0xFE)
#define REG_DISP_TOP_GAMMA_0_7F_H    (REG_DISP_TOP_GAMMA_0_BASE + 0xFF)

#define REG_DISP_TOP_MACE_00_L    (REG_DISP_TOP_MACE_BASE + 0x00)
#define REG_DISP_TOP_MACE_00_H    (REG_DISP_TOP_MACE_BASE + 0x01)
#define REG_DISP_TOP_MACE_01_L    (REG_DISP_TOP_MACE_BASE + 0x02)
#define REG_DISP_TOP_MACE_01_H    (REG_DISP_TOP_MACE_BASE + 0x03)
#define REG_DISP_TOP_MACE_02_L    (REG_DISP_TOP_MACE_BASE + 0x04)
#define REG_DISP_TOP_MACE_02_H    (REG_DISP_TOP_MACE_BASE + 0x05)
#define REG_DISP_TOP_MACE_03_L    (REG_DISP_TOP_MACE_BASE + 0x06)
#define REG_DISP_TOP_MACE_03_H    (REG_DISP_TOP_MACE_BASE + 0x07)
#define REG_DISP_TOP_MACE_04_L    (REG_DISP_TOP_MACE_BASE + 0x08)
#define REG_DISP_TOP_MACE_04_H    (REG_DISP_TOP_MACE_BASE + 0x09)
#define REG_DISP_TOP_MACE_05_L    (REG_DISP_TOP_MACE_BASE + 0x0A)
#define REG_DISP_TOP_MACE_05_H    (REG_DISP_TOP_MACE_BASE + 0x0B)
#define REG_DISP_TOP_MACE_06_L    (REG_DISP_TOP_MACE_BASE + 0x0C)
#define REG_DISP_TOP_MACE_06_H    (REG_DISP_TOP_MACE_BASE + 0x0D)
#define REG_DISP_TOP_MACE_07_L    (REG_DISP_TOP_MACE_BASE + 0x0E)
#define REG_DISP_TOP_MACE_07_H    (REG_DISP_TOP_MACE_BASE + 0x0F)
#define REG_DISP_TOP_MACE_08_L    (REG_DISP_TOP_MACE_BASE + 0x10)
#define REG_DISP_TOP_MACE_08_H    (REG_DISP_TOP_MACE_BASE + 0x11)
#define REG_DISP_TOP_MACE_09_L    (REG_DISP_TOP_MACE_BASE + 0x12)
#define REG_DISP_TOP_MACE_09_H    (REG_DISP_TOP_MACE_BASE + 0x13)
#define REG_DISP_TOP_MACE_0A_L    (REG_DISP_TOP_MACE_BASE + 0x14)
#define REG_DISP_TOP_MACE_0A_H    (REG_DISP_TOP_MACE_BASE + 0x15)
#define REG_DISP_TOP_MACE_0B_L    (REG_DISP_TOP_MACE_BASE + 0x16)
#define REG_DISP_TOP_MACE_0B_H    (REG_DISP_TOP_MACE_BASE + 0x17)
#define REG_DISP_TOP_MACE_0C_L    (REG_DISP_TOP_MACE_BASE + 0x18)
#define REG_DISP_TOP_MACE_0C_H    (REG_DISP_TOP_MACE_BASE + 0x19)
#define REG_DISP_TOP_MACE_0D_L    (REG_DISP_TOP_MACE_BASE + 0x1A)
#define REG_DISP_TOP_MACE_0D_H    (REG_DISP_TOP_MACE_BASE + 0x1B)
#define REG_DISP_TOP_MACE_0E_L    (REG_DISP_TOP_MACE_BASE + 0x1C)
#define REG_DISP_TOP_MACE_0E_H    (REG_DISP_TOP_MACE_BASE + 0x1D)
#define REG_DISP_TOP_MACE_0F_L    (REG_DISP_TOP_MACE_BASE + 0x1E)
#define REG_DISP_TOP_MACE_0F_H    (REG_DISP_TOP_MACE_BASE + 0x1F)
#define REG_DISP_TOP_MACE_10_L    (REG_DISP_TOP_MACE_BASE + 0x20)
#define REG_DISP_TOP_MACE_10_H    (REG_DISP_TOP_MACE_BASE + 0x21)
#define REG_DISP_TOP_MACE_11_L    (REG_DISP_TOP_MACE_BASE + 0x22)
#define REG_DISP_TOP_MACE_11_H    (REG_DISP_TOP_MACE_BASE + 0x23)
#define REG_DISP_TOP_MACE_12_L    (REG_DISP_TOP_MACE_BASE + 0x24)
#define REG_DISP_TOP_MACE_12_H    (REG_DISP_TOP_MACE_BASE + 0x25)
#define REG_DISP_TOP_MACE_13_L    (REG_DISP_TOP_MACE_BASE + 0x26)
#define REG_DISP_TOP_MACE_13_H    (REG_DISP_TOP_MACE_BASE + 0x27)
#define REG_DISP_TOP_MACE_14_L    (REG_DISP_TOP_MACE_BASE + 0x28)
#define REG_DISP_TOP_MACE_14_H    (REG_DISP_TOP_MACE_BASE + 0x29)
#define REG_DISP_TOP_MACE_15_L    (REG_DISP_TOP_MACE_BASE + 0x2A)
#define REG_DISP_TOP_MACE_15_H    (REG_DISP_TOP_MACE_BASE + 0x2B)
#define REG_DISP_TOP_MACE_16_L    (REG_DISP_TOP_MACE_BASE + 0x2C)
#define REG_DISP_TOP_MACE_16_H    (REG_DISP_TOP_MACE_BASE + 0x2D)
#define REG_DISP_TOP_MACE_17_L    (REG_DISP_TOP_MACE_BASE + 0x2E)
#define REG_DISP_TOP_MACE_17_H    (REG_DISP_TOP_MACE_BASE + 0x2F)
#define REG_DISP_TOP_MACE_18_L    (REG_DISP_TOP_MACE_BASE + 0x30)
#define REG_DISP_TOP_MACE_18_H    (REG_DISP_TOP_MACE_BASE + 0x31)
#define REG_DISP_TOP_MACE_19_L    (REG_DISP_TOP_MACE_BASE + 0x32)
#define REG_DISP_TOP_MACE_19_H    (REG_DISP_TOP_MACE_BASE + 0x33)
#define REG_DISP_TOP_MACE_1A_L    (REG_DISP_TOP_MACE_BASE + 0x34)
#define REG_DISP_TOP_MACE_1A_H    (REG_DISP_TOP_MACE_BASE + 0x35)
#define REG_DISP_TOP_MACE_1B_L    (REG_DISP_TOP_MACE_BASE + 0x36)
#define REG_DISP_TOP_MACE_1B_H    (REG_DISP_TOP_MACE_BASE + 0x37)
#define REG_DISP_TOP_MACE_1C_L    (REG_DISP_TOP_MACE_BASE + 0x38)
#define REG_DISP_TOP_MACE_1C_H    (REG_DISP_TOP_MACE_BASE + 0x39)
#define REG_DISP_TOP_MACE_1D_L    (REG_DISP_TOP_MACE_BASE + 0x3A)
#define REG_DISP_TOP_MACE_1D_H    (REG_DISP_TOP_MACE_BASE + 0x3B)
#define REG_DISP_TOP_MACE_1E_L    (REG_DISP_TOP_MACE_BASE + 0x3C)
#define REG_DISP_TOP_MACE_1E_H    (REG_DISP_TOP_MACE_BASE + 0x3D)
#define REG_DISP_TOP_MACE_1F_L    (REG_DISP_TOP_MACE_BASE + 0x3E)
#define REG_DISP_TOP_MACE_1F_H    (REG_DISP_TOP_MACE_BASE + 0x3F)
#define REG_DISP_TOP_MACE_20_L    (REG_DISP_TOP_MACE_BASE + 0x40)
#define REG_DISP_TOP_MACE_20_H    (REG_DISP_TOP_MACE_BASE + 0x41)
#define REG_DISP_TOP_MACE_21_L    (REG_DISP_TOP_MACE_BASE + 0x42)
#define REG_DISP_TOP_MACE_21_H    (REG_DISP_TOP_MACE_BASE + 0x43)
#define REG_DISP_TOP_MACE_22_L    (REG_DISP_TOP_MACE_BASE + 0x44)
#define REG_DISP_TOP_MACE_22_H    (REG_DISP_TOP_MACE_BASE + 0x45)
#define REG_DISP_TOP_MACE_23_L    (REG_DISP_TOP_MACE_BASE + 0x46)
#define REG_DISP_TOP_MACE_23_H    (REG_DISP_TOP_MACE_BASE + 0x47)
#define REG_DISP_TOP_MACE_24_L    (REG_DISP_TOP_MACE_BASE + 0x48)
#define REG_DISP_TOP_MACE_24_H    (REG_DISP_TOP_MACE_BASE + 0x49)
#define REG_DISP_TOP_MACE_25_L    (REG_DISP_TOP_MACE_BASE + 0x4A)
#define REG_DISP_TOP_MACE_25_H    (REG_DISP_TOP_MACE_BASE + 0x4B)
#define REG_DISP_TOP_MACE_26_L    (REG_DISP_TOP_MACE_BASE + 0x4C)
#define REG_DISP_TOP_MACE_26_H    (REG_DISP_TOP_MACE_BASE + 0x4D)
#define REG_DISP_TOP_MACE_27_L    (REG_DISP_TOP_MACE_BASE + 0x4E)
#define REG_DISP_TOP_MACE_27_H    (REG_DISP_TOP_MACE_BASE + 0x4F)
#define REG_DISP_TOP_MACE_28_L    (REG_DISP_TOP_MACE_BASE + 0x50)
#define REG_DISP_TOP_MACE_28_H    (REG_DISP_TOP_MACE_BASE + 0x51)
#define REG_DISP_TOP_MACE_29_L    (REG_DISP_TOP_MACE_BASE + 0x52)
#define REG_DISP_TOP_MACE_29_H    (REG_DISP_TOP_MACE_BASE + 0x53)
#define REG_DISP_TOP_MACE_2A_L    (REG_DISP_TOP_MACE_BASE + 0x54)
#define REG_DISP_TOP_MACE_2A_H    (REG_DISP_TOP_MACE_BASE + 0x55)
#define REG_DISP_TOP_MACE_2B_L    (REG_DISP_TOP_MACE_BASE + 0x56)
#define REG_DISP_TOP_MACE_2B_H    (REG_DISP_TOP_MACE_BASE + 0x57)
#define REG_DISP_TOP_MACE_2C_L    (REG_DISP_TOP_MACE_BASE + 0x58)
#define REG_DISP_TOP_MACE_2C_H    (REG_DISP_TOP_MACE_BASE + 0x59)
#define REG_DISP_TOP_MACE_2D_L    (REG_DISP_TOP_MACE_BASE + 0x5A)
#define REG_DISP_TOP_MACE_2D_H    (REG_DISP_TOP_MACE_BASE + 0x5B)
#define REG_DISP_TOP_MACE_2E_L    (REG_DISP_TOP_MACE_BASE + 0x5C)
#define REG_DISP_TOP_MACE_2E_H    (REG_DISP_TOP_MACE_BASE + 0x5D)
#define REG_DISP_TOP_MACE_2F_L    (REG_DISP_TOP_MACE_BASE + 0x5E)
#define REG_DISP_TOP_MACE_2F_H    (REG_DISP_TOP_MACE_BASE + 0x5F)
#define REG_DISP_TOP_MACE_30_L    (REG_DISP_TOP_MACE_BASE + 0x60)
#define REG_DISP_TOP_MACE_30_H    (REG_DISP_TOP_MACE_BASE + 0x61)
#define REG_DISP_TOP_MACE_31_L    (REG_DISP_TOP_MACE_BASE + 0x62)
#define REG_DISP_TOP_MACE_31_H    (REG_DISP_TOP_MACE_BASE + 0x63)
#define REG_DISP_TOP_MACE_32_L    (REG_DISP_TOP_MACE_BASE + 0x64)
#define REG_DISP_TOP_MACE_32_H    (REG_DISP_TOP_MACE_BASE + 0x65)
#define REG_DISP_TOP_MACE_33_L    (REG_DISP_TOP_MACE_BASE + 0x66)
#define REG_DISP_TOP_MACE_33_H    (REG_DISP_TOP_MACE_BASE + 0x67)
#define REG_DISP_TOP_MACE_34_L    (REG_DISP_TOP_MACE_BASE + 0x68)
#define REG_DISP_TOP_MACE_34_H    (REG_DISP_TOP_MACE_BASE + 0x69)
#define REG_DISP_TOP_MACE_35_L    (REG_DISP_TOP_MACE_BASE + 0x6A)
#define REG_DISP_TOP_MACE_35_H    (REG_DISP_TOP_MACE_BASE + 0x6B)
#define REG_DISP_TOP_MACE_36_L    (REG_DISP_TOP_MACE_BASE + 0x6C)
#define REG_DISP_TOP_MACE_36_H    (REG_DISP_TOP_MACE_BASE + 0x6D)
#define REG_DISP_TOP_MACE_37_L    (REG_DISP_TOP_MACE_BASE + 0x6E)
#define REG_DISP_TOP_MACE_37_H    (REG_DISP_TOP_MACE_BASE + 0x6F)
#define REG_DISP_TOP_MACE_38_L    (REG_DISP_TOP_MACE_BASE + 0x70)
#define REG_DISP_TOP_MACE_38_H    (REG_DISP_TOP_MACE_BASE + 0x71)
#define REG_DISP_TOP_MACE_39_L    (REG_DISP_TOP_MACE_BASE + 0x72)
#define REG_DISP_TOP_MACE_39_H    (REG_DISP_TOP_MACE_BASE + 0x73)
#define REG_DISP_TOP_MACE_3A_L    (REG_DISP_TOP_MACE_BASE + 0x74)
#define REG_DISP_TOP_MACE_3A_H    (REG_DISP_TOP_MACE_BASE + 0x75)
#define REG_DISP_TOP_MACE_3B_L    (REG_DISP_TOP_MACE_BASE + 0x76)
#define REG_DISP_TOP_MACE_3B_H    (REG_DISP_TOP_MACE_BASE + 0x77)
#define REG_DISP_TOP_MACE_3C_L    (REG_DISP_TOP_MACE_BASE + 0x78)
#define REG_DISP_TOP_MACE_3C_H    (REG_DISP_TOP_MACE_BASE + 0x79)
#define REG_DISP_TOP_MACE_3D_L    (REG_DISP_TOP_MACE_BASE + 0x7A)
#define REG_DISP_TOP_MACE_3D_H    (REG_DISP_TOP_MACE_BASE + 0x7B)
#define REG_DISP_TOP_MACE_3E_L    (REG_DISP_TOP_MACE_BASE + 0x7C)
#define REG_DISP_TOP_MACE_3E_H    (REG_DISP_TOP_MACE_BASE + 0x7D)
#define REG_DISP_TOP_MACE_3F_L    (REG_DISP_TOP_MACE_BASE + 0x7E)
#define REG_DISP_TOP_MACE_3F_H    (REG_DISP_TOP_MACE_BASE + 0x7F)
#define REG_DISP_TOP_MACE_40_L    (REG_DISP_TOP_MACE_BASE + 0x80)
#define REG_DISP_TOP_MACE_40_H    (REG_DISP_TOP_MACE_BASE + 0x81)
#define REG_DISP_TOP_MACE_41_L    (REG_DISP_TOP_MACE_BASE + 0x82)
#define REG_DISP_TOP_MACE_41_H    (REG_DISP_TOP_MACE_BASE + 0x83)
#define REG_DISP_TOP_MACE_42_L    (REG_DISP_TOP_MACE_BASE + 0x84)
#define REG_DISP_TOP_MACE_42_H    (REG_DISP_TOP_MACE_BASE + 0x85)
#define REG_DISP_TOP_MACE_43_L    (REG_DISP_TOP_MACE_BASE + 0x86)
#define REG_DISP_TOP_MACE_43_H    (REG_DISP_TOP_MACE_BASE + 0x87)
#define REG_DISP_TOP_MACE_44_L    (REG_DISP_TOP_MACE_BASE + 0x88)
#define REG_DISP_TOP_MACE_44_H    (REG_DISP_TOP_MACE_BASE + 0x89)
#define REG_DISP_TOP_MACE_45_L    (REG_DISP_TOP_MACE_BASE + 0x8A)
#define REG_DISP_TOP_MACE_45_H    (REG_DISP_TOP_MACE_BASE + 0x8B)
#define REG_DISP_TOP_MACE_46_L    (REG_DISP_TOP_MACE_BASE + 0x8C)
#define REG_DISP_TOP_MACE_46_H    (REG_DISP_TOP_MACE_BASE + 0x8D)
#define REG_DISP_TOP_MACE_47_L    (REG_DISP_TOP_MACE_BASE + 0x8E)
#define REG_DISP_TOP_MACE_47_H    (REG_DISP_TOP_MACE_BASE + 0x8F)
#define REG_DISP_TOP_MACE_48_L    (REG_DISP_TOP_MACE_BASE + 0x90)
#define REG_DISP_TOP_MACE_48_H    (REG_DISP_TOP_MACE_BASE + 0x91)
#define REG_DISP_TOP_MACE_49_L    (REG_DISP_TOP_MACE_BASE + 0x92)
#define REG_DISP_TOP_MACE_49_H    (REG_DISP_TOP_MACE_BASE + 0x93)
#define REG_DISP_TOP_MACE_4A_L    (REG_DISP_TOP_MACE_BASE + 0x94)
#define REG_DISP_TOP_MACE_4A_H    (REG_DISP_TOP_MACE_BASE + 0x95)
#define REG_DISP_TOP_MACE_4B_L    (REG_DISP_TOP_MACE_BASE + 0x96)
#define REG_DISP_TOP_MACE_4B_H    (REG_DISP_TOP_MACE_BASE + 0x97)
#define REG_DISP_TOP_MACE_4C_L    (REG_DISP_TOP_MACE_BASE + 0x98)
#define REG_DISP_TOP_MACE_4C_H    (REG_DISP_TOP_MACE_BASE + 0x99)
#define REG_DISP_TOP_MACE_4D_L    (REG_DISP_TOP_MACE_BASE + 0x9A)
#define REG_DISP_TOP_MACE_4D_H    (REG_DISP_TOP_MACE_BASE + 0x9B)
#define REG_DISP_TOP_MACE_4E_L    (REG_DISP_TOP_MACE_BASE + 0x9C)
#define REG_DISP_TOP_MACE_4E_H    (REG_DISP_TOP_MACE_BASE + 0x9D)
#define REG_DISP_TOP_MACE_4F_L    (REG_DISP_TOP_MACE_BASE + 0x9E)
#define REG_DISP_TOP_MACE_4F_H    (REG_DISP_TOP_MACE_BASE + 0x9F)
#define REG_DISP_TOP_MACE_50_L    (REG_DISP_TOP_MACE_BASE + 0xA0)
#define REG_DISP_TOP_MACE_50_H    (REG_DISP_TOP_MACE_BASE + 0xA1)
#define REG_DISP_TOP_MACE_51_L    (REG_DISP_TOP_MACE_BASE + 0xA2)
#define REG_DISP_TOP_MACE_51_H    (REG_DISP_TOP_MACE_BASE + 0xA3)
#define REG_DISP_TOP_MACE_52_L    (REG_DISP_TOP_MACE_BASE + 0xA4)
#define REG_DISP_TOP_MACE_52_H    (REG_DISP_TOP_MACE_BASE + 0xA5)
#define REG_DISP_TOP_MACE_53_L    (REG_DISP_TOP_MACE_BASE + 0xA6)
#define REG_DISP_TOP_MACE_53_H    (REG_DISP_TOP_MACE_BASE + 0xA7)
#define REG_DISP_TOP_MACE_54_L    (REG_DISP_TOP_MACE_BASE + 0xA8)
#define REG_DISP_TOP_MACE_54_H    (REG_DISP_TOP_MACE_BASE + 0xA9)
#define REG_DISP_TOP_MACE_55_L    (REG_DISP_TOP_MACE_BASE + 0xAA)
#define REG_DISP_TOP_MACE_55_H    (REG_DISP_TOP_MACE_BASE + 0xAB)
#define REG_DISP_TOP_MACE_56_L    (REG_DISP_TOP_MACE_BASE + 0xAC)
#define REG_DISP_TOP_MACE_56_H    (REG_DISP_TOP_MACE_BASE + 0xAD)
#define REG_DISP_TOP_MACE_57_L    (REG_DISP_TOP_MACE_BASE + 0xAE)
#define REG_DISP_TOP_MACE_57_H    (REG_DISP_TOP_MACE_BASE + 0xAF)
#define REG_DISP_TOP_MACE_58_L    (REG_DISP_TOP_MACE_BASE + 0xB0)
#define REG_DISP_TOP_MACE_58_H    (REG_DISP_TOP_MACE_BASE + 0xB1)
#define REG_DISP_TOP_MACE_59_L    (REG_DISP_TOP_MACE_BASE + 0xB2)
#define REG_DISP_TOP_MACE_59_H    (REG_DISP_TOP_MACE_BASE + 0xB3)
#define REG_DISP_TOP_MACE_5A_L    (REG_DISP_TOP_MACE_BASE + 0xB4)
#define REG_DISP_TOP_MACE_5A_H    (REG_DISP_TOP_MACE_BASE + 0xB5)
#define REG_DISP_TOP_MACE_5B_L    (REG_DISP_TOP_MACE_BASE + 0xB6)
#define REG_DISP_TOP_MACE_5B_H    (REG_DISP_TOP_MACE_BASE + 0xB7)
#define REG_DISP_TOP_MACE_5C_L    (REG_DISP_TOP_MACE_BASE + 0xB8)
#define REG_DISP_TOP_MACE_5C_H    (REG_DISP_TOP_MACE_BASE + 0xB9)
#define REG_DISP_TOP_MACE_5D_L    (REG_DISP_TOP_MACE_BASE + 0xBA)
#define REG_DISP_TOP_MACE_5D_H    (REG_DISP_TOP_MACE_BASE + 0xBB)
#define REG_DISP_TOP_MACE_5E_L    (REG_DISP_TOP_MACE_BASE + 0xBC)
#define REG_DISP_TOP_MACE_5E_H    (REG_DISP_TOP_MACE_BASE + 0xBD)
#define REG_DISP_TOP_MACE_5F_L    (REG_DISP_TOP_MACE_BASE + 0xBE)
#define REG_DISP_TOP_MACE_5F_H    (REG_DISP_TOP_MACE_BASE + 0xBF)
#define REG_DISP_TOP_MACE_60_L    (REG_DISP_TOP_MACE_BASE + 0xC0)
#define REG_DISP_TOP_MACE_60_H    (REG_DISP_TOP_MACE_BASE + 0xC1)
#define REG_DISP_TOP_MACE_61_L    (REG_DISP_TOP_MACE_BASE + 0xC2)
#define REG_DISP_TOP_MACE_61_H    (REG_DISP_TOP_MACE_BASE + 0xC3)
#define REG_DISP_TOP_MACE_62_L    (REG_DISP_TOP_MACE_BASE + 0xC4)
#define REG_DISP_TOP_MACE_62_H    (REG_DISP_TOP_MACE_BASE + 0xC5)
#define REG_DISP_TOP_MACE_63_L    (REG_DISP_TOP_MACE_BASE + 0xC6)
#define REG_DISP_TOP_MACE_63_H    (REG_DISP_TOP_MACE_BASE + 0xC7)
#define REG_DISP_TOP_MACE_64_L    (REG_DISP_TOP_MACE_BASE + 0xC8)
#define REG_DISP_TOP_MACE_64_H    (REG_DISP_TOP_MACE_BASE + 0xC9)
#define REG_DISP_TOP_MACE_65_L    (REG_DISP_TOP_MACE_BASE + 0xCA)
#define REG_DISP_TOP_MACE_65_H    (REG_DISP_TOP_MACE_BASE + 0xCB)
#define REG_DISP_TOP_MACE_66_L    (REG_DISP_TOP_MACE_BASE + 0xCC)
#define REG_DISP_TOP_MACE_66_H    (REG_DISP_TOP_MACE_BASE + 0xCD)
#define REG_DISP_TOP_MACE_67_L    (REG_DISP_TOP_MACE_BASE + 0xCE)
#define REG_DISP_TOP_MACE_67_H    (REG_DISP_TOP_MACE_BASE + 0xCF)
#define REG_DISP_TOP_MACE_68_L    (REG_DISP_TOP_MACE_BASE + 0xD0)
#define REG_DISP_TOP_MACE_68_H    (REG_DISP_TOP_MACE_BASE + 0xD1)
#define REG_DISP_TOP_MACE_69_L    (REG_DISP_TOP_MACE_BASE + 0xD2)
#define REG_DISP_TOP_MACE_69_H    (REG_DISP_TOP_MACE_BASE + 0xD3)
#define REG_DISP_TOP_MACE_6A_L    (REG_DISP_TOP_MACE_BASE + 0xD4)
#define REG_DISP_TOP_MACE_6A_H    (REG_DISP_TOP_MACE_BASE + 0xD5)
#define REG_DISP_TOP_MACE_6B_L    (REG_DISP_TOP_MACE_BASE + 0xD6)
#define REG_DISP_TOP_MACE_6B_H    (REG_DISP_TOP_MACE_BASE + 0xD7)
#define REG_DISP_TOP_MACE_6C_L    (REG_DISP_TOP_MACE_BASE + 0xD8)
#define REG_DISP_TOP_MACE_6C_H    (REG_DISP_TOP_MACE_BASE + 0xD9)
#define REG_DISP_TOP_MACE_6D_L    (REG_DISP_TOP_MACE_BASE + 0xDA)
#define REG_DISP_TOP_MACE_6D_H    (REG_DISP_TOP_MACE_BASE + 0xDB)
#define REG_DISP_TOP_MACE_6E_L    (REG_DISP_TOP_MACE_BASE + 0xDC)
#define REG_DISP_TOP_MACE_6E_H    (REG_DISP_TOP_MACE_BASE + 0xDD)
#define REG_DISP_TOP_MACE_6F_L    (REG_DISP_TOP_MACE_BASE + 0xDE)
#define REG_DISP_TOP_MACE_6F_H    (REG_DISP_TOP_MACE_BASE + 0xDF)
#define REG_DISP_TOP_MACE_70_L    (REG_DISP_TOP_MACE_BASE + 0xE0)
#define REG_DISP_TOP_MACE_70_H    (REG_DISP_TOP_MACE_BASE + 0xE1)
#define REG_DISP_TOP_MACE_71_L    (REG_DISP_TOP_MACE_BASE + 0xE2)
#define REG_DISP_TOP_MACE_71_H    (REG_DISP_TOP_MACE_BASE + 0xE3)
#define REG_DISP_TOP_MACE_72_L    (REG_DISP_TOP_MACE_BASE + 0xE4)
#define REG_DISP_TOP_MACE_72_H    (REG_DISP_TOP_MACE_BASE + 0xE5)
#define REG_DISP_TOP_MACE_73_L    (REG_DISP_TOP_MACE_BASE + 0xE6)
#define REG_DISP_TOP_MACE_73_H    (REG_DISP_TOP_MACE_BASE + 0xE7)
#define REG_DISP_TOP_MACE_74_L    (REG_DISP_TOP_MACE_BASE + 0xE8)
#define REG_DISP_TOP_MACE_74_H    (REG_DISP_TOP_MACE_BASE + 0xE9)
#define REG_DISP_TOP_MACE_75_L    (REG_DISP_TOP_MACE_BASE + 0xEA)
#define REG_DISP_TOP_MACE_75_H    (REG_DISP_TOP_MACE_BASE + 0xEB)
#define REG_DISP_TOP_MACE_76_L    (REG_DISP_TOP_MACE_BASE + 0xEC)
#define REG_DISP_TOP_MACE_76_H    (REG_DISP_TOP_MACE_BASE + 0xED)
#define REG_DISP_TOP_MACE_77_L    (REG_DISP_TOP_MACE_BASE + 0xEE)
#define REG_DISP_TOP_MACE_77_H    (REG_DISP_TOP_MACE_BASE + 0xEF)
#define REG_DISP_TOP_MACE_78_L    (REG_DISP_TOP_MACE_BASE + 0xF0)
#define REG_DISP_TOP_MACE_78_H    (REG_DISP_TOP_MACE_BASE + 0xF1)
#define REG_DISP_TOP_MACE_79_L    (REG_DISP_TOP_MACE_BASE + 0xF2)
#define REG_DISP_TOP_MACE_79_H    (REG_DISP_TOP_MACE_BASE + 0xF3)
#define REG_DISP_TOP_MACE_7A_L    (REG_DISP_TOP_MACE_BASE + 0xF4)
#define REG_DISP_TOP_MACE_7A_H    (REG_DISP_TOP_MACE_BASE + 0xF5)
#define REG_DISP_TOP_MACE_7B_L    (REG_DISP_TOP_MACE_BASE + 0xF6)
#define REG_DISP_TOP_MACE_7B_H    (REG_DISP_TOP_MACE_BASE + 0xF7)
#define REG_DISP_TOP_MACE_7C_L    (REG_DISP_TOP_MACE_BASE + 0xF8)
#define REG_DISP_TOP_MACE_7C_H    (REG_DISP_TOP_MACE_BASE + 0xF9)
#define REG_DISP_TOP_MACE_7D_L    (REG_DISP_TOP_MACE_BASE + 0xFA)
#define REG_DISP_TOP_MACE_7D_H    (REG_DISP_TOP_MACE_BASE + 0xFB)
#define REG_DISP_TOP_MACE_7E_L    (REG_DISP_TOP_MACE_BASE + 0xFC)
#define REG_DISP_TOP_MACE_7E_H    (REG_DISP_TOP_MACE_BASE + 0xFD)
#define REG_DISP_TOP_MACE_7F_L    (REG_DISP_TOP_MACE_BASE + 0xFE)
#define REG_DISP_TOP_MACE_7F_H    (REG_DISP_TOP_MACE_BASE + 0xFF)

#define REG_DISP_MOPS_BK0_00_L     (REG_DISP_MOPS_BK0_BASE + 0x00)
#define REG_DISP_MOPS_BK0_00_H     (REG_DISP_MOPS_BK0_BASE + 0x01)
#define REG_DISP_MOPS_BK0_01_L     (REG_DISP_MOPS_BK0_BASE + 0x02)
#define REG_DISP_MOPS_BK0_01_H     (REG_DISP_MOPS_BK0_BASE + 0x03)
#define REG_DISP_MOPS_BK0_02_L     (REG_DISP_MOPS_BK0_BASE + 0x04)
#define REG_DISP_MOPS_BK0_02_H     (REG_DISP_MOPS_BK0_BASE + 0x05)
#define REG_DISP_MOPS_BK0_03_L     (REG_DISP_MOPS_BK0_BASE + 0x06)
#define REG_DISP_MOPS_BK0_03_H     (REG_DISP_MOPS_BK0_BASE + 0x07)
#define REG_DISP_MOPS_BK0_04_L     (REG_DISP_MOPS_BK0_BASE + 0x08)
#define REG_DISP_MOPS_BK0_04_H     (REG_DISP_MOPS_BK0_BASE + 0x09)
#define REG_DISP_MOPS_BK0_05_L     (REG_DISP_MOPS_BK0_BASE + 0x0A)
#define REG_DISP_MOPS_BK0_05_H     (REG_DISP_MOPS_BK0_BASE + 0x0B)
#define REG_DISP_MOPS_BK0_06_L     (REG_DISP_MOPS_BK0_BASE + 0x0C)
#define REG_DISP_MOPS_BK0_06_H     (REG_DISP_MOPS_BK0_BASE + 0x0D)
#define REG_DISP_MOPS_BK0_07_L     (REG_DISP_MOPS_BK0_BASE + 0x0E)
#define REG_DISP_MOPS_BK0_07_H     (REG_DISP_MOPS_BK0_BASE + 0x0F)
#define REG_DISP_MOPS_BK0_08_L     (REG_DISP_MOPS_BK0_BASE + 0x10)
#define REG_DISP_MOPS_BK0_08_H     (REG_DISP_MOPS_BK0_BASE + 0x11)
#define REG_DISP_MOPS_BK0_09_L     (REG_DISP_MOPS_BK0_BASE + 0x12)
#define REG_DISP_MOPS_BK0_09_H     (REG_DISP_MOPS_BK0_BASE + 0x13)
#define REG_DISP_MOPS_BK0_0A_L     (REG_DISP_MOPS_BK0_BASE + 0x14)
#define REG_DISP_MOPS_BK0_0A_H     (REG_DISP_MOPS_BK0_BASE + 0x15)
#define REG_DISP_MOPS_BK0_0B_L     (REG_DISP_MOPS_BK0_BASE + 0x16)
#define REG_DISP_MOPS_BK0_0B_H     (REG_DISP_MOPS_BK0_BASE + 0x17)
#define REG_DISP_MOPS_BK0_0C_L     (REG_DISP_MOPS_BK0_BASE + 0x18)
#define REG_DISP_MOPS_BK0_0C_H     (REG_DISP_MOPS_BK0_BASE + 0x19)
#define REG_DISP_MOPS_BK0_0D_L     (REG_DISP_MOPS_BK0_BASE + 0x1A)
#define REG_DISP_MOPS_BK0_0D_H     (REG_DISP_MOPS_BK0_BASE + 0x1B)
#define REG_DISP_MOPS_BK0_0E_L     (REG_DISP_MOPS_BK0_BASE + 0x1C)
#define REG_DISP_MOPS_BK0_0E_H     (REG_DISP_MOPS_BK0_BASE + 0x1D)
#define REG_DISP_MOPS_BK0_0F_L     (REG_DISP_MOPS_BK0_BASE + 0x1E)
#define REG_DISP_MOPS_BK0_0F_H     (REG_DISP_MOPS_BK0_BASE + 0x1F)
#define REG_DISP_MOPS_BK0_10_L     (REG_DISP_MOPS_BK0_BASE + 0x20)
#define REG_DISP_MOPS_BK0_10_H     (REG_DISP_MOPS_BK0_BASE + 0x21)
#define REG_DISP_MOPS_BK0_11_L     (REG_DISP_MOPS_BK0_BASE + 0x22)
#define REG_DISP_MOPS_BK0_11_H     (REG_DISP_MOPS_BK0_BASE + 0x23)
#define REG_DISP_MOPS_BK0_12_L     (REG_DISP_MOPS_BK0_BASE + 0x24)
#define REG_DISP_MOPS_BK0_12_H     (REG_DISP_MOPS_BK0_BASE + 0x25)
#define REG_DISP_MOPS_BK0_13_L     (REG_DISP_MOPS_BK0_BASE + 0x26)
#define REG_DISP_MOPS_BK0_13_H     (REG_DISP_MOPS_BK0_BASE + 0x27)
#define REG_DISP_MOPS_BK0_14_L     (REG_DISP_MOPS_BK0_BASE + 0x28)
#define REG_DISP_MOPS_BK0_14_H     (REG_DISP_MOPS_BK0_BASE + 0x29)
#define REG_DISP_MOPS_BK0_15_L     (REG_DISP_MOPS_BK0_BASE + 0x2A)
#define REG_DISP_MOPS_BK0_15_H     (REG_DISP_MOPS_BK0_BASE + 0x2B)
#define REG_DISP_MOPS_BK0_16_L     (REG_DISP_MOPS_BK0_BASE + 0x2C)
#define REG_DISP_MOPS_BK0_16_H     (REG_DISP_MOPS_BK0_BASE + 0x2D)
#define REG_DISP_MOPS_BK0_17_L     (REG_DISP_MOPS_BK0_BASE + 0x2E)
#define REG_DISP_MOPS_BK0_17_H     (REG_DISP_MOPS_BK0_BASE + 0x2F)
#define REG_DISP_MOPS_BK0_18_L     (REG_DISP_MOPS_BK0_BASE + 0x30)
#define REG_DISP_MOPS_BK0_18_H     (REG_DISP_MOPS_BK0_BASE + 0x31)
#define REG_DISP_MOPS_BK0_19_L     (REG_DISP_MOPS_BK0_BASE + 0x32)
#define REG_DISP_MOPS_BK0_19_H     (REG_DISP_MOPS_BK0_BASE + 0x33)
#define REG_DISP_MOPS_BK0_1A_L     (REG_DISP_MOPS_BK0_BASE + 0x34)
#define REG_DISP_MOPS_BK0_1A_H     (REG_DISP_MOPS_BK0_BASE + 0x35)
#define REG_DISP_MOPS_BK0_1B_L     (REG_DISP_MOPS_BK0_BASE + 0x36)
#define REG_DISP_MOPS_BK0_1B_H     (REG_DISP_MOPS_BK0_BASE + 0x37)
#define REG_DISP_MOPS_BK0_1C_L     (REG_DISP_MOPS_BK0_BASE + 0x38)
#define REG_DISP_MOPS_BK0_1C_H     (REG_DISP_MOPS_BK0_BASE + 0x39)
#define REG_DISP_MOPS_BK0_1D_L     (REG_DISP_MOPS_BK0_BASE + 0x3A)
#define REG_DISP_MOPS_BK0_1D_H     (REG_DISP_MOPS_BK0_BASE + 0x3B)
#define REG_DISP_MOPS_BK0_1E_L     (REG_DISP_MOPS_BK0_BASE + 0x3C)
#define REG_DISP_MOPS_BK0_1E_H     (REG_DISP_MOPS_BK0_BASE + 0x3D)
#define REG_DISP_MOPS_BK0_1F_L     (REG_DISP_MOPS_BK0_BASE + 0x3E)
#define REG_DISP_MOPS_BK0_1F_H     (REG_DISP_MOPS_BK0_BASE + 0x3F)
#define REG_DISP_MOPS_BK0_20_L     (REG_DISP_MOPS_BK0_BASE + 0x40)
#define REG_DISP_MOPS_BK0_20_H     (REG_DISP_MOPS_BK0_BASE + 0x41)
#define REG_DISP_MOPS_BK0_21_L     (REG_DISP_MOPS_BK0_BASE + 0x42)
#define REG_DISP_MOPS_BK0_21_H     (REG_DISP_MOPS_BK0_BASE + 0x43)
#define REG_DISP_MOPS_BK0_22_L     (REG_DISP_MOPS_BK0_BASE + 0x44)
#define REG_DISP_MOPS_BK0_22_H     (REG_DISP_MOPS_BK0_BASE + 0x45)
#define REG_DISP_MOPS_BK0_23_L     (REG_DISP_MOPS_BK0_BASE + 0x46)
#define REG_DISP_MOPS_BK0_23_H     (REG_DISP_MOPS_BK0_BASE + 0x47)
#define REG_DISP_MOPS_BK0_24_L     (REG_DISP_MOPS_BK0_BASE + 0x48)
#define REG_DISP_MOPS_BK0_24_H     (REG_DISP_MOPS_BK0_BASE + 0x49)
#define REG_DISP_MOPS_BK0_25_L     (REG_DISP_MOPS_BK0_BASE + 0x4A)
#define REG_DISP_MOPS_BK0_25_H     (REG_DISP_MOPS_BK0_BASE + 0x4B)
#define REG_DISP_MOPS_BK0_26_L     (REG_DISP_MOPS_BK0_BASE + 0x4C)
#define REG_DISP_MOPS_BK0_26_H     (REG_DISP_MOPS_BK0_BASE + 0x4D)
#define REG_DISP_MOPS_BK0_27_L     (REG_DISP_MOPS_BK0_BASE + 0x4E)
#define REG_DISP_MOPS_BK0_27_H     (REG_DISP_MOPS_BK0_BASE + 0x4F)
#define REG_DISP_MOPS_BK0_28_L     (REG_DISP_MOPS_BK0_BASE + 0x50)
#define REG_DISP_MOPS_BK0_28_H     (REG_DISP_MOPS_BK0_BASE + 0x51)
#define REG_DISP_MOPS_BK0_29_L     (REG_DISP_MOPS_BK0_BASE + 0x52)
#define REG_DISP_MOPS_BK0_29_H     (REG_DISP_MOPS_BK0_BASE + 0x53)
#define REG_DISP_MOPS_BK0_2A_L     (REG_DISP_MOPS_BK0_BASE + 0x54)
#define REG_DISP_MOPS_BK0_2A_H     (REG_DISP_MOPS_BK0_BASE + 0x55)
#define REG_DISP_MOPS_BK0_2B_L     (REG_DISP_MOPS_BK0_BASE + 0x56)
#define REG_DISP_MOPS_BK0_2B_H     (REG_DISP_MOPS_BK0_BASE + 0x57)
#define REG_DISP_MOPS_BK0_2C_L     (REG_DISP_MOPS_BK0_BASE + 0x58)
#define REG_DISP_MOPS_BK0_2C_H     (REG_DISP_MOPS_BK0_BASE + 0x59)
#define REG_DISP_MOPS_BK0_2D_L     (REG_DISP_MOPS_BK0_BASE + 0x5A)
#define REG_DISP_MOPS_BK0_2D_H     (REG_DISP_MOPS_BK0_BASE + 0x5B)
#define REG_DISP_MOPS_BK0_2E_L     (REG_DISP_MOPS_BK0_BASE + 0x5C)
#define REG_DISP_MOPS_BK0_2E_H     (REG_DISP_MOPS_BK0_BASE + 0x5D)
#define REG_DISP_MOPS_BK0_2F_L     (REG_DISP_MOPS_BK0_BASE + 0x5E)
#define REG_DISP_MOPS_BK0_2F_H     (REG_DISP_MOPS_BK0_BASE + 0x5F)
#define REG_DISP_MOPS_BK0_30_L     (REG_DISP_MOPS_BK0_BASE + 0x60)
#define REG_DISP_MOPS_BK0_30_H     (REG_DISP_MOPS_BK0_BASE + 0x61)
#define REG_DISP_MOPS_BK0_31_L     (REG_DISP_MOPS_BK0_BASE + 0x62)
#define REG_DISP_MOPS_BK0_31_H     (REG_DISP_MOPS_BK0_BASE + 0x63)
#define REG_DISP_MOPS_BK0_32_L     (REG_DISP_MOPS_BK0_BASE + 0x64)
#define REG_DISP_MOPS_BK0_32_H     (REG_DISP_MOPS_BK0_BASE + 0x65)
#define REG_DISP_MOPS_BK0_33_L     (REG_DISP_MOPS_BK0_BASE + 0x66)
#define REG_DISP_MOPS_BK0_33_H     (REG_DISP_MOPS_BK0_BASE + 0x67)
#define REG_DISP_MOPS_BK0_34_L     (REG_DISP_MOPS_BK0_BASE + 0x68)
#define REG_DISP_MOPS_BK0_34_H     (REG_DISP_MOPS_BK0_BASE + 0x69)
#define REG_DISP_MOPS_BK0_35_L     (REG_DISP_MOPS_BK0_BASE + 0x6A)
#define REG_DISP_MOPS_BK0_35_H     (REG_DISP_MOPS_BK0_BASE + 0x6B)
#define REG_DISP_MOPS_BK0_36_L     (REG_DISP_MOPS_BK0_BASE + 0x6C)
#define REG_DISP_MOPS_BK0_36_H     (REG_DISP_MOPS_BK0_BASE + 0x6D)
#define REG_DISP_MOPS_BK0_37_L     (REG_DISP_MOPS_BK0_BASE + 0x6E)
#define REG_DISP_MOPS_BK0_37_H     (REG_DISP_MOPS_BK0_BASE + 0x6F)
#define REG_DISP_MOPS_BK0_38_L     (REG_DISP_MOPS_BK0_BASE + 0x70)
#define REG_DISP_MOPS_BK0_38_H     (REG_DISP_MOPS_BK0_BASE + 0x71)
#define REG_DISP_MOPS_BK0_39_L     (REG_DISP_MOPS_BK0_BASE + 0x72)
#define REG_DISP_MOPS_BK0_39_H     (REG_DISP_MOPS_BK0_BASE + 0x73)
#define REG_DISP_MOPS_BK0_3A_L     (REG_DISP_MOPS_BK0_BASE + 0x74)
#define REG_DISP_MOPS_BK0_3A_H     (REG_DISP_MOPS_BK0_BASE + 0x75)
#define REG_DISP_MOPS_BK0_3B_L     (REG_DISP_MOPS_BK0_BASE + 0x76)
#define REG_DISP_MOPS_BK0_3B_H     (REG_DISP_MOPS_BK0_BASE + 0x77)
#define REG_DISP_MOPS_BK0_3C_L     (REG_DISP_MOPS_BK0_BASE + 0x78)
#define REG_DISP_MOPS_BK0_3C_H     (REG_DISP_MOPS_BK0_BASE + 0x79)
#define REG_DISP_MOPS_BK0_3D_L     (REG_DISP_MOPS_BK0_BASE + 0x7A)
#define REG_DISP_MOPS_BK0_3D_H     (REG_DISP_MOPS_BK0_BASE + 0x7B)
#define REG_DISP_MOPS_BK0_3E_L     (REG_DISP_MOPS_BK0_BASE + 0x7C)
#define REG_DISP_MOPS_BK0_3E_H     (REG_DISP_MOPS_BK0_BASE + 0x7D)
#define REG_DISP_MOPS_BK0_3F_L     (REG_DISP_MOPS_BK0_BASE + 0x7E)
#define REG_DISP_MOPS_BK0_3F_H     (REG_DISP_MOPS_BK0_BASE + 0x7F)
#define REG_DISP_MOPS_BK0_40_L     (REG_DISP_MOPS_BK0_BASE + 0x80)
#define REG_DISP_MOPS_BK0_40_H     (REG_DISP_MOPS_BK0_BASE + 0x81)
#define REG_DISP_MOPS_BK0_41_L     (REG_DISP_MOPS_BK0_BASE + 0x82)
#define REG_DISP_MOPS_BK0_41_H     (REG_DISP_MOPS_BK0_BASE + 0x83)
#define REG_DISP_MOPS_BK0_42_L     (REG_DISP_MOPS_BK0_BASE + 0x84)
#define REG_DISP_MOPS_BK0_42_H     (REG_DISP_MOPS_BK0_BASE + 0x85)
#define REG_DISP_MOPS_BK0_43_L     (REG_DISP_MOPS_BK0_BASE + 0x86)
#define REG_DISP_MOPS_BK0_43_H     (REG_DISP_MOPS_BK0_BASE + 0x87)
#define REG_DISP_MOPS_BK0_44_L     (REG_DISP_MOPS_BK0_BASE + 0x88)
#define REG_DISP_MOPS_BK0_44_H     (REG_DISP_MOPS_BK0_BASE + 0x89)
#define REG_DISP_MOPS_BK0_45_L     (REG_DISP_MOPS_BK0_BASE + 0x8A)
#define REG_DISP_MOPS_BK0_45_H     (REG_DISP_MOPS_BK0_BASE + 0x8B)
#define REG_DISP_MOPS_BK0_46_L     (REG_DISP_MOPS_BK0_BASE + 0x8C)
#define REG_DISP_MOPS_BK0_46_H     (REG_DISP_MOPS_BK0_BASE + 0x8D)
#define REG_DISP_MOPS_BK0_47_L     (REG_DISP_MOPS_BK0_BASE + 0x8E)
#define REG_DISP_MOPS_BK0_47_H     (REG_DISP_MOPS_BK0_BASE + 0x8F)
#define REG_DISP_MOPS_BK0_48_L     (REG_DISP_MOPS_BK0_BASE + 0x90)
#define REG_DISP_MOPS_BK0_48_H     (REG_DISP_MOPS_BK0_BASE + 0x91)
#define REG_DISP_MOPS_BK0_49_L     (REG_DISP_MOPS_BK0_BASE + 0x92)
#define REG_DISP_MOPS_BK0_49_H     (REG_DISP_MOPS_BK0_BASE + 0x93)
#define REG_DISP_MOPS_BK0_4A_L     (REG_DISP_MOPS_BK0_BASE + 0x94)
#define REG_DISP_MOPS_BK0_4A_H     (REG_DISP_MOPS_BK0_BASE + 0x95)
#define REG_DISP_MOPS_BK0_4B_L     (REG_DISP_MOPS_BK0_BASE + 0x96)
#define REG_DISP_MOPS_BK0_4B_H     (REG_DISP_MOPS_BK0_BASE + 0x97)
#define REG_DISP_MOPS_BK0_4C_L     (REG_DISP_MOPS_BK0_BASE + 0x98)
#define REG_DISP_MOPS_BK0_4C_H     (REG_DISP_MOPS_BK0_BASE + 0x99)
#define REG_DISP_MOPS_BK0_4D_L     (REG_DISP_MOPS_BK0_BASE + 0x9A)
#define REG_DISP_MOPS_BK0_4D_H     (REG_DISP_MOPS_BK0_BASE + 0x9B)
#define REG_DISP_MOPS_BK0_4E_L     (REG_DISP_MOPS_BK0_BASE + 0x9C)
#define REG_DISP_MOPS_BK0_4E_H     (REG_DISP_MOPS_BK0_BASE + 0x9D)
#define REG_DISP_MOPS_BK0_4F_L     (REG_DISP_MOPS_BK0_BASE + 0x9E)
#define REG_DISP_MOPS_BK0_4F_H     (REG_DISP_MOPS_BK0_BASE + 0x9F)
#define REG_DISP_MOPS_BK0_50_L     (REG_DISP_MOPS_BK0_BASE + 0xA0)
#define REG_DISP_MOPS_BK0_50_H     (REG_DISP_MOPS_BK0_BASE + 0xA1)
#define REG_DISP_MOPS_BK0_51_L     (REG_DISP_MOPS_BK0_BASE + 0xA2)
#define REG_DISP_MOPS_BK0_51_H     (REG_DISP_MOPS_BK0_BASE + 0xA3)
#define REG_DISP_MOPS_BK0_52_L     (REG_DISP_MOPS_BK0_BASE + 0xA4)
#define REG_DISP_MOPS_BK0_52_H     (REG_DISP_MOPS_BK0_BASE + 0xA5)
#define REG_DISP_MOPS_BK0_53_L     (REG_DISP_MOPS_BK0_BASE + 0xA6)
#define REG_DISP_MOPS_BK0_53_H     (REG_DISP_MOPS_BK0_BASE + 0xA7)
#define REG_DISP_MOPS_BK0_54_L     (REG_DISP_MOPS_BK0_BASE + 0xA8)
#define REG_DISP_MOPS_BK0_54_H     (REG_DISP_MOPS_BK0_BASE + 0xA9)
#define REG_DISP_MOPS_BK0_55_L     (REG_DISP_MOPS_BK0_BASE + 0xAA)
#define REG_DISP_MOPS_BK0_55_H     (REG_DISP_MOPS_BK0_BASE + 0xAB)
#define REG_DISP_MOPS_BK0_56_L     (REG_DISP_MOPS_BK0_BASE + 0xAC)
#define REG_DISP_MOPS_BK0_56_H     (REG_DISP_MOPS_BK0_BASE + 0xAD)
#define REG_DISP_MOPS_BK0_57_L     (REG_DISP_MOPS_BK0_BASE + 0xAE)
#define REG_DISP_MOPS_BK0_57_H     (REG_DISP_MOPS_BK0_BASE + 0xAF)
#define REG_DISP_MOPS_BK0_58_L     (REG_DISP_MOPS_BK0_BASE + 0xB0)
#define REG_DISP_MOPS_BK0_58_H     (REG_DISP_MOPS_BK0_BASE + 0xB1)
#define REG_DISP_MOPS_BK0_59_L     (REG_DISP_MOPS_BK0_BASE + 0xB2)
#define REG_DISP_MOPS_BK0_59_H     (REG_DISP_MOPS_BK0_BASE + 0xB3)
#define REG_DISP_MOPS_BK0_5A_L     (REG_DISP_MOPS_BK0_BASE + 0xB4)
#define REG_DISP_MOPS_BK0_5A_H     (REG_DISP_MOPS_BK0_BASE + 0xB5)
#define REG_DISP_MOPS_BK0_5B_L     (REG_DISP_MOPS_BK0_BASE + 0xB6)
#define REG_DISP_MOPS_BK0_5B_H     (REG_DISP_MOPS_BK0_BASE + 0xB7)
#define REG_DISP_MOPS_BK0_5C_L     (REG_DISP_MOPS_BK0_BASE + 0xB8)
#define REG_DISP_MOPS_BK0_5C_H     (REG_DISP_MOPS_BK0_BASE + 0xB9)
#define REG_DISP_MOPS_BK0_5D_L     (REG_DISP_MOPS_BK0_BASE + 0xBA)
#define REG_DISP_MOPS_BK0_5D_H     (REG_DISP_MOPS_BK0_BASE + 0xBB)
#define REG_DISP_MOPS_BK0_5E_L     (REG_DISP_MOPS_BK0_BASE + 0xBC)
#define REG_DISP_MOPS_BK0_5E_H     (REG_DISP_MOPS_BK0_BASE + 0xBD)
#define REG_DISP_MOPS_BK0_5F_L     (REG_DISP_MOPS_BK0_BASE + 0xBE)
#define REG_DISP_MOPS_BK0_5F_H     (REG_DISP_MOPS_BK0_BASE + 0xBF)
#define REG_DISP_MOPS_BK0_60_L     (REG_DISP_MOPS_BK0_BASE + 0xC0)
#define REG_DISP_MOPS_BK0_60_H     (REG_DISP_MOPS_BK0_BASE + 0xC1)
#define REG_DISP_MOPS_BK0_61_L     (REG_DISP_MOPS_BK0_BASE + 0xC2)
#define REG_DISP_MOPS_BK0_61_H     (REG_DISP_MOPS_BK0_BASE + 0xC3)
#define REG_DISP_MOPS_BK0_62_L     (REG_DISP_MOPS_BK0_BASE + 0xC4)
#define REG_DISP_MOPS_BK0_62_H     (REG_DISP_MOPS_BK0_BASE + 0xC5)
#define REG_DISP_MOPS_BK0_63_L     (REG_DISP_MOPS_BK0_BASE + 0xC6)
#define REG_DISP_MOPS_BK0_63_H     (REG_DISP_MOPS_BK0_BASE + 0xC7)
#define REG_DISP_MOPS_BK0_64_L     (REG_DISP_MOPS_BK0_BASE + 0xC8)
#define REG_DISP_MOPS_BK0_64_H     (REG_DISP_MOPS_BK0_BASE + 0xC9)
#define REG_DISP_MOPS_BK0_65_L     (REG_DISP_MOPS_BK0_BASE + 0xCA)
#define REG_DISP_MOPS_BK0_65_H     (REG_DISP_MOPS_BK0_BASE + 0xCB)
#define REG_DISP_MOPS_BK0_66_L     (REG_DISP_MOPS_BK0_BASE + 0xCC)
#define REG_DISP_MOPS_BK0_66_H     (REG_DISP_MOPS_BK0_BASE + 0xCD)
#define REG_DISP_MOPS_BK0_67_L     (REG_DISP_MOPS_BK0_BASE + 0xCE)
#define REG_DISP_MOPS_BK0_67_H     (REG_DISP_MOPS_BK0_BASE + 0xCF)
#define REG_DISP_MOPS_BK0_68_L     (REG_DISP_MOPS_BK0_BASE + 0xD0)
#define REG_DISP_MOPS_BK0_68_H     (REG_DISP_MOPS_BK0_BASE + 0xD1)
#define REG_DISP_MOPS_BK0_69_L     (REG_DISP_MOPS_BK0_BASE + 0xD2)
#define REG_DISP_MOPS_BK0_69_H     (REG_DISP_MOPS_BK0_BASE + 0xD3)
#define REG_DISP_MOPS_BK0_6A_L     (REG_DISP_MOPS_BK0_BASE + 0xD4)
#define REG_DISP_MOPS_BK0_6A_H     (REG_DISP_MOPS_BK0_BASE + 0xD5)
#define REG_DISP_MOPS_BK0_6B_L     (REG_DISP_MOPS_BK0_BASE + 0xD6)
#define REG_DISP_MOPS_BK0_6B_H     (REG_DISP_MOPS_BK0_BASE + 0xD7)
#define REG_DISP_MOPS_BK0_6C_L     (REG_DISP_MOPS_BK0_BASE + 0xD8)
#define REG_DISP_MOPS_BK0_6C_H     (REG_DISP_MOPS_BK0_BASE + 0xD9)
#define REG_DISP_MOPS_BK0_6D_L     (REG_DISP_MOPS_BK0_BASE + 0xDA)
#define REG_DISP_MOPS_BK0_6D_H     (REG_DISP_MOPS_BK0_BASE + 0xDB)
#define REG_DISP_MOPS_BK0_6E_L     (REG_DISP_MOPS_BK0_BASE + 0xDC)
#define REG_DISP_MOPS_BK0_6E_H     (REG_DISP_MOPS_BK0_BASE + 0xDD)
#define REG_DISP_MOPS_BK0_6F_L     (REG_DISP_MOPS_BK0_BASE + 0xDE)
#define REG_DISP_MOPS_BK0_6F_H     (REG_DISP_MOPS_BK0_BASE + 0xDF)
#define REG_DISP_MOPS_BK0_70_L     (REG_DISP_MOPS_BK0_BASE + 0xE0)
#define REG_DISP_MOPS_BK0_70_H     (REG_DISP_MOPS_BK0_BASE + 0xE1)
#define REG_DISP_MOPS_BK0_71_L     (REG_DISP_MOPS_BK0_BASE + 0xE2)
#define REG_DISP_MOPS_BK0_71_H     (REG_DISP_MOPS_BK0_BASE + 0xE3)
#define REG_DISP_MOPS_BK0_72_L     (REG_DISP_MOPS_BK0_BASE + 0xE4)
#define REG_DISP_MOPS_BK0_72_H     (REG_DISP_MOPS_BK0_BASE + 0xE5)
#define REG_DISP_MOPS_BK0_73_L     (REG_DISP_MOPS_BK0_BASE + 0xE6)
#define REG_DISP_MOPS_BK0_73_H     (REG_DISP_MOPS_BK0_BASE + 0xE7)
#define REG_DISP_MOPS_BK0_74_L     (REG_DISP_MOPS_BK0_BASE + 0xE8)
#define REG_DISP_MOPS_BK0_74_H     (REG_DISP_MOPS_BK0_BASE + 0xE9)
#define REG_DISP_MOPS_BK0_75_L     (REG_DISP_MOPS_BK0_BASE + 0xEA)
#define REG_DISP_MOPS_BK0_75_H     (REG_DISP_MOPS_BK0_BASE + 0xEB)
#define REG_DISP_MOPS_BK0_76_L     (REG_DISP_MOPS_BK0_BASE + 0xEC)
#define REG_DISP_MOPS_BK0_76_H     (REG_DISP_MOPS_BK0_BASE + 0xED)
#define REG_DISP_MOPS_BK0_77_L     (REG_DISP_MOPS_BK0_BASE + 0xEE)
#define REG_DISP_MOPS_BK0_77_H     (REG_DISP_MOPS_BK0_BASE + 0xEF)
#define REG_DISP_MOPS_BK0_78_L     (REG_DISP_MOPS_BK0_BASE + 0xF0)
#define REG_DISP_MOPS_BK0_78_H     (REG_DISP_MOPS_BK0_BASE + 0xF1)
#define REG_DISP_MOPS_BK0_79_L     (REG_DISP_MOPS_BK0_BASE + 0xF2)
#define REG_DISP_MOPS_BK0_79_H     (REG_DISP_MOPS_BK0_BASE + 0xF3)
#define REG_DISP_MOPS_BK0_7A_L     (REG_DISP_MOPS_BK0_BASE + 0xF4)
#define REG_DISP_MOPS_BK0_7A_H     (REG_DISP_MOPS_BK0_BASE + 0xF5)
#define REG_DISP_MOPS_BK0_7B_L     (REG_DISP_MOPS_BK0_BASE + 0xF6)
#define REG_DISP_MOPS_BK0_7B_H     (REG_DISP_MOPS_BK0_BASE + 0xF7)
#define REG_DISP_MOPS_BK0_7C_L     (REG_DISP_MOPS_BK0_BASE + 0xF8)
#define REG_DISP_MOPS_BK0_7C_H     (REG_DISP_MOPS_BK0_BASE + 0xF9)
#define REG_DISP_MOPS_BK0_7D_L     (REG_DISP_MOPS_BK0_BASE + 0xFA)
#define REG_DISP_MOPS_BK0_7D_H     (REG_DISP_MOPS_BK0_BASE + 0xFB)
#define REG_DISP_MOPS_BK0_7E_L     (REG_DISP_MOPS_BK0_BASE + 0xFC)
#define REG_DISP_MOPS_BK0_7E_H     (REG_DISP_MOPS_BK0_BASE + 0xFD)
#define REG_DISP_MOPS_BK0_7F_L     (REG_DISP_MOPS_BK0_BASE + 0xFE)
#define REG_DISP_MOPS_BK0_7F_H     (REG_DISP_MOPS_BK0_BASE + 0xFF)


#define REG_DISP_MOPS_HVSP_00_L     (REG_DISP_MOPS_HVSP_BASE + 0x00)
#define REG_DISP_MOPS_HVSP_00_H     (REG_DISP_MOPS_HVSP_BASE + 0x01)
#define REG_DISP_MOPS_HVSP_01_L     (REG_DISP_MOPS_HVSP_BASE + 0x02)
#define REG_DISP_MOPS_HVSP_01_H     (REG_DISP_MOPS_HVSP_BASE + 0x03)
#define REG_DISP_MOPS_HVSP_02_L     (REG_DISP_MOPS_HVSP_BASE + 0x04)
#define REG_DISP_MOPS_HVSP_02_H     (REG_DISP_MOPS_HVSP_BASE + 0x05)
#define REG_DISP_MOPS_HVSP_03_L     (REG_DISP_MOPS_HVSP_BASE + 0x06)
#define REG_DISP_MOPS_HVSP_03_H     (REG_DISP_MOPS_HVSP_BASE + 0x07)
#define REG_DISP_MOPS_HVSP_04_L     (REG_DISP_MOPS_HVSP_BASE + 0x08)
#define REG_DISP_MOPS_HVSP_04_H     (REG_DISP_MOPS_HVSP_BASE + 0x09)
#define REG_DISP_MOPS_HVSP_05_L     (REG_DISP_MOPS_HVSP_BASE + 0x0A)
#define REG_DISP_MOPS_HVSP_05_H     (REG_DISP_MOPS_HVSP_BASE + 0x0B)
#define REG_DISP_MOPS_HVSP_06_L     (REG_DISP_MOPS_HVSP_BASE + 0x0C)
#define REG_DISP_MOPS_HVSP_06_H     (REG_DISP_MOPS_HVSP_BASE + 0x0D)
#define REG_DISP_MOPS_HVSP_07_L     (REG_DISP_MOPS_HVSP_BASE + 0x0E)
#define REG_DISP_MOPS_HVSP_07_H     (REG_DISP_MOPS_HVSP_BASE + 0x0F)
#define REG_DISP_MOPS_HVSP_08_L     (REG_DISP_MOPS_HVSP_BASE + 0x10)
#define REG_DISP_MOPS_HVSP_08_H     (REG_DISP_MOPS_HVSP_BASE + 0x11)
#define REG_DISP_MOPS_HVSP_09_L     (REG_DISP_MOPS_HVSP_BASE + 0x12)
#define REG_DISP_MOPS_HVSP_09_H     (REG_DISP_MOPS_HVSP_BASE + 0x13)
#define REG_DISP_MOPS_HVSP_0A_L     (REG_DISP_MOPS_HVSP_BASE + 0x14)
#define REG_DISP_MOPS_HVSP_0A_H     (REG_DISP_MOPS_HVSP_BASE + 0x15)
#define REG_DISP_MOPS_HVSP_0B_L     (REG_DISP_MOPS_HVSP_BASE + 0x16)
#define REG_DISP_MOPS_HVSP_0B_H     (REG_DISP_MOPS_HVSP_BASE + 0x17)
#define REG_DISP_MOPS_HVSP_0C_L     (REG_DISP_MOPS_HVSP_BASE + 0x18)
#define REG_DISP_MOPS_HVSP_0C_H     (REG_DISP_MOPS_HVSP_BASE + 0x19)
#define REG_DISP_MOPS_HVSP_0D_L     (REG_DISP_MOPS_HVSP_BASE + 0x1A)
#define REG_DISP_MOPS_HVSP_0D_H     (REG_DISP_MOPS_HVSP_BASE + 0x1B)
#define REG_DISP_MOPS_HVSP_0E_L     (REG_DISP_MOPS_HVSP_BASE + 0x1C)
#define REG_DISP_MOPS_HVSP_0E_H     (REG_DISP_MOPS_HVSP_BASE + 0x1D)
#define REG_DISP_MOPS_HVSP_0F_L     (REG_DISP_MOPS_HVSP_BASE + 0x1E)
#define REG_DISP_MOPS_HVSP_0F_H     (REG_DISP_MOPS_HVSP_BASE + 0x1F)
#define REG_DISP_MOPS_HVSP_10_L     (REG_DISP_MOPS_HVSP_BASE + 0x20)
#define REG_DISP_MOPS_HVSP_10_H     (REG_DISP_MOPS_HVSP_BASE + 0x21)
#define REG_DISP_MOPS_HVSP_11_L     (REG_DISP_MOPS_HVSP_BASE + 0x22)
#define REG_DISP_MOPS_HVSP_11_H     (REG_DISP_MOPS_HVSP_BASE + 0x23)
#define REG_DISP_MOPS_HVSP_12_L     (REG_DISP_MOPS_HVSP_BASE + 0x24)
#define REG_DISP_MOPS_HVSP_12_H     (REG_DISP_MOPS_HVSP_BASE + 0x25)
#define REG_DISP_MOPS_HVSP_13_L     (REG_DISP_MOPS_HVSP_BASE + 0x26)
#define REG_DISP_MOPS_HVSP_13_H     (REG_DISP_MOPS_HVSP_BASE + 0x27)
#define REG_DISP_MOPS_HVSP_14_L     (REG_DISP_MOPS_HVSP_BASE + 0x28)
#define REG_DISP_MOPS_HVSP_14_H     (REG_DISP_MOPS_HVSP_BASE + 0x29)
#define REG_DISP_MOPS_HVSP_15_L     (REG_DISP_MOPS_HVSP_BASE + 0x2A)
#define REG_DISP_MOPS_HVSP_15_H     (REG_DISP_MOPS_HVSP_BASE + 0x2B)
#define REG_DISP_MOPS_HVSP_16_L     (REG_DISP_MOPS_HVSP_BASE + 0x2C)
#define REG_DISP_MOPS_HVSP_16_H     (REG_DISP_MOPS_HVSP_BASE + 0x2D)
#define REG_DISP_MOPS_HVSP_17_L     (REG_DISP_MOPS_HVSP_BASE + 0x2E)
#define REG_DISP_MOPS_HVSP_17_H     (REG_DISP_MOPS_HVSP_BASE + 0x2F)
#define REG_DISP_MOPS_HVSP_18_L     (REG_DISP_MOPS_HVSP_BASE + 0x30)
#define REG_DISP_MOPS_HVSP_18_H     (REG_DISP_MOPS_HVSP_BASE + 0x31)
#define REG_DISP_MOPS_HVSP_19_L     (REG_DISP_MOPS_HVSP_BASE + 0x32)
#define REG_DISP_MOPS_HVSP_19_H     (REG_DISP_MOPS_HVSP_BASE + 0x33)
#define REG_DISP_MOPS_HVSP_1A_L     (REG_DISP_MOPS_HVSP_BASE + 0x34)
#define REG_DISP_MOPS_HVSP_1A_H     (REG_DISP_MOPS_HVSP_BASE + 0x35)
#define REG_DISP_MOPS_HVSP_1B_L     (REG_DISP_MOPS_HVSP_BASE + 0x36)
#define REG_DISP_MOPS_HVSP_1B_H     (REG_DISP_MOPS_HVSP_BASE + 0x37)
#define REG_DISP_MOPS_HVSP_1C_L     (REG_DISP_MOPS_HVSP_BASE + 0x38)
#define REG_DISP_MOPS_HVSP_1C_H     (REG_DISP_MOPS_HVSP_BASE + 0x39)
#define REG_DISP_MOPS_HVSP_1D_L     (REG_DISP_MOPS_HVSP_BASE + 0x3A)
#define REG_DISP_MOPS_HVSP_1D_H     (REG_DISP_MOPS_HVSP_BASE + 0x3B)
#define REG_DISP_MOPS_HVSP_1E_L     (REG_DISP_MOPS_HVSP_BASE + 0x3C)
#define REG_DISP_MOPS_HVSP_1E_H     (REG_DISP_MOPS_HVSP_BASE + 0x3D)
#define REG_DISP_MOPS_HVSP_1F_L     (REG_DISP_MOPS_HVSP_BASE + 0x3E)
#define REG_DISP_MOPS_HVSP_1F_H     (REG_DISP_MOPS_HVSP_BASE + 0x3F)
#define REG_DISP_MOPS_HVSP_20_L     (REG_DISP_MOPS_HVSP_BASE + 0x40)
#define REG_DISP_MOPS_HVSP_20_H     (REG_DISP_MOPS_HVSP_BASE + 0x41)
#define REG_DISP_MOPS_HVSP_21_L     (REG_DISP_MOPS_HVSP_BASE + 0x42)
#define REG_DISP_MOPS_HVSP_21_H     (REG_DISP_MOPS_HVSP_BASE + 0x43)
#define REG_DISP_MOPS_HVSP_22_L     (REG_DISP_MOPS_HVSP_BASE + 0x44)
#define REG_DISP_MOPS_HVSP_22_H     (REG_DISP_MOPS_HVSP_BASE + 0x45)
#define REG_DISP_MOPS_HVSP_23_L     (REG_DISP_MOPS_HVSP_BASE + 0x46)
#define REG_DISP_MOPS_HVSP_23_H     (REG_DISP_MOPS_HVSP_BASE + 0x47)
#define REG_DISP_MOPS_HVSP_24_L     (REG_DISP_MOPS_HVSP_BASE + 0x48)
#define REG_DISP_MOPS_HVSP_24_H     (REG_DISP_MOPS_HVSP_BASE + 0x49)
#define REG_DISP_MOPS_HVSP_25_L     (REG_DISP_MOPS_HVSP_BASE + 0x4A)
#define REG_DISP_MOPS_HVSP_25_H     (REG_DISP_MOPS_HVSP_BASE + 0x4B)
#define REG_DISP_MOPS_HVSP_26_L     (REG_DISP_MOPS_HVSP_BASE + 0x4C)
#define REG_DISP_MOPS_HVSP_26_H     (REG_DISP_MOPS_HVSP_BASE + 0x4D)
#define REG_DISP_MOPS_HVSP_27_L     (REG_DISP_MOPS_HVSP_BASE + 0x4E)
#define REG_DISP_MOPS_HVSP_27_H     (REG_DISP_MOPS_HVSP_BASE + 0x4F)
#define REG_DISP_MOPS_HVSP_28_L     (REG_DISP_MOPS_HVSP_BASE + 0x50)
#define REG_DISP_MOPS_HVSP_28_H     (REG_DISP_MOPS_HVSP_BASE + 0x51)
#define REG_DISP_MOPS_HVSP_29_L     (REG_DISP_MOPS_HVSP_BASE + 0x52)
#define REG_DISP_MOPS_HVSP_29_H     (REG_DISP_MOPS_HVSP_BASE + 0x53)
#define REG_DISP_MOPS_HVSP_2A_L     (REG_DISP_MOPS_HVSP_BASE + 0x54)
#define REG_DISP_MOPS_HVSP_2A_H     (REG_DISP_MOPS_HVSP_BASE + 0x55)
#define REG_DISP_MOPS_HVSP_2B_L     (REG_DISP_MOPS_HVSP_BASE + 0x56)
#define REG_DISP_MOPS_HVSP_2B_H     (REG_DISP_MOPS_HVSP_BASE + 0x57)
#define REG_DISP_MOPS_HVSP_2C_L     (REG_DISP_MOPS_HVSP_BASE + 0x58)
#define REG_DISP_MOPS_HVSP_2C_H     (REG_DISP_MOPS_HVSP_BASE + 0x59)
#define REG_DISP_MOPS_HVSP_2D_L     (REG_DISP_MOPS_HVSP_BASE + 0x5A)
#define REG_DISP_MOPS_HVSP_2D_H     (REG_DISP_MOPS_HVSP_BASE + 0x5B)
#define REG_DISP_MOPS_HVSP_2E_L     (REG_DISP_MOPS_HVSP_BASE + 0x5C)
#define REG_DISP_MOPS_HVSP_2E_H     (REG_DISP_MOPS_HVSP_BASE + 0x5D)
#define REG_DISP_MOPS_HVSP_2F_L     (REG_DISP_MOPS_HVSP_BASE + 0x5E)
#define REG_DISP_MOPS_HVSP_2F_H     (REG_DISP_MOPS_HVSP_BASE + 0x5F)
#define REG_DISP_MOPS_HVSP_30_L     (REG_DISP_MOPS_HVSP_BASE + 0x60)
#define REG_DISP_MOPS_HVSP_30_H     (REG_DISP_MOPS_HVSP_BASE + 0x61)
#define REG_DISP_MOPS_HVSP_31_L     (REG_DISP_MOPS_HVSP_BASE + 0x62)
#define REG_DISP_MOPS_HVSP_31_H     (REG_DISP_MOPS_HVSP_BASE + 0x63)
#define REG_DISP_MOPS_HVSP_32_L     (REG_DISP_MOPS_HVSP_BASE + 0x64)
#define REG_DISP_MOPS_HVSP_32_H     (REG_DISP_MOPS_HVSP_BASE + 0x65)
#define REG_DISP_MOPS_HVSP_33_L     (REG_DISP_MOPS_HVSP_BASE + 0x66)
#define REG_DISP_MOPS_HVSP_33_H     (REG_DISP_MOPS_HVSP_BASE + 0x67)
#define REG_DISP_MOPS_HVSP_34_L     (REG_DISP_MOPS_HVSP_BASE + 0x68)
#define REG_DISP_MOPS_HVSP_34_H     (REG_DISP_MOPS_HVSP_BASE + 0x69)
#define REG_DISP_MOPS_HVSP_35_L     (REG_DISP_MOPS_HVSP_BASE + 0x6A)
#define REG_DISP_MOPS_HVSP_35_H     (REG_DISP_MOPS_HVSP_BASE + 0x6B)
#define REG_DISP_MOPS_HVSP_36_L     (REG_DISP_MOPS_HVSP_BASE + 0x6C)
#define REG_DISP_MOPS_HVSP_36_H     (REG_DISP_MOPS_HVSP_BASE + 0x6D)
#define REG_DISP_MOPS_HVSP_37_L     (REG_DISP_MOPS_HVSP_BASE + 0x6E)
#define REG_DISP_MOPS_HVSP_37_H     (REG_DISP_MOPS_HVSP_BASE + 0x6F)
#define REG_DISP_MOPS_HVSP_38_L     (REG_DISP_MOPS_HVSP_BASE + 0x70)
#define REG_DISP_MOPS_HVSP_38_H     (REG_DISP_MOPS_HVSP_BASE + 0x71)
#define REG_DISP_MOPS_HVSP_39_L     (REG_DISP_MOPS_HVSP_BASE + 0x72)
#define REG_DISP_MOPS_HVSP_39_H     (REG_DISP_MOPS_HVSP_BASE + 0x73)
#define REG_DISP_MOPS_HVSP_3A_L     (REG_DISP_MOPS_HVSP_BASE + 0x74)
#define REG_DISP_MOPS_HVSP_3A_H     (REG_DISP_MOPS_HVSP_BASE + 0x75)
#define REG_DISP_MOPS_HVSP_3B_L     (REG_DISP_MOPS_HVSP_BASE + 0x76)
#define REG_DISP_MOPS_HVSP_3B_H     (REG_DISP_MOPS_HVSP_BASE + 0x77)
#define REG_DISP_MOPS_HVSP_3C_L     (REG_DISP_MOPS_HVSP_BASE + 0x78)
#define REG_DISP_MOPS_HVSP_3C_H     (REG_DISP_MOPS_HVSP_BASE + 0x79)
#define REG_DISP_MOPS_HVSP_3D_L     (REG_DISP_MOPS_HVSP_BASE + 0x7A)
#define REG_DISP_MOPS_HVSP_3D_H     (REG_DISP_MOPS_HVSP_BASE + 0x7B)
#define REG_DISP_MOPS_HVSP_3E_L     (REG_DISP_MOPS_HVSP_BASE + 0x7C)
#define REG_DISP_MOPS_HVSP_3E_H     (REG_DISP_MOPS_HVSP_BASE + 0x7D)
#define REG_DISP_MOPS_HVSP_3F_L     (REG_DISP_MOPS_HVSP_BASE + 0x7E)
#define REG_DISP_MOPS_HVSP_3F_H     (REG_DISP_MOPS_HVSP_BASE + 0x7F)
#define REG_DISP_MOPS_HVSP_40_L     (REG_DISP_MOPS_HVSP_BASE + 0x80)
#define REG_DISP_MOPS_HVSP_40_H     (REG_DISP_MOPS_HVSP_BASE + 0x81)
#define REG_DISP_MOPS_HVSP_41_L     (REG_DISP_MOPS_HVSP_BASE + 0x82)
#define REG_DISP_MOPS_HVSP_41_H     (REG_DISP_MOPS_HVSP_BASE + 0x83)
#define REG_DISP_MOPS_HVSP_42_L     (REG_DISP_MOPS_HVSP_BASE + 0x84)
#define REG_DISP_MOPS_HVSP_42_H     (REG_DISP_MOPS_HVSP_BASE + 0x85)
#define REG_DISP_MOPS_HVSP_43_L     (REG_DISP_MOPS_HVSP_BASE + 0x86)
#define REG_DISP_MOPS_HVSP_43_H     (REG_DISP_MOPS_HVSP_BASE + 0x87)
#define REG_DISP_MOPS_HVSP_44_L     (REG_DISP_MOPS_HVSP_BASE + 0x88)
#define REG_DISP_MOPS_HVSP_44_H     (REG_DISP_MOPS_HVSP_BASE + 0x89)
#define REG_DISP_MOPS_HVSP_45_L     (REG_DISP_MOPS_HVSP_BASE + 0x8A)
#define REG_DISP_MOPS_HVSP_45_H     (REG_DISP_MOPS_HVSP_BASE + 0x8B)
#define REG_DISP_MOPS_HVSP_46_L     (REG_DISP_MOPS_HVSP_BASE + 0x8C)
#define REG_DISP_MOPS_HVSP_46_H     (REG_DISP_MOPS_HVSP_BASE + 0x8D)
#define REG_DISP_MOPS_HVSP_47_L     (REG_DISP_MOPS_HVSP_BASE + 0x8E)
#define REG_DISP_MOPS_HVSP_47_H     (REG_DISP_MOPS_HVSP_BASE + 0x8F)
#define REG_DISP_MOPS_HVSP_48_L     (REG_DISP_MOPS_HVSP_BASE + 0x90)
#define REG_DISP_MOPS_HVSP_48_H     (REG_DISP_MOPS_HVSP_BASE + 0x91)
#define REG_DISP_MOPS_HVSP_49_L     (REG_DISP_MOPS_HVSP_BASE + 0x92)
#define REG_DISP_MOPS_HVSP_49_H     (REG_DISP_MOPS_HVSP_BASE + 0x93)
#define REG_DISP_MOPS_HVSP_4A_L     (REG_DISP_MOPS_HVSP_BASE + 0x94)
#define REG_DISP_MOPS_HVSP_4A_H     (REG_DISP_MOPS_HVSP_BASE + 0x95)
#define REG_DISP_MOPS_HVSP_4B_L     (REG_DISP_MOPS_HVSP_BASE + 0x96)
#define REG_DISP_MOPS_HVSP_4B_H     (REG_DISP_MOPS_HVSP_BASE + 0x97)
#define REG_DISP_MOPS_HVSP_4C_L     (REG_DISP_MOPS_HVSP_BASE + 0x98)
#define REG_DISP_MOPS_HVSP_4C_H     (REG_DISP_MOPS_HVSP_BASE + 0x99)
#define REG_DISP_MOPS_HVSP_4D_L     (REG_DISP_MOPS_HVSP_BASE + 0x9A)
#define REG_DISP_MOPS_HVSP_4D_H     (REG_DISP_MOPS_HVSP_BASE + 0x9B)
#define REG_DISP_MOPS_HVSP_4E_L     (REG_DISP_MOPS_HVSP_BASE + 0x9C)
#define REG_DISP_MOPS_HVSP_4E_H     (REG_DISP_MOPS_HVSP_BASE + 0x9D)
#define REG_DISP_MOPS_HVSP_4F_L     (REG_DISP_MOPS_HVSP_BASE + 0x9E)
#define REG_DISP_MOPS_HVSP_4F_H     (REG_DISP_MOPS_HVSP_BASE + 0x9F)
#define REG_DISP_MOPS_HVSP_50_L     (REG_DISP_MOPS_HVSP_BASE + 0xA0)
#define REG_DISP_MOPS_HVSP_50_H     (REG_DISP_MOPS_HVSP_BASE + 0xA1)
#define REG_DISP_MOPS_HVSP_51_L     (REG_DISP_MOPS_HVSP_BASE + 0xA2)
#define REG_DISP_MOPS_HVSP_51_H     (REG_DISP_MOPS_HVSP_BASE + 0xA3)
#define REG_DISP_MOPS_HVSP_52_L     (REG_DISP_MOPS_HVSP_BASE + 0xA4)
#define REG_DISP_MOPS_HVSP_52_H     (REG_DISP_MOPS_HVSP_BASE + 0xA5)
#define REG_DISP_MOPS_HVSP_53_L     (REG_DISP_MOPS_HVSP_BASE + 0xA6)
#define REG_DISP_MOPS_HVSP_53_H     (REG_DISP_MOPS_HVSP_BASE + 0xA7)
#define REG_DISP_MOPS_HVSP_54_L     (REG_DISP_MOPS_HVSP_BASE + 0xA8)
#define REG_DISP_MOPS_HVSP_54_H     (REG_DISP_MOPS_HVSP_BASE + 0xA9)
#define REG_DISP_MOPS_HVSP_55_L     (REG_DISP_MOPS_HVSP_BASE + 0xAA)
#define REG_DISP_MOPS_HVSP_55_H     (REG_DISP_MOPS_HVSP_BASE + 0xAB)
#define REG_DISP_MOPS_HVSP_56_L     (REG_DISP_MOPS_HVSP_BASE + 0xAC)
#define REG_DISP_MOPS_HVSP_56_H     (REG_DISP_MOPS_HVSP_BASE + 0xAD)
#define REG_DISP_MOPS_HVSP_57_L     (REG_DISP_MOPS_HVSP_BASE + 0xAE)
#define REG_DISP_MOPS_HVSP_57_H     (REG_DISP_MOPS_HVSP_BASE + 0xAF)
#define REG_DISP_MOPS_HVSP_58_L     (REG_DISP_MOPS_HVSP_BASE + 0xB0)
#define REG_DISP_MOPS_HVSP_58_H     (REG_DISP_MOPS_HVSP_BASE + 0xB1)
#define REG_DISP_MOPS_HVSP_59_L     (REG_DISP_MOPS_HVSP_BASE + 0xB2)
#define REG_DISP_MOPS_HVSP_59_H     (REG_DISP_MOPS_HVSP_BASE + 0xB3)
#define REG_DISP_MOPS_HVSP_5A_L     (REG_DISP_MOPS_HVSP_BASE + 0xB4)
#define REG_DISP_MOPS_HVSP_5A_H     (REG_DISP_MOPS_HVSP_BASE + 0xB5)
#define REG_DISP_MOPS_HVSP_5B_L     (REG_DISP_MOPS_HVSP_BASE + 0xB6)
#define REG_DISP_MOPS_HVSP_5B_H     (REG_DISP_MOPS_HVSP_BASE + 0xB7)
#define REG_DISP_MOPS_HVSP_5C_L     (REG_DISP_MOPS_HVSP_BASE + 0xB8)
#define REG_DISP_MOPS_HVSP_5C_H     (REG_DISP_MOPS_HVSP_BASE + 0xB9)
#define REG_DISP_MOPS_HVSP_5D_L     (REG_DISP_MOPS_HVSP_BASE + 0xBA)
#define REG_DISP_MOPS_HVSP_5D_H     (REG_DISP_MOPS_HVSP_BASE + 0xBB)
#define REG_DISP_MOPS_HVSP_5E_L     (REG_DISP_MOPS_HVSP_BASE + 0xBC)
#define REG_DISP_MOPS_HVSP_5E_H     (REG_DISP_MOPS_HVSP_BASE + 0xBD)
#define REG_DISP_MOPS_HVSP_5F_L     (REG_DISP_MOPS_HVSP_BASE + 0xBE)
#define REG_DISP_MOPS_HVSP_5F_H     (REG_DISP_MOPS_HVSP_BASE + 0xBF)
#define REG_DISP_MOPS_HVSP_60_L     (REG_DISP_MOPS_HVSP_BASE + 0xC0)
#define REG_DISP_MOPS_HVSP_60_H     (REG_DISP_MOPS_HVSP_BASE + 0xC1)
#define REG_DISP_MOPS_HVSP_61_L     (REG_DISP_MOPS_HVSP_BASE + 0xC2)
#define REG_DISP_MOPS_HVSP_61_H     (REG_DISP_MOPS_HVSP_BASE + 0xC3)
#define REG_DISP_MOPS_HVSP_62_L     (REG_DISP_MOPS_HVSP_BASE + 0xC4)
#define REG_DISP_MOPS_HVSP_62_H     (REG_DISP_MOPS_HVSP_BASE + 0xC5)
#define REG_DISP_MOPS_HVSP_63_L     (REG_DISP_MOPS_HVSP_BASE + 0xC6)
#define REG_DISP_MOPS_HVSP_63_H     (REG_DISP_MOPS_HVSP_BASE + 0xC7)
#define REG_DISP_MOPS_HVSP_64_L     (REG_DISP_MOPS_HVSP_BASE + 0xC8)
#define REG_DISP_MOPS_HVSP_64_H     (REG_DISP_MOPS_HVSP_BASE + 0xC9)
#define REG_DISP_MOPS_HVSP_65_L     (REG_DISP_MOPS_HVSP_BASE + 0xCA)
#define REG_DISP_MOPS_HVSP_65_H     (REG_DISP_MOPS_HVSP_BASE + 0xCB)
#define REG_DISP_MOPS_HVSP_66_L     (REG_DISP_MOPS_HVSP_BASE + 0xCC)
#define REG_DISP_MOPS_HVSP_66_H     (REG_DISP_MOPS_HVSP_BASE + 0xCD)
#define REG_DISP_MOPS_HVSP_67_L     (REG_DISP_MOPS_HVSP_BASE + 0xCE)
#define REG_DISP_MOPS_HVSP_67_H     (REG_DISP_MOPS_HVSP_BASE + 0xCF)
#define REG_DISP_MOPS_HVSP_68_L     (REG_DISP_MOPS_HVSP_BASE + 0xD0)
#define REG_DISP_MOPS_HVSP_68_H     (REG_DISP_MOPS_HVSP_BASE + 0xD1)
#define REG_DISP_MOPS_HVSP_69_L     (REG_DISP_MOPS_HVSP_BASE + 0xD2)
#define REG_DISP_MOPS_HVSP_69_H     (REG_DISP_MOPS_HVSP_BASE + 0xD3)
#define REG_DISP_MOPS_HVSP_6A_L     (REG_DISP_MOPS_HVSP_BASE + 0xD4)
#define REG_DISP_MOPS_HVSP_6A_H     (REG_DISP_MOPS_HVSP_BASE + 0xD5)
#define REG_DISP_MOPS_HVSP_6B_L     (REG_DISP_MOPS_HVSP_BASE + 0xD6)
#define REG_DISP_MOPS_HVSP_6B_H     (REG_DISP_MOPS_HVSP_BASE + 0xD7)
#define REG_DISP_MOPS_HVSP_6C_L     (REG_DISP_MOPS_HVSP_BASE + 0xD8)
#define REG_DISP_MOPS_HVSP_6C_H     (REG_DISP_MOPS_HVSP_BASE + 0xD9)
#define REG_DISP_MOPS_HVSP_6D_L     (REG_DISP_MOPS_HVSP_BASE + 0xDA)
#define REG_DISP_MOPS_HVSP_6D_H     (REG_DISP_MOPS_HVSP_BASE + 0xDB)
#define REG_DISP_MOPS_HVSP_6E_L     (REG_DISP_MOPS_HVSP_BASE + 0xDC)
#define REG_DISP_MOPS_HVSP_6E_H     (REG_DISP_MOPS_HVSP_BASE + 0xDD)
#define REG_DISP_MOPS_HVSP_6F_L     (REG_DISP_MOPS_HVSP_BASE + 0xDE)
#define REG_DISP_MOPS_HVSP_6F_H     (REG_DISP_MOPS_HVSP_BASE + 0xDF)
#define REG_DISP_MOPS_HVSP_70_L     (REG_DISP_MOPS_HVSP_BASE + 0xE0)
#define REG_DISP_MOPS_HVSP_70_H     (REG_DISP_MOPS_HVSP_BASE + 0xE1)
#define REG_DISP_MOPS_HVSP_71_L     (REG_DISP_MOPS_HVSP_BASE + 0xE2)
#define REG_DISP_MOPS_HVSP_71_H     (REG_DISP_MOPS_HVSP_BASE + 0xE3)
#define REG_DISP_MOPS_HVSP_72_L     (REG_DISP_MOPS_HVSP_BASE + 0xE4)
#define REG_DISP_MOPS_HVSP_72_H     (REG_DISP_MOPS_HVSP_BASE + 0xE5)
#define REG_DISP_MOPS_HVSP_73_L     (REG_DISP_MOPS_HVSP_BASE + 0xE6)
#define REG_DISP_MOPS_HVSP_73_H     (REG_DISP_MOPS_HVSP_BASE + 0xE7)
#define REG_DISP_MOPS_HVSP_74_L     (REG_DISP_MOPS_HVSP_BASE + 0xE8)
#define REG_DISP_MOPS_HVSP_74_H     (REG_DISP_MOPS_HVSP_BASE + 0xE9)
#define REG_DISP_MOPS_HVSP_75_L     (REG_DISP_MOPS_HVSP_BASE + 0xEA)
#define REG_DISP_MOPS_HVSP_75_H     (REG_DISP_MOPS_HVSP_BASE + 0xEB)
#define REG_DISP_MOPS_HVSP_76_L     (REG_DISP_MOPS_HVSP_BASE + 0xEC)
#define REG_DISP_MOPS_HVSP_76_H     (REG_DISP_MOPS_HVSP_BASE + 0xED)
#define REG_DISP_MOPS_HVSP_77_L     (REG_DISP_MOPS_HVSP_BASE + 0xEE)
#define REG_DISP_MOPS_HVSP_77_H     (REG_DISP_MOPS_HVSP_BASE + 0xEF)
#define REG_DISP_MOPS_HVSP_78_L     (REG_DISP_MOPS_HVSP_BASE + 0xF0)
#define REG_DISP_MOPS_HVSP_78_H     (REG_DISP_MOPS_HVSP_BASE + 0xF1)
#define REG_DISP_MOPS_HVSP_79_L     (REG_DISP_MOPS_HVSP_BASE + 0xF2)
#define REG_DISP_MOPS_HVSP_79_H     (REG_DISP_MOPS_HVSP_BASE + 0xF3)
#define REG_DISP_MOPS_HVSP_7A_L     (REG_DISP_MOPS_HVSP_BASE + 0xF4)
#define REG_DISP_MOPS_HVSP_7A_H     (REG_DISP_MOPS_HVSP_BASE + 0xF5)
#define REG_DISP_MOPS_HVSP_7B_L     (REG_DISP_MOPS_HVSP_BASE + 0xF6)
#define REG_DISP_MOPS_HVSP_7B_H     (REG_DISP_MOPS_HVSP_BASE + 0xF7)
#define REG_DISP_MOPS_HVSP_7C_L     (REG_DISP_MOPS_HVSP_BASE + 0xF8)
#define REG_DISP_MOPS_HVSP_7C_H     (REG_DISP_MOPS_HVSP_BASE + 0xF9)
#define REG_DISP_MOPS_HVSP_7D_L     (REG_DISP_MOPS_HVSP_BASE + 0xFA)
#define REG_DISP_MOPS_HVSP_7D_H     (REG_DISP_MOPS_HVSP_BASE + 0xFB)
#define REG_DISP_MOPS_HVSP_7E_L     (REG_DISP_MOPS_HVSP_BASE + 0xFC)
#define REG_DISP_MOPS_HVSP_7E_H     (REG_DISP_MOPS_HVSP_BASE + 0xFD)
#define REG_DISP_MOPS_HVSP_7F_L     (REG_DISP_MOPS_HVSP_BASE + 0xFE)
#define REG_DISP_MOPS_HVSP_7F_H     (REG_DISP_MOPS_HVSP_BASE + 0xFF)




#define REG_CLKGEN_00_L              (REG_CLKGEN_BASE + 0x00)
#define REG_CLKGEN_00_H              (REG_CLKGEN_BASE + 0x01)
#define REG_CLKGEN_01_L              (REG_CLKGEN_BASE + 0x02)
#define REG_CLKGEN_01_H              (REG_CLKGEN_BASE + 0x03)
#define REG_CLKGEN_02_L              (REG_CLKGEN_BASE + 0x04)
#define REG_CLKGEN_02_H              (REG_CLKGEN_BASE + 0x05)
#define REG_CLKGEN_03_L              (REG_CLKGEN_BASE + 0x06)
#define REG_CLKGEN_03_H              (REG_CLKGEN_BASE + 0x07)
#define REG_CLKGEN_04_L              (REG_CLKGEN_BASE + 0x08)
#define REG_CLKGEN_04_H              (REG_CLKGEN_BASE + 0x09)
#define REG_CLKGEN_05_L              (REG_CLKGEN_BASE + 0x0A)
#define REG_CLKGEN_05_H              (REG_CLKGEN_BASE + 0x0B)
#define REG_CLKGEN_06_L              (REG_CLKGEN_BASE + 0x0C)
#define REG_CLKGEN_06_H              (REG_CLKGEN_BASE + 0x0D)
#define REG_CLKGEN_07_L              (REG_CLKGEN_BASE + 0x0E)
#define REG_CLKGEN_07_H              (REG_CLKGEN_BASE + 0x0F)
#define REG_CLKGEN_08_L              (REG_CLKGEN_BASE + 0x10)
#define REG_CLKGEN_08_H              (REG_CLKGEN_BASE + 0x11)
#define REG_CLKGEN_09_L              (REG_CLKGEN_BASE + 0x12)
#define REG_CLKGEN_09_H              (REG_CLKGEN_BASE + 0x13)
#define REG_CLKGEN_0A_L              (REG_CLKGEN_BASE + 0x14)
#define REG_CLKGEN_0A_H              (REG_CLKGEN_BASE + 0x15)
#define REG_CLKGEN_0B_L              (REG_CLKGEN_BASE + 0x16)
#define REG_CLKGEN_0B_H              (REG_CLKGEN_BASE + 0x17)
#define REG_CLKGEN_0C_L              (REG_CLKGEN_BASE + 0x18)
#define REG_CLKGEN_0C_H              (REG_CLKGEN_BASE + 0x19)
#define REG_CLKGEN_0D_L              (REG_CLKGEN_BASE + 0x1A)
#define REG_CLKGEN_0D_H              (REG_CLKGEN_BASE + 0x1B)
#define REG_CLKGEN_0E_L              (REG_CLKGEN_BASE + 0x1C)
#define REG_CLKGEN_0E_H              (REG_CLKGEN_BASE + 0x1D)
#define REG_CLKGEN_0F_L              (REG_CLKGEN_BASE + 0x1E)
#define REG_CLKGEN_0F_H              (REG_CLKGEN_BASE + 0x1F)
#define REG_CLKGEN_10_L              (REG_CLKGEN_BASE + 0x20)
#define REG_CLKGEN_10_H              (REG_CLKGEN_BASE + 0x21)
#define REG_CLKGEN_11_L              (REG_CLKGEN_BASE + 0x22)
#define REG_CLKGEN_11_H              (REG_CLKGEN_BASE + 0x23)
#define REG_CLKGEN_12_L              (REG_CLKGEN_BASE + 0x24)
#define REG_CLKGEN_12_H              (REG_CLKGEN_BASE + 0x25)
#define REG_CLKGEN_13_L              (REG_CLKGEN_BASE + 0x26)
#define REG_CLKGEN_13_H              (REG_CLKGEN_BASE + 0x27)
#define REG_CLKGEN_14_L              (REG_CLKGEN_BASE + 0x28)
#define REG_CLKGEN_14_H              (REG_CLKGEN_BASE + 0x29)
#define REG_CLKGEN_15_L              (REG_CLKGEN_BASE + 0x2A)
#define REG_CLKGEN_15_H              (REG_CLKGEN_BASE + 0x2B)
#define REG_CLKGEN_16_L              (REG_CLKGEN_BASE + 0x2C)
#define REG_CLKGEN_16_H              (REG_CLKGEN_BASE + 0x2D)
#define REG_CLKGEN_17_L              (REG_CLKGEN_BASE + 0x2E)
#define REG_CLKGEN_17_H              (REG_CLKGEN_BASE + 0x2F)
#define REG_CLKGEN_18_L              (REG_CLKGEN_BASE + 0x30)
#define REG_CLKGEN_18_H              (REG_CLKGEN_BASE + 0x31)
#define REG_CLKGEN_19_L              (REG_CLKGEN_BASE + 0x32)
#define REG_CLKGEN_19_H              (REG_CLKGEN_BASE + 0x33)
#define REG_CLKGEN_1A_L              (REG_CLKGEN_BASE + 0x34)
#define REG_CLKGEN_1A_H              (REG_CLKGEN_BASE + 0x35)
#define REG_CLKGEN_1B_L              (REG_CLKGEN_BASE + 0x36)
#define REG_CLKGEN_1B_H              (REG_CLKGEN_BASE + 0x37)
#define REG_CLKGEN_1C_L              (REG_CLKGEN_BASE + 0x38)
#define REG_CLKGEN_1C_H              (REG_CLKGEN_BASE + 0x39)
#define REG_CLKGEN_1D_L              (REG_CLKGEN_BASE + 0x3A)
#define REG_CLKGEN_1D_H              (REG_CLKGEN_BASE + 0x3B)
#define REG_CLKGEN_1E_L              (REG_CLKGEN_BASE + 0x3C)
#define REG_CLKGEN_1E_H              (REG_CLKGEN_BASE + 0x3D)
#define REG_CLKGEN_1F_L              (REG_CLKGEN_BASE + 0x3E)
#define REG_CLKGEN_1F_H              (REG_CLKGEN_BASE + 0x3F)
#define REG_CLKGEN_20_L              (REG_CLKGEN_BASE + 0x40)
#define REG_CLKGEN_20_H              (REG_CLKGEN_BASE + 0x41)
#define REG_CLKGEN_21_L              (REG_CLKGEN_BASE + 0x42)
#define REG_CLKGEN_21_H              (REG_CLKGEN_BASE + 0x43)
#define REG_CLKGEN_22_L              (REG_CLKGEN_BASE + 0x44)
#define REG_CLKGEN_22_H              (REG_CLKGEN_BASE + 0x45)
#define REG_CLKGEN_23_L              (REG_CLKGEN_BASE + 0x46)
#define REG_CLKGEN_23_H              (REG_CLKGEN_BASE + 0x47)
#define REG_CLKGEN_24_L              (REG_CLKGEN_BASE + 0x48)
#define REG_CLKGEN_24_H              (REG_CLKGEN_BASE + 0x49)
#define REG_CLKGEN_25_L              (REG_CLKGEN_BASE + 0x4A)
#define REG_CLKGEN_25_H              (REG_CLKGEN_BASE + 0x4B)
#define REG_CLKGEN_26_L              (REG_CLKGEN_BASE + 0x4C)
#define REG_CLKGEN_26_H              (REG_CLKGEN_BASE + 0x4D)
#define REG_CLKGEN_27_L              (REG_CLKGEN_BASE + 0x4E)
#define REG_CLKGEN_27_H              (REG_CLKGEN_BASE + 0x4F)
#define REG_CLKGEN_28_L              (REG_CLKGEN_BASE + 0x50)
#define REG_CLKGEN_28_H              (REG_CLKGEN_BASE + 0x51)
#define REG_CLKGEN_29_L              (REG_CLKGEN_BASE + 0x52)
#define REG_CLKGEN_29_H              (REG_CLKGEN_BASE + 0x53)
#define REG_CLKGEN_2A_L              (REG_CLKGEN_BASE + 0x54)
#define REG_CLKGEN_2A_H              (REG_CLKGEN_BASE + 0x55)
#define REG_CLKGEN_2B_L              (REG_CLKGEN_BASE + 0x56)
#define REG_CLKGEN_2B_H              (REG_CLKGEN_BASE + 0x57)
#define REG_CLKGEN_2C_L              (REG_CLKGEN_BASE + 0x58)
#define REG_CLKGEN_2C_H              (REG_CLKGEN_BASE + 0x59)
#define REG_CLKGEN_2D_L              (REG_CLKGEN_BASE + 0x5A)
#define REG_CLKGEN_2D_H              (REG_CLKGEN_BASE + 0x5B)
#define REG_CLKGEN_2E_L              (REG_CLKGEN_BASE + 0x5C)
#define REG_CLKGEN_2E_H              (REG_CLKGEN_BASE + 0x5D)
#define REG_CLKGEN_2F_L              (REG_CLKGEN_BASE + 0x5E)
#define REG_CLKGEN_2F_H              (REG_CLKGEN_BASE + 0x5F)
#define REG_CLKGEN_30_L              (REG_CLKGEN_BASE + 0x60)
#define REG_CLKGEN_30_H              (REG_CLKGEN_BASE + 0x61)
#define REG_CLKGEN_31_L              (REG_CLKGEN_BASE + 0x62)
#define REG_CLKGEN_31_H              (REG_CLKGEN_BASE + 0x63)
#define REG_CLKGEN_32_L              (REG_CLKGEN_BASE + 0x64)
#define REG_CLKGEN_32_H              (REG_CLKGEN_BASE + 0x65)
#define REG_CLKGEN_33_L              (REG_CLKGEN_BASE + 0x66)
#define REG_CLKGEN_33_H              (REG_CLKGEN_BASE + 0x67)
#define REG_CLKGEN_34_L              (REG_CLKGEN_BASE + 0x68)
#define REG_CLKGEN_34_H              (REG_CLKGEN_BASE + 0x69)
#define REG_CLKGEN_35_L              (REG_CLKGEN_BASE + 0x6A)
#define REG_CLKGEN_35_H              (REG_CLKGEN_BASE + 0x6B)
#define REG_CLKGEN_36_L              (REG_CLKGEN_BASE + 0x6C)
#define REG_CLKGEN_36_H              (REG_CLKGEN_BASE + 0x6D)
#define REG_CLKGEN_37_L              (REG_CLKGEN_BASE + 0x6E)
#define REG_CLKGEN_37_H              (REG_CLKGEN_BASE + 0x6F)
#define REG_CLKGEN_38_L              (REG_CLKGEN_BASE + 0x70)
#define REG_CLKGEN_38_H              (REG_CLKGEN_BASE + 0x71)
#define REG_CLKGEN_39_L              (REG_CLKGEN_BASE + 0x72)
#define REG_CLKGEN_39_H              (REG_CLKGEN_BASE + 0x73)
#define REG_CLKGEN_3A_L              (REG_CLKGEN_BASE + 0x74)
#define REG_CLKGEN_3A_H              (REG_CLKGEN_BASE + 0x75)
#define REG_CLKGEN_3B_L              (REG_CLKGEN_BASE + 0x76)
#define REG_CLKGEN_3B_H              (REG_CLKGEN_BASE + 0x77)
#define REG_CLKGEN_3C_L              (REG_CLKGEN_BASE + 0x78)
#define REG_CLKGEN_3C_H              (REG_CLKGEN_BASE + 0x79)
#define REG_CLKGEN_3D_L              (REG_CLKGEN_BASE + 0x7A)
#define REG_CLKGEN_3D_H              (REG_CLKGEN_BASE + 0x7B)
#define REG_CLKGEN_3E_L              (REG_CLKGEN_BASE + 0x7C)
#define REG_CLKGEN_3E_H              (REG_CLKGEN_BASE + 0x7D)
#define REG_CLKGEN_3F_L              (REG_CLKGEN_BASE + 0x7E)
#define REG_CLKGEN_3F_H              (REG_CLKGEN_BASE + 0x7F)
#define REG_CLKGEN_40_L              (REG_CLKGEN_BASE + 0x80)
#define REG_CLKGEN_40_H              (REG_CLKGEN_BASE + 0x81)
#define REG_CLKGEN_41_L              (REG_CLKGEN_BASE + 0x82)
#define REG_CLKGEN_41_H              (REG_CLKGEN_BASE + 0x83)
#define REG_CLKGEN_42_L              (REG_CLKGEN_BASE + 0x84)
#define REG_CLKGEN_42_H              (REG_CLKGEN_BASE + 0x85)
#define REG_CLKGEN_43_L              (REG_CLKGEN_BASE + 0x86)
#define REG_CLKGEN_43_H              (REG_CLKGEN_BASE + 0x87)
#define REG_CLKGEN_44_L              (REG_CLKGEN_BASE + 0x88)
#define REG_CLKGEN_44_H              (REG_CLKGEN_BASE + 0x89)
#define REG_CLKGEN_45_L              (REG_CLKGEN_BASE + 0x8A)
#define REG_CLKGEN_45_H              (REG_CLKGEN_BASE + 0x8B)
#define REG_CLKGEN_46_L              (REG_CLKGEN_BASE + 0x8C)
#define REG_CLKGEN_46_H              (REG_CLKGEN_BASE + 0x8D)
#define REG_CLKGEN_47_L              (REG_CLKGEN_BASE + 0x8E)
#define REG_CLKGEN_47_H              (REG_CLKGEN_BASE + 0x8F)
#define REG_CLKGEN_48_L              (REG_CLKGEN_BASE + 0x90)
#define REG_CLKGEN_48_H              (REG_CLKGEN_BASE + 0x91)
#define REG_CLKGEN_49_L              (REG_CLKGEN_BASE + 0x92)
#define REG_CLKGEN_49_H              (REG_CLKGEN_BASE + 0x93)
#define REG_CLKGEN_4A_L              (REG_CLKGEN_BASE + 0x94)
#define REG_CLKGEN_4A_H              (REG_CLKGEN_BASE + 0x95)
#define REG_CLKGEN_4B_L              (REG_CLKGEN_BASE + 0x96)
#define REG_CLKGEN_4B_H              (REG_CLKGEN_BASE + 0x97)
#define REG_CLKGEN_4C_L              (REG_CLKGEN_BASE + 0x98)
#define REG_CLKGEN_4C_H              (REG_CLKGEN_BASE + 0x99)
#define REG_CLKGEN_4D_L              (REG_CLKGEN_BASE + 0x9A)
#define REG_CLKGEN_4D_H              (REG_CLKGEN_BASE + 0x9B)
#define REG_CLKGEN_4E_L              (REG_CLKGEN_BASE + 0x9C)
#define REG_CLKGEN_4E_H              (REG_CLKGEN_BASE + 0x9D)
#define REG_CLKGEN_4F_L              (REG_CLKGEN_BASE + 0x9E)
#define REG_CLKGEN_4F_H              (REG_CLKGEN_BASE + 0x9F)
#define REG_CLKGEN_50_L              (REG_CLKGEN_BASE + 0xA0)
#define REG_CLKGEN_50_H              (REG_CLKGEN_BASE + 0xA1)
#define REG_CLKGEN_51_L              (REG_CLKGEN_BASE + 0xA2)
#define REG_CLKGEN_51_H              (REG_CLKGEN_BASE + 0xA3)
#define REG_CLKGEN_52_L              (REG_CLKGEN_BASE + 0xA4)
#define REG_CLKGEN_52_H              (REG_CLKGEN_BASE + 0xA5)
#define REG_CLKGEN_53_L              (REG_CLKGEN_BASE + 0xA6)
#define REG_CLKGEN_53_H              (REG_CLKGEN_BASE + 0xA7)
#define REG_CLKGEN_54_L              (REG_CLKGEN_BASE + 0xA8)
#define REG_CLKGEN_54_H              (REG_CLKGEN_BASE + 0xA9)
#define REG_CLKGEN_55_L              (REG_CLKGEN_BASE + 0xAA)
#define REG_CLKGEN_55_H              (REG_CLKGEN_BASE + 0xAB)
#define REG_CLKGEN_56_L              (REG_CLKGEN_BASE + 0xAC)
#define REG_CLKGEN_56_H              (REG_CLKGEN_BASE + 0xAD)
#define REG_CLKGEN_57_L              (REG_CLKGEN_BASE + 0xAE)
#define REG_CLKGEN_57_H              (REG_CLKGEN_BASE + 0xAF)
#define REG_CLKGEN_58_L              (REG_CLKGEN_BASE + 0xB0)
#define REG_CLKGEN_58_H              (REG_CLKGEN_BASE + 0xB1)
#define REG_CLKGEN_59_L              (REG_CLKGEN_BASE + 0xB2)
#define REG_CLKGEN_59_H              (REG_CLKGEN_BASE + 0xB3)
#define REG_CLKGEN_5A_L              (REG_CLKGEN_BASE + 0xB4)
#define REG_CLKGEN_5A_H              (REG_CLKGEN_BASE + 0xB5)
#define REG_CLKGEN_5B_L              (REG_CLKGEN_BASE + 0xB6)
#define REG_CLKGEN_5B_H              (REG_CLKGEN_BASE + 0xB7)
#define REG_CLKGEN_5C_L              (REG_CLKGEN_BASE + 0xB8)
#define REG_CLKGEN_5C_H              (REG_CLKGEN_BASE + 0xB9)
#define REG_CLKGEN_5D_L              (REG_CLKGEN_BASE + 0xBA)
#define REG_CLKGEN_5D_H              (REG_CLKGEN_BASE + 0xBB)
#define REG_CLKGEN_5E_L              (REG_CLKGEN_BASE + 0xBC)
#define REG_CLKGEN_5E_H              (REG_CLKGEN_BASE + 0xBD)
#define REG_CLKGEN_5F_L              (REG_CLKGEN_BASE + 0xBE)
#define REG_CLKGEN_5F_H              (REG_CLKGEN_BASE + 0xBF)
#define REG_CLKGEN_60_L              (REG_CLKGEN_BASE + 0xC0)
#define REG_CLKGEN_60_H              (REG_CLKGEN_BASE + 0xC1)
#define REG_CLKGEN_61_L              (REG_CLKGEN_BASE + 0xC2)
#define REG_CLKGEN_61_H              (REG_CLKGEN_BASE + 0xC3)
#define REG_CLKGEN_62_L              (REG_CLKGEN_BASE + 0xC4)
#define REG_CLKGEN_62_H              (REG_CLKGEN_BASE + 0xC5)
#define REG_CLKGEN_63_L              (REG_CLKGEN_BASE + 0xC6)
#define REG_CLKGEN_63_H              (REG_CLKGEN_BASE + 0xC7)
#define REG_CLKGEN_64_L              (REG_CLKGEN_BASE + 0xC8)
#define REG_CLKGEN_64_H              (REG_CLKGEN_BASE + 0xC9)
#define REG_CLKGEN_65_L              (REG_CLKGEN_BASE + 0xCA)
#define REG_CLKGEN_65_H              (REG_CLKGEN_BASE + 0xCB)
#define REG_CLKGEN_66_L              (REG_CLKGEN_BASE + 0xCC)
#define REG_CLKGEN_66_H              (REG_CLKGEN_BASE + 0xCD)
#define REG_CLKGEN_67_L              (REG_CLKGEN_BASE + 0xCE)
#define REG_CLKGEN_67_H              (REG_CLKGEN_BASE + 0xCF)
#define REG_CLKGEN_68_L              (REG_CLKGEN_BASE + 0xD0)
#define REG_CLKGEN_68_H              (REG_CLKGEN_BASE + 0xD1)
#define REG_CLKGEN_69_L              (REG_CLKGEN_BASE + 0xD2)
#define REG_CLKGEN_69_H              (REG_CLKGEN_BASE + 0xD3)
#define REG_CLKGEN_6A_L              (REG_CLKGEN_BASE + 0xD4)
#define REG_CLKGEN_6A_H              (REG_CLKGEN_BASE + 0xD5)
#define REG_CLKGEN_6B_L              (REG_CLKGEN_BASE + 0xD6)
#define REG_CLKGEN_6B_H              (REG_CLKGEN_BASE + 0xD7)
#define REG_CLKGEN_6C_L              (REG_CLKGEN_BASE + 0xD8)
#define REG_CLKGEN_6C_H              (REG_CLKGEN_BASE + 0xD9)
#define REG_CLKGEN_6D_L              (REG_CLKGEN_BASE + 0xDA)
#define REG_CLKGEN_6D_H              (REG_CLKGEN_BASE + 0xDB)
#define REG_CLKGEN_6E_L              (REG_CLKGEN_BASE + 0xDC)
#define REG_CLKGEN_6E_H              (REG_CLKGEN_BASE + 0xDD)
#define REG_CLKGEN_6F_L              (REG_CLKGEN_BASE + 0xDE)
#define REG_CLKGEN_6F_H              (REG_CLKGEN_BASE + 0xDF)
#define REG_CLKGEN_70_L              (REG_CLKGEN_BASE + 0xE0)
#define REG_CLKGEN_70_H              (REG_CLKGEN_BASE + 0xE1)
#define REG_CLKGEN_71_L              (REG_CLKGEN_BASE + 0xE2)
#define REG_CLKGEN_71_H              (REG_CLKGEN_BASE + 0xE3)
#define REG_CLKGEN_72_L              (REG_CLKGEN_BASE + 0xE4)
#define REG_CLKGEN_72_H              (REG_CLKGEN_BASE + 0xE5)
#define REG_CLKGEN_73_L              (REG_CLKGEN_BASE + 0xE6)
#define REG_CLKGEN_73_H              (REG_CLKGEN_BASE + 0xE7)
#define REG_CLKGEN_74_L              (REG_CLKGEN_BASE + 0xE8)
#define REG_CLKGEN_74_H              (REG_CLKGEN_BASE + 0xE9)
#define REG_CLKGEN_75_L              (REG_CLKGEN_BASE + 0xEA)
#define REG_CLKGEN_75_H              (REG_CLKGEN_BASE + 0xEB)
#define REG_CLKGEN_76_L              (REG_CLKGEN_BASE + 0xEC)
#define REG_CLKGEN_76_H              (REG_CLKGEN_BASE + 0xED)
#define REG_CLKGEN_77_L              (REG_CLKGEN_BASE + 0xEE)
#define REG_CLKGEN_77_H              (REG_CLKGEN_BASE + 0xEF)
#define REG_CLKGEN_78_L              (REG_CLKGEN_BASE + 0xF0)
#define REG_CLKGEN_78_H              (REG_CLKGEN_BASE + 0xF1)
#define REG_CLKGEN_79_L              (REG_CLKGEN_BASE + 0xF2)
#define REG_CLKGEN_79_H              (REG_CLKGEN_BASE + 0xF3)
#define REG_CLKGEN_7A_L              (REG_CLKGEN_BASE + 0xF4)
#define REG_CLKGEN_7A_H              (REG_CLKGEN_BASE + 0xF5)
#define REG_CLKGEN_7B_L              (REG_CLKGEN_BASE + 0xF6)
#define REG_CLKGEN_7B_H              (REG_CLKGEN_BASE + 0xF7)
#define REG_CLKGEN_7C_L              (REG_CLKGEN_BASE + 0xF8)
#define REG_CLKGEN_7C_H              (REG_CLKGEN_BASE + 0xF9)
#define REG_CLKGEN_7D_L              (REG_CLKGEN_BASE + 0xFA)
#define REG_CLKGEN_7D_H              (REG_CLKGEN_BASE + 0xFB)
#define REG_CLKGEN_7E_L              (REG_CLKGEN_BASE + 0xFC)
#define REG_CLKGEN_7E_H              (REG_CLKGEN_BASE + 0xFD)
#define REG_CLKGEN_7F_L              (REG_CLKGEN_BASE + 0xFE)
#define REG_CLKGEN_7F_H              (REG_CLKGEN_BASE + 0xFF)

#define REG_SC_GP_CTRL_00_L             (REG_SC_GP_CTRL_BASE + 0x00)
#define REG_SC_GP_CTRL_00_H             (REG_SC_GP_CTRL_BASE + 0x01)
#define REG_SC_GP_CTRL_01_L             (REG_SC_GP_CTRL_BASE + 0x02)
#define REG_SC_GP_CTRL_01_H             (REG_SC_GP_CTRL_BASE + 0x03)
#define REG_SC_GP_CTRL_02_L             (REG_SC_GP_CTRL_BASE + 0x04)
#define REG_SC_GP_CTRL_02_H             (REG_SC_GP_CTRL_BASE + 0x05)
#define REG_SC_GP_CTRL_03_L             (REG_SC_GP_CTRL_BASE + 0x06)
#define REG_SC_GP_CTRL_03_H             (REG_SC_GP_CTRL_BASE + 0x07)
#define REG_SC_GP_CTRL_04_L             (REG_SC_GP_CTRL_BASE + 0x08)
#define REG_SC_GP_CTRL_04_H             (REG_SC_GP_CTRL_BASE + 0x09)
#define REG_SC_GP_CTRL_05_L             (REG_SC_GP_CTRL_BASE + 0x0A)
#define REG_SC_GP_CTRL_05_H             (REG_SC_GP_CTRL_BASE + 0x0B)
#define REG_SC_GP_CTRL_06_L             (REG_SC_GP_CTRL_BASE + 0x0C)
#define REG_SC_GP_CTRL_06_H             (REG_SC_GP_CTRL_BASE + 0x0D)
#define REG_SC_GP_CTRL_07_L             (REG_SC_GP_CTRL_BASE + 0x0E)
#define REG_SC_GP_CTRL_07_H             (REG_SC_GP_CTRL_BASE + 0x0F)
#define REG_SC_GP_CTRL_08_L             (REG_SC_GP_CTRL_BASE + 0x10)
#define REG_SC_GP_CTRL_08_H             (REG_SC_GP_CTRL_BASE + 0x11)
#define REG_SC_GP_CTRL_09_L             (REG_SC_GP_CTRL_BASE + 0x12)
#define REG_SC_GP_CTRL_09_H             (REG_SC_GP_CTRL_BASE + 0x13)
#define REG_SC_GP_CTRL_0A_L             (REG_SC_GP_CTRL_BASE + 0x14)
#define REG_SC_GP_CTRL_0A_H             (REG_SC_GP_CTRL_BASE + 0x15)
#define REG_SC_GP_CTRL_0B_L             (REG_SC_GP_CTRL_BASE + 0x16)
#define REG_SC_GP_CTRL_0B_H             (REG_SC_GP_CTRL_BASE + 0x17)
#define REG_SC_GP_CTRL_0C_L             (REG_SC_GP_CTRL_BASE + 0x18)
#define REG_SC_GP_CTRL_0C_H             (REG_SC_GP_CTRL_BASE + 0x19)
#define REG_SC_GP_CTRL_0D_L             (REG_SC_GP_CTRL_BASE + 0x1A)
#define REG_SC_GP_CTRL_0D_H             (REG_SC_GP_CTRL_BASE + 0x1B)
#define REG_SC_GP_CTRL_0E_L             (REG_SC_GP_CTRL_BASE + 0x1C)
#define REG_SC_GP_CTRL_0E_H             (REG_SC_GP_CTRL_BASE + 0x1D)
#define REG_SC_GP_CTRL_0F_L             (REG_SC_GP_CTRL_BASE + 0x1E)
#define REG_SC_GP_CTRL_0F_H             (REG_SC_GP_CTRL_BASE + 0x1F)
#define REG_SC_GP_CTRL_10_L             (REG_SC_GP_CTRL_BASE + 0x20)
#define REG_SC_GP_CTRL_10_H             (REG_SC_GP_CTRL_BASE + 0x21)
#define REG_SC_GP_CTRL_11_L             (REG_SC_GP_CTRL_BASE + 0x22)
#define REG_SC_GP_CTRL_11_H             (REG_SC_GP_CTRL_BASE + 0x23)
#define REG_SC_GP_CTRL_12_L             (REG_SC_GP_CTRL_BASE + 0x24)
#define REG_SC_GP_CTRL_12_H             (REG_SC_GP_CTRL_BASE + 0x25)
#define REG_SC_GP_CTRL_13_L             (REG_SC_GP_CTRL_BASE + 0x26)
#define REG_SC_GP_CTRL_13_H             (REG_SC_GP_CTRL_BASE + 0x27)
#define REG_SC_GP_CTRL_14_L             (REG_SC_GP_CTRL_BASE + 0x28)
#define REG_SC_GP_CTRL_14_H             (REG_SC_GP_CTRL_BASE + 0x29)
#define REG_SC_GP_CTRL_15_L             (REG_SC_GP_CTRL_BASE + 0x2A)
#define REG_SC_GP_CTRL_15_H             (REG_SC_GP_CTRL_BASE + 0x2B)
#define REG_SC_GP_CTRL_16_L             (REG_SC_GP_CTRL_BASE + 0x2C)
#define REG_SC_GP_CTRL_16_H             (REG_SC_GP_CTRL_BASE + 0x2D)
#define REG_SC_GP_CTRL_17_L             (REG_SC_GP_CTRL_BASE + 0x2E)
#define REG_SC_GP_CTRL_17_H             (REG_SC_GP_CTRL_BASE + 0x2F)
#define REG_SC_GP_CTRL_18_L             (REG_SC_GP_CTRL_BASE + 0x30)
#define REG_SC_GP_CTRL_18_H             (REG_SC_GP_CTRL_BASE + 0x31)
#define REG_SC_GP_CTRL_19_L             (REG_SC_GP_CTRL_BASE + 0x32)
#define REG_SC_GP_CTRL_19_H             (REG_SC_GP_CTRL_BASE + 0x33)
#define REG_SC_GP_CTRL_1A_L             (REG_SC_GP_CTRL_BASE + 0x34)
#define REG_SC_GP_CTRL_1A_H             (REG_SC_GP_CTRL_BASE + 0x35)
#define REG_SC_GP_CTRL_1B_L             (REG_SC_GP_CTRL_BASE + 0x36)
#define REG_SC_GP_CTRL_1B_H             (REG_SC_GP_CTRL_BASE + 0x37)
#define REG_SC_GP_CTRL_1C_L             (REG_SC_GP_CTRL_BASE + 0x38)
#define REG_SC_GP_CTRL_1C_H             (REG_SC_GP_CTRL_BASE + 0x39)
#define REG_SC_GP_CTRL_1D_L             (REG_SC_GP_CTRL_BASE + 0x3A)
#define REG_SC_GP_CTRL_1D_H             (REG_SC_GP_CTRL_BASE + 0x3B)
#define REG_SC_GP_CTRL_1E_L             (REG_SC_GP_CTRL_BASE + 0x3C)
#define REG_SC_GP_CTRL_1E_H             (REG_SC_GP_CTRL_BASE + 0x3D)
#define REG_SC_GP_CTRL_1F_L             (REG_SC_GP_CTRL_BASE + 0x3E)
#define REG_SC_GP_CTRL_1F_H             (REG_SC_GP_CTRL_BASE + 0x3F)
#define REG_SC_GP_CTRL_20_L             (REG_SC_GP_CTRL_BASE + 0x40)
#define REG_SC_GP_CTRL_20_H             (REG_SC_GP_CTRL_BASE + 0x41)
#define REG_SC_GP_CTRL_21_L             (REG_SC_GP_CTRL_BASE + 0x42)
#define REG_SC_GP_CTRL_21_H             (REG_SC_GP_CTRL_BASE + 0x43)
#define REG_SC_GP_CTRL_22_L             (REG_SC_GP_CTRL_BASE + 0x44)
#define REG_SC_GP_CTRL_22_H             (REG_SC_GP_CTRL_BASE + 0x45)
#define REG_SC_GP_CTRL_23_L             (REG_SC_GP_CTRL_BASE + 0x46)
#define REG_SC_GP_CTRL_23_H             (REG_SC_GP_CTRL_BASE + 0x47)
#define REG_SC_GP_CTRL_24_L             (REG_SC_GP_CTRL_BASE + 0x48)
#define REG_SC_GP_CTRL_24_H             (REG_SC_GP_CTRL_BASE + 0x49)
#define REG_SC_GP_CTRL_25_L             (REG_SC_GP_CTRL_BASE + 0x4A)
#define REG_SC_GP_CTRL_25_H             (REG_SC_GP_CTRL_BASE + 0x4B)
#define REG_SC_GP_CTRL_26_L             (REG_SC_GP_CTRL_BASE + 0x4C)
#define REG_SC_GP_CTRL_26_H             (REG_SC_GP_CTRL_BASE + 0x4D)
#define REG_SC_GP_CTRL_27_L             (REG_SC_GP_CTRL_BASE + 0x4E)
#define REG_SC_GP_CTRL_27_H             (REG_SC_GP_CTRL_BASE + 0x4F)
#define REG_SC_GP_CTRL_28_L             (REG_SC_GP_CTRL_BASE + 0x50)
#define REG_SC_GP_CTRL_28_H             (REG_SC_GP_CTRL_BASE + 0x51)
#define REG_SC_GP_CTRL_29_L             (REG_SC_GP_CTRL_BASE + 0x52)
#define REG_SC_GP_CTRL_29_H             (REG_SC_GP_CTRL_BASE + 0x53)
#define REG_SC_GP_CTRL_2A_L             (REG_SC_GP_CTRL_BASE + 0x54)
#define REG_SC_GP_CTRL_2A_H             (REG_SC_GP_CTRL_BASE + 0x55)
#define REG_SC_GP_CTRL_2B_L             (REG_SC_GP_CTRL_BASE + 0x56)
#define REG_SC_GP_CTRL_2B_H             (REG_SC_GP_CTRL_BASE + 0x57)
#define REG_SC_GP_CTRL_2C_L             (REG_SC_GP_CTRL_BASE + 0x58)
#define REG_SC_GP_CTRL_2C_H             (REG_SC_GP_CTRL_BASE + 0x59)
#define REG_SC_GP_CTRL_2D_L             (REG_SC_GP_CTRL_BASE + 0x5A)
#define REG_SC_GP_CTRL_2D_H             (REG_SC_GP_CTRL_BASE + 0x5B)
#define REG_SC_GP_CTRL_2E_L             (REG_SC_GP_CTRL_BASE + 0x5C)
#define REG_SC_GP_CTRL_2E_H             (REG_SC_GP_CTRL_BASE + 0x5D)
#define REG_SC_GP_CTRL_2F_L             (REG_SC_GP_CTRL_BASE + 0x5E)
#define REG_SC_GP_CTRL_2F_H             (REG_SC_GP_CTRL_BASE + 0x5F)
#define REG_SC_GP_CTRL_30_L             (REG_SC_GP_CTRL_BASE + 0x60)
#define REG_SC_GP_CTRL_30_H             (REG_SC_GP_CTRL_BASE + 0x61)
#define REG_SC_GP_CTRL_31_L             (REG_SC_GP_CTRL_BASE + 0x62)
#define REG_SC_GP_CTRL_31_H             (REG_SC_GP_CTRL_BASE + 0x63)
#define REG_SC_GP_CTRL_32_L             (REG_SC_GP_CTRL_BASE + 0x64)
#define REG_SC_GP_CTRL_32_H             (REG_SC_GP_CTRL_BASE + 0x65)
#define REG_SC_GP_CTRL_33_L             (REG_SC_GP_CTRL_BASE + 0x66)
#define REG_SC_GP_CTRL_33_H             (REG_SC_GP_CTRL_BASE + 0x67)
#define REG_SC_GP_CTRL_34_L             (REG_SC_GP_CTRL_BASE + 0x68)
#define REG_SC_GP_CTRL_34_H             (REG_SC_GP_CTRL_BASE + 0x69)
#define REG_SC_GP_CTRL_35_L             (REG_SC_GP_CTRL_BASE + 0x6A)
#define REG_SC_GP_CTRL_35_H             (REG_SC_GP_CTRL_BASE + 0x6B)
#define REG_SC_GP_CTRL_36_L             (REG_SC_GP_CTRL_BASE + 0x6C)
#define REG_SC_GP_CTRL_36_H             (REG_SC_GP_CTRL_BASE + 0x6D)
#define REG_SC_GP_CTRL_37_L             (REG_SC_GP_CTRL_BASE + 0x6E)
#define REG_SC_GP_CTRL_37_H             (REG_SC_GP_CTRL_BASE + 0x6F)
#define REG_SC_GP_CTRL_38_L             (REG_SC_GP_CTRL_BASE + 0x70)
#define REG_SC_GP_CTRL_38_H             (REG_SC_GP_CTRL_BASE + 0x71)
#define REG_SC_GP_CTRL_39_L             (REG_SC_GP_CTRL_BASE + 0x72)
#define REG_SC_GP_CTRL_39_H             (REG_SC_GP_CTRL_BASE + 0x73)
#define REG_SC_GP_CTRL_3A_L             (REG_SC_GP_CTRL_BASE + 0x74)
#define REG_SC_GP_CTRL_3A_H             (REG_SC_GP_CTRL_BASE + 0x75)
#define REG_SC_GP_CTRL_3B_L             (REG_SC_GP_CTRL_BASE + 0x76)
#define REG_SC_GP_CTRL_3B_H             (REG_SC_GP_CTRL_BASE + 0x77)
#define REG_SC_GP_CTRL_3C_L             (REG_SC_GP_CTRL_BASE + 0x78)
#define REG_SC_GP_CTRL_3C_H             (REG_SC_GP_CTRL_BASE + 0x79)
#define REG_SC_GP_CTRL_3D_L             (REG_SC_GP_CTRL_BASE + 0x7A)
#define REG_SC_GP_CTRL_3D_H             (REG_SC_GP_CTRL_BASE + 0x7B)
#define REG_SC_GP_CTRL_3E_L             (REG_SC_GP_CTRL_BASE + 0x7C)
#define REG_SC_GP_CTRL_3E_H             (REG_SC_GP_CTRL_BASE + 0x7D)
#define REG_SC_GP_CTRL_3F_L             (REG_SC_GP_CTRL_BASE + 0x7E)
#define REG_SC_GP_CTRL_3F_H             (REG_SC_GP_CTRL_BASE + 0x7F)
#define REG_SC_GP_CTRL_40_L             (REG_SC_GP_CTRL_BASE + 0x80)
#define REG_SC_GP_CTRL_40_H             (REG_SC_GP_CTRL_BASE + 0x81)
#define REG_SC_GP_CTRL_41_L             (REG_SC_GP_CTRL_BASE + 0x82)
#define REG_SC_GP_CTRL_41_H             (REG_SC_GP_CTRL_BASE + 0x83)
#define REG_SC_GP_CTRL_42_L             (REG_SC_GP_CTRL_BASE + 0x84)
#define REG_SC_GP_CTRL_42_H             (REG_SC_GP_CTRL_BASE + 0x85)
#define REG_SC_GP_CTRL_43_L             (REG_SC_GP_CTRL_BASE + 0x86)
#define REG_SC_GP_CTRL_43_H             (REG_SC_GP_CTRL_BASE + 0x87)
#define REG_SC_GP_CTRL_44_L             (REG_SC_GP_CTRL_BASE + 0x88)
#define REG_SC_GP_CTRL_44_H             (REG_SC_GP_CTRL_BASE + 0x89)
#define REG_SC_GP_CTRL_45_L             (REG_SC_GP_CTRL_BASE + 0x8A)
#define REG_SC_GP_CTRL_45_H             (REG_SC_GP_CTRL_BASE + 0x8B)
#define REG_SC_GP_CTRL_46_L             (REG_SC_GP_CTRL_BASE + 0x8C)
#define REG_SC_GP_CTRL_46_H             (REG_SC_GP_CTRL_BASE + 0x8D)
#define REG_SC_GP_CTRL_47_L             (REG_SC_GP_CTRL_BASE + 0x8E)
#define REG_SC_GP_CTRL_47_H             (REG_SC_GP_CTRL_BASE + 0x8F)
#define REG_SC_GP_CTRL_48_L             (REG_SC_GP_CTRL_BASE + 0x90)
#define REG_SC_GP_CTRL_48_H             (REG_SC_GP_CTRL_BASE + 0x91)
#define REG_SC_GP_CTRL_49_L             (REG_SC_GP_CTRL_BASE + 0x92)
#define REG_SC_GP_CTRL_49_H             (REG_SC_GP_CTRL_BASE + 0x93)
#define REG_SC_GP_CTRL_4A_L             (REG_SC_GP_CTRL_BASE + 0x94)
#define REG_SC_GP_CTRL_4A_H             (REG_SC_GP_CTRL_BASE + 0x95)
#define REG_SC_GP_CTRL_4B_L             (REG_SC_GP_CTRL_BASE + 0x96)
#define REG_SC_GP_CTRL_4B_H             (REG_SC_GP_CTRL_BASE + 0x97)
#define REG_SC_GP_CTRL_4C_L             (REG_SC_GP_CTRL_BASE + 0x98)
#define REG_SC_GP_CTRL_4C_H             (REG_SC_GP_CTRL_BASE + 0x99)
#define REG_SC_GP_CTRL_4D_L             (REG_SC_GP_CTRL_BASE + 0x9A)
#define REG_SC_GP_CTRL_4D_H             (REG_SC_GP_CTRL_BASE + 0x9B)
#define REG_SC_GP_CTRL_4E_L             (REG_SC_GP_CTRL_BASE + 0x9C)
#define REG_SC_GP_CTRL_4E_H             (REG_SC_GP_CTRL_BASE + 0x9D)
#define REG_SC_GP_CTRL_4F_L             (REG_SC_GP_CTRL_BASE + 0x9E)
#define REG_SC_GP_CTRL_4F_H             (REG_SC_GP_CTRL_BASE + 0x9F)
#define REG_SC_GP_CTRL_50_L             (REG_SC_GP_CTRL_BASE + 0xA0)
#define REG_SC_GP_CTRL_50_H             (REG_SC_GP_CTRL_BASE + 0xA1)
#define REG_SC_GP_CTRL_51_L             (REG_SC_GP_CTRL_BASE + 0xA2)
#define REG_SC_GP_CTRL_51_H             (REG_SC_GP_CTRL_BASE + 0xA3)
#define REG_SC_GP_CTRL_52_L             (REG_SC_GP_CTRL_BASE + 0xA4)
#define REG_SC_GP_CTRL_52_H             (REG_SC_GP_CTRL_BASE + 0xA5)
#define REG_SC_GP_CTRL_53_L             (REG_SC_GP_CTRL_BASE + 0xA6)
#define REG_SC_GP_CTRL_53_H             (REG_SC_GP_CTRL_BASE + 0xA7)
#define REG_SC_GP_CTRL_54_L             (REG_SC_GP_CTRL_BASE + 0xA8)
#define REG_SC_GP_CTRL_54_H             (REG_SC_GP_CTRL_BASE + 0xA9)
#define REG_SC_GP_CTRL_55_L             (REG_SC_GP_CTRL_BASE + 0xAA)
#define REG_SC_GP_CTRL_55_H             (REG_SC_GP_CTRL_BASE + 0xAB)
#define REG_SC_GP_CTRL_56_L             (REG_SC_GP_CTRL_BASE + 0xAC)
#define REG_SC_GP_CTRL_56_H             (REG_SC_GP_CTRL_BASE + 0xAD)
#define REG_SC_GP_CTRL_57_L             (REG_SC_GP_CTRL_BASE + 0xAE)
#define REG_SC_GP_CTRL_57_H             (REG_SC_GP_CTRL_BASE + 0xAF)
#define REG_SC_GP_CTRL_58_L             (REG_SC_GP_CTRL_BASE + 0xB0)
#define REG_SC_GP_CTRL_58_H             (REG_SC_GP_CTRL_BASE + 0xB1)
#define REG_SC_GP_CTRL_59_L             (REG_SC_GP_CTRL_BASE + 0xB2)
#define REG_SC_GP_CTRL_59_H             (REG_SC_GP_CTRL_BASE + 0xB3)
#define REG_SC_GP_CTRL_5A_L             (REG_SC_GP_CTRL_BASE + 0xB4)
#define REG_SC_GP_CTRL_5A_H             (REG_SC_GP_CTRL_BASE + 0xB5)
#define REG_SC_GP_CTRL_5B_L             (REG_SC_GP_CTRL_BASE + 0xB6)
#define REG_SC_GP_CTRL_5B_H             (REG_SC_GP_CTRL_BASE + 0xB7)
#define REG_SC_GP_CTRL_5C_L             (REG_SC_GP_CTRL_BASE + 0xB8)
#define REG_SC_GP_CTRL_5C_H             (REG_SC_GP_CTRL_BASE + 0xB9)
#define REG_SC_GP_CTRL_5D_L             (REG_SC_GP_CTRL_BASE + 0xBA)
#define REG_SC_GP_CTRL_5D_H             (REG_SC_GP_CTRL_BASE + 0xBB)
#define REG_SC_GP_CTRL_5E_L             (REG_SC_GP_CTRL_BASE + 0xBC)
#define REG_SC_GP_CTRL_5E_H             (REG_SC_GP_CTRL_BASE + 0xBD)
#define REG_SC_GP_CTRL_5F_L             (REG_SC_GP_CTRL_BASE + 0xBE)
#define REG_SC_GP_CTRL_5F_H             (REG_SC_GP_CTRL_BASE + 0xBF)
#define REG_SC_GP_CTRL_60_L             (REG_SC_GP_CTRL_BASE + 0xC0)
#define REG_SC_GP_CTRL_60_H             (REG_SC_GP_CTRL_BASE + 0xC1)
#define REG_SC_GP_CTRL_61_L             (REG_SC_GP_CTRL_BASE + 0xC2)
#define REG_SC_GP_CTRL_61_H             (REG_SC_GP_CTRL_BASE + 0xC3)
#define REG_SC_GP_CTRL_62_L             (REG_SC_GP_CTRL_BASE + 0xC4)
#define REG_SC_GP_CTRL_62_H             (REG_SC_GP_CTRL_BASE + 0xC5)
#define REG_SC_GP_CTRL_63_L             (REG_SC_GP_CTRL_BASE + 0xC6)
#define REG_SC_GP_CTRL_63_H             (REG_SC_GP_CTRL_BASE + 0xC7)
#define REG_SC_GP_CTRL_64_L             (REG_SC_GP_CTRL_BASE + 0xC8)
#define REG_SC_GP_CTRL_64_H             (REG_SC_GP_CTRL_BASE + 0xC9)
#define REG_SC_GP_CTRL_65_L             (REG_SC_GP_CTRL_BASE + 0xCA)
#define REG_SC_GP_CTRL_65_H             (REG_SC_GP_CTRL_BASE + 0xCB)
#define REG_SC_GP_CTRL_66_L             (REG_SC_GP_CTRL_BASE + 0xCC)
#define REG_SC_GP_CTRL_66_H             (REG_SC_GP_CTRL_BASE + 0xCD)
#define REG_SC_GP_CTRL_67_L             (REG_SC_GP_CTRL_BASE + 0xCE)
#define REG_SC_GP_CTRL_67_H             (REG_SC_GP_CTRL_BASE + 0xCF)
#define REG_SC_GP_CTRL_68_L             (REG_SC_GP_CTRL_BASE + 0xD0)
#define REG_SC_GP_CTRL_68_H             (REG_SC_GP_CTRL_BASE + 0xD1)
#define REG_SC_GP_CTRL_69_L             (REG_SC_GP_CTRL_BASE + 0xD2)
#define REG_SC_GP_CTRL_69_H             (REG_SC_GP_CTRL_BASE + 0xD3)
#define REG_SC_GP_CTRL_6A_L             (REG_SC_GP_CTRL_BASE + 0xD4)
#define REG_SC_GP_CTRL_6A_H             (REG_SC_GP_CTRL_BASE + 0xD5)
#define REG_SC_GP_CTRL_6B_L             (REG_SC_GP_CTRL_BASE + 0xD6)
#define REG_SC_GP_CTRL_6B_H             (REG_SC_GP_CTRL_BASE + 0xD7)
#define REG_SC_GP_CTRL_6C_L             (REG_SC_GP_CTRL_BASE + 0xD8)
#define REG_SC_GP_CTRL_6C_H             (REG_SC_GP_CTRL_BASE + 0xD9)
#define REG_SC_GP_CTRL_6D_L             (REG_SC_GP_CTRL_BASE + 0xDA)
#define REG_SC_GP_CTRL_6D_H             (REG_SC_GP_CTRL_BASE + 0xDB)
#define REG_SC_GP_CTRL_6E_L             (REG_SC_GP_CTRL_BASE + 0xDC)
#define REG_SC_GP_CTRL_6E_H             (REG_SC_GP_CTRL_BASE + 0xDD)
#define REG_SC_GP_CTRL_6F_L             (REG_SC_GP_CTRL_BASE + 0xDE)
#define REG_SC_GP_CTRL_6F_H             (REG_SC_GP_CTRL_BASE + 0xDF)
#define REG_SC_GP_CTRL_70_L             (REG_SC_GP_CTRL_BASE + 0xE0)
#define REG_SC_GP_CTRL_70_H             (REG_SC_GP_CTRL_BASE + 0xE1)
#define REG_SC_GP_CTRL_71_L             (REG_SC_GP_CTRL_BASE + 0xE2)
#define REG_SC_GP_CTRL_71_H             (REG_SC_GP_CTRL_BASE + 0xE3)
#define REG_SC_GP_CTRL_72_L             (REG_SC_GP_CTRL_BASE + 0xE4)
#define REG_SC_GP_CTRL_72_H             (REG_SC_GP_CTRL_BASE + 0xE5)
#define REG_SC_GP_CTRL_73_L             (REG_SC_GP_CTRL_BASE + 0xE6)
#define REG_SC_GP_CTRL_73_H             (REG_SC_GP_CTRL_BASE + 0xE7)
#define REG_SC_GP_CTRL_74_L             (REG_SC_GP_CTRL_BASE + 0xE8)
#define REG_SC_GP_CTRL_74_H             (REG_SC_GP_CTRL_BASE + 0xE9)
#define REG_SC_GP_CTRL_75_L             (REG_SC_GP_CTRL_BASE + 0xEA)
#define REG_SC_GP_CTRL_75_H             (REG_SC_GP_CTRL_BASE + 0xEB)
#define REG_SC_GP_CTRL_76_L             (REG_SC_GP_CTRL_BASE + 0xEC)
#define REG_SC_GP_CTRL_76_H             (REG_SC_GP_CTRL_BASE + 0xED)
#define REG_SC_GP_CTRL_77_L             (REG_SC_GP_CTRL_BASE + 0xEE)
#define REG_SC_GP_CTRL_77_H             (REG_SC_GP_CTRL_BASE + 0xEF)
#define REG_SC_GP_CTRL_78_L             (REG_SC_GP_CTRL_BASE + 0xF0)
#define REG_SC_GP_CTRL_78_H             (REG_SC_GP_CTRL_BASE + 0xF1)
#define REG_SC_GP_CTRL_79_L             (REG_SC_GP_CTRL_BASE + 0xF2)
#define REG_SC_GP_CTRL_79_H             (REG_SC_GP_CTRL_BASE + 0xF3)
#define REG_SC_GP_CTRL_7A_L             (REG_SC_GP_CTRL_BASE + 0xF4)
#define REG_SC_GP_CTRL_7A_H             (REG_SC_GP_CTRL_BASE + 0xF5)
#define REG_SC_GP_CTRL_7B_L             (REG_SC_GP_CTRL_BASE + 0xF6)
#define REG_SC_GP_CTRL_7B_H             (REG_SC_GP_CTRL_BASE + 0xF7)
#define REG_SC_GP_CTRL_7C_L             (REG_SC_GP_CTRL_BASE + 0xF8)
#define REG_SC_GP_CTRL_7C_H             (REG_SC_GP_CTRL_BASE + 0xF9)
#define REG_SC_GP_CTRL_7D_L             (REG_SC_GP_CTRL_BASE + 0xFA)
#define REG_SC_GP_CTRL_7D_H             (REG_SC_GP_CTRL_BASE + 0xFB)
#define REG_SC_GP_CTRL_7E_L             (REG_SC_GP_CTRL_BASE + 0xFC)
#define REG_SC_GP_CTRL_7E_H             (REG_SC_GP_CTRL_BASE + 0xFD)
#define REG_SC_GP_CTRL_7F_L             (REG_SC_GP_CTRL_BASE + 0xFE)
#define REG_SC_GP_CTRL_7F_H             (REG_SC_GP_CTRL_BASE + 0xFF)

/*#define REG_DISP_GP_CTRL_00_L    (REG_DISP_GP_CTRL_BASE + 0x00)
#define REG_DISP_GP_CTRL_00_H    (REG_DISP_GP_CTRL_BASE + 0x01)
#define REG_DISP_GP_CTRL_01_L    (REG_DISP_GP_CTRL_BASE + 0x02)
#define REG_DISP_GP_CTRL_01_H    (REG_DISP_GP_CTRL_BASE + 0x03)
#define REG_DISP_GP_CTRL_02_L    (REG_DISP_GP_CTRL_BASE + 0x04)
#define REG_DISP_GP_CTRL_02_H    (REG_DISP_GP_CTRL_BASE + 0x05)
#define REG_DISP_GP_CTRL_03_L    (REG_DISP_GP_CTRL_BASE + 0x06)
#define REG_DISP_GP_CTRL_03_H    (REG_DISP_GP_CTRL_BASE + 0x07)
#define REG_DISP_GP_CTRL_04_L    (REG_DISP_GP_CTRL_BASE + 0x08)
#define REG_DISP_GP_CTRL_04_H    (REG_DISP_GP_CTRL_BASE + 0x09)
#define REG_DISP_GP_CTRL_05_L    (REG_DISP_GP_CTRL_BASE + 0x0A)
#define REG_DISP_GP_CTRL_05_H    (REG_DISP_GP_CTRL_BASE + 0x0B)
#define REG_DISP_GP_CTRL_06_L    (REG_DISP_GP_CTRL_BASE + 0x0C)
#define REG_DISP_GP_CTRL_06_H    (REG_DISP_GP_CTRL_BASE + 0x0D)
#define REG_DISP_GP_CTRL_07_L    (REG_DISP_GP_CTRL_BASE + 0x0E)
#define REG_DISP_GP_CTRL_07_H    (REG_DISP_GP_CTRL_BASE + 0x0F)
#define REG_DISP_GP_CTRL_08_L    (REG_DISP_GP_CTRL_BASE + 0x10)
#define REG_DISP_GP_CTRL_08_H    (REG_DISP_GP_CTRL_BASE + 0x11)
#define REG_DISP_GP_CTRL_09_L    (REG_DISP_GP_CTRL_BASE + 0x12)
#define REG_DISP_GP_CTRL_09_H    (REG_DISP_GP_CTRL_BASE + 0x13)
#define REG_DISP_GP_CTRL_0A_L    (REG_DISP_GP_CTRL_BASE + 0x14)
#define REG_DISP_GP_CTRL_0A_H    (REG_DISP_GP_CTRL_BASE + 0x15)
#define REG_DISP_GP_CTRL_0B_L    (REG_DISP_GP_CTRL_BASE + 0x16)
#define REG_DISP_GP_CTRL_0B_H    (REG_DISP_GP_CTRL_BASE + 0x17)
#define REG_DISP_GP_CTRL_0C_L    (REG_DISP_GP_CTRL_BASE + 0x18)
#define REG_DISP_GP_CTRL_0C_H    (REG_DISP_GP_CTRL_BASE + 0x19)
#define REG_DISP_GP_CTRL_0D_L    (REG_DISP_GP_CTRL_BASE + 0x1A)
#define REG_DISP_GP_CTRL_0D_H    (REG_DISP_GP_CTRL_BASE + 0x1B)
#define REG_DISP_GP_CTRL_0E_L    (REG_DISP_GP_CTRL_BASE + 0x1C)
#define REG_DISP_GP_CTRL_0E_H    (REG_DISP_GP_CTRL_BASE + 0x1D)
#define REG_DISP_GP_CTRL_0F_L    (REG_DISP_GP_CTRL_BASE + 0x1E)
#define REG_DISP_GP_CTRL_0F_H    (REG_DISP_GP_CTRL_BASE + 0x1F)
#define REG_DISP_GP_CTRL_10_L    (REG_DISP_GP_CTRL_BASE + 0x20)
#define REG_DISP_GP_CTRL_10_H    (REG_DISP_GP_CTRL_BASE + 0x21)
#define REG_DISP_GP_CTRL_11_L    (REG_DISP_GP_CTRL_BASE + 0x22)
#define REG_DISP_GP_CTRL_11_H    (REG_DISP_GP_CTRL_BASE + 0x23)
#define REG_DISP_GP_CTRL_12_L    (REG_DISP_GP_CTRL_BASE + 0x24)
#define REG_DISP_GP_CTRL_12_H    (REG_DISP_GP_CTRL_BASE + 0x25)
#define REG_DISP_GP_CTRL_13_L    (REG_DISP_GP_CTRL_BASE + 0x26)
#define REG_DISP_GP_CTRL_13_H    (REG_DISP_GP_CTRL_BASE + 0x27)
#define REG_DISP_GP_CTRL_14_L    (REG_DISP_GP_CTRL_BASE + 0x28)
#define REG_DISP_GP_CTRL_14_H    (REG_DISP_GP_CTRL_BASE + 0x29)
#define REG_DISP_GP_CTRL_15_L    (REG_DISP_GP_CTRL_BASE + 0x2A)
#define REG_DISP_GP_CTRL_15_H    (REG_DISP_GP_CTRL_BASE + 0x2B)
#define REG_DISP_GP_CTRL_16_L    (REG_DISP_GP_CTRL_BASE + 0x2C)
#define REG_DISP_GP_CTRL_16_H    (REG_DISP_GP_CTRL_BASE + 0x2D)
#define REG_DISP_GP_CTRL_17_L    (REG_DISP_GP_CTRL_BASE + 0x2E)
#define REG_DISP_GP_CTRL_17_H    (REG_DISP_GP_CTRL_BASE + 0x2F)
#define REG_DISP_GP_CTRL_18_L    (REG_DISP_GP_CTRL_BASE + 0x30)
#define REG_DISP_GP_CTRL_18_H    (REG_DISP_GP_CTRL_BASE + 0x31)
#define REG_DISP_GP_CTRL_19_L    (REG_DISP_GP_CTRL_BASE + 0x32)
#define REG_DISP_GP_CTRL_19_H    (REG_DISP_GP_CTRL_BASE + 0x33)
#define REG_DISP_GP_CTRL_1A_L    (REG_DISP_GP_CTRL_BASE + 0x34)
#define REG_DISP_GP_CTRL_1A_H    (REG_DISP_GP_CTRL_BASE + 0x35)
#define REG_DISP_GP_CTRL_1B_L    (REG_DISP_GP_CTRL_BASE + 0x36)
#define REG_DISP_GP_CTRL_1B_H    (REG_DISP_GP_CTRL_BASE + 0x37)
#define REG_DISP_GP_CTRL_1C_L    (REG_DISP_GP_CTRL_BASE + 0x38)
#define REG_DISP_GP_CTRL_1C_H    (REG_DISP_GP_CTRL_BASE + 0x39)
#define REG_DISP_GP_CTRL_1D_L    (REG_DISP_GP_CTRL_BASE + 0x3A)
#define REG_DISP_GP_CTRL_1D_H    (REG_DISP_GP_CTRL_BASE + 0x3B)
#define REG_DISP_GP_CTRL_1E_L    (REG_DISP_GP_CTRL_BASE + 0x3C)
#define REG_DISP_GP_CTRL_1E_H    (REG_DISP_GP_CTRL_BASE + 0x3D)
#define REG_DISP_GP_CTRL_1F_L    (REG_DISP_GP_CTRL_BASE + 0x3E)
#define REG_DISP_GP_CTRL_1F_H    (REG_DISP_GP_CTRL_BASE + 0x3F)
#define REG_DISP_GP_CTRL_20_L    (REG_DISP_GP_CTRL_BASE + 0x40)
#define REG_DISP_GP_CTRL_20_H    (REG_DISP_GP_CTRL_BASE + 0x41)
#define REG_DISP_GP_CTRL_21_L    (REG_DISP_GP_CTRL_BASE + 0x42)
#define REG_DISP_GP_CTRL_21_H    (REG_DISP_GP_CTRL_BASE + 0x43)
#define REG_DISP_GP_CTRL_22_L    (REG_DISP_GP_CTRL_BASE + 0x44)
#define REG_DISP_GP_CTRL_22_H    (REG_DISP_GP_CTRL_BASE + 0x45)
#define REG_DISP_GP_CTRL_23_L    (REG_DISP_GP_CTRL_BASE + 0x46)
#define REG_DISP_GP_CTRL_23_H    (REG_DISP_GP_CTRL_BASE + 0x47)
#define REG_DISP_GP_CTRL_24_L    (REG_DISP_GP_CTRL_BASE + 0x48)
#define REG_DISP_GP_CTRL_24_H    (REG_DISP_GP_CTRL_BASE + 0x49)
#define REG_DISP_GP_CTRL_25_L    (REG_DISP_GP_CTRL_BASE + 0x4A)
#define REG_DISP_GP_CTRL_25_H    (REG_DISP_GP_CTRL_BASE + 0x4B)
#define REG_DISP_GP_CTRL_26_L    (REG_DISP_GP_CTRL_BASE + 0x4C)
#define REG_DISP_GP_CTRL_26_H    (REG_DISP_GP_CTRL_BASE + 0x4D)
#define REG_DISP_GP_CTRL_27_L    (REG_DISP_GP_CTRL_BASE + 0x4E)
#define REG_DISP_GP_CTRL_27_H    (REG_DISP_GP_CTRL_BASE + 0x4F)
#define REG_DISP_GP_CTRL_28_L    (REG_DISP_GP_CTRL_BASE + 0x50)
#define REG_DISP_GP_CTRL_28_H    (REG_DISP_GP_CTRL_BASE + 0x51)
#define REG_DISP_GP_CTRL_29_L    (REG_DISP_GP_CTRL_BASE + 0x52)
#define REG_DISP_GP_CTRL_29_H    (REG_DISP_GP_CTRL_BASE + 0x53)
#define REG_DISP_GP_CTRL_2A_L    (REG_DISP_GP_CTRL_BASE + 0x54)
#define REG_DISP_GP_CTRL_2A_H    (REG_DISP_GP_CTRL_BASE + 0x55)
#define REG_DISP_GP_CTRL_2B_L    (REG_DISP_GP_CTRL_BASE + 0x56)
#define REG_DISP_GP_CTRL_2B_H    (REG_DISP_GP_CTRL_BASE + 0x57)
#define REG_DISP_GP_CTRL_2C_L    (REG_DISP_GP_CTRL_BASE + 0x58)
#define REG_DISP_GP_CTRL_2C_H    (REG_DISP_GP_CTRL_BASE + 0x59)
#define REG_DISP_GP_CTRL_2D_L    (REG_DISP_GP_CTRL_BASE + 0x5A)
#define REG_DISP_GP_CTRL_2D_H    (REG_DISP_GP_CTRL_BASE + 0x5B)
#define REG_DISP_GP_CTRL_2E_L    (REG_DISP_GP_CTRL_BASE + 0x5C)
#define REG_DISP_GP_CTRL_2E_H    (REG_DISP_GP_CTRL_BASE + 0x5D)
#define REG_DISP_GP_CTRL_2F_L    (REG_DISP_GP_CTRL_BASE + 0x5E)
#define REG_DISP_GP_CTRL_2F_H    (REG_DISP_GP_CTRL_BASE + 0x5F)
#define REG_DISP_GP_CTRL_30_L    (REG_DISP_GP_CTRL_BASE + 0x60)
#define REG_DISP_GP_CTRL_30_H    (REG_DISP_GP_CTRL_BASE + 0x61)
#define REG_DISP_GP_CTRL_31_L    (REG_DISP_GP_CTRL_BASE + 0x62)
#define REG_DISP_GP_CTRL_31_H    (REG_DISP_GP_CTRL_BASE + 0x63)
#define REG_DISP_GP_CTRL_32_L    (REG_DISP_GP_CTRL_BASE + 0x64)
#define REG_DISP_GP_CTRL_32_H    (REG_DISP_GP_CTRL_BASE + 0x65)
#define REG_DISP_GP_CTRL_33_L    (REG_DISP_GP_CTRL_BASE + 0x66)
#define REG_DISP_GP_CTRL_33_H    (REG_DISP_GP_CTRL_BASE + 0x67)
#define REG_DISP_GP_CTRL_34_L    (REG_DISP_GP_CTRL_BASE + 0x68)
#define REG_DISP_GP_CTRL_34_H    (REG_DISP_GP_CTRL_BASE + 0x69)
#define REG_DISP_GP_CTRL_35_L    (REG_DISP_GP_CTRL_BASE + 0x6A)
#define REG_DISP_GP_CTRL_35_H    (REG_DISP_GP_CTRL_BASE + 0x6B)
#define REG_DISP_GP_CTRL_36_L    (REG_DISP_GP_CTRL_BASE + 0x6C)
#define REG_DISP_GP_CTRL_36_H    (REG_DISP_GP_CTRL_BASE + 0x6D)
#define REG_DISP_GP_CTRL_37_L    (REG_DISP_GP_CTRL_BASE + 0x6E)
#define REG_DISP_GP_CTRL_37_H    (REG_DISP_GP_CTRL_BASE + 0x6F)
#define REG_DISP_GP_CTRL_38_L    (REG_DISP_GP_CTRL_BASE + 0x70)
#define REG_DISP_GP_CTRL_38_H    (REG_DISP_GP_CTRL_BASE + 0x71)
#define REG_DISP_GP_CTRL_39_L    (REG_DISP_GP_CTRL_BASE + 0x72)
#define REG_DISP_GP_CTRL_39_H    (REG_DISP_GP_CTRL_BASE + 0x73)
#define REG_DISP_GP_CTRL_3A_L    (REG_DISP_GP_CTRL_BASE + 0x74)
#define REG_DISP_GP_CTRL_3A_H    (REG_DISP_GP_CTRL_BASE + 0x75)
#define REG_DISP_GP_CTRL_3B_L    (REG_DISP_GP_CTRL_BASE + 0x76)
#define REG_DISP_GP_CTRL_3B_H    (REG_DISP_GP_CTRL_BASE + 0x77)
#define REG_DISP_GP_CTRL_3C_L    (REG_DISP_GP_CTRL_BASE + 0x78)
#define REG_DISP_GP_CTRL_3C_H    (REG_DISP_GP_CTRL_BASE + 0x79)
#define REG_DISP_GP_CTRL_3D_L    (REG_DISP_GP_CTRL_BASE + 0x7A)
#define REG_DISP_GP_CTRL_3D_H    (REG_DISP_GP_CTRL_BASE + 0x7B)
#define REG_DISP_GP_CTRL_3E_L    (REG_DISP_GP_CTRL_BASE + 0x7C)
#define REG_DISP_GP_CTRL_3E_H    (REG_DISP_GP_CTRL_BASE + 0x7D)
#define REG_DISP_GP_CTRL_3F_L    (REG_DISP_GP_CTRL_BASE + 0x7E)
#define REG_DISP_GP_CTRL_3F_H    (REG_DISP_GP_CTRL_BASE + 0x7F)
#define REG_DISP_GP_CTRL_40_L    (REG_DISP_GP_CTRL_BASE + 0x80)
#define REG_DISP_GP_CTRL_40_H    (REG_DISP_GP_CTRL_BASE + 0x81)
#define REG_DISP_GP_CTRL_41_L    (REG_DISP_GP_CTRL_BASE + 0x82)
#define REG_DISP_GP_CTRL_41_H    (REG_DISP_GP_CTRL_BASE + 0x83)
#define REG_DISP_GP_CTRL_42_L    (REG_DISP_GP_CTRL_BASE + 0x84)
#define REG_DISP_GP_CTRL_42_H    (REG_DISP_GP_CTRL_BASE + 0x85)
#define REG_DISP_GP_CTRL_43_L    (REG_DISP_GP_CTRL_BASE + 0x86)
#define REG_DISP_GP_CTRL_43_H    (REG_DISP_GP_CTRL_BASE + 0x87)
#define REG_DISP_GP_CTRL_44_L    (REG_DISP_GP_CTRL_BASE + 0x88)
#define REG_DISP_GP_CTRL_44_H    (REG_DISP_GP_CTRL_BASE + 0x89)
#define REG_DISP_GP_CTRL_45_L    (REG_DISP_GP_CTRL_BASE + 0x8A)
#define REG_DISP_GP_CTRL_45_H    (REG_DISP_GP_CTRL_BASE + 0x8B)
#define REG_DISP_GP_CTRL_46_L    (REG_DISP_GP_CTRL_BASE + 0x8C)
#define REG_DISP_GP_CTRL_46_H    (REG_DISP_GP_CTRL_BASE + 0x8D)
#define REG_DISP_GP_CTRL_47_L    (REG_DISP_GP_CTRL_BASE + 0x8E)
#define REG_DISP_GP_CTRL_47_H    (REG_DISP_GP_CTRL_BASE + 0x8F)
#define REG_DISP_GP_CTRL_48_L    (REG_DISP_GP_CTRL_BASE + 0x90)
#define REG_DISP_GP_CTRL_48_H    (REG_DISP_GP_CTRL_BASE + 0x91)
#define REG_DISP_GP_CTRL_49_L    (REG_DISP_GP_CTRL_BASE + 0x92)
#define REG_DISP_GP_CTRL_49_H    (REG_DISP_GP_CTRL_BASE + 0x93)
#define REG_DISP_GP_CTRL_4A_L    (REG_DISP_GP_CTRL_BASE + 0x94)
#define REG_DISP_GP_CTRL_4A_H    (REG_DISP_GP_CTRL_BASE + 0x95)
#define REG_DISP_GP_CTRL_4B_L    (REG_DISP_GP_CTRL_BASE + 0x96)
#define REG_DISP_GP_CTRL_4B_H    (REG_DISP_GP_CTRL_BASE + 0x97)
#define REG_DISP_GP_CTRL_4C_L    (REG_DISP_GP_CTRL_BASE + 0x98)
#define REG_DISP_GP_CTRL_4C_H    (REG_DISP_GP_CTRL_BASE + 0x99)
#define REG_DISP_GP_CTRL_4D_L    (REG_DISP_GP_CTRL_BASE + 0x9A)
#define REG_DISP_GP_CTRL_4D_H    (REG_DISP_GP_CTRL_BASE + 0x9B)
#define REG_DISP_GP_CTRL_4E_L    (REG_DISP_GP_CTRL_BASE + 0x9C)
#define REG_DISP_GP_CTRL_4E_H    (REG_DISP_GP_CTRL_BASE + 0x9D)
#define REG_DISP_GP_CTRL_4F_L    (REG_DISP_GP_CTRL_BASE + 0x9E)
#define REG_DISP_GP_CTRL_4F_H    (REG_DISP_GP_CTRL_BASE + 0x9F)
#define REG_DISP_GP_CTRL_50_L    (REG_DISP_GP_CTRL_BASE + 0xA0)
#define REG_DISP_GP_CTRL_50_H    (REG_DISP_GP_CTRL_BASE + 0xA1)
#define REG_DISP_GP_CTRL_51_L    (REG_DISP_GP_CTRL_BASE + 0xA2)
#define REG_DISP_GP_CTRL_51_H    (REG_DISP_GP_CTRL_BASE + 0xA3)
#define REG_DISP_GP_CTRL_52_L    (REG_DISP_GP_CTRL_BASE + 0xA4)
#define REG_DISP_GP_CTRL_52_H    (REG_DISP_GP_CTRL_BASE + 0xA5)
#define REG_DISP_GP_CTRL_53_L    (REG_DISP_GP_CTRL_BASE + 0xA6)
#define REG_DISP_GP_CTRL_53_H    (REG_DISP_GP_CTRL_BASE + 0xA7)
#define REG_DISP_GP_CTRL_54_L    (REG_DISP_GP_CTRL_BASE + 0xA8)
#define REG_DISP_GP_CTRL_54_H    (REG_DISP_GP_CTRL_BASE + 0xA9)
#define REG_DISP_GP_CTRL_55_L    (REG_DISP_GP_CTRL_BASE + 0xAA)
#define REG_DISP_GP_CTRL_55_H    (REG_DISP_GP_CTRL_BASE + 0xAB)
#define REG_DISP_GP_CTRL_56_L    (REG_DISP_GP_CTRL_BASE + 0xAC)
#define REG_DISP_GP_CTRL_56_H    (REG_DISP_GP_CTRL_BASE + 0xAD)
#define REG_DISP_GP_CTRL_57_L    (REG_DISP_GP_CTRL_BASE + 0xAE)
#define REG_DISP_GP_CTRL_57_H    (REG_DISP_GP_CTRL_BASE + 0xAF)
#define REG_DISP_GP_CTRL_58_L    (REG_DISP_GP_CTRL_BASE + 0xB0)
#define REG_DISP_GP_CTRL_58_H    (REG_DISP_GP_CTRL_BASE + 0xB1)
#define REG_DISP_GP_CTRL_59_L    (REG_DISP_GP_CTRL_BASE + 0xB2)
#define REG_DISP_GP_CTRL_59_H    (REG_DISP_GP_CTRL_BASE + 0xB3)
#define REG_DISP_GP_CTRL_5A_L    (REG_DISP_GP_CTRL_BASE + 0xB4)
#define REG_DISP_GP_CTRL_5A_H    (REG_DISP_GP_CTRL_BASE + 0xB5)
#define REG_DISP_GP_CTRL_5B_L    (REG_DISP_GP_CTRL_BASE + 0xB6)
#define REG_DISP_GP_CTRL_5B_H    (REG_DISP_GP_CTRL_BASE + 0xB7)
#define REG_DISP_GP_CTRL_5C_L    (REG_DISP_GP_CTRL_BASE + 0xB8)
#define REG_DISP_GP_CTRL_5C_H    (REG_DISP_GP_CTRL_BASE + 0xB9)
#define REG_DISP_GP_CTRL_5D_L    (REG_DISP_GP_CTRL_BASE + 0xBA)
#define REG_DISP_GP_CTRL_5D_H    (REG_DISP_GP_CTRL_BASE + 0xBB)
#define REG_DISP_GP_CTRL_5E_L    (REG_DISP_GP_CTRL_BASE + 0xBC)
#define REG_DISP_GP_CTRL_5E_H    (REG_DISP_GP_CTRL_BASE + 0xBD)
#define REG_DISP_GP_CTRL_5F_L    (REG_DISP_GP_CTRL_BASE + 0xBE)
#define REG_DISP_GP_CTRL_5F_H    (REG_DISP_GP_CTRL_BASE + 0xBF)
#define REG_DISP_GP_CTRL_60_L    (REG_DISP_GP_CTRL_BASE + 0xC0)
#define REG_DISP_GP_CTRL_60_H    (REG_DISP_GP_CTRL_BASE + 0xC1)
#define REG_DISP_GP_CTRL_61_L    (REG_DISP_GP_CTRL_BASE + 0xC2)
#define REG_DISP_GP_CTRL_61_H    (REG_DISP_GP_CTRL_BASE + 0xC3)
#define REG_DISP_GP_CTRL_62_L    (REG_DISP_GP_CTRL_BASE + 0xC4)
#define REG_DISP_GP_CTRL_62_H    (REG_DISP_GP_CTRL_BASE + 0xC5)
#define REG_DISP_GP_CTRL_63_L    (REG_DISP_GP_CTRL_BASE + 0xC6)
#define REG_DISP_GP_CTRL_63_H    (REG_DISP_GP_CTRL_BASE + 0xC7)
#define REG_DISP_GP_CTRL_64_L    (REG_DISP_GP_CTRL_BASE + 0xC8)
#define REG_DISP_GP_CTRL_64_H    (REG_DISP_GP_CTRL_BASE + 0xC9)
#define REG_DISP_GP_CTRL_65_L    (REG_DISP_GP_CTRL_BASE + 0xCA)
#define REG_DISP_GP_CTRL_65_H    (REG_DISP_GP_CTRL_BASE + 0xCB)
#define REG_DISP_GP_CTRL_66_L    (REG_DISP_GP_CTRL_BASE + 0xCC)
#define REG_DISP_GP_CTRL_66_H    (REG_DISP_GP_CTRL_BASE + 0xCD)
#define REG_DISP_GP_CTRL_67_L    (REG_DISP_GP_CTRL_BASE + 0xCE)
#define REG_DISP_GP_CTRL_67_H    (REG_DISP_GP_CTRL_BASE + 0xCF)
#define REG_DISP_GP_CTRL_68_L    (REG_DISP_GP_CTRL_BASE + 0xD0)
#define REG_DISP_GP_CTRL_68_H    (REG_DISP_GP_CTRL_BASE + 0xD1)
#define REG_DISP_GP_CTRL_69_L    (REG_DISP_GP_CTRL_BASE + 0xD2)
#define REG_DISP_GP_CTRL_69_H    (REG_DISP_GP_CTRL_BASE + 0xD3)
#define REG_DISP_GP_CTRL_6A_L    (REG_DISP_GP_CTRL_BASE + 0xD4)
#define REG_DISP_GP_CTRL_6A_H    (REG_DISP_GP_CTRL_BASE + 0xD5)
#define REG_DISP_GP_CTRL_6B_L    (REG_DISP_GP_CTRL_BASE + 0xD6)
#define REG_DISP_GP_CTRL_6B_H    (REG_DISP_GP_CTRL_BASE + 0xD7)
#define REG_DISP_GP_CTRL_6C_L    (REG_DISP_GP_CTRL_BASE + 0xD8)
#define REG_DISP_GP_CTRL_6C_H    (REG_DISP_GP_CTRL_BASE + 0xD9)
#define REG_DISP_GP_CTRL_6D_L    (REG_DISP_GP_CTRL_BASE + 0xDA)
#define REG_DISP_GP_CTRL_6D_H    (REG_DISP_GP_CTRL_BASE + 0xDB)
#define REG_DISP_GP_CTRL_6E_L    (REG_DISP_GP_CTRL_BASE + 0xDC)
#define REG_DISP_GP_CTRL_6E_H    (REG_DISP_GP_CTRL_BASE + 0xDD)
#define REG_DISP_GP_CTRL_6F_L    (REG_DISP_GP_CTRL_BASE + 0xDE)
#define REG_DISP_GP_CTRL_6F_H    (REG_DISP_GP_CTRL_BASE + 0xDF)
#define REG_DISP_GP_CTRL_70_L    (REG_DISP_GP_CTRL_BASE + 0xE0)
#define REG_DISP_GP_CTRL_70_H    (REG_DISP_GP_CTRL_BASE + 0xE1)
#define REG_DISP_GP_CTRL_71_L    (REG_DISP_GP_CTRL_BASE + 0xE2)
#define REG_DISP_GP_CTRL_71_H    (REG_DISP_GP_CTRL_BASE + 0xE3)
#define REG_DISP_GP_CTRL_72_L    (REG_DISP_GP_CTRL_BASE + 0xE4)
#define REG_DISP_GP_CTRL_72_H    (REG_DISP_GP_CTRL_BASE + 0xE5)
#define REG_DISP_GP_CTRL_73_L    (REG_DISP_GP_CTRL_BASE + 0xE6)
#define REG_DISP_GP_CTRL_73_H    (REG_DISP_GP_CTRL_BASE + 0xE7)
#define REG_DISP_GP_CTRL_74_L    (REG_DISP_GP_CTRL_BASE + 0xE8)
#define REG_DISP_GP_CTRL_74_H    (REG_DISP_GP_CTRL_BASE + 0xE9)
#define REG_DISP_GP_CTRL_75_L    (REG_DISP_GP_CTRL_BASE + 0xEA)
#define REG_DISP_GP_CTRL_75_H    (REG_DISP_GP_CTRL_BASE + 0xEB)
#define REG_DISP_GP_CTRL_76_L    (REG_DISP_GP_CTRL_BASE + 0xEC)
#define REG_DISP_GP_CTRL_76_H    (REG_DISP_GP_CTRL_BASE + 0xED)
#define REG_DISP_GP_CTRL_77_L    (REG_DISP_GP_CTRL_BASE + 0xEE)
#define REG_DISP_GP_CTRL_77_H    (REG_DISP_GP_CTRL_BASE + 0xEF)
#define REG_DISP_GP_CTRL_78_L    (REG_DISP_GP_CTRL_BASE + 0xF0)
#define REG_DISP_GP_CTRL_78_H    (REG_DISP_GP_CTRL_BASE + 0xF1)
#define REG_DISP_GP_CTRL_79_L    (REG_DISP_GP_CTRL_BASE + 0xF2)
#define REG_DISP_GP_CTRL_79_H    (REG_DISP_GP_CTRL_BASE + 0xF3)
#define REG_DISP_GP_CTRL_7A_L    (REG_DISP_GP_CTRL_BASE + 0xF4)
#define REG_DISP_GP_CTRL_7A_H    (REG_DISP_GP_CTRL_BASE + 0xF5)
#define REG_DISP_GP_CTRL_7B_L    (REG_DISP_GP_CTRL_BASE + 0xF6)
#define REG_DISP_GP_CTRL_7B_H    (REG_DISP_GP_CTRL_BASE + 0xF7)
#define REG_DISP_GP_CTRL_7C_L    (REG_DISP_GP_CTRL_BASE + 0xF8)
#define REG_DISP_GP_CTRL_7C_H    (REG_DISP_GP_CTRL_BASE + 0xF9)
#define REG_DISP_GP_CTRL_7D_L    (REG_DISP_GP_CTRL_BASE + 0xFA)
#define REG_DISP_GP_CTRL_7D_H    (REG_DISP_GP_CTRL_BASE + 0xFB)
#define REG_DISP_GP_CTRL_7E_L    (REG_DISP_GP_CTRL_BASE + 0xFC)
#define REG_DISP_GP_CTRL_7E_H    (REG_DISP_GP_CTRL_BASE + 0xFD)
#define REG_DISP_GP_CTRL_7F_L    (REG_DISP_GP_CTRL_BASE + 0xFE)
#define REG_DISP_GP_CTRL_7F_H    (REG_DISP_GP_CTRL_BASE + 0xFF)
*/

#define REG_EFUSE_00_L          (REG_EFUSE_BASE + 0x00)
#define REG_EFUSE_00_H          (REG_EFUSE_BASE + 0x01)
#define REG_EFUSE_01_L          (REG_EFUSE_BASE + 0x02)
#define REG_EFUSE_01_H          (REG_EFUSE_BASE + 0x03)
#define REG_EFUSE_02_L          (REG_EFUSE_BASE + 0x04)
#define REG_EFUSE_02_H          (REG_EFUSE_BASE + 0x05)
#define REG_EFUSE_03_L          (REG_EFUSE_BASE + 0x06)
#define REG_EFUSE_03_H          (REG_EFUSE_BASE + 0x07)
#define REG_EFUSE_04_L          (REG_EFUSE_BASE + 0x08)
#define REG_EFUSE_04_H          (REG_EFUSE_BASE + 0x09)
#define REG_EFUSE_05_L          (REG_EFUSE_BASE + 0x0A)
#define REG_EFUSE_05_H          (REG_EFUSE_BASE + 0x0B)
#define REG_EFUSE_06_L          (REG_EFUSE_BASE + 0x0C)
#define REG_EFUSE_06_H          (REG_EFUSE_BASE + 0x0D)
#define REG_EFUSE_07_L          (REG_EFUSE_BASE + 0x0E)
#define REG_EFUSE_07_H          (REG_EFUSE_BASE + 0x0F)
#define REG_EFUSE_08_L          (REG_EFUSE_BASE + 0x10)
#define REG_EFUSE_08_H          (REG_EFUSE_BASE + 0x11)
#define REG_EFUSE_09_L          (REG_EFUSE_BASE + 0x12)
#define REG_EFUSE_09_H          (REG_EFUSE_BASE + 0x13)
#define REG_EFUSE_0A_L          (REG_EFUSE_BASE + 0x14)
#define REG_EFUSE_0A_H          (REG_EFUSE_BASE + 0x15)
#define REG_EFUSE_0B_L          (REG_EFUSE_BASE + 0x16)
#define REG_EFUSE_0B_H          (REG_EFUSE_BASE + 0x17)
#define REG_EFUSE_0C_L          (REG_EFUSE_BASE + 0x18)
#define REG_EFUSE_0C_H          (REG_EFUSE_BASE + 0x19)
#define REG_EFUSE_0D_L          (REG_EFUSE_BASE + 0x1A)
#define REG_EFUSE_0D_H          (REG_EFUSE_BASE + 0x1B)
#define REG_EFUSE_0E_L          (REG_EFUSE_BASE + 0x1C)
#define REG_EFUSE_0E_H          (REG_EFUSE_BASE + 0x1D)
#define REG_EFUSE_0F_L          (REG_EFUSE_BASE + 0x1E)
#define REG_EFUSE_0F_H          (REG_EFUSE_BASE + 0x1F)
#define REG_EFUSE_10_L          (REG_EFUSE_BASE + 0x20)
#define REG_EFUSE_10_H          (REG_EFUSE_BASE + 0x21)
#define REG_EFUSE_11_L          (REG_EFUSE_BASE + 0x22)
#define REG_EFUSE_11_H          (REG_EFUSE_BASE + 0x23)
#define REG_EFUSE_12_L          (REG_EFUSE_BASE + 0x24)
#define REG_EFUSE_12_H          (REG_EFUSE_BASE + 0x25)
#define REG_EFUSE_13_L          (REG_EFUSE_BASE + 0x26)
#define REG_EFUSE_13_H          (REG_EFUSE_BASE + 0x27)
#define REG_EFUSE_14_L          (REG_EFUSE_BASE + 0x28)
#define REG_EFUSE_14_H          (REG_EFUSE_BASE + 0x29)
#define REG_EFUSE_15_L          (REG_EFUSE_BASE + 0x2A)
#define REG_EFUSE_15_H          (REG_EFUSE_BASE + 0x2B)
#define REG_EFUSE_16_L          (REG_EFUSE_BASE + 0x2C)
#define REG_EFUSE_16_H          (REG_EFUSE_BASE + 0x2D)
#define REG_EFUSE_17_L          (REG_EFUSE_BASE + 0x2E)
#define REG_EFUSE_17_H          (REG_EFUSE_BASE + 0x2F)
#define REG_EFUSE_18_L          (REG_EFUSE_BASE + 0x30)
#define REG_EFUSE_18_H          (REG_EFUSE_BASE + 0x31)
#define REG_EFUSE_19_L          (REG_EFUSE_BASE + 0x32)
#define REG_EFUSE_19_H          (REG_EFUSE_BASE + 0x33)
#define REG_EFUSE_1A_L          (REG_EFUSE_BASE + 0x34)
#define REG_EFUSE_1A_H          (REG_EFUSE_BASE + 0x35)
#define REG_EFUSE_1B_L          (REG_EFUSE_BASE + 0x36)
#define REG_EFUSE_1B_H          (REG_EFUSE_BASE + 0x37)
#define REG_EFUSE_1C_L          (REG_EFUSE_BASE + 0x38)
#define REG_EFUSE_1C_H          (REG_EFUSE_BASE + 0x39)
#define REG_EFUSE_1D_L          (REG_EFUSE_BASE + 0x3A)
#define REG_EFUSE_1D_H          (REG_EFUSE_BASE + 0x3B)
#define REG_EFUSE_1E_L          (REG_EFUSE_BASE + 0x3C)
#define REG_EFUSE_1E_H          (REG_EFUSE_BASE + 0x3D)
#define REG_EFUSE_1F_L          (REG_EFUSE_BASE + 0x3E)
#define REG_EFUSE_1F_H          (REG_EFUSE_BASE + 0x3F)
#define REG_EFUSE_20_L          (REG_EFUSE_BASE + 0x40)
#define REG_EFUSE_20_H          (REG_EFUSE_BASE + 0x41)
#define REG_EFUSE_21_L          (REG_EFUSE_BASE + 0x42)
#define REG_EFUSE_21_H          (REG_EFUSE_BASE + 0x43)
#define REG_EFUSE_22_L          (REG_EFUSE_BASE + 0x44)
#define REG_EFUSE_22_H          (REG_EFUSE_BASE + 0x45)
#define REG_EFUSE_23_L          (REG_EFUSE_BASE + 0x46)
#define REG_EFUSE_23_H          (REG_EFUSE_BASE + 0x47)
#define REG_EFUSE_24_L          (REG_EFUSE_BASE + 0x48)
#define REG_EFUSE_24_H          (REG_EFUSE_BASE + 0x49)
#define REG_EFUSE_25_L          (REG_EFUSE_BASE + 0x4A)
#define REG_EFUSE_25_H          (REG_EFUSE_BASE + 0x4B)
#define REG_EFUSE_26_L          (REG_EFUSE_BASE + 0x4C)
#define REG_EFUSE_26_H          (REG_EFUSE_BASE + 0x4D)
#define REG_EFUSE_27_L          (REG_EFUSE_BASE + 0x4E)
#define REG_EFUSE_27_H          (REG_EFUSE_BASE + 0x4F)
#define REG_EFUSE_28_L          (REG_EFUSE_BASE + 0x50)
#define REG_EFUSE_28_H          (REG_EFUSE_BASE + 0x51)
#define REG_EFUSE_29_L          (REG_EFUSE_BASE + 0x52)
#define REG_EFUSE_29_H          (REG_EFUSE_BASE + 0x53)
#define REG_EFUSE_2A_L          (REG_EFUSE_BASE + 0x54)
#define REG_EFUSE_2A_H          (REG_EFUSE_BASE + 0x55)
#define REG_EFUSE_2B_L          (REG_EFUSE_BASE + 0x56)
#define REG_EFUSE_2B_H          (REG_EFUSE_BASE + 0x57)
#define REG_EFUSE_2C_L          (REG_EFUSE_BASE + 0x58)
#define REG_EFUSE_2C_H          (REG_EFUSE_BASE + 0x59)
#define REG_EFUSE_2D_L          (REG_EFUSE_BASE + 0x5A)
#define REG_EFUSE_2D_H          (REG_EFUSE_BASE + 0x5B)
#define REG_EFUSE_2E_L          (REG_EFUSE_BASE + 0x5C)
#define REG_EFUSE_2E_H          (REG_EFUSE_BASE + 0x5D)
#define REG_EFUSE_2F_L          (REG_EFUSE_BASE + 0x5E)
#define REG_EFUSE_2F_H          (REG_EFUSE_BASE + 0x5F)
#define REG_EFUSE_30_L          (REG_EFUSE_BASE + 0x60)
#define REG_EFUSE_30_H          (REG_EFUSE_BASE + 0x61)
#define REG_EFUSE_31_L          (REG_EFUSE_BASE + 0x62)
#define REG_EFUSE_31_H          (REG_EFUSE_BASE + 0x63)
#define REG_EFUSE_32_L          (REG_EFUSE_BASE + 0x64)
#define REG_EFUSE_32_H          (REG_EFUSE_BASE + 0x65)
#define REG_EFUSE_33_L          (REG_EFUSE_BASE + 0x66)
#define REG_EFUSE_33_H          (REG_EFUSE_BASE + 0x67)
#define REG_EFUSE_34_L          (REG_EFUSE_BASE + 0x68)
#define REG_EFUSE_34_H          (REG_EFUSE_BASE + 0x69)
#define REG_EFUSE_35_L          (REG_EFUSE_BASE + 0x6A)
#define REG_EFUSE_35_H          (REG_EFUSE_BASE + 0x6B)
#define REG_EFUSE_36_L          (REG_EFUSE_BASE + 0x6C)
#define REG_EFUSE_36_H          (REG_EFUSE_BASE + 0x6D)
#define REG_EFUSE_37_L          (REG_EFUSE_BASE + 0x6E)
#define REG_EFUSE_37_H          (REG_EFUSE_BASE + 0x6F)
#define REG_EFUSE_38_L          (REG_EFUSE_BASE + 0x70)
#define REG_EFUSE_38_H          (REG_EFUSE_BASE + 0x71)
#define REG_EFUSE_39_L          (REG_EFUSE_BASE + 0x72)
#define REG_EFUSE_39_H          (REG_EFUSE_BASE + 0x73)
#define REG_EFUSE_3A_L          (REG_EFUSE_BASE + 0x74)
#define REG_EFUSE_3A_H          (REG_EFUSE_BASE + 0x75)
#define REG_EFUSE_3B_L          (REG_EFUSE_BASE + 0x76)
#define REG_EFUSE_3B_H          (REG_EFUSE_BASE + 0x77)
#define REG_EFUSE_3C_L          (REG_EFUSE_BASE + 0x78)
#define REG_EFUSE_3C_H          (REG_EFUSE_BASE + 0x79)
#define REG_EFUSE_3D_L          (REG_EFUSE_BASE + 0x7A)
#define REG_EFUSE_3D_H          (REG_EFUSE_BASE + 0x7B)
#define REG_EFUSE_3E_L          (REG_EFUSE_BASE + 0x7C)
#define REG_EFUSE_3E_H          (REG_EFUSE_BASE + 0x7D)
#define REG_EFUSE_3F_L          (REG_EFUSE_BASE + 0x7E)
#define REG_EFUSE_3F_H          (REG_EFUSE_BASE + 0x7F)
#define REG_EFUSE_40_L          (REG_EFUSE_BASE + 0x80)
#define REG_EFUSE_40_H          (REG_EFUSE_BASE + 0x81)
#define REG_EFUSE_41_L          (REG_EFUSE_BASE + 0x82)
#define REG_EFUSE_41_H          (REG_EFUSE_BASE + 0x83)
#define REG_EFUSE_42_L          (REG_EFUSE_BASE + 0x84)
#define REG_EFUSE_42_H          (REG_EFUSE_BASE + 0x85)
#define REG_EFUSE_43_L          (REG_EFUSE_BASE + 0x86)
#define REG_EFUSE_43_H          (REG_EFUSE_BASE + 0x87)
#define REG_EFUSE_44_L          (REG_EFUSE_BASE + 0x88)
#define REG_EFUSE_44_H          (REG_EFUSE_BASE + 0x89)
#define REG_EFUSE_45_L          (REG_EFUSE_BASE + 0x8A)
#define REG_EFUSE_45_H          (REG_EFUSE_BASE + 0x8B)
#define REG_EFUSE_46_L          (REG_EFUSE_BASE + 0x8C)
#define REG_EFUSE_46_H          (REG_EFUSE_BASE + 0x8D)
#define REG_EFUSE_47_L          (REG_EFUSE_BASE + 0x8E)
#define REG_EFUSE_47_H          (REG_EFUSE_BASE + 0x8F)
#define REG_EFUSE_48_L          (REG_EFUSE_BASE + 0x90)
#define REG_EFUSE_48_H          (REG_EFUSE_BASE + 0x91)
#define REG_EFUSE_49_L          (REG_EFUSE_BASE + 0x92)
#define REG_EFUSE_49_H          (REG_EFUSE_BASE + 0x93)
#define REG_EFUSE_4A_L          (REG_EFUSE_BASE + 0x94)
#define REG_EFUSE_4A_H          (REG_EFUSE_BASE + 0x95)
#define REG_EFUSE_4B_L          (REG_EFUSE_BASE + 0x96)
#define REG_EFUSE_4B_H          (REG_EFUSE_BASE + 0x97)
#define REG_EFUSE_4C_L          (REG_EFUSE_BASE + 0x98)
#define REG_EFUSE_4C_H          (REG_EFUSE_BASE + 0x99)
#define REG_EFUSE_4D_L          (REG_EFUSE_BASE + 0x9A)
#define REG_EFUSE_4D_H          (REG_EFUSE_BASE + 0x9B)
#define REG_EFUSE_4E_L          (REG_EFUSE_BASE + 0x9C)
#define REG_EFUSE_4E_H          (REG_EFUSE_BASE + 0x9D)
#define REG_EFUSE_4F_L          (REG_EFUSE_BASE + 0x9E)
#define REG_EFUSE_4F_H          (REG_EFUSE_BASE + 0x9F)
#define REG_EFUSE_50_L          (REG_EFUSE_BASE + 0xA0)
#define REG_EFUSE_50_H          (REG_EFUSE_BASE + 0xA1)
#define REG_EFUSE_51_L          (REG_EFUSE_BASE + 0xA2)
#define REG_EFUSE_51_H          (REG_EFUSE_BASE + 0xA3)
#define REG_EFUSE_52_L          (REG_EFUSE_BASE + 0xA4)
#define REG_EFUSE_52_H          (REG_EFUSE_BASE + 0xA5)
#define REG_EFUSE_53_L          (REG_EFUSE_BASE + 0xA6)
#define REG_EFUSE_53_H          (REG_EFUSE_BASE + 0xA7)
#define REG_EFUSE_54_L          (REG_EFUSE_BASE + 0xA8)
#define REG_EFUSE_54_H          (REG_EFUSE_BASE + 0xA9)
#define REG_EFUSE_55_L          (REG_EFUSE_BASE + 0xAA)
#define REG_EFUSE_55_H          (REG_EFUSE_BASE + 0xAB)
#define REG_EFUSE_56_L          (REG_EFUSE_BASE + 0xAC)
#define REG_EFUSE_56_H          (REG_EFUSE_BASE + 0xAD)
#define REG_EFUSE_57_L          (REG_EFUSE_BASE + 0xAE)
#define REG_EFUSE_57_H          (REG_EFUSE_BASE + 0xAF)
#define REG_EFUSE_58_L          (REG_EFUSE_BASE + 0xB0)
#define REG_EFUSE_58_H          (REG_EFUSE_BASE + 0xB1)
#define REG_EFUSE_59_L          (REG_EFUSE_BASE + 0xB2)
#define REG_EFUSE_59_H          (REG_EFUSE_BASE + 0xB3)
#define REG_EFUSE_5A_L          (REG_EFUSE_BASE + 0xB4)
#define REG_EFUSE_5A_H          (REG_EFUSE_BASE + 0xB5)
#define REG_EFUSE_5B_L          (REG_EFUSE_BASE + 0xB6)
#define REG_EFUSE_5B_H          (REG_EFUSE_BASE + 0xB7)
#define REG_EFUSE_5C_L          (REG_EFUSE_BASE + 0xB8)
#define REG_EFUSE_5C_H          (REG_EFUSE_BASE + 0xB9)
#define REG_EFUSE_5D_L          (REG_EFUSE_BASE + 0xBA)
#define REG_EFUSE_5D_H          (REG_EFUSE_BASE + 0xBB)
#define REG_EFUSE_5E_L          (REG_EFUSE_BASE + 0xBC)
#define REG_EFUSE_5E_H          (REG_EFUSE_BASE + 0xBD)
#define REG_EFUSE_5F_L          (REG_EFUSE_BASE + 0xBE)
#define REG_EFUSE_5F_H          (REG_EFUSE_BASE + 0xBF)
#define REG_EFUSE_60_L          (REG_EFUSE_BASE + 0xC0)
#define REG_EFUSE_60_H          (REG_EFUSE_BASE + 0xC1)
#define REG_EFUSE_61_L          (REG_EFUSE_BASE + 0xC2)
#define REG_EFUSE_61_H          (REG_EFUSE_BASE + 0xC3)
#define REG_EFUSE_62_L          (REG_EFUSE_BASE + 0xC4)
#define REG_EFUSE_62_H          (REG_EFUSE_BASE + 0xC5)
#define REG_EFUSE_63_L          (REG_EFUSE_BASE + 0xC6)
#define REG_EFUSE_63_H          (REG_EFUSE_BASE + 0xC7)
#define REG_EFUSE_64_L          (REG_EFUSE_BASE + 0xC8)
#define REG_EFUSE_64_H          (REG_EFUSE_BASE + 0xC9)
#define REG_EFUSE_65_L          (REG_EFUSE_BASE + 0xCA)
#define REG_EFUSE_65_H          (REG_EFUSE_BASE + 0xCB)
#define REG_EFUSE_66_L          (REG_EFUSE_BASE + 0xCC)
#define REG_EFUSE_66_H          (REG_EFUSE_BASE + 0xCD)
#define REG_EFUSE_67_L          (REG_EFUSE_BASE + 0xCE)
#define REG_EFUSE_67_H          (REG_EFUSE_BASE + 0xCF)
#define REG_EFUSE_68_L          (REG_EFUSE_BASE + 0xD0)
#define REG_EFUSE_68_H          (REG_EFUSE_BASE + 0xD1)
#define REG_EFUSE_69_L          (REG_EFUSE_BASE + 0xD2)
#define REG_EFUSE_69_H          (REG_EFUSE_BASE + 0xD3)
#define REG_EFUSE_6A_L          (REG_EFUSE_BASE + 0xD4)
#define REG_EFUSE_6A_H          (REG_EFUSE_BASE + 0xD5)
#define REG_EFUSE_6B_L          (REG_EFUSE_BASE + 0xD6)
#define REG_EFUSE_6B_H          (REG_EFUSE_BASE + 0xD7)
#define REG_EFUSE_6C_L          (REG_EFUSE_BASE + 0xD8)
#define REG_EFUSE_6C_H          (REG_EFUSE_BASE + 0xD9)
#define REG_EFUSE_6D_L          (REG_EFUSE_BASE + 0xDA)
#define REG_EFUSE_6D_H          (REG_EFUSE_BASE + 0xDB)
#define REG_EFUSE_6E_L          (REG_EFUSE_BASE + 0xDC)
#define REG_EFUSE_6E_H          (REG_EFUSE_BASE + 0xDD)
#define REG_EFUSE_6F_L          (REG_EFUSE_BASE + 0xDE)
#define REG_EFUSE_6F_H          (REG_EFUSE_BASE + 0xDF)
#define REG_EFUSE_70_L          (REG_EFUSE_BASE + 0xE0)
#define REG_EFUSE_70_H          (REG_EFUSE_BASE + 0xE1)
#define REG_EFUSE_71_L          (REG_EFUSE_BASE + 0xE2)
#define REG_EFUSE_71_H          (REG_EFUSE_BASE + 0xE3)
#define REG_EFUSE_72_L          (REG_EFUSE_BASE + 0xE4)
#define REG_EFUSE_72_H          (REG_EFUSE_BASE + 0xE5)
#define REG_EFUSE_73_L          (REG_EFUSE_BASE + 0xE6)
#define REG_EFUSE_73_H          (REG_EFUSE_BASE + 0xE7)
#define REG_EFUSE_74_L          (REG_EFUSE_BASE + 0xE8)
#define REG_EFUSE_74_H          (REG_EFUSE_BASE + 0xE9)
#define REG_EFUSE_75_L          (REG_EFUSE_BASE + 0xEA)
#define REG_EFUSE_75_H          (REG_EFUSE_BASE + 0xEB)
#define REG_EFUSE_76_L          (REG_EFUSE_BASE + 0xEC)
#define REG_EFUSE_76_H          (REG_EFUSE_BASE + 0xED)
#define REG_EFUSE_77_L          (REG_EFUSE_BASE + 0xEE)
#define REG_EFUSE_77_H          (REG_EFUSE_BASE + 0xEF)
#define REG_EFUSE_78_L          (REG_EFUSE_BASE + 0xF0)
#define REG_EFUSE_78_H          (REG_EFUSE_BASE + 0xF1)
#define REG_EFUSE_79_L          (REG_EFUSE_BASE + 0xF2)
#define REG_EFUSE_79_H          (REG_EFUSE_BASE + 0xF3)
#define REG_EFUSE_7A_L          (REG_EFUSE_BASE + 0xF4)
#define REG_EFUSE_7A_H          (REG_EFUSE_BASE + 0xF5)
#define REG_EFUSE_7B_L          (REG_EFUSE_BASE + 0xF6)
#define REG_EFUSE_7B_H          (REG_EFUSE_BASE + 0xF7)
#define REG_EFUSE_7C_L          (REG_EFUSE_BASE + 0xF8)
#define REG_EFUSE_7C_H          (REG_EFUSE_BASE + 0xF9)
#define REG_EFUSE_7D_L          (REG_EFUSE_BASE + 0xFA)
#define REG_EFUSE_7D_H          (REG_EFUSE_BASE + 0xFB)
#define REG_EFUSE_7E_L          (REG_EFUSE_BASE + 0xFC)
#define REG_EFUSE_7E_H          (REG_EFUSE_BASE + 0xFD)
#define REG_EFUSE_7F_L          (REG_EFUSE_BASE + 0xFE)
#define REG_EFUSE_7F_H          (REG_EFUSE_BASE + 0xFF)

#define REG_LCD_MISC_00_L       (REG_LCD_MISC_BASE + 0x00)
#define REG_LCD_MISC_00_H       (REG_LCD_MISC_BASE + 0x01)
#define REG_LCD_MISC_01_L       (REG_LCD_MISC_BASE + 0x02)
#define REG_LCD_MISC_01_H       (REG_LCD_MISC_BASE + 0x03)
#define REG_LCD_MISC_02_L       (REG_LCD_MISC_BASE + 0x04)
#define REG_LCD_MISC_02_H       (REG_LCD_MISC_BASE + 0x05)
#define REG_LCD_MISC_03_L       (REG_LCD_MISC_BASE + 0x06)
#define REG_LCD_MISC_03_H       (REG_LCD_MISC_BASE + 0x07)
#define REG_LCD_MISC_04_L       (REG_LCD_MISC_BASE + 0x08)
#define REG_LCD_MISC_04_H       (REG_LCD_MISC_BASE + 0x09)
#define REG_LCD_MISC_05_L       (REG_LCD_MISC_BASE + 0x0A)
#define REG_LCD_MISC_05_H       (REG_LCD_MISC_BASE + 0x0B)
#define REG_LCD_MISC_06_L       (REG_LCD_MISC_BASE + 0x0C)
#define REG_LCD_MISC_06_H       (REG_LCD_MISC_BASE + 0x0D)
#define REG_LCD_MISC_07_L       (REG_LCD_MISC_BASE + 0x0E)
#define REG_LCD_MISC_07_H       (REG_LCD_MISC_BASE + 0x0F)
#define REG_LCD_MISC_08_L       (REG_LCD_MISC_BASE + 0x10)
#define REG_LCD_MISC_08_H       (REG_LCD_MISC_BASE + 0x11)
#define REG_LCD_MISC_09_L       (REG_LCD_MISC_BASE + 0x12)
#define REG_LCD_MISC_09_H       (REG_LCD_MISC_BASE + 0x13)
#define REG_LCD_MISC_0A_L       (REG_LCD_MISC_BASE + 0x14)
#define REG_LCD_MISC_0A_H       (REG_LCD_MISC_BASE + 0x15)
#define REG_LCD_MISC_0B_L       (REG_LCD_MISC_BASE + 0x16)
#define REG_LCD_MISC_0B_H       (REG_LCD_MISC_BASE + 0x17)
#define REG_LCD_MISC_0C_L       (REG_LCD_MISC_BASE + 0x18)
#define REG_LCD_MISC_0C_H       (REG_LCD_MISC_BASE + 0x19)
#define REG_LCD_MISC_0D_L       (REG_LCD_MISC_BASE + 0x1A)
#define REG_LCD_MISC_0D_H       (REG_LCD_MISC_BASE + 0x1B)
#define REG_LCD_MISC_0E_L       (REG_LCD_MISC_BASE + 0x1C)
#define REG_LCD_MISC_0E_H       (REG_LCD_MISC_BASE + 0x1D)
#define REG_LCD_MISC_0F_L       (REG_LCD_MISC_BASE + 0x1E)
#define REG_LCD_MISC_0F_H       (REG_LCD_MISC_BASE + 0x1F)
#define REG_LCD_MISC_10_L       (REG_LCD_MISC_BASE + 0x20)
#define REG_LCD_MISC_10_H       (REG_LCD_MISC_BASE + 0x21)
#define REG_LCD_MISC_11_L       (REG_LCD_MISC_BASE + 0x22)
#define REG_LCD_MISC_11_H       (REG_LCD_MISC_BASE + 0x23)
#define REG_LCD_MISC_12_L       (REG_LCD_MISC_BASE + 0x24)
#define REG_LCD_MISC_12_H       (REG_LCD_MISC_BASE + 0x25)
#define REG_LCD_MISC_13_L       (REG_LCD_MISC_BASE + 0x26)
#define REG_LCD_MISC_13_H       (REG_LCD_MISC_BASE + 0x27)
#define REG_LCD_MISC_14_L       (REG_LCD_MISC_BASE + 0x28)
#define REG_LCD_MISC_14_H       (REG_LCD_MISC_BASE + 0x29)
#define REG_LCD_MISC_15_L       (REG_LCD_MISC_BASE + 0x2A)
#define REG_LCD_MISC_15_H       (REG_LCD_MISC_BASE + 0x2B)
#define REG_LCD_MISC_16_L       (REG_LCD_MISC_BASE + 0x2C)
#define REG_LCD_MISC_16_H       (REG_LCD_MISC_BASE + 0x2D)
#define REG_LCD_MISC_17_L       (REG_LCD_MISC_BASE + 0x2E)
#define REG_LCD_MISC_17_H       (REG_LCD_MISC_BASE + 0x2F)
#define REG_LCD_MISC_18_L       (REG_LCD_MISC_BASE + 0x30)
#define REG_LCD_MISC_18_H       (REG_LCD_MISC_BASE + 0x31)
#define REG_LCD_MISC_19_L       (REG_LCD_MISC_BASE + 0x32)
#define REG_LCD_MISC_19_H       (REG_LCD_MISC_BASE + 0x33)
#define REG_LCD_MISC_1A_L       (REG_LCD_MISC_BASE + 0x34)
#define REG_LCD_MISC_1A_H       (REG_LCD_MISC_BASE + 0x35)
#define REG_LCD_MISC_1B_L       (REG_LCD_MISC_BASE + 0x36)
#define REG_LCD_MISC_1B_H       (REG_LCD_MISC_BASE + 0x37)
#define REG_LCD_MISC_1C_L       (REG_LCD_MISC_BASE + 0x38)
#define REG_LCD_MISC_1C_H       (REG_LCD_MISC_BASE + 0x39)
#define REG_LCD_MISC_1D_L       (REG_LCD_MISC_BASE + 0x3A)
#define REG_LCD_MISC_1D_H       (REG_LCD_MISC_BASE + 0x3B)
#define REG_LCD_MISC_1E_L       (REG_LCD_MISC_BASE + 0x3C)
#define REG_LCD_MISC_1E_H       (REG_LCD_MISC_BASE + 0x3D)
#define REG_LCD_MISC_1F_L       (REG_LCD_MISC_BASE + 0x3E)
#define REG_LCD_MISC_1F_H       (REG_LCD_MISC_BASE + 0x3F)
#define REG_LCD_MISC_20_L       (REG_LCD_MISC_BASE + 0x40)
#define REG_LCD_MISC_20_H       (REG_LCD_MISC_BASE + 0x41)
#define REG_LCD_MISC_21_L       (REG_LCD_MISC_BASE + 0x42)
#define REG_LCD_MISC_21_H       (REG_LCD_MISC_BASE + 0x43)
#define REG_LCD_MISC_22_L       (REG_LCD_MISC_BASE + 0x44)
#define REG_LCD_MISC_22_H       (REG_LCD_MISC_BASE + 0x45)
#define REG_LCD_MISC_23_L       (REG_LCD_MISC_BASE + 0x46)
#define REG_LCD_MISC_23_H       (REG_LCD_MISC_BASE + 0x47)
#define REG_LCD_MISC_24_L       (REG_LCD_MISC_BASE + 0x48)
#define REG_LCD_MISC_24_H       (REG_LCD_MISC_BASE + 0x49)
#define REG_LCD_MISC_25_L       (REG_LCD_MISC_BASE + 0x4A)
#define REG_LCD_MISC_25_H       (REG_LCD_MISC_BASE + 0x4B)
#define REG_LCD_MISC_26_L       (REG_LCD_MISC_BASE + 0x4C)
#define REG_LCD_MISC_26_H       (REG_LCD_MISC_BASE + 0x4D)
#define REG_LCD_MISC_27_L       (REG_LCD_MISC_BASE + 0x4E)
#define REG_LCD_MISC_27_H       (REG_LCD_MISC_BASE + 0x4F)
#define REG_LCD_MISC_28_L       (REG_LCD_MISC_BASE + 0x50)
#define REG_LCD_MISC_28_H       (REG_LCD_MISC_BASE + 0x51)
#define REG_LCD_MISC_29_L       (REG_LCD_MISC_BASE + 0x52)
#define REG_LCD_MISC_29_H       (REG_LCD_MISC_BASE + 0x53)
#define REG_LCD_MISC_2A_L       (REG_LCD_MISC_BASE + 0x54)
#define REG_LCD_MISC_2A_H       (REG_LCD_MISC_BASE + 0x55)
#define REG_LCD_MISC_2B_L       (REG_LCD_MISC_BASE + 0x56)
#define REG_LCD_MISC_2B_H       (REG_LCD_MISC_BASE + 0x57)
#define REG_LCD_MISC_2C_L       (REG_LCD_MISC_BASE + 0x58)
#define REG_LCD_MISC_2C_H       (REG_LCD_MISC_BASE + 0x59)
#define REG_LCD_MISC_2D_L       (REG_LCD_MISC_BASE + 0x5A)
#define REG_LCD_MISC_2D_H       (REG_LCD_MISC_BASE + 0x5B)
#define REG_LCD_MISC_2E_L       (REG_LCD_MISC_BASE + 0x5C)
#define REG_LCD_MISC_2E_H       (REG_LCD_MISC_BASE + 0x5D)
#define REG_LCD_MISC_2F_L       (REG_LCD_MISC_BASE + 0x5E)
#define REG_LCD_MISC_2F_H       (REG_LCD_MISC_BASE + 0x5F)
#define REG_LCD_MISC_30_L       (REG_LCD_MISC_BASE + 0x60)
#define REG_LCD_MISC_30_H       (REG_LCD_MISC_BASE + 0x61)
#define REG_LCD_MISC_31_L       (REG_LCD_MISC_BASE + 0x62)
#define REG_LCD_MISC_31_H       (REG_LCD_MISC_BASE + 0x63)
#define REG_LCD_MISC_32_L       (REG_LCD_MISC_BASE + 0x64)
#define REG_LCD_MISC_32_H       (REG_LCD_MISC_BASE + 0x65)
#define REG_LCD_MISC_33_L       (REG_LCD_MISC_BASE + 0x66)
#define REG_LCD_MISC_33_H       (REG_LCD_MISC_BASE + 0x67)
#define REG_LCD_MISC_34_L       (REG_LCD_MISC_BASE + 0x68)
#define REG_LCD_MISC_34_H       (REG_LCD_MISC_BASE + 0x69)
#define REG_LCD_MISC_35_L       (REG_LCD_MISC_BASE + 0x6A)
#define REG_LCD_MISC_35_H       (REG_LCD_MISC_BASE + 0x6B)
#define REG_LCD_MISC_36_L       (REG_LCD_MISC_BASE + 0x6C)
#define REG_LCD_MISC_36_H       (REG_LCD_MISC_BASE + 0x6D)
#define REG_LCD_MISC_37_L       (REG_LCD_MISC_BASE + 0x6E)
#define REG_LCD_MISC_37_H       (REG_LCD_MISC_BASE + 0x6F)
#define REG_LCD_MISC_38_L       (REG_LCD_MISC_BASE + 0x70)
#define REG_LCD_MISC_38_H       (REG_LCD_MISC_BASE + 0x71)
#define REG_LCD_MISC_39_L       (REG_LCD_MISC_BASE + 0x72)
#define REG_LCD_MISC_39_H       (REG_LCD_MISC_BASE + 0x73)
#define REG_LCD_MISC_3A_L       (REG_LCD_MISC_BASE + 0x74)
#define REG_LCD_MISC_3A_H       (REG_LCD_MISC_BASE + 0x75)
#define REG_LCD_MISC_3B_L       (REG_LCD_MISC_BASE + 0x76)
#define REG_LCD_MISC_3B_H       (REG_LCD_MISC_BASE + 0x77)
#define REG_LCD_MISC_3C_L       (REG_LCD_MISC_BASE + 0x78)
#define REG_LCD_MISC_3C_H       (REG_LCD_MISC_BASE + 0x79)
#define REG_LCD_MISC_3D_L       (REG_LCD_MISC_BASE + 0x7A)
#define REG_LCD_MISC_3D_H       (REG_LCD_MISC_BASE + 0x7B)
#define REG_LCD_MISC_3E_L       (REG_LCD_MISC_BASE + 0x7C)
#define REG_LCD_MISC_3E_H       (REG_LCD_MISC_BASE + 0x7D)
#define REG_LCD_MISC_3F_L       (REG_LCD_MISC_BASE + 0x7E)
#define REG_LCD_MISC_3F_H       (REG_LCD_MISC_BASE + 0x7F)
#define REG_LCD_MISC_40_L       (REG_LCD_MISC_BASE + 0x80)
#define REG_LCD_MISC_40_H       (REG_LCD_MISC_BASE + 0x81)
#define REG_LCD_MISC_41_L       (REG_LCD_MISC_BASE + 0x82)
#define REG_LCD_MISC_41_H       (REG_LCD_MISC_BASE + 0x83)
#define REG_LCD_MISC_42_L       (REG_LCD_MISC_BASE + 0x84)
#define REG_LCD_MISC_42_H       (REG_LCD_MISC_BASE + 0x85)
#define REG_LCD_MISC_43_L       (REG_LCD_MISC_BASE + 0x86)
#define REG_LCD_MISC_43_H       (REG_LCD_MISC_BASE + 0x87)
#define REG_LCD_MISC_44_L       (REG_LCD_MISC_BASE + 0x88)
#define REG_LCD_MISC_44_H       (REG_LCD_MISC_BASE + 0x89)
#define REG_LCD_MISC_45_L       (REG_LCD_MISC_BASE + 0x8A)
#define REG_LCD_MISC_45_H       (REG_LCD_MISC_BASE + 0x8B)
#define REG_LCD_MISC_46_L       (REG_LCD_MISC_BASE + 0x8C)
#define REG_LCD_MISC_46_H       (REG_LCD_MISC_BASE + 0x8D)
#define REG_LCD_MISC_47_L       (REG_LCD_MISC_BASE + 0x8E)
#define REG_LCD_MISC_47_H       (REG_LCD_MISC_BASE + 0x8F)
#define REG_LCD_MISC_48_L       (REG_LCD_MISC_BASE + 0x90)
#define REG_LCD_MISC_48_H       (REG_LCD_MISC_BASE + 0x91)
#define REG_LCD_MISC_49_L       (REG_LCD_MISC_BASE + 0x92)
#define REG_LCD_MISC_49_H       (REG_LCD_MISC_BASE + 0x93)
#define REG_LCD_MISC_4A_L       (REG_LCD_MISC_BASE + 0x94)
#define REG_LCD_MISC_4A_H       (REG_LCD_MISC_BASE + 0x95)
#define REG_LCD_MISC_4B_L       (REG_LCD_MISC_BASE + 0x96)
#define REG_LCD_MISC_4B_H       (REG_LCD_MISC_BASE + 0x97)
#define REG_LCD_MISC_4C_L       (REG_LCD_MISC_BASE + 0x98)
#define REG_LCD_MISC_4C_H       (REG_LCD_MISC_BASE + 0x99)
#define REG_LCD_MISC_4D_L       (REG_LCD_MISC_BASE + 0x9A)
#define REG_LCD_MISC_4D_H       (REG_LCD_MISC_BASE + 0x9B)
#define REG_LCD_MISC_4E_L       (REG_LCD_MISC_BASE + 0x9C)
#define REG_LCD_MISC_4E_H       (REG_LCD_MISC_BASE + 0x9D)
#define REG_LCD_MISC_4F_L       (REG_LCD_MISC_BASE + 0x9E)
#define REG_LCD_MISC_4F_H       (REG_LCD_MISC_BASE + 0x9F)
#define REG_LCD_MISC_50_L       (REG_LCD_MISC_BASE + 0xA0)
#define REG_LCD_MISC_50_H       (REG_LCD_MISC_BASE + 0xA1)
#define REG_LCD_MISC_51_L       (REG_LCD_MISC_BASE + 0xA2)
#define REG_LCD_MISC_51_H       (REG_LCD_MISC_BASE + 0xA3)
#define REG_LCD_MISC_52_L       (REG_LCD_MISC_BASE + 0xA4)
#define REG_LCD_MISC_52_H       (REG_LCD_MISC_BASE + 0xA5)
#define REG_LCD_MISC_53_L       (REG_LCD_MISC_BASE + 0xA6)
#define REG_LCD_MISC_53_H       (REG_LCD_MISC_BASE + 0xA7)
#define REG_LCD_MISC_54_L       (REG_LCD_MISC_BASE + 0xA8)
#define REG_LCD_MISC_54_H       (REG_LCD_MISC_BASE + 0xA9)
#define REG_LCD_MISC_55_L       (REG_LCD_MISC_BASE + 0xAA)
#define REG_LCD_MISC_55_H       (REG_LCD_MISC_BASE + 0xAB)
#define REG_LCD_MISC_56_L       (REG_LCD_MISC_BASE + 0xAC)
#define REG_LCD_MISC_56_H       (REG_LCD_MISC_BASE + 0xAD)
#define REG_LCD_MISC_57_L       (REG_LCD_MISC_BASE + 0xAE)
#define REG_LCD_MISC_57_H       (REG_LCD_MISC_BASE + 0xAF)
#define REG_LCD_MISC_58_L       (REG_LCD_MISC_BASE + 0xB0)
#define REG_LCD_MISC_58_H       (REG_LCD_MISC_BASE + 0xB1)
#define REG_LCD_MISC_59_L       (REG_LCD_MISC_BASE + 0xB2)
#define REG_LCD_MISC_59_H       (REG_LCD_MISC_BASE + 0xB3)
#define REG_LCD_MISC_5A_L       (REG_LCD_MISC_BASE + 0xB4)
#define REG_LCD_MISC_5A_H       (REG_LCD_MISC_BASE + 0xB5)
#define REG_LCD_MISC_5B_L       (REG_LCD_MISC_BASE + 0xB6)
#define REG_LCD_MISC_5B_H       (REG_LCD_MISC_BASE + 0xB7)
#define REG_LCD_MISC_5C_L       (REG_LCD_MISC_BASE + 0xB8)
#define REG_LCD_MISC_5C_H       (REG_LCD_MISC_BASE + 0xB9)
#define REG_LCD_MISC_5D_L       (REG_LCD_MISC_BASE + 0xBA)
#define REG_LCD_MISC_5D_H       (REG_LCD_MISC_BASE + 0xBB)
#define REG_LCD_MISC_5E_L       (REG_LCD_MISC_BASE + 0xBC)
#define REG_LCD_MISC_5E_H       (REG_LCD_MISC_BASE + 0xBD)
#define REG_LCD_MISC_5F_L       (REG_LCD_MISC_BASE + 0xBE)
#define REG_LCD_MISC_5F_H       (REG_LCD_MISC_BASE + 0xBF)
#define REG_LCD_MISC_60_L       (REG_LCD_MISC_BASE + 0xC0)
#define REG_LCD_MISC_60_H       (REG_LCD_MISC_BASE + 0xC1)
#define REG_LCD_MISC_61_L       (REG_LCD_MISC_BASE + 0xC2)
#define REG_LCD_MISC_61_H       (REG_LCD_MISC_BASE + 0xC3)
#define REG_LCD_MISC_62_L       (REG_LCD_MISC_BASE + 0xC4)
#define REG_LCD_MISC_62_H       (REG_LCD_MISC_BASE + 0xC5)
#define REG_LCD_MISC_63_L       (REG_LCD_MISC_BASE + 0xC6)
#define REG_LCD_MISC_63_H       (REG_LCD_MISC_BASE + 0xC7)
#define REG_LCD_MISC_64_L       (REG_LCD_MISC_BASE + 0xC8)
#define REG_LCD_MISC_64_H       (REG_LCD_MISC_BASE + 0xC9)
#define REG_LCD_MISC_65_L       (REG_LCD_MISC_BASE + 0xCA)
#define REG_LCD_MISC_65_H       (REG_LCD_MISC_BASE + 0xCB)
#define REG_LCD_MISC_66_L       (REG_LCD_MISC_BASE + 0xCC)
#define REG_LCD_MISC_66_H       (REG_LCD_MISC_BASE + 0xCD)
#define REG_LCD_MISC_67_L       (REG_LCD_MISC_BASE + 0xCE)
#define REG_LCD_MISC_67_H       (REG_LCD_MISC_BASE + 0xCF)
#define REG_LCD_MISC_68_L       (REG_LCD_MISC_BASE + 0xD0)
#define REG_LCD_MISC_68_H       (REG_LCD_MISC_BASE + 0xD1)
#define REG_LCD_MISC_69_L       (REG_LCD_MISC_BASE + 0xD2)
#define REG_LCD_MISC_69_H       (REG_LCD_MISC_BASE + 0xD3)
#define REG_LCD_MISC_6A_L       (REG_LCD_MISC_BASE + 0xD4)
#define REG_LCD_MISC_6A_H       (REG_LCD_MISC_BASE + 0xD5)
#define REG_LCD_MISC_6B_L       (REG_LCD_MISC_BASE + 0xD6)
#define REG_LCD_MISC_6B_H       (REG_LCD_MISC_BASE + 0xD7)
#define REG_LCD_MISC_6C_L       (REG_LCD_MISC_BASE + 0xD8)
#define REG_LCD_MISC_6C_H       (REG_LCD_MISC_BASE + 0xD9)
#define REG_LCD_MISC_6D_L       (REG_LCD_MISC_BASE + 0xDA)
#define REG_LCD_MISC_6D_H       (REG_LCD_MISC_BASE + 0xDB)
#define REG_LCD_MISC_6E_L       (REG_LCD_MISC_BASE + 0xDC)
#define REG_LCD_MISC_6E_H       (REG_LCD_MISC_BASE + 0xDD)
#define REG_LCD_MISC_6F_L       (REG_LCD_MISC_BASE + 0xDE)
#define REG_LCD_MISC_6F_H       (REG_LCD_MISC_BASE + 0xDF)
#define REG_LCD_MISC_70_L       (REG_LCD_MISC_BASE + 0xE0)
#define REG_LCD_MISC_70_H       (REG_LCD_MISC_BASE + 0xE1)
#define REG_LCD_MISC_71_L       (REG_LCD_MISC_BASE + 0xE2)
#define REG_LCD_MISC_71_H       (REG_LCD_MISC_BASE + 0xE3)
#define REG_LCD_MISC_72_L       (REG_LCD_MISC_BASE + 0xE4)
#define REG_LCD_MISC_72_H       (REG_LCD_MISC_BASE + 0xE5)
#define REG_LCD_MISC_73_L       (REG_LCD_MISC_BASE + 0xE6)
#define REG_LCD_MISC_73_H       (REG_LCD_MISC_BASE + 0xE7)
#define REG_LCD_MISC_74_L       (REG_LCD_MISC_BASE + 0xE8)
#define REG_LCD_MISC_74_H       (REG_LCD_MISC_BASE + 0xE9)
#define REG_LCD_MISC_75_L       (REG_LCD_MISC_BASE + 0xEA)
#define REG_LCD_MISC_75_H       (REG_LCD_MISC_BASE + 0xEB)
#define REG_LCD_MISC_76_L       (REG_LCD_MISC_BASE + 0xEC)
#define REG_LCD_MISC_76_H       (REG_LCD_MISC_BASE + 0xED)
#define REG_LCD_MISC_77_L       (REG_LCD_MISC_BASE + 0xEE)
#define REG_LCD_MISC_77_H       (REG_LCD_MISC_BASE + 0xEF)
#define REG_LCD_MISC_78_L       (REG_LCD_MISC_BASE + 0xF0)
#define REG_LCD_MISC_78_H       (REG_LCD_MISC_BASE + 0xF1)
#define REG_LCD_MISC_79_L       (REG_LCD_MISC_BASE + 0xF2)
#define REG_LCD_MISC_79_H       (REG_LCD_MISC_BASE + 0xF3)
#define REG_LCD_MISC_7A_L       (REG_LCD_MISC_BASE + 0xF4)
#define REG_LCD_MISC_7A_H       (REG_LCD_MISC_BASE + 0xF5)
#define REG_LCD_MISC_7B_L       (REG_LCD_MISC_BASE + 0xF6)
#define REG_LCD_MISC_7B_H       (REG_LCD_MISC_BASE + 0xF7)
#define REG_LCD_MISC_7C_L       (REG_LCD_MISC_BASE + 0xF8)
#define REG_LCD_MISC_7C_H       (REG_LCD_MISC_BASE + 0xF9)
#define REG_LCD_MISC_7D_L       (REG_LCD_MISC_BASE + 0xFA)
#define REG_LCD_MISC_7D_H       (REG_LCD_MISC_BASE + 0xFB)
#define REG_LCD_MISC_7E_L       (REG_LCD_MISC_BASE + 0xFC)
#define REG_LCD_MISC_7E_H       (REG_LCD_MISC_BASE + 0xFD)
#define REG_LCD_MISC_7F_L       (REG_LCD_MISC_BASE + 0xFE)
#define REG_LCD_MISC_7F_H       (REG_LCD_MISC_BASE + 0xFF)


#define REG_LCD_00_L            (REG_LCD_BASE + 0x00)
#define REG_LCD_00_H            (REG_LCD_BASE + 0x01)
#define REG_LCD_01_L            (REG_LCD_BASE + 0x02)
#define REG_LCD_01_H            (REG_LCD_BASE + 0x03)
#define REG_LCD_02_L            (REG_LCD_BASE + 0x04)
#define REG_LCD_02_H            (REG_LCD_BASE + 0x05)
#define REG_LCD_03_L            (REG_LCD_BASE + 0x06)
#define REG_LCD_03_H            (REG_LCD_BASE + 0x07)
#define REG_LCD_04_L            (REG_LCD_BASE + 0x08)
#define REG_LCD_04_H            (REG_LCD_BASE + 0x09)
#define REG_LCD_05_L            (REG_LCD_BASE + 0x0A)
#define REG_LCD_05_H            (REG_LCD_BASE + 0x0B)
#define REG_LCD_06_L            (REG_LCD_BASE + 0x0C)
#define REG_LCD_06_H            (REG_LCD_BASE + 0x0D)
#define REG_LCD_07_L            (REG_LCD_BASE + 0x0E)
#define REG_LCD_07_H            (REG_LCD_BASE + 0x0F)
#define REG_LCD_08_L            (REG_LCD_BASE + 0x10)
#define REG_LCD_08_H            (REG_LCD_BASE + 0x11)
#define REG_LCD_09_L            (REG_LCD_BASE + 0x12)
#define REG_LCD_09_H            (REG_LCD_BASE + 0x13)
#define REG_LCD_0A_L            (REG_LCD_BASE + 0x14)
#define REG_LCD_0A_H            (REG_LCD_BASE + 0x15)
#define REG_LCD_0B_L            (REG_LCD_BASE + 0x16)
#define REG_LCD_0B_H            (REG_LCD_BASE + 0x17)
#define REG_LCD_0C_L            (REG_LCD_BASE + 0x18)
#define REG_LCD_0C_H            (REG_LCD_BASE + 0x19)
#define REG_LCD_0D_L            (REG_LCD_BASE + 0x1A)
#define REG_LCD_0D_H            (REG_LCD_BASE + 0x1B)
#define REG_LCD_0E_L            (REG_LCD_BASE + 0x1C)
#define REG_LCD_0E_H            (REG_LCD_BASE + 0x1D)
#define REG_LCD_0F_L            (REG_LCD_BASE + 0x1E)
#define REG_LCD_0F_H            (REG_LCD_BASE + 0x1F)
#define REG_LCD_10_L            (REG_LCD_BASE + 0x20)
#define REG_LCD_10_H            (REG_LCD_BASE + 0x21)
#define REG_LCD_11_L            (REG_LCD_BASE + 0x22)
#define REG_LCD_11_H            (REG_LCD_BASE + 0x23)
#define REG_LCD_12_L            (REG_LCD_BASE + 0x24)
#define REG_LCD_12_H            (REG_LCD_BASE + 0x25)
#define REG_LCD_13_L            (REG_LCD_BASE + 0x26)
#define REG_LCD_13_H            (REG_LCD_BASE + 0x27)
#define REG_LCD_14_L            (REG_LCD_BASE + 0x28)
#define REG_LCD_14_H            (REG_LCD_BASE + 0x29)
#define REG_LCD_15_L            (REG_LCD_BASE + 0x2A)
#define REG_LCD_15_H            (REG_LCD_BASE + 0x2B)
#define REG_LCD_16_L            (REG_LCD_BASE + 0x2C)
#define REG_LCD_16_H            (REG_LCD_BASE + 0x2D)
#define REG_LCD_17_L            (REG_LCD_BASE + 0x2E)
#define REG_LCD_17_H            (REG_LCD_BASE + 0x2F)
#define REG_LCD_18_L            (REG_LCD_BASE + 0x30)
#define REG_LCD_18_H            (REG_LCD_BASE + 0x31)
#define REG_LCD_19_L            (REG_LCD_BASE + 0x32)
#define REG_LCD_19_H            (REG_LCD_BASE + 0x33)
#define REG_LCD_1A_L            (REG_LCD_BASE + 0x34)
#define REG_LCD_1A_H            (REG_LCD_BASE + 0x35)
#define REG_LCD_1B_L            (REG_LCD_BASE + 0x36)
#define REG_LCD_1B_H            (REG_LCD_BASE + 0x37)
#define REG_LCD_1C_L            (REG_LCD_BASE + 0x38)
#define REG_LCD_1C_H            (REG_LCD_BASE + 0x39)
#define REG_LCD_1D_L            (REG_LCD_BASE + 0x3A)
#define REG_LCD_1D_H            (REG_LCD_BASE + 0x3B)
#define REG_LCD_1E_L            (REG_LCD_BASE + 0x3C)
#define REG_LCD_1E_H            (REG_LCD_BASE + 0x3D)
#define REG_LCD_1F_L            (REG_LCD_BASE + 0x3E)
#define REG_LCD_1F_H            (REG_LCD_BASE + 0x3F)
#define REG_LCD_20_L            (REG_LCD_BASE + 0x40)
#define REG_LCD_20_H            (REG_LCD_BASE + 0x41)
#define REG_LCD_21_L            (REG_LCD_BASE + 0x42)
#define REG_LCD_21_H            (REG_LCD_BASE + 0x43)
#define REG_LCD_22_L            (REG_LCD_BASE + 0x44)
#define REG_LCD_22_H            (REG_LCD_BASE + 0x45)
#define REG_LCD_23_L            (REG_LCD_BASE + 0x46)
#define REG_LCD_23_H            (REG_LCD_BASE + 0x47)
#define REG_LCD_24_L            (REG_LCD_BASE + 0x48)
#define REG_LCD_24_H            (REG_LCD_BASE + 0x49)
#define REG_LCD_25_L            (REG_LCD_BASE + 0x4A)
#define REG_LCD_25_H            (REG_LCD_BASE + 0x4B)
#define REG_LCD_26_L            (REG_LCD_BASE + 0x4C)
#define REG_LCD_26_H            (REG_LCD_BASE + 0x4D)
#define REG_LCD_27_L            (REG_LCD_BASE + 0x4E)
#define REG_LCD_27_H            (REG_LCD_BASE + 0x4F)
#define REG_LCD_28_L            (REG_LCD_BASE + 0x50)
#define REG_LCD_28_H            (REG_LCD_BASE + 0x51)
#define REG_LCD_29_L            (REG_LCD_BASE + 0x52)
#define REG_LCD_29_H            (REG_LCD_BASE + 0x53)
#define REG_LCD_2A_L            (REG_LCD_BASE + 0x54)
#define REG_LCD_2A_H            (REG_LCD_BASE + 0x55)
#define REG_LCD_2B_L            (REG_LCD_BASE + 0x56)
#define REG_LCD_2B_H            (REG_LCD_BASE + 0x57)
#define REG_LCD_2C_L            (REG_LCD_BASE + 0x58)
#define REG_LCD_2C_H            (REG_LCD_BASE + 0x59)
#define REG_LCD_2D_L            (REG_LCD_BASE + 0x5A)
#define REG_LCD_2D_H            (REG_LCD_BASE + 0x5B)
#define REG_LCD_2E_L            (REG_LCD_BASE + 0x5C)
#define REG_LCD_2E_H            (REG_LCD_BASE + 0x5D)
#define REG_LCD_2F_L            (REG_LCD_BASE + 0x5E)
#define REG_LCD_2F_H            (REG_LCD_BASE + 0x5F)
#define REG_LCD_30_L            (REG_LCD_BASE + 0x60)
#define REG_LCD_30_H            (REG_LCD_BASE + 0x61)
#define REG_LCD_31_L            (REG_LCD_BASE + 0x62)
#define REG_LCD_31_H            (REG_LCD_BASE + 0x63)
#define REG_LCD_32_L            (REG_LCD_BASE + 0x64)
#define REG_LCD_32_H            (REG_LCD_BASE + 0x65)
#define REG_LCD_33_L            (REG_LCD_BASE + 0x66)
#define REG_LCD_33_H            (REG_LCD_BASE + 0x67)
#define REG_LCD_34_L            (REG_LCD_BASE + 0x68)
#define REG_LCD_34_H            (REG_LCD_BASE + 0x69)
#define REG_LCD_35_L            (REG_LCD_BASE + 0x6A)
#define REG_LCD_35_H            (REG_LCD_BASE + 0x6B)
#define REG_LCD_36_L            (REG_LCD_BASE + 0x6C)
#define REG_LCD_36_H            (REG_LCD_BASE + 0x6D)
#define REG_LCD_37_L            (REG_LCD_BASE + 0x6E)
#define REG_LCD_37_H            (REG_LCD_BASE + 0x6F)
#define REG_LCD_38_L            (REG_LCD_BASE + 0x70)
#define REG_LCD_38_H            (REG_LCD_BASE + 0x71)
#define REG_LCD_39_L            (REG_LCD_BASE + 0x72)
#define REG_LCD_39_H            (REG_LCD_BASE + 0x73)
#define REG_LCD_3A_L            (REG_LCD_BASE + 0x74)
#define REG_LCD_3A_H            (REG_LCD_BASE + 0x75)
#define REG_LCD_3B_L            (REG_LCD_BASE + 0x76)
#define REG_LCD_3B_H            (REG_LCD_BASE + 0x77)
#define REG_LCD_3C_L            (REG_LCD_BASE + 0x78)
#define REG_LCD_3C_H            (REG_LCD_BASE + 0x79)
#define REG_LCD_3D_L            (REG_LCD_BASE + 0x7A)
#define REG_LCD_3D_H            (REG_LCD_BASE + 0x7B)
#define REG_LCD_3E_L            (REG_LCD_BASE + 0x7C)
#define REG_LCD_3E_H            (REG_LCD_BASE + 0x7D)
#define REG_LCD_3F_L            (REG_LCD_BASE + 0x7E)
#define REG_LCD_3F_H            (REG_LCD_BASE + 0x7F)
#define REG_LCD_40_L            (REG_LCD_BASE + 0x80)
#define REG_LCD_40_H            (REG_LCD_BASE + 0x81)
#define REG_LCD_41_L            (REG_LCD_BASE + 0x82)
#define REG_LCD_41_H            (REG_LCD_BASE + 0x83)
#define REG_LCD_42_L            (REG_LCD_BASE + 0x84)
#define REG_LCD_42_H            (REG_LCD_BASE + 0x85)
#define REG_LCD_43_L            (REG_LCD_BASE + 0x86)
#define REG_LCD_43_H            (REG_LCD_BASE + 0x87)
#define REG_LCD_44_L            (REG_LCD_BASE + 0x88)
#define REG_LCD_44_H            (REG_LCD_BASE + 0x89)
#define REG_LCD_45_L            (REG_LCD_BASE + 0x8A)
#define REG_LCD_45_H            (REG_LCD_BASE + 0x8B)
#define REG_LCD_46_L            (REG_LCD_BASE + 0x8C)
#define REG_LCD_46_H            (REG_LCD_BASE + 0x8D)
#define REG_LCD_47_L            (REG_LCD_BASE + 0x8E)
#define REG_LCD_47_H            (REG_LCD_BASE + 0x8F)
#define REG_LCD_48_L            (REG_LCD_BASE + 0x90)
#define REG_LCD_48_H            (REG_LCD_BASE + 0x91)
#define REG_LCD_49_L            (REG_LCD_BASE + 0x92)
#define REG_LCD_49_H            (REG_LCD_BASE + 0x93)
#define REG_LCD_4A_L            (REG_LCD_BASE + 0x94)
#define REG_LCD_4A_H            (REG_LCD_BASE + 0x95)
#define REG_LCD_4B_L            (REG_LCD_BASE + 0x96)
#define REG_LCD_4B_H            (REG_LCD_BASE + 0x97)
#define REG_LCD_4C_L            (REG_LCD_BASE + 0x98)
#define REG_LCD_4C_H            (REG_LCD_BASE + 0x99)
#define REG_LCD_4D_L            (REG_LCD_BASE + 0x9A)
#define REG_LCD_4D_H            (REG_LCD_BASE + 0x9B)
#define REG_LCD_4E_L            (REG_LCD_BASE + 0x9C)
#define REG_LCD_4E_H            (REG_LCD_BASE + 0x9D)
#define REG_LCD_4F_L            (REG_LCD_BASE + 0x9E)
#define REG_LCD_4F_H            (REG_LCD_BASE + 0x9F)
#define REG_LCD_50_L            (REG_LCD_BASE + 0xA0)
#define REG_LCD_50_H            (REG_LCD_BASE + 0xA1)
#define REG_LCD_51_L            (REG_LCD_BASE + 0xA2)
#define REG_LCD_51_H            (REG_LCD_BASE + 0xA3)
#define REG_LCD_52_L            (REG_LCD_BASE + 0xA4)
#define REG_LCD_52_H            (REG_LCD_BASE + 0xA5)
#define REG_LCD_53_L            (REG_LCD_BASE + 0xA6)
#define REG_LCD_53_H            (REG_LCD_BASE + 0xA7)
#define REG_LCD_54_L            (REG_LCD_BASE + 0xA8)
#define REG_LCD_54_H            (REG_LCD_BASE + 0xA9)
#define REG_LCD_55_L            (REG_LCD_BASE + 0xAA)
#define REG_LCD_55_H            (REG_LCD_BASE + 0xAB)
#define REG_LCD_56_L            (REG_LCD_BASE + 0xAC)
#define REG_LCD_56_H            (REG_LCD_BASE + 0xAD)
#define REG_LCD_57_L            (REG_LCD_BASE + 0xAE)
#define REG_LCD_57_H            (REG_LCD_BASE + 0xAF)
#define REG_LCD_58_L            (REG_LCD_BASE + 0xB0)
#define REG_LCD_58_H            (REG_LCD_BASE + 0xB1)
#define REG_LCD_59_L            (REG_LCD_BASE + 0xB2)
#define REG_LCD_59_H            (REG_LCD_BASE + 0xB3)
#define REG_LCD_5A_L            (REG_LCD_BASE + 0xB4)
#define REG_LCD_5A_H            (REG_LCD_BASE + 0xB5)
#define REG_LCD_5B_L            (REG_LCD_BASE + 0xB6)
#define REG_LCD_5B_H            (REG_LCD_BASE + 0xB7)
#define REG_LCD_5C_L            (REG_LCD_BASE + 0xB8)
#define REG_LCD_5C_H            (REG_LCD_BASE + 0xB9)
#define REG_LCD_5D_L            (REG_LCD_BASE + 0xBA)
#define REG_LCD_5D_H            (REG_LCD_BASE + 0xBB)
#define REG_LCD_5E_L            (REG_LCD_BASE + 0xBC)
#define REG_LCD_5E_H            (REG_LCD_BASE + 0xBD)
#define REG_LCD_5F_L            (REG_LCD_BASE + 0xBE)
#define REG_LCD_5F_H            (REG_LCD_BASE + 0xBF)
#define REG_LCD_60_L            (REG_LCD_BASE + 0xC0)
#define REG_LCD_60_H            (REG_LCD_BASE + 0xC1)
#define REG_LCD_61_L            (REG_LCD_BASE + 0xC2)
#define REG_LCD_61_H            (REG_LCD_BASE + 0xC3)
#define REG_LCD_62_L            (REG_LCD_BASE + 0xC4)
#define REG_LCD_62_H            (REG_LCD_BASE + 0xC5)
#define REG_LCD_63_L            (REG_LCD_BASE + 0xC6)
#define REG_LCD_63_H            (REG_LCD_BASE + 0xC7)
#define REG_LCD_64_L            (REG_LCD_BASE + 0xC8)
#define REG_LCD_64_H            (REG_LCD_BASE + 0xC9)
#define REG_LCD_65_L            (REG_LCD_BASE + 0xCA)
#define REG_LCD_65_H            (REG_LCD_BASE + 0xCB)
#define REG_LCD_66_L            (REG_LCD_BASE + 0xCC)
#define REG_LCD_66_H            (REG_LCD_BASE + 0xCD)
#define REG_LCD_67_L            (REG_LCD_BASE + 0xCE)
#define REG_LCD_67_H            (REG_LCD_BASE + 0xCF)
#define REG_LCD_68_L            (REG_LCD_BASE + 0xD0)
#define REG_LCD_68_H            (REG_LCD_BASE + 0xD1)
#define REG_LCD_69_L            (REG_LCD_BASE + 0xD2)
#define REG_LCD_69_H            (REG_LCD_BASE + 0xD3)
#define REG_LCD_6A_L            (REG_LCD_BASE + 0xD4)
#define REG_LCD_6A_H            (REG_LCD_BASE + 0xD5)
#define REG_LCD_6B_L            (REG_LCD_BASE + 0xD6)
#define REG_LCD_6B_H            (REG_LCD_BASE + 0xD7)
#define REG_LCD_6C_L            (REG_LCD_BASE + 0xD8)
#define REG_LCD_6C_H            (REG_LCD_BASE + 0xD9)
#define REG_LCD_6D_L            (REG_LCD_BASE + 0xDA)
#define REG_LCD_6D_H            (REG_LCD_BASE + 0xDB)
#define REG_LCD_6E_L            (REG_LCD_BASE + 0xDC)
#define REG_LCD_6E_H            (REG_LCD_BASE + 0xDD)
#define REG_LCD_6F_L            (REG_LCD_BASE + 0xDE)
#define REG_LCD_6F_H            (REG_LCD_BASE + 0xDF)
#define REG_LCD_70_L            (REG_LCD_BASE + 0xE0)
#define REG_LCD_70_H            (REG_LCD_BASE + 0xE1)
#define REG_LCD_71_L            (REG_LCD_BASE + 0xE2)
#define REG_LCD_71_H            (REG_LCD_BASE + 0xE3)
#define REG_LCD_72_L            (REG_LCD_BASE + 0xE4)
#define REG_LCD_72_H            (REG_LCD_BASE + 0xE5)
#define REG_LCD_73_L            (REG_LCD_BASE + 0xE6)
#define REG_LCD_73_H            (REG_LCD_BASE + 0xE7)
#define REG_LCD_74_L            (REG_LCD_BASE + 0xE8)
#define REG_LCD_74_H            (REG_LCD_BASE + 0xE9)
#define REG_LCD_75_L            (REG_LCD_BASE + 0xEA)
#define REG_LCD_75_H            (REG_LCD_BASE + 0xEB)
#define REG_LCD_76_L            (REG_LCD_BASE + 0xEC)
#define REG_LCD_76_H            (REG_LCD_BASE + 0xED)
#define REG_LCD_77_L            (REG_LCD_BASE + 0xEE)
#define REG_LCD_77_H            (REG_LCD_BASE + 0xEF)
#define REG_LCD_78_L            (REG_LCD_BASE + 0xF0)
#define REG_LCD_78_H            (REG_LCD_BASE + 0xF1)
#define REG_LCD_79_L            (REG_LCD_BASE + 0xF2)
#define REG_LCD_79_H            (REG_LCD_BASE + 0xF3)
#define REG_LCD_7A_L            (REG_LCD_BASE + 0xF4)
#define REG_LCD_7A_H            (REG_LCD_BASE + 0xF5)
#define REG_LCD_7B_L            (REG_LCD_BASE + 0xF6)
#define REG_LCD_7B_H            (REG_LCD_BASE + 0xF7)
#define REG_LCD_7C_L            (REG_LCD_BASE + 0xF8)
#define REG_LCD_7C_H            (REG_LCD_BASE + 0xF9)
#define REG_LCD_7D_L            (REG_LCD_BASE + 0xFA)
#define REG_LCD_7D_H            (REG_LCD_BASE + 0xFB)
#define REG_LCD_7E_L            (REG_LCD_BASE + 0xFC)
#define REG_LCD_7E_H            (REG_LCD_BASE + 0xFD)
#define REG_LCD_7F_L            (REG_LCD_BASE + 0xFE)
#define REG_LCD_7F_H            (REG_LCD_BASE + 0xFF)


#define REG_DISP_DMA_00_L       (REG_DISP_DMA_BASE + 0x00)
#define REG_DISP_DMA_00_H       (REG_DISP_DMA_BASE + 0x01)
#define REG_DISP_DMA_01_L       (REG_DISP_DMA_BASE + 0x02)
#define REG_DISP_DMA_01_H       (REG_DISP_DMA_BASE + 0x03)
#define REG_DISP_DMA_02_L       (REG_DISP_DMA_BASE + 0x04)
#define REG_DISP_DMA_02_H       (REG_DISP_DMA_BASE + 0x05)
#define REG_DISP_DMA_03_L       (REG_DISP_DMA_BASE + 0x06)
#define REG_DISP_DMA_03_H       (REG_DISP_DMA_BASE + 0x07)
#define REG_DISP_DMA_04_L       (REG_DISP_DMA_BASE + 0x08)
#define REG_DISP_DMA_04_H       (REG_DISP_DMA_BASE + 0x09)
#define REG_DISP_DMA_05_L       (REG_DISP_DMA_BASE + 0x0A)
#define REG_DISP_DMA_05_H       (REG_DISP_DMA_BASE + 0x0B)
#define REG_DISP_DMA_06_L       (REG_DISP_DMA_BASE + 0x0C)
#define REG_DISP_DMA_06_H       (REG_DISP_DMA_BASE + 0x0D)
#define REG_DISP_DMA_07_L       (REG_DISP_DMA_BASE + 0x0E)
#define REG_DISP_DMA_07_H       (REG_DISP_DMA_BASE + 0x0F)
#define REG_DISP_DMA_08_L       (REG_DISP_DMA_BASE + 0x10)
#define REG_DISP_DMA_08_H       (REG_DISP_DMA_BASE + 0x11)
#define REG_DISP_DMA_09_L       (REG_DISP_DMA_BASE + 0x12)
#define REG_DISP_DMA_09_H       (REG_DISP_DMA_BASE + 0x13)
#define REG_DISP_DMA_0A_L       (REG_DISP_DMA_BASE + 0x14)
#define REG_DISP_DMA_0A_H       (REG_DISP_DMA_BASE + 0x15)
#define REG_DISP_DMA_0B_L       (REG_DISP_DMA_BASE + 0x16)
#define REG_DISP_DMA_0B_H       (REG_DISP_DMA_BASE + 0x17)
#define REG_DISP_DMA_0C_L       (REG_DISP_DMA_BASE + 0x18)
#define REG_DISP_DMA_0C_H       (REG_DISP_DMA_BASE + 0x19)
#define REG_DISP_DMA_0D_L       (REG_DISP_DMA_BASE + 0x1A)
#define REG_DISP_DMA_0D_H       (REG_DISP_DMA_BASE + 0x1B)
#define REG_DISP_DMA_0E_L       (REG_DISP_DMA_BASE + 0x1C)
#define REG_DISP_DMA_0E_H       (REG_DISP_DMA_BASE + 0x1D)
#define REG_DISP_DMA_0F_L       (REG_DISP_DMA_BASE + 0x1E)
#define REG_DISP_DMA_0F_H       (REG_DISP_DMA_BASE + 0x1F)
#define REG_DISP_DMA_10_L       (REG_DISP_DMA_BASE + 0x20)
#define REG_DISP_DMA_10_H       (REG_DISP_DMA_BASE + 0x21)
#define REG_DISP_DMA_11_L       (REG_DISP_DMA_BASE + 0x22)
#define REG_DISP_DMA_11_H       (REG_DISP_DMA_BASE + 0x23)
#define REG_DISP_DMA_12_L       (REG_DISP_DMA_BASE + 0x24)
#define REG_DISP_DMA_12_H       (REG_DISP_DMA_BASE + 0x25)
#define REG_DISP_DMA_13_L       (REG_DISP_DMA_BASE + 0x26)
#define REG_DISP_DMA_13_H       (REG_DISP_DMA_BASE + 0x27)
#define REG_DISP_DMA_14_L       (REG_DISP_DMA_BASE + 0x28)
#define REG_DISP_DMA_14_H       (REG_DISP_DMA_BASE + 0x29)
#define REG_DISP_DMA_15_L       (REG_DISP_DMA_BASE + 0x2A)
#define REG_DISP_DMA_15_H       (REG_DISP_DMA_BASE + 0x2B)
#define REG_DISP_DMA_16_L       (REG_DISP_DMA_BASE + 0x2C)
#define REG_DISP_DMA_16_H       (REG_DISP_DMA_BASE + 0x2D)
#define REG_DISP_DMA_17_L       (REG_DISP_DMA_BASE + 0x2E)
#define REG_DISP_DMA_17_H       (REG_DISP_DMA_BASE + 0x2F)
#define REG_DISP_DMA_18_L       (REG_DISP_DMA_BASE + 0x30)
#define REG_DISP_DMA_18_H       (REG_DISP_DMA_BASE + 0x31)
#define REG_DISP_DMA_19_L       (REG_DISP_DMA_BASE + 0x32)
#define REG_DISP_DMA_19_H       (REG_DISP_DMA_BASE + 0x33)
#define REG_DISP_DMA_1A_L       (REG_DISP_DMA_BASE + 0x34)
#define REG_DISP_DMA_1A_H       (REG_DISP_DMA_BASE + 0x35)
#define REG_DISP_DMA_1B_L       (REG_DISP_DMA_BASE + 0x36)
#define REG_DISP_DMA_1B_H       (REG_DISP_DMA_BASE + 0x37)
#define REG_DISP_DMA_1C_L       (REG_DISP_DMA_BASE + 0x38)
#define REG_DISP_DMA_1C_H       (REG_DISP_DMA_BASE + 0x39)
#define REG_DISP_DMA_1D_L       (REG_DISP_DMA_BASE + 0x3A)
#define REG_DISP_DMA_1D_H       (REG_DISP_DMA_BASE + 0x3B)
#define REG_DISP_DMA_1E_L       (REG_DISP_DMA_BASE + 0x3C)
#define REG_DISP_DMA_1E_H       (REG_DISP_DMA_BASE + 0x3D)
#define REG_DISP_DMA_1F_L       (REG_DISP_DMA_BASE + 0x3E)
#define REG_DISP_DMA_1F_H       (REG_DISP_DMA_BASE + 0x3F)
#define REG_DISP_DMA_20_L       (REG_DISP_DMA_BASE + 0x40)
#define REG_DISP_DMA_20_H       (REG_DISP_DMA_BASE + 0x41)
#define REG_DISP_DMA_21_L       (REG_DISP_DMA_BASE + 0x42)
#define REG_DISP_DMA_21_H       (REG_DISP_DMA_BASE + 0x43)
#define REG_DISP_DMA_22_L       (REG_DISP_DMA_BASE + 0x44)
#define REG_DISP_DMA_22_H       (REG_DISP_DMA_BASE + 0x45)
#define REG_DISP_DMA_23_L       (REG_DISP_DMA_BASE + 0x46)
#define REG_DISP_DMA_23_H       (REG_DISP_DMA_BASE + 0x47)
#define REG_DISP_DMA_24_L       (REG_DISP_DMA_BASE + 0x48)
#define REG_DISP_DMA_24_H       (REG_DISP_DMA_BASE + 0x49)
#define REG_DISP_DMA_25_L       (REG_DISP_DMA_BASE + 0x4A)
#define REG_DISP_DMA_25_H       (REG_DISP_DMA_BASE + 0x4B)
#define REG_DISP_DMA_26_L       (REG_DISP_DMA_BASE + 0x4C)
#define REG_DISP_DMA_26_H       (REG_DISP_DMA_BASE + 0x4D)
#define REG_DISP_DMA_27_L       (REG_DISP_DMA_BASE + 0x4E)
#define REG_DISP_DMA_27_H       (REG_DISP_DMA_BASE + 0x4F)
#define REG_DISP_DMA_28_L       (REG_DISP_DMA_BASE + 0x50)
#define REG_DISP_DMA_28_H       (REG_DISP_DMA_BASE + 0x51)
#define REG_DISP_DMA_29_L       (REG_DISP_DMA_BASE + 0x52)
#define REG_DISP_DMA_29_H       (REG_DISP_DMA_BASE + 0x53)
#define REG_DISP_DMA_2A_L       (REG_DISP_DMA_BASE + 0x54)
#define REG_DISP_DMA_2A_H       (REG_DISP_DMA_BASE + 0x55)
#define REG_DISP_DMA_2B_L       (REG_DISP_DMA_BASE + 0x56)
#define REG_DISP_DMA_2B_H       (REG_DISP_DMA_BASE + 0x57)
#define REG_DISP_DMA_2C_L       (REG_DISP_DMA_BASE + 0x58)
#define REG_DISP_DMA_2C_H       (REG_DISP_DMA_BASE + 0x59)
#define REG_DISP_DMA_2D_L       (REG_DISP_DMA_BASE + 0x5A)
#define REG_DISP_DMA_2D_H       (REG_DISP_DMA_BASE + 0x5B)
#define REG_DISP_DMA_2E_L       (REG_DISP_DMA_BASE + 0x5C)
#define REG_DISP_DMA_2E_H       (REG_DISP_DMA_BASE + 0x5D)
#define REG_DISP_DMA_2F_L       (REG_DISP_DMA_BASE + 0x5E)
#define REG_DISP_DMA_2F_H       (REG_DISP_DMA_BASE + 0x5F)
#define REG_DISP_DMA_30_L       (REG_DISP_DMA_BASE + 0x60)
#define REG_DISP_DMA_30_H       (REG_DISP_DMA_BASE + 0x61)
#define REG_DISP_DMA_31_L       (REG_DISP_DMA_BASE + 0x62)
#define REG_DISP_DMA_31_H       (REG_DISP_DMA_BASE + 0x63)
#define REG_DISP_DMA_32_L       (REG_DISP_DMA_BASE + 0x64)
#define REG_DISP_DMA_32_H       (REG_DISP_DMA_BASE + 0x65)
#define REG_DISP_DMA_33_L       (REG_DISP_DMA_BASE + 0x66)
#define REG_DISP_DMA_33_H       (REG_DISP_DMA_BASE + 0x67)
#define REG_DISP_DMA_34_L       (REG_DISP_DMA_BASE + 0x68)
#define REG_DISP_DMA_34_H       (REG_DISP_DMA_BASE + 0x69)
#define REG_DISP_DMA_35_L       (REG_DISP_DMA_BASE + 0x6A)
#define REG_DISP_DMA_35_H       (REG_DISP_DMA_BASE + 0x6B)
#define REG_DISP_DMA_36_L       (REG_DISP_DMA_BASE + 0x6C)
#define REG_DISP_DMA_36_H       (REG_DISP_DMA_BASE + 0x6D)
#define REG_DISP_DMA_37_L       (REG_DISP_DMA_BASE + 0x6E)
#define REG_DISP_DMA_37_H       (REG_DISP_DMA_BASE + 0x6F)
#define REG_DISP_DMA_38_L       (REG_DISP_DMA_BASE + 0x70)
#define REG_DISP_DMA_38_H       (REG_DISP_DMA_BASE + 0x71)
#define REG_DISP_DMA_39_L       (REG_DISP_DMA_BASE + 0x72)
#define REG_DISP_DMA_39_H       (REG_DISP_DMA_BASE + 0x73)
#define REG_DISP_DMA_3A_L       (REG_DISP_DMA_BASE + 0x74)
#define REG_DISP_DMA_3A_H       (REG_DISP_DMA_BASE + 0x75)
#define REG_DISP_DMA_3B_L       (REG_DISP_DMA_BASE + 0x76)
#define REG_DISP_DMA_3B_H       (REG_DISP_DMA_BASE + 0x77)
#define REG_DISP_DMA_3C_L       (REG_DISP_DMA_BASE + 0x78)
#define REG_DISP_DMA_3C_H       (REG_DISP_DMA_BASE + 0x79)
#define REG_DISP_DMA_3D_L       (REG_DISP_DMA_BASE + 0x7A)
#define REG_DISP_DMA_3D_H       (REG_DISP_DMA_BASE + 0x7B)
#define REG_DISP_DMA_3E_L       (REG_DISP_DMA_BASE + 0x7C)
#define REG_DISP_DMA_3E_H       (REG_DISP_DMA_BASE + 0x7D)
#define REG_DISP_DMA_3F_L       (REG_DISP_DMA_BASE + 0x7E)
#define REG_DISP_DMA_3F_H       (REG_DISP_DMA_BASE + 0x7F)
#define REG_DISP_DMA_40_L       (REG_DISP_DMA_BASE + 0x80)
#define REG_DISP_DMA_40_H       (REG_DISP_DMA_BASE + 0x81)
#define REG_DISP_DMA_41_L       (REG_DISP_DMA_BASE + 0x82)
#define REG_DISP_DMA_41_H       (REG_DISP_DMA_BASE + 0x83)
#define REG_DISP_DMA_42_L       (REG_DISP_DMA_BASE + 0x84)
#define REG_DISP_DMA_42_H       (REG_DISP_DMA_BASE + 0x85)
#define REG_DISP_DMA_43_L       (REG_DISP_DMA_BASE + 0x86)
#define REG_DISP_DMA_43_H       (REG_DISP_DMA_BASE + 0x87)
#define REG_DISP_DMA_44_L       (REG_DISP_DMA_BASE + 0x88)
#define REG_DISP_DMA_44_H       (REG_DISP_DMA_BASE + 0x89)
#define REG_DISP_DMA_45_L       (REG_DISP_DMA_BASE + 0x8A)
#define REG_DISP_DMA_45_H       (REG_DISP_DMA_BASE + 0x8B)
#define REG_DISP_DMA_46_L       (REG_DISP_DMA_BASE + 0x8C)
#define REG_DISP_DMA_46_H       (REG_DISP_DMA_BASE + 0x8D)
#define REG_DISP_DMA_47_L       (REG_DISP_DMA_BASE + 0x8E)
#define REG_DISP_DMA_47_H       (REG_DISP_DMA_BASE + 0x8F)
#define REG_DISP_DMA_48_L       (REG_DISP_DMA_BASE + 0x90)
#define REG_DISP_DMA_48_H       (REG_DISP_DMA_BASE + 0x91)
#define REG_DISP_DMA_49_L       (REG_DISP_DMA_BASE + 0x92)
#define REG_DISP_DMA_49_H       (REG_DISP_DMA_BASE + 0x93)
#define REG_DISP_DMA_4A_L       (REG_DISP_DMA_BASE + 0x94)
#define REG_DISP_DMA_4A_H       (REG_DISP_DMA_BASE + 0x95)
#define REG_DISP_DMA_4B_L       (REG_DISP_DMA_BASE + 0x96)
#define REG_DISP_DMA_4B_H       (REG_DISP_DMA_BASE + 0x97)
#define REG_DISP_DMA_4C_L       (REG_DISP_DMA_BASE + 0x98)
#define REG_DISP_DMA_4C_H       (REG_DISP_DMA_BASE + 0x99)
#define REG_DISP_DMA_4D_L       (REG_DISP_DMA_BASE + 0x9A)
#define REG_DISP_DMA_4D_H       (REG_DISP_DMA_BASE + 0x9B)
#define REG_DISP_DMA_4E_L       (REG_DISP_DMA_BASE + 0x9C)
#define REG_DISP_DMA_4E_H       (REG_DISP_DMA_BASE + 0x9D)
#define REG_DISP_DMA_4F_L       (REG_DISP_DMA_BASE + 0x9E)
#define REG_DISP_DMA_4F_H       (REG_DISP_DMA_BASE + 0x9F)
#define REG_DISP_DMA_50_L       (REG_DISP_DMA_BASE + 0xA0)
#define REG_DISP_DMA_50_H       (REG_DISP_DMA_BASE + 0xA1)
#define REG_DISP_DMA_51_L       (REG_DISP_DMA_BASE + 0xA2)
#define REG_DISP_DMA_51_H       (REG_DISP_DMA_BASE + 0xA3)
#define REG_DISP_DMA_52_L       (REG_DISP_DMA_BASE + 0xA4)
#define REG_DISP_DMA_52_H       (REG_DISP_DMA_BASE + 0xA5)
#define REG_DISP_DMA_53_L       (REG_DISP_DMA_BASE + 0xA6)
#define REG_DISP_DMA_53_H       (REG_DISP_DMA_BASE + 0xA7)
#define REG_DISP_DMA_54_L       (REG_DISP_DMA_BASE + 0xA8)
#define REG_DISP_DMA_54_H       (REG_DISP_DMA_BASE + 0xA9)
#define REG_DISP_DMA_55_L       (REG_DISP_DMA_BASE + 0xAA)
#define REG_DISP_DMA_55_H       (REG_DISP_DMA_BASE + 0xAB)
#define REG_DISP_DMA_56_L       (REG_DISP_DMA_BASE + 0xAC)
#define REG_DISP_DMA_56_H       (REG_DISP_DMA_BASE + 0xAD)
#define REG_DISP_DMA_57_L       (REG_DISP_DMA_BASE + 0xAE)
#define REG_DISP_DMA_57_H       (REG_DISP_DMA_BASE + 0xAF)
#define REG_DISP_DMA_58_L       (REG_DISP_DMA_BASE + 0xB0)
#define REG_DISP_DMA_58_H       (REG_DISP_DMA_BASE + 0xB1)
#define REG_DISP_DMA_59_L       (REG_DISP_DMA_BASE + 0xB2)
#define REG_DISP_DMA_59_H       (REG_DISP_DMA_BASE + 0xB3)
#define REG_DISP_DMA_5A_L       (REG_DISP_DMA_BASE + 0xB4)
#define REG_DISP_DMA_5A_H       (REG_DISP_DMA_BASE + 0xB5)
#define REG_DISP_DMA_5B_L       (REG_DISP_DMA_BASE + 0xB6)
#define REG_DISP_DMA_5B_H       (REG_DISP_DMA_BASE + 0xB7)
#define REG_DISP_DMA_5C_L       (REG_DISP_DMA_BASE + 0xB8)
#define REG_DISP_DMA_5C_H       (REG_DISP_DMA_BASE + 0xB9)
#define REG_DISP_DMA_5D_L       (REG_DISP_DMA_BASE + 0xBA)
#define REG_DISP_DMA_5D_H       (REG_DISP_DMA_BASE + 0xBB)
#define REG_DISP_DMA_5E_L       (REG_DISP_DMA_BASE + 0xBC)
#define REG_DISP_DMA_5E_H       (REG_DISP_DMA_BASE + 0xBD)
#define REG_DISP_DMA_5F_L       (REG_DISP_DMA_BASE + 0xBE)
#define REG_DISP_DMA_5F_H       (REG_DISP_DMA_BASE + 0xBF)
#define REG_DISP_DMA_60_L       (REG_DISP_DMA_BASE + 0xC0)
#define REG_DISP_DMA_60_H       (REG_DISP_DMA_BASE + 0xC1)
#define REG_DISP_DMA_61_L       (REG_DISP_DMA_BASE + 0xC2)
#define REG_DISP_DMA_61_H       (REG_DISP_DMA_BASE + 0xC3)
#define REG_DISP_DMA_62_L       (REG_DISP_DMA_BASE + 0xC4)
#define REG_DISP_DMA_62_H       (REG_DISP_DMA_BASE + 0xC5)
#define REG_DISP_DMA_63_L       (REG_DISP_DMA_BASE + 0xC6)
#define REG_DISP_DMA_63_H       (REG_DISP_DMA_BASE + 0xC7)
#define REG_DISP_DMA_64_L       (REG_DISP_DMA_BASE + 0xC8)
#define REG_DISP_DMA_64_H       (REG_DISP_DMA_BASE + 0xC9)
#define REG_DISP_DMA_65_L       (REG_DISP_DMA_BASE + 0xCA)
#define REG_DISP_DMA_65_H       (REG_DISP_DMA_BASE + 0xCB)
#define REG_DISP_DMA_66_L       (REG_DISP_DMA_BASE + 0xCC)
#define REG_DISP_DMA_66_H       (REG_DISP_DMA_BASE + 0xCD)
#define REG_DISP_DMA_67_L       (REG_DISP_DMA_BASE + 0xCE)
#define REG_DISP_DMA_67_H       (REG_DISP_DMA_BASE + 0xCF)
#define REG_DISP_DMA_68_L       (REG_DISP_DMA_BASE + 0xD0)
#define REG_DISP_DMA_68_H       (REG_DISP_DMA_BASE + 0xD1)
#define REG_DISP_DMA_69_L       (REG_DISP_DMA_BASE + 0xD2)
#define REG_DISP_DMA_69_H       (REG_DISP_DMA_BASE + 0xD3)
#define REG_DISP_DMA_6A_L       (REG_DISP_DMA_BASE + 0xD4)
#define REG_DISP_DMA_6A_H       (REG_DISP_DMA_BASE + 0xD5)
#define REG_DISP_DMA_6B_L       (REG_DISP_DMA_BASE + 0xD6)
#define REG_DISP_DMA_6B_H       (REG_DISP_DMA_BASE + 0xD7)
#define REG_DISP_DMA_6C_L       (REG_DISP_DMA_BASE + 0xD8)
#define REG_DISP_DMA_6C_H       (REG_DISP_DMA_BASE + 0xD9)
#define REG_DISP_DMA_6D_L       (REG_DISP_DMA_BASE + 0xDA)
#define REG_DISP_DMA_6D_H       (REG_DISP_DMA_BASE + 0xDB)
#define REG_DISP_DMA_6E_L       (REG_DISP_DMA_BASE + 0xDC)
#define REG_DISP_DMA_6E_H       (REG_DISP_DMA_BASE + 0xDD)
#define REG_DISP_DMA_6F_L       (REG_DISP_DMA_BASE + 0xDE)
#define REG_DISP_DMA_6F_H       (REG_DISP_DMA_BASE + 0xDF)
#define REG_DISP_DMA_70_L       (REG_DISP_DMA_BASE + 0xE0)
#define REG_DISP_DMA_70_H       (REG_DISP_DMA_BASE + 0xE1)
#define REG_DISP_DMA_71_L       (REG_DISP_DMA_BASE + 0xE2)
#define REG_DISP_DMA_71_H       (REG_DISP_DMA_BASE + 0xE3)
#define REG_DISP_DMA_72_L       (REG_DISP_DMA_BASE + 0xE4)
#define REG_DISP_DMA_72_H       (REG_DISP_DMA_BASE + 0xE5)
#define REG_DISP_DMA_73_L       (REG_DISP_DMA_BASE + 0xE6)
#define REG_DISP_DMA_73_H       (REG_DISP_DMA_BASE + 0xE7)
#define REG_DISP_DMA_74_L       (REG_DISP_DMA_BASE + 0xE8)
#define REG_DISP_DMA_74_H       (REG_DISP_DMA_BASE + 0xE9)
#define REG_DISP_DMA_75_L       (REG_DISP_DMA_BASE + 0xEA)
#define REG_DISP_DMA_75_H       (REG_DISP_DMA_BASE + 0xEB)
#define REG_DISP_DMA_76_L       (REG_DISP_DMA_BASE + 0xEC)
#define REG_DISP_DMA_76_H       (REG_DISP_DMA_BASE + 0xED)
#define REG_DISP_DMA_77_L       (REG_DISP_DMA_BASE + 0xEE)
#define REG_DISP_DMA_77_H       (REG_DISP_DMA_BASE + 0xEF)
#define REG_DISP_DMA_78_L       (REG_DISP_DMA_BASE + 0xF0)
#define REG_DISP_DMA_78_H       (REG_DISP_DMA_BASE + 0xF1)
#define REG_DISP_DMA_79_L       (REG_DISP_DMA_BASE + 0xF2)
#define REG_DISP_DMA_79_H       (REG_DISP_DMA_BASE + 0xF3)
#define REG_DISP_DMA_7A_L       (REG_DISP_DMA_BASE + 0xF4)
#define REG_DISP_DMA_7A_H       (REG_DISP_DMA_BASE + 0xF5)
#define REG_DISP_DMA_7B_L       (REG_DISP_DMA_BASE + 0xF6)
#define REG_DISP_DMA_7B_H       (REG_DISP_DMA_BASE + 0xF7)
#define REG_DISP_DMA_7C_L       (REG_DISP_DMA_BASE + 0xF8)
#define REG_DISP_DMA_7C_H       (REG_DISP_DMA_BASE + 0xF9)
#define REG_DISP_DMA_7D_L       (REG_DISP_DMA_BASE + 0xFA)
#define REG_DISP_DMA_7D_H       (REG_DISP_DMA_BASE + 0xFB)
#define REG_DISP_DMA_7E_L       (REG_DISP_DMA_BASE + 0xFC)
#define REG_DISP_DMA_7E_H       (REG_DISP_DMA_BASE + 0xFD)
#define REG_DISP_DMA_7F_L       (REG_DISP_DMA_BASE + 0xFE)
#define REG_DISP_DMA_7F_H       (REG_DISP_DMA_BASE + 0xFF)

#endif /* __HAL_DISP_REG_H__ */
